<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromCollection;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\Exportable;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithStyles;
use PhpOffice\PhpSpreadsheet\Worksheet\Worksheet;

class CityBillExportReport implements FromCollection, WithHeadings, ShouldAutoSize, WithStyles
{
    use Exportable;

    protected $data;

    public function __construct(Collection $data)
    {
        $this->data = $data;
    }

    public function collection()
    {
        return $this->data;
    }

    public function headings(): array
    {
        // Define your header row here dynamically
        return [
            'Reference No.',
            'Role',
            'NTA ID',
            'Functionary Name',
            'Mobile No.',
            'Exam ID',
            'Exam Name',
            'Bill Submitted Date',
            'Bill Status',
            'PAN No.',
            'Bank Branch Name',
            'Bank Name',
            'IFSC Code',
            'Beneficiary Name',
            'Completed Date',
            'Exam Type',
            'Remarks',
            'Rejection Remark',
            'No_ of Candidate Alloted',
            'No_ of Candidate Alloted NTA',
            'No_ of Candidate Present',
            'No_ of Candidate Absent',
            'City Coord. MockDrill Remuneration',
            'City Coord. MockDrill Remuneration Deduction',
            'City Coord. MockDrill Conveyance',
            'City Coord. MockDrill Conveyance Deduction',
            'City Coord. Remuneration Amount',
            'City Coord. Remuneration Amount Deduction',
            'City Coord. Conveyance Amount',
            'City Coord. Conveyance Amount Deduction',
            'Admin. Staff Mock Drill',
            'Admin. Staff/Clerk Amount',
            'Admin. Staff/Clerk Amount Deduction',
            'Suppor. Staff MockDrill',
            'Supporting Staff Mock Drill Deduction',
            'Supporting Staff Sweeper/Cleaning Staff Amount',
            'Supporting Staff Sweeper/Cleaning Staff Amount Deduction',
            'Refreshment Amount',
            'Refreshment Deduction Amount',
            'WatchMan Mock Drill',
            'Watchman Mock Drill Deduction',
            'Watchman/Guard Amount',
            'Watchman/Guard Amount Deduction',
            'WaterBoy Mock Drill',
            'Water Boy Mock Drill Deduction',
            'Waterman/Peon Amount',
            'Waterman/Peon Amount Deduction',
            'Miscellaneous Charge',
            'Miscellaneous Deduction Amount',
            'Other Charges',
            'Mock Drill Amount for Observer',
            'Mock Drill Amount for Observer Deduction',
            'Total Observer Amount',
            'Total Observer Amount Deduction',
            'Observer Conveyance',
            'Mock Drill Amount for Deputy Observer',
            'Mock Drill Amount for Deputy Observer Deduction',
            'Total Deputy Observer Amount',
            'Total Deputy Observer Amount Deduction',
            'Total Expenditure Amount',
            'Advance Payment',
            'TDS(%)',
            'TDS Amount',
            'Observer TDS Amount',
            'Deputy Observer TDS Amount',
            'Net Amount Payable',
            'Total Deduction Amount',
            'Net Payable After Deduction Amount'

        ];
    }

    public function styles(Worksheet $sheet)
    {
        // Apply styles to header row (A1:C1 in Excel)
        $sheet->getStyle('A1:BP1')->applyFromArray([
            'font' => [
                'bold' => true,
            ],
            'fill' => [
                'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                'startColor' => [
                    'rgb' => 'FFFF00', // Yellow background color
                ],
            ],
        ]);
        // Freeze the first row
        $sheet->freezePane('A2');
    }
}
