<?php

use Illuminate\Support\Facades\Auth;
use App\Models\VendorBankTbl;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;

if (!function_exists('pr')) {
    function pr($param)
    {
        echo '<pre>';
        print_r($param);
    }
}

if (!function_exists('prd')) {
    function prd($param)
    {
        echo '<pre>';
        print_r($param);
        die;
    }
}

if (!function_exists('getUserInformation')) {
    function getUserInformation()
    {

        $userProfile = null;
        $username = Auth::user()->UserName;
        if ($username) {
            $userProfile = VendorBankTbl::where('No_', $username)->first();
        }
        return  $userProfile;
    }
}

if (!function_exists('getUserExamsList')) {
    function getUserExamsList()
    {
        $username = Auth::user()->UserName;
        $examProfileTableName = config('constants.ExamProfile');
        $examDatesTableName = config('constants.ExamDates');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

        $setExamsData = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => "[Exam Type]",
            'input' => "WHERE 1=1",
            'table' => "[$CentralizedRemunerationHeaderTable]"
        ]);
        $setExams = array_column($setExamsData, 'Exam Type');
        $examLists = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => "*",
            'input' => "join [$examProfileTableName] ON [$examProfileTableName].ObserverID = FRONT_ERP_USER_AdminUser.NTA_Unique_Admin_ID
                            JOIN [$examDatesTableName] ON [$examProfileTableName].ExamType = [$examDatesTableName].[Exam Type]
                            WHERE NTA_Unique_Admin_ID = '$username' AND [$examDatesTableName].Is_Active = '1'",
            'table' => "FRONT_ERP_USER_AdminUser",

        ]);
        if (!empty($examLists)) {
            $UniqueExamsList = [];
            $Uniqueexam = [];
            foreach ($examLists as $key => $exams) {
                if (!isset($Uniqueexam[$exams->{'Exam Name'}])) {
                    $Uniqueexam[$exams->{'Exam Name'}] = true;
                    $UniqueExamsList[] = $exams;
                }
            }
            return array($UniqueExamsList, $setExams);
        }
        return false;
    }
}


if (!function_exists('getAllExamsList')) {
    function getAllExamsList($perPage = null, $searchQuery = null)
    {
        $examDatesTableName = config('constants.ExamDates');

        $query = DB::table($examDatesTableName)
            ->select('Exam Type Id', 'Exam Type', 'Year', 'Exam Name', 'Exam_Mode', 'Exam_Duration', 'Is_active', 'Mock_Date','mockval','Date_1','Date_2','Date_3','Date_4','Date_5','Date_6','Date_7','Date_8','Date_9','Date_10','Date_11','Date_12')
            ->orderBy('Exam Type Id', 'DESC');

        if ($searchQuery) {
            $query->where('Exam Name', 'like', '%' . $searchQuery . '%');
            $query->orwhere('Exam_Mode', 'like', '%' . $searchQuery . '%');
            $query->orwhere('Year', 'like', '%' . $searchQuery . '%');
        }

        // Apply pagination if perPage is provided
        $ExamsList = $query->paginate($perPage);

        return $ExamsList;
    }
}


// if (!function_exists('getAllExamProfileList')) {
//     function getAllExamProfileList($perPage = null)
//     {
//         $examDatesTableName = config('constants.ExamProfile');
//         $ExamsList = DB::table($examDatesTableName)
//             ->select('Name', 'ExamType', 'Designation', 'Mobile', 'ID', 'Observer Type')
//             ->orderBy('ID', 'DESC')
//             ->paginate($perPage); // Apply pagination here

//         return $ExamsList;
//     }
// }

if (!function_exists('getAllExamProfileList')) {
    function getAllExamProfileList($perPage = null, $examName = null, $NTA_Observer_ID = null, $searchData = null)
    {
        // $ExamProfileTableName = config('constants.ExamProfile');
        // $ExamDates = config('constants.ExamDates');
        // $ExamsList = DB::table($ExamProfileTableName . ' as EP')
        //     ->select('EP.ObserverID', 'EP.Name', 'EP.ExamType', 'EP.Designation', 'EP.Mobile', 'EP.ID', 'EP.Observer Type', 'ED.Exam Name')
        //     ->join($ExamDates . ' as ED', 'ED.Exam Type', '=', 'EP.ExamType')
        //     ->orderBy('EP.ID', 'DESC')
        //     ->paginate($perPage); // Apply pagination here
        // return $ExamsList;

        $ExamProfileTableName = config('constants.ExamProfile');
        $ExamDates = config('constants.ExamDates');
        $ExamsList = DB::table($ExamProfileTableName . ' as EP')
            ->select('EP.ObserverID', 'EP.CENTNO', 'EP.Name', 'EP.Email', 'EP.ExamType', 'EP.Designation', 'EP.Mobile', 'EP.ID', 'EP.Observer Type', 'ED.Exam Name')
            ->join($ExamDates . ' as ED', 'ED.Exam Type', '=', 'EP.ExamType')
            ->orderBy('EP.ID', 'DESC');
        if (!empty($examName)) {
            $ExamsList->where('ED.Exam Name', $examName);
        }
        if (!empty($NTA_Observer_ID)) {
            $ExamsList->where('EP.Observer Type', $NTA_Observer_ID);
        }
        if (!empty($searchData)) {
            $ExamsList->where('EP.Name', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('EP.ObserverID', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('EP.Email', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('EP.Mobile', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('EP.CENTNO', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('EP.Designation', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('ED.Exam Name', 'like', '%' . $searchData . '%');
        }

        return $ExamsList->paginate($perPage);
    }
}

if (!function_exists('getAllExamProfileShiftList')) {
    function getAllExamProfileShiftList($perPage = null, $NTA_Observer_ID = null, $searchData = null)
    {
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $ExamsList = DB::table($ExamProfileShiftWise)
            ->select('ID', 'Observer ID', 'Exam Type', 'CenterNo');
        if (!empty($NTA_Observer_ID)) {
            $ExamsList->where('Observer ID', $NTA_Observer_ID);
        }
        if (!empty($searchData)) {
            $ExamsList->where('Exam Type', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('Observer ID', 'like', '%' . $searchData . '%');
            $ExamsList->orwhere('CenterNo', 'like', '%' . $searchData . '%');
        }
        return $ExamsList->paginate($perPage);
    }
}


if (!function_exists('getExaSourceCodeList')) {
    function getExaSourceCodeList($Role = '', $SourceCode = '')
    {
        $ExamSourceCodeTableName = config('constants.ExamSourceCode');

        $ExamsList = DB::table($ExamSourceCodeTableName)
            ->select('*');

        if (!empty($Role)) {
            $ExamsList->where('Source Type', $Role);
        }

        if (!empty($SourceCode)) {
            $ExamsList->where('Source Code', trim($SourceCode));
        }

        $ExamsList = $ExamsList->orderBy('Source Code', 'asc')->get();

        return $ExamsList;
    }
}


if (!function_exists('getExamDateList')) {
    function getExamDateList()
    {
        $ExamDatesTableName = config('constants.ExamDates');
        $ExamsDateList = DB::table($ExamDatesTableName)
            ->select('Exam Type Id', 'Exam Type', 'Exam Group', 'Exam Name', 'Exam Unit', 'Exam_Mode')
            ->orderBy('Exam Name', 'asc')
            ->get(); // Apply pagination here
        return $ExamsDateList;
    }
}


if (!function_exists('getExamList')) {
    function getExamList($id)
    {
        $ExamDatesTableName = config('constants.ExamDates');
        $ExamsDateList = DB::table($ExamDatesTableName)
            ->select('Exam Type Id', 'Exam Type', 'Exam Group', 'Exam Name', 'Exam Unit', 'Exam_Mode')
            ->where('Exam Type Id', $id)
            ->orderBy('Exam Name', 'asc')
            ->first(); // Apply pagination here
        return $ExamsDateList;
    }
}


if (!function_exists('getFinancialAllNormsList')) {
    function getFinancialAllNormsList()
    {
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');
        $ExamsList = DB::table($CentralizedRemunerationHeaderTable)
            ->select('Exam Type ID', 'Exam Type', 'Exam Name')
            ->distinct('Exam Type ID')  // This will ensure the result is distinct based on the selected columns
            ->orderBy('Exam Type ID', 'Desc')
            ->get();
        return $ExamsList;
    }
}


if (!function_exists('getFinancialExamNormsList')) {
    function getFinancialExamNormsList($perPage = null, $examType = null, $sourceType = null)
    {


        $username = Auth::user()->UserName;
        $examProfileTableName = config('constants.ExamProfile');
        $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

        $ExamsList = DB::table($CentralizedRemunerationLineTableShiftWise)
            ->select(
                'Document No_',
                'Line No_',
                'Source Code',
                'Source Name',
                'Remuneration Amount_S1',
                'Remuneration Amount_S2',
                'Remuneration Amount_S3',
                'Remuneration Amount_S4',
                'Conveyance Amount',
                'Food Amount',
                'Other Charges',
                'ScribeRate',
                'Mock Drill Conveyance',
                'Mock Drill Charge',
                'Source Type',
                'No_ of Candidates',
                'No_ of Person',
                'No_ of Days',
                'Fixed Amount',
                'Remuneration Text',
                'Mock Drill Text',
                // Add the columns you need from the $CentralizedRemunerationHeaderTable
                'HeaderTable.Exam Type ID',
                'HeaderTable.Exam Type',
                'HeaderTable.Exam Name',
                'isTds'
            )
            ->leftJoin($CentralizedRemunerationHeaderTable . ' as HeaderTable', function ($join) {
                $join->on('HeaderTable.ID', '=', config('constants.CentralizedRemunerationLineTableShiftWise') . '.Document No_');
            });
        if (!empty($examType)) {
            $ExamsList->where('HeaderTable.Exam Type ID', $examType);
        }

        if (!empty($sourceType)) {
            $ExamsList->where($CentralizedRemunerationLineTableShiftWise . '.Source Type', $sourceType);
        }

        $ExamsList = $ExamsList->orderBy('Document No_', 'Desc')
            ->paginate($perPage); // Apply pagination

        return $ExamsList;
    }
}



if (!function_exists('getFinancialNormsList')) {
    function getFinancialNormsList($perPage = null, $examType = null)
    {
        $username = Auth::user()->UserName;
        $examProfileTableName = config('constants.ExamProfile');
        $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

        $ExamsList = DB::table($CentralizedRemunerationLineTableShiftWise)
            ->select(
                'Document No_',
                'Source Type',
                'Line No_',
                'Source Code',
                'Source Name',
                'Remuneration Amount_S1',
                'Remuneration Amount_S2',
                'Remuneration Amount_S3',
                'Remuneration Amount_S4',
                'Conveyance Amount',
                'Food Amount',
                'Other Charges',
                'ScribeRate',
                'Mock Drill Conveyance',
                'Mock Drill Charge',
                'Source Type',
                'No_ of Candidates',
                'No_ of Person',
                'No_ of Days',
                'Fixed Amount',
                'Remuneration Text',
                'Mock Drill Text',
                // Add the columns you need from the $CentralizedRemunerationHeaderTable
                'HeaderTable.Exam Type ID',
                'HeaderTable.Exam Type',
                'HeaderTable.Exam Name',
                'isTds'
            )
            ->leftJoin($CentralizedRemunerationHeaderTable . ' as HeaderTable', function ($join) {
                $join->on('HeaderTable.ID', '=', config('constants.CentralizedRemunerationLineTableShiftWise') . '.Document No_');
            })
            ->orderBy('Document No_', 'Desc')
            ->paginate($perPage); // Apply pagination
        return $ExamsList;
    }
}



if (!function_exists('getFinancialNormsEdit')) {

    function getFinancialNormsEdit($document_id, $line_id)
    {
        // dd($line_id);

        $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

        $ExamsList = DB::table($CentralizedRemunerationLineTableShiftWise)
            ->select(
                'Document No_',
                'Line No_',
                'Source Code',
                'Source Name',
                'Remuneration Amount_S1',
                'Remuneration Amount_S2',
                'Remuneration Amount_S3',
                'Remuneration Amount_S4',
                'Remuneration Text',
                'Conveyance Amount',
                'Food Amount',
                'Other Charges',
                'ScribeRate',
                'Mock Drill Conveyance',
                'Mock Drill Charge',
                'Source Type',
                'No_ of Candidates',
                'No_ of Person',
                'No_ of Days',
                'Fixed Amount',
                'Remuneration Text',
                'Mock Drill Text',
                'isAttechment',
                'isAttechmentRequired',
                'readonly',
                'isRequired',
                'displayOrder',
                'isTds',
                'tdsPrecentage',
                'Field_Name',
                'MockDrillFiledName',
                'isActive',
                'isExtrafield',
                // Add the columns you need from the $CentralizedRemunerationHeaderTable
                'HeaderTable.Exam Type ID',
                'HeaderTable.Exam Type',
                'HeaderTable.Exam Mode',
                'HeaderTable.Exam Name'
            )
            ->leftJoin($CentralizedRemunerationHeaderTable . ' as HeaderTable', function ($join) {
                $join->on('HeaderTable.ID', '=', config('constants.CentralizedRemunerationLineTableShiftWise') . '.Document No_');
            })
            ->orderBy('Document No_', 'Desc')
            ->where(['Document No_' => $document_id, 'Line No_' => $line_id])
            ->first();
        return $ExamsList;
    }
}



if (!function_exists('getCenterNamesaddress')) {
    function getCenterNamesaddress($center = '')
    {
        $centerNos = $center ?? Session::get('centers');
        $ExamType =  Session::get('examType');
        $ObserverID =  Session::get('ObserverID');
        $ExamProfile = config('constants.ExamProfile');

        if (isset($centerNos) && !empty($centerNos)) {
            $centerStrings = is_array($centerNos) ? "'" . join(',', $centerNos) . "'" : $centerNos;
            $centerLists = DB::select("exec getCommonDataSP :select, :input, :table", [
                'select' => "TC_NAME,Centre_Address",
                'input' => "WHERE ObserverID='$ObserverID' and ExamType='$ExamType' and CENTNO in ($centerStrings)",
                'table' => "[$ExamProfile]"
            ]);
        } else {
            // Handle case where $centerNos is empty or not set
            $centerLists = collect(); // Use an empty collection
        }
        // prd($centerLists);
        $centerAddressNameString = '';

        foreach ($centerLists as $index => $center) {
            // Construct Centre_Name_Address for each item
            $centreNameAddress = ($index + 1) . '.' . (($center->TC_NAME) ? $center->TC_NAME . ', ' : '') . $center->Centre_Address;
            // Append to the string
            $centerAddressNameString .= $centreNameAddress;
            // Add a comma and space between items, except after the last one
            if ($index < count($centerLists) - 1) {
                $centerAddressNameString .= ', ';
            }
        }

        // Debugging to see the result
        return $centerAddressNameString;
    }




    if (!function_exists('getUserProfileDataByNTAID')) {
        function getUserProfileDataByNTAID($ObserverID = null)
        {
            $ExamProfile = config('constants.ExamProfile');
            $centerLists = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                'select' => "Name",
                'input' => "WHERE ObserverID='$ObserverID'",
                'table' => "[$ExamProfile]"
            ]);
            return $centerLists;
        }
    }

    function getAllChargesLists($getExamType)
    {
        $sourceCodeOffline = array(
            'ZONAL COORDINATOR',
            'CITY COORDINATOR',
            'REGIONAL COORDINATOR',
            'CENTRE SUPERITENDENT',
            'OBSERVER OUTSTATION',
            'OBSERVER LOCAL',
            'DEPUTY OBSERVER',
            'ADMIN. STAFF/CLERK',
            'CONFID. MATERIAL',
            'CONTINGENT CHARGES',
            'CONVEYANCE OMR',
            'INFRASTRUCTURE COST',
            'VIDEOGRAPHER',
            'PURCHASE WALLCLOCK',
            'SUPPORTING STAFF',
            'WATERBOY',
            'POSTAL CHARGES',
            'REFRESHMENT CHARGES',
            'DEPUTY CENTRE SUPER.',
            'ROOM INVIGILATOR',
            'PHOTOGRAPHER'
        );

        // $examType =  session('examType');
        $examType =  $getExamType ?? session('examType');

        $placeholders = "'" . implode("','", $sourceCodeOffline) . "'";
        //  echo '<pre>'; print_r($placeholders); die;
        $MasterTbl = config('constants.masterTbl');
        $RemDataLineTbl = config('constants.RemDataLineTbl');
        // $MasterDataList =DB::select("SELECT b.* FROM [$MasterTbl] a left join [$RemDataLineTbl] b on a.ID = b.[Document No_]  WHERE a.[Exam Type] = '$examType' and b.[Source Code] IN ($placeholders) ");

        $MasterDataList = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => " b.*",
            'input' => " join [$RemDataLineTbl] b on a.ID = b.[Document No_]
                            WHERE a.[Exam Type] = '$examType' and b.[Source Code] IN ($placeholders) ",
            'table' => "[$MasterTbl] a",
        ]);

        if (!empty($MasterDataList)) {
            $MasterDataListArray = array_map(function ($item) {
                return (array) $item;
            }, $MasterDataList);
        }

        $RemonrationData = array();
        if (isset($MasterDataListArray) && !empty($MasterDataListArray)) {
            foreach ($MasterDataListArray as $MasterData) {
                $RemonrationData[$MasterData['Source Code']] = $MasterData;
            }
        }

        return $RemonrationData;
    }

    function getVendorDetails()
    {

        $Unique_Admin_ID = Auth::user()->UserName;
        $VendorBankTbl = config('constants.VendorBankTbl');
        $VendorPanTbl = config('constants.VendorPanTbl');
        $VendorContactTbl = config('constants.VendorContactTbl');

        $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => "v1.[E-mail] Email,v3.[Profile Image] ProfileImage,v1.Name FullName,v1.No_,v1.Address,v1.[Mobile Phone No_] MobileNo,v2.[P_A_N_ No_] as PAN,v3.Branch,v3.[Vendor Account No_] as AccountNumber,v3.[IFSC Code] as IFSC, v3.[Bank Name] BankName, v3.[PAN Image Path] as PANImage, v3.[Cancelled Cheque Path] CancelledChequePath, v3.[Vendor D_O_B] DOB",
            'input' => " join [$VendorPanTbl] v2 on  v2.No_ = v1.No_
                            join [$VendorBankTbl] v3 on  v3.No_ = v1.No_
                            WHERE v1.No_='$Unique_Admin_ID'",
            'table' => "[$VendorContactTbl] v1",
        ]);


        if (isset($UserData) && !empty($UserData)) {
            return (object)$UserData;
        }

        return false;
    }

    if (!function_exists('getVendorDetailsNew')) {
        function getVendorDetailsNew($perPage = null, $searchData = null)
        {
            $venderTableName = config('constants.VendorContactTbl');
            $vendorList = DB::table($venderTableName)
                ->select('Name', 'E-Mail', 'Mobile Phone No_', 'No_')
                ->orderBy('No_', 'DESC');
            if (!empty($searchData)) {
                $vendorList->where('Name', 'like', '%' . $searchData . '%');
                $vendorList->orwhere('No_', 'like', '%' . $searchData . '%');
                $vendorList->orwhere('E-Mail', 'like', '%' . $searchData . '%');
                $vendorList->orwhere('Mobile Phone No_', 'like', '%' . $searchData . '%');
            }
            return $vendorList->paginate($perPage);
        }
    }

    function getCurrentUserDataById()
    {

        $Unique_Admin_ID = Auth::user()->UserName;
        $VendorBankTbl = config('constants.VendorBankTbl');
        $VendorPanTbl = config('constants.VendorPanTbl');
        $VendorContactTbl = config('constants.VendorContactTbl');

        $UserData = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => "v1.[E-mail] Email,v3.[Profile Image] ProfileImage,v1.Name FullName,v1.No_,v1.Address,v1.[Mobile Phone No_] MobileNo,v2.[P_A_N_ No_] as PAN,v3.Branch,v3.[Vendor Account No_] as AccountNumber,v3.[IFSC Code] as IFSC, v3.[Bank Name] BankName, v3.[PAN Image Path] as PANImage, v3.[Cancelled Cheque Path] CancelledChequePath, v3.[Vendor D_O_B] DOB",
            'input' => " join [$VendorPanTbl] v2 on  v2.No_ = v1.No_
                            join [$VendorBankTbl] v3 on  v3.No_ = v1.No_
                            WHERE v1.No_='$Unique_Admin_ID'",
            'table' => "[$VendorContactTbl] v1",
        ]);


        if (isset($UserData) && !empty($UserData)) {
            return (object)$UserData;
        }

        return false;
    }

    // app/Helpers/encryptionHelper.php

    if (!function_exists('encrypt')) {
        function encrypt($plainText, $encryptionKey)
        {
            $method = 'AES-256-CBC';
            $secretKey = hextobin(md5($encryptionKey));
            $initVector = pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
            $encryptedText = openssl_encrypt($plainText, $method, $secretKey, OPENSSL_RAW_DATA, $initVector);
            $encryptedText = bin2hex($encryptedText);
            return $encryptedText;
        }
    }

    if (!function_exists('decrypt')) {
        function decrypt($encryptedText, $encryptionKey)
        {
            $method = 'AES-256-CBC';
            $secretKey = hextobin(md5($encryptionKey));
            $initVector = pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
            $encryptedText = hextobin($encryptedText);
            $decryptedText = openssl_decrypt($encryptedText, $method, $secretKey, OPENSSL_RAW_DATA, $initVector);
            return $decryptedText;
        }
    }

    if (!function_exists('hextobin')) {
        function hextobin($hexString)
        {
            $length = strlen($hexString);
            $binString = "";
            $count = 0;
            while ($count < $length) {
                $subString = substr($hexString, $count, 2);
                $packedString = pack("H*", $subString);
                if ($count == 0) {
                    $binString = $packedString;
                } else {
                    $binString .= $packedString;
                }

                $count += 2;
            }
            return $binString;
        }
    }

    // Get all the advance payment data
    if (!function_exists('getAllAdvanceAmountData')) {
        function getAllAdvanceAmountData($perPage = null, $search = null)
        {
            $Table = config('constants.AdvanceTable');

            // Start the query builder
            $query = DB::table($Table)
                ->select('Advance No_', 'NTA Observer ID', 'Observer Name', 'Advance Amount', 'Exam Type');

            // If $search is provided, apply the WHERE LIKE clause to all selected columns
            if (!empty($search)) {
                $query->where(function ($query) use ($search) {
                    $query->where('NTA Observer ID', 'LIKE', '%' . $search . '%')
                        ->orWhere('Observer Name', 'LIKE', '%' . $search . '%')
                        ->orWhere('Advance Amount', 'LIKE', '%' . $search . '%')
                        ->orWhere('Exam Type', 'LIKE', '%' . $search . '%');
                });
            }

            // Apply pagination
            $advanceData = $query->paginate($perPage);

            return $advanceData;
        }
    }

    if (!function_exists('getFormFieldData')) {
        function getFormFieldData($perPage = null, $examType = null)
        {
            $forFields = config('constants.CentralizedFormFields');
            $query = DB::table($forFields)
                ->select('examType', 'Role', 'fieldName', 'fieldLabel', 'displayOrder', 'isRequired', 'fieldType', 'maxLength', 'minLength', 'readonly', 'isActive', 'ID')
                ->orderBy('ID', 'DESC');
            if (!empty($examType)) {
                $query->where('examType', $examType);
            }

            $formField = $query->paginate($perPage);
            return $formField;
        }
    }


    // Get all the advance payment data
    if (!function_exists('getCandidateWiseCountData')) {
        function getCandidateWiseCountData($perPage = null, $search = null)
        {
            $Table = config('constants.CandidateCountTable');

            // Start the query builder
            $query = DB::table($Table)
                ->select('*');

            // If $search is provided, apply the WHERE LIKE clause to all selected columns
            if (!empty($search)) {
                $query->where(function ($query) use ($search) {
                    $query->where('CenterNo', 'LIKE', '%' . $search . '%')
                        ->orWhere('Exam Type', 'LIKE', '%' . $search . '%')
                        ->orWhere('Max Count Exam', 'LIKE', '%' . $search . '%')
                        ->orWhere('Total Candidate Count in Exam', 'LIKE', '%' . $search . '%');
                });
            }

            // Apply pagination
            $advanceData = $query->paginate($perPage);

            return $advanceData;
        }
    }

    if (!function_exists('commonmail')) {
        function commonmail($mailTo, $OTP, $Name)
        {
            $post_data =  array(
                'APP-ID' => 'ZNLPVM0GxX7ztf86hkO1nYBeyDlb2RqW',
                'SECRET-KEY' => 'ldrGLCw1pSt7P3EmQANzHIUWDe5Jsg8f',
                'TEMPLATE_UID' => '66b33d5d779e4',
                'SENDER_UID' => '66b33d0349a39',
                'TO' => "$mailTo", //'xxxx@abcd.com',
                'PARAMS' => '{"CNAME":"' . $Name . '","COTP":"' . $OTP . '"}',
            );
            $curl = curl_init();

            curl_setopt($curl, CURLOPT_URL, 'https://helloip.co/api/data/');
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);

            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

            $result = curl_exec($curl);
            if (!$result) {
                die("Connection Failure");
            }
            curl_close($curl);

            $result = json_decode($result);
            return $result;
        }
    }
    if (!function_exists('getExamNameByExamType')) {
        function getExamNameByExamType($examType)
        {
            $ExamDatesTableName = config('constants.ExamDates');
            $ExamsDateList = DB::table($ExamDatesTableName)
                ->where('Exam Type', $examType)
                ->value('Exam Name');
            return $ExamsDateList;
        }
    }
    if (!function_exists('getExamRole')) {
        function getExamRole($examType, $ObserverID)
        {
            $ExamProfileTableName = config('constants.ExamProfile');
            $role = DB::table($ExamProfileTableName)
                ->where('ExamType', $examType)
                ->where('ObserverID', $ObserverID)
                ->value('Observer Type');
            return $role;
        }
    }
    if (!function_exists('getUserDetailsByNTAID')) {
        function getUserDetailsByNTAID($ObserverID = null)
        {
            $VendorContactTbl = config('constants.VendorContactTbl');
            $centerLists = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                'select' => "Name name,[E-Mail] email,[Mobile Phone No_] mobile",
                'input' => "WHERE [No_]='$ObserverID'",
                'table' => "[$VendorContactTbl]"
            ]);
            return $centerLists;
        }
    }

    if (!function_exists('resetPasswordMail__')) {
        function resetPasswordMail__($mailTo, $OTP, $Name)
        {
            $test = 'Test Project';
            $post_data =  array(
                'APP-ID' => 'ZNLPVM0GxX7ztf86hkO1nYBeyDlb2RqW',
                'SECRET-KEY' => 'ldrGLCw1pSt7P3EmQANzHIUWDe5Jsg8f',
                'TEMPLATE_UID' => '66bb247747867',
                'SENDER_UID' => '66b33d0349a39',
                'TO' => "$mailTo", //'xxxx@abcd.com',
                'PARAMS' => '{"CANDIDATENAME":"' . $Name . '","PROJECTNAME":"' . $test . '","LINK":"' . $OTP . '"}',
            );
            $curl = curl_init();

            curl_setopt($curl, CURLOPT_URL, 'https://helloip.co/api/data/');
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);

            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

            $result = curl_exec($curl);
            if (!$result) {
                die("Connection Failure");
            }
            curl_close($curl);

            $result = json_decode($result);
            return $result;
        }
    }


    if (!function_exists('resetPasswordMail')) {
        function resetPasswordMail($mailTo, $TEMPLATE_UID, $PARAMS, $DOCUMENT = null, $BCC = null)
        {

            if (isset($mailTo, $TEMPLATE_UID, $PARAMS) && !empty($mailTo) && !empty($TEMPLATE_UID) && !empty($PARAMS)) {
                $PostParams = json_encode($PARAMS);
                $post_data =  array(
                    'APP-ID' => 'ZNLPVM0GxX7ztf86hkO1nYBeyDlb2RqW',
                    'SECRET-KEY' => 'ldrGLCw1pSt7P3EmQANzHIUWDe5Jsg8f',
                    'TEMPLATE_UID' => $TEMPLATE_UID,
                    'SENDER_UID' => '66b33d0349a39',
                    'TO' => $mailTo,
                    'PARAMS' => $PostParams,
                );

                //    if(isset($DOCUMENT) && !empty($DOCUMENT)){
                //         $post_data['DOCUMENT'] = $DOCUMENT;
                //    }
                //         if(isset($BCC) && !empty($BCC)){
                //             $post_data['BCC'] = $BCC;
                //     }


                $curl = curl_init();
                curl_setopt($curl, CURLOPT_URL, 'https://helloip.co/api/data/');
                curl_setopt($curl, CURLOPT_POST, 1);
                curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
                $result = curl_exec($curl);
                if (!$result) {
                    die("Connection Failure");
                }
                curl_close($curl);
                $resultArr = json_decode($result);
                return $resultArr;
            } else {
                $resultErr = '{"status":0,"message":"error"}';
                $resultArr = json_decode($resultErr);
                return $resultArr;
            }
        }
    }

    if (!function_exists('getCommonSettingsData')) {
        function getCommonSettingsData($perPage = null, $search = null)
        {
            $Table = config('constants.CommonSettingTbl');

            // Start the query builder
            $query = DB::table($Table)
                ->select('*');

            // If $search is provided, apply the WHERE LIKE clause to all selected columns
            if (!empty($search)) {
                $query->where(function ($query) use ($search) {
                    $query->where('travel_allowance', 'LIKE', '%' . $search . '%')
                        ->orWhere('Exam_Type', 'LIKE', '%' . $search . '%')
                        ->orWhere('hotel_allowance', 'LIKE', '%' . $search . '%')
                        ->orWhere('role', 'LIKE', '%' . $search . '%');
                });
            }

            // Apply pagination
            $advanceData = $query->paginate($perPage);

            return $advanceData;
        }
    }

    if (!function_exists('_getCommonSettingsData')) {
        function _getCommonSettingsData($ExamType = null, $role = null)
        {
            $Table = config('constants.CommonSettingTbl');
    
            $query = DB::table($Table);
            if (!empty($ExamType)) {
                $query->where('Exam_Type', $ExamType);
            }
            if (!empty($role)) {
                $query->where('role', $role);
            }
            
            // $advanceData = $query->first();
            $advanceData = $query->orderBy('id', 'desc')->first();
            return $advanceData;
        }
    }


    if (!function_exists('_getCommonSettingsDataLastNotBlank')) {
        function _getCommonSettingsDataLastNotBlank($ExamType = null, $role = null)
        {
            $Table = config('constants.CommonSettingTbl');
            $query = DB::table($Table);
            $query->whereRaw("CAST(instructions_texts AS NVARCHAR(MAX)) != ''");
            $advanceData = $query->orderBy('id', 'desc')->first();
            return $advanceData;
        }
    }



    
    
}
