<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use DB;
use Auth;
use Redirect;
use Config;

class DashboardController extends Controller
{
    public function __construct()
    {
        $this->middleware(function ($request, $next) {
            if (auth()->guest()) {
                return redirect()->route('home');
            }
    
            return $next($request);
        });
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {    

        Session::forget(['centers', 'role', 'examType', 'examName', 'type']); // Session destroy

        $username = Auth::user()->UserName; 
        $ExamProfile = config('constants.ExamProfile'); 
        $ExamDates = config('constants.ExamDates'); 
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable'); 
        $AllocatedExamByUser = getUserExamsList();  
        $setExams =  $AllocatedExamByUser[1] ?? [];
        return view('dashboard.dashboard',['ExamName'=> $AllocatedExamByUser,'setExams'=>$setExams]);      
        
    }

    public function myProfile()
    {   
        try{         
        return view('dashboard.my-profile');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error',$message);
        }
    }
    public function ExamDashboard(Request $request)
    {   

        try{    
            $ExamDates = config('constants.ExamDates');
            $OBSProfile = config('constants.ExamProfile');
            if($request->isMethod('post'))
            {
                $data = $request->all();
                $ID = Auth::user()->UserName;
                
                $getExamDetails = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                      'select' => "[$OBSProfile].[Observer Type],[$ExamDates].[Exam Name],[$OBSProfile].[Name],[$ExamDates].[mockval]",
                      'input' => "left join [$ExamDates] on [$ExamDates].[Exam Type] = [$OBSProfile].ExamType  WHERE [$OBSProfile].[ExamType]='$data[ExamType]' and [$OBSProfile].ObserverID='$ID'",
                      'table' =>"[$OBSProfile]"
                    ]);
                if (isset($getExamDetails) && !empty($getExamDetails)) {
                    $role = $getExamDetails->{'Observer Type'};
                    $examName = $getExamDetails->{'Exam Name'};
                    $Name = $getExamDetails->{'Name'};
                    $DayWiseExam = $getExamDetails->{'mockval'};
                }
                
                $getCenterList = DB::select("exec getCommonDataSP :select, :input, :table", [
                    'select' => "[$OBSProfile].[CENTNO]",
                    'input' => "WHERE [$OBSProfile].[ExamType]='$data[ExamType]' and [$OBSProfile].ObserverID='$ID'",
                    'table' =>"[$OBSProfile]"
                ]);
                $centers= array_column($getCenterList,'CENTNO');    


                $request->session()->put('centers',array_unique($centers));
                $request->session()->put('role',$role);
                $request->session()->put('examType',$data['ExamType']);
                $request->session()->put('examName',$examName);
                $request->session()->put('ObserverID',$ID);
                $request->session()->put('email',Auth::user()->Email);
                $request->session()->put('Name',$Name);
                $request->session()->put('DayWiseExam',$DayWiseExam);

                return  view('dashboard.exam-dashboard');
            }
            else{
                return  view('dashboard.exam-dashboard');
            }
        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error',$message); 
        }
    
    }

    public function ExamSubDashboard(Request $request)
    {   
        try{    
            $ExamDates = config('constants.ExamDates');
            $OBSProfile = config('constants.ExamProfile');
            if($request->isMethod('post'))
            {     
                $request->session()->put('type',$request->input('type'));           
                return view('dashboard.exam-subdashboard', ['type'=>Session::get('type')]);
            }else{      
                if(Session::has('type')) 
                {
                    return view('dashboard.exam-subdashboard',  ['type'=>Session::get('type')]);   
                }else{
                    return redirect()->route('dashboard');
                }
            }
                } catch (\Exception $e) {
                    $message = $e->getMessage();
                    dd($message);
                    return redirect()->back()->with('error',$message);
                }

    }
    public function switchExam(Request $request)
    {   
        $ExamDates = config('constants.ExamDates');
        $OBSProfile = config('constants.ExamProfile');
        if($request->isMethod('post'))
        {
          $data = $request->all();
                $ID = Auth::user()->UserName;
                
                $getExamDetails = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                      'select' => "[$OBSProfile].[Observer Type],[$ExamDates].[Exam Name],[$OBSProfile].[Name],[$ExamDates].[mockval]",
                      'input' => "left join [$ExamDates] on [$ExamDates].[Exam Type] = [$OBSProfile].ExamType  WHERE [$OBSProfile].[ExamType]='$data[ExamType]' and [$OBSProfile].ObserverID='$ID'",
                      'table' =>"[$OBSProfile]"
                    ]);
                if (isset($getExamDetails) && !empty($getExamDetails)) {
                    $role = $getExamDetails->{'Observer Type'};
                    $examName = $getExamDetails->{'Exam Name'};
                    $Name = $getExamDetails->{'Name'};
                    $DayWiseExam = $getExamDetails->{'mockval'};
                }
                
                $getCenterList = DB::select("exec getCommonDataSP :select, :input, :table", [
                    'select' => "[$OBSProfile].[CENTNO]",
                    'input' => "WHERE [$OBSProfile].[ExamType]='$data[ExamType]' and [$OBSProfile].ObserverID='$ID'",
                    'table' =>"[$OBSProfile]"
                ]);
                $centers= array_column($getCenterList,'CENTNO');    


                $request->session()->put('centers',array_unique($centers));
                $request->session()->put('role',$role);
                $request->session()->put('examType',$data['ExamType']);
                $request->session()->put('examName',$examName);
                $request->session()->put('ObserverID',$ID);
                $request->session()->put('email',Auth::user()->Email);
                $request->session()->put('Name',$Name);
                $request->session()->put('DayWiseExam',$DayWiseExam);
                return redirect(url()->previous());
        }
    }
    
}
