<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use Auth;
use Illuminate\Pagination\LengthAwarePaginator;
use App\Exports\CityCoordinatorReportsExport;
use App\Exports\ObserverReportsExport;
use App\Exports\CSReportsExport;
use Maatwebsite\Excel\Facades\Excel;
use Illuminate\Support\Collection;
use App\Services\MasterServices;


class ReportController extends Controller
{

    public function cityCoordinatorReport(Request $request, $excel = NULL, $billDate = NULL)
    {
        try {
            $ObserverID = Auth::user()->UserName;
            $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');
            $whrTaBill = '';
            

            if ($request->input('Reset')) {
                $billDate = '';
            } else {
                $billDate = $request->input('billDate') ?? $billDate;
            }

            //echo  $excel;die;
            if (!empty($billDate)) {
                $dateFormat = date('Y-m-d', strtotime($billDate));
                $whrTaBill .= " AND CAST(cc.[Created On] AS DATE) = '$dateFormat'";
            }
            // echo  $whrTaBill;die;
            $CityCoordinatorsObj = DB::select("exec getCommonDataSP :select, :input, :table , :orderBy", [
                ':select' => '*',
                ':input' => "WHERE [Observer ID] = '{$ObserverID}' AND 1=1 $whrTaBill",
                ':table' => "[$CityCoordinatorOfflineTbl] as cc",
                ':orderBy' => 'order by cc.[Created On] DESC'
            ]);

           // prd($CityCoordinatorsObj);

            if (isset($excel) && !empty($excel) && $excel == 'excel') {
            MasterServices::customlog('Excel Report Download', 'User Download Excel Report.');
                if (!empty($CityCoordinatorsObj)) {
                    $CCArray = array_map(function ($item) {
                        return (array) $item;
                    }, $CityCoordinatorsObj);
                }
                if (isset($CCArray) && !empty($CCArray)) {
                    foreach ($CCArray as $key => $excelval) {

                        if ($excelval['Bill Status'] == 0) {
                            $Billstatus = 'Submitted';
                        } elseif ($excelval['Bill Status'] == 1) {
                            $Billstatus = 'In Process';
                        } elseif ($excelval['Bill Status'] == 3) {
                            $Billstatus = 'Rejected';
                        } elseif ($excelval['Bill Status'] == 5) {
                            $Billstatus = 'Settled';
                        } else {
                            $Billstatus = 'NA';
                        }

                        $remark = '-';
                        if($excelval['Bill Status'] == 3 && isset($excelval['Rejection Remark']) && !empty($excelval['Rejection Remark'])){
                            $remark = $excelval['Rejection Remark'];
                        }elseif($excelval['Bill Status'] == 5 && isset($excelval['Remark']) && !empty($excelval['Remark'])){
                            $remark = $excelval['Remark'];
                        }

                        $CCdataArray[] = [
                           $excelval['Reference No_'],
                           $excelval['CenterNo'],
                           $excelval['Center City'],
                           $excelval['Exam Name'],
                           $excelval['Net Amount Payable'],
                           isset($excelval['Created On']) ? date('d-m-Y', strtotime($excelval['Created On'])) : null,
                           $Billstatus,
                           $remark,
                        ];
                    }

                    $dataCollection = new Collection($CCdataArray);
                    $export = new CityCoordinatorReportsExport($dataCollection);
                    return Excel::download(new CityCoordinatorReportsExport($dataCollection), 'CCreports.xlsx');
                }
            }

            //Pagination Start
            $page = $request->input('page', 1);
            $perPage = $request->input('per_page',10);
            $collection = Collection::make($CityCoordinatorsObj);
           if( $perPage== 'all'){
            $currentPageItems = $collection->values();
           }else{
            $perPage = (int) $perPage;
            $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
           }

            $paginator = new LengthAwarePaginator(
                $currentPageItems,
                $collection->count(),
                $perPage == 'all' ? $collection->count() : $perPage,
                $page,
                ['path' => $request->url(), 'query' => $request->query()]
            );
            //Pagination end
            return view('report.city-coordinator-report', ['CityCoordinators' => $paginator]);
        } catch (\Exception $e) {
            $message = "Error: " . $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }
    }


    public function observerReport(Request $request, $excel = NULL)
    {

        try {

            $TATBL = config('constants.TABillHeaderTbl');
            $ExamProfile = config('constants.ExamProfile');
            $ID = Auth::user()->UserName;

            $getCenterList = DB::select("exec getCommonDataSP :select, :input, :table", [
                ':select' => 'CENTNO',
                ':input' => "WHERE [ObserverID] = '{$ID}'",
                ':table' => "[$ExamProfile]"
            ]);


            $CENTNO = array_column($getCenterList, 'CENTNO');

            $CENTNOArray = array_map(function ($item) {
                return "'" . $item . "'";
            }, $CENTNO);

            $CENTNOSTR = implode(',', $CENTNOArray);

            $observerList = DB::select("exec getCommonDataSP :select, :input, :table", [
                ':select' => 'DISTINCT(ObserverID), Name',
                ':input' => "Where CENTNO IN ($CENTNOSTR) AND [Observer Type] IN ('5', '2')",
                ':table' => "[$ExamProfile]"
            ]);

            $ObserverID = array_column($observerList, 'ObserverID');
            $Name = array_column($observerList, 'Name');

            $observers = array_combine($ObserverID, array_map(function ($Name, $ObserverID) {
                return $Name . ' - ' . $ObserverID;
            }, $Name, $ObserverID));

            $whrTaBill = '';

            if ($request->input('Reset')) {
                $billDate = '';
                $examName = '';
                $obName = '';
            } else {
                $billDate = $request->input('billDate') ?? '';
                $examName = $request->input('examName') ?? '';
                $obName = $request->input('obName') ?? '';
            }

            /*--------------- Paginate and Get  Data ---------------*/

            if (!empty($billDate)) {
                $dateFormat = date('Y-m-d', strtotime($billDate));
                $whrTaBill .= " AND CAST([CreatedDate] AS DATE) = '$dateFormat'";
            }
            if (!empty($examName)) {
                $whrTaBill .= " AND e.[Exam Type Id] = '$examName'";
            }
            if (!empty($obName)) {
                $whrTaBill .= " AND [Observer ID] = '{$obName}'";
            }

            $ObserverType = $request->session()->get('role');

            $ConditionaryObservers = null;
            if ($ObserverType == 1) {
                //$ConditionaryObservers = is_array($ObserverID) ? $ObserverID : [$ObserverID];
                $ObserversArr = array_map(function ($item) {
                    return "'" . $item . "'";
                }, $ObserverID);
                $ConditionaryObservers = implode(',', $ObserversArr);
            } else {
                $ConditionaryObservers =  "'" . $ID . "'";
            }

            $inputCondition = "WHERE [Observer ID] IN ($ConditionaryObservers) $whrTaBill";
           
            $obsReportArr = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
                'select' => '*',
                'input' => $inputCondition,
                'table' => "[$TATBL]",
                'orderBy' => "order by CreatedDate DESC"
            ]);
            
            if (isset($excel) && !empty($excel) && $excel == 'excel') {
            MasterServices::customlog('Excel Report Download', 'User Download Excel Report.');
                if (!empty($obsReportArr)) {
                    $OBSArray = array_map(function ($item) {
                        return (array) $item;
                    }, $obsReportArr);
                }
                if (isset($OBSArray) && !empty($OBSArray)) {
                    foreach ($OBSArray as $key => $excelval) {

                        if ($excelval['Bill Status'] == 0) {
                            $Billstatus = 'Submitted';
                        } elseif ($excelval['Bill Status'] == 1) {
                            $Billstatus = 'In Process';
                        } elseif ($excelval['Bill Status'] == 3) {
                            $Billstatus = 'Rejected';
                        }elseif($excelval['Bill Status'] == 5){
                            $Billstatus = 'Settled';
                        } else {
                            $Billstatus = 'NA';
                        }
                        $remark = '-';
                        if($excelval['Bill Status'] == 3 && isset($excelval['Rejection Remark']) && !empty($excelval['Rejection Remark'])){
                            $remark = $excelval['Rejection Remark'];
                        }elseif($excelval['Bill Status'] == 5 && isset($excelval['Remark']) && !empty($excelval['Remark'])){
                            $remark = $excelval['Remark'];
                        }
                        $observerName = (array)getUserProfileDataByNTAID($excelval['Observer ID']);

                        $OBSdataArray[] = [
                            $excelval['Reference No_'],
                            $excelval['Exam Name'],
                            $observerName['Name'],
                            $excelval['Centre No_'],
                            $excelval['Net Payable Amount'],
                            isset($excelval['CreatedDate']) ? date('d-m-Y', strtotime($excelval['CreatedDate'])) : null,
                            $Billstatus,
                            $remark
                        ];
                    }

                    //prd($dataArray);
                    $dataCollection = new Collection($OBSdataArray);
                    $export = new ObserverReportsExport($dataCollection);
                    return Excel::download(new ObserverReportsExport($dataCollection), 'OBSreports.xlsx');
                }
            }
            //Pagination Start
            $page = $request->input('page', 1);// Get the current page, default to 1
            $perPage = $request->input('per_page',10);// Default to 10 items per page
            $collection = Collection::make($obsReportArr);
            if( $perPage== 'all'){
                $currentPageItems = $collection->values();
             }else{
                $perPage = (int) $perPage;
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
            }

            $paginator = new LengthAwarePaginator(
                $currentPageItems,
                $collection->count(),
                $perPage == 'all' ? $collection->count() : $perPage,
                $page,
                ['path' => $request->url(), 'query' => $request->query()]
            );
            //Pagination end

            return view('report.observer-report', [
                'Observers' => $paginator,
                'obsFilter' => $observers
            ]);
        } catch (\Exception $e) {
            $message = "Error: " . $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }
    }

    public function CSReport(Request $request, $excel = NULL, $billDate = NULL)
    {
        try {

            $CentreBillTbl = config('constants.CentreBillTbl');
            $ObserverID = Auth::user()->UserName;
            $whrTaBill = '';

            if ($request->input('Reset')) {
                $billDate = '';
            } else {
                $billDate = $request->input('billDate') ?? '';
            }
            if (!empty($billDate)) {
                $dateFormat = date('Y-m-d', strtotime($billDate));
                //$whrTaBill .= " AND cb.[Created on] = '$dateFormat'";
                $whrTaBill .= " AND CAST(cb.[Created On] AS DATE) = '$dateFormat'";
            }

            $CSReport = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
                'select' => '*',
                'input' => "WHERE [Observer ID] = '{$ObserverID}' AND 1=1 $whrTaBill",
                'table' => "[$CentreBillTbl] as cb",
                'orderBy' => 'order by cb.[Created On] DESC'
            ]);
            //prd($CSReport);

            if (isset($excel) && !empty($excel) && $excel == 'excel') {

                MasterServices::customlog('Excel Report Download', 'User Download Excel Report.');

                if (!empty($CSReport)) {
                    $CSArray = array_map(function ($item) {
                        return (array) $item;
                    }, $CSReport);
                }
                if (isset($CSArray) && !empty($CSArray)) {
                    foreach ($CSArray as $key => $excelval) {

                        if ($excelval['Bill Status'] == 0) {
                            $Billstatus = 'Submitted';
                        } elseif ($excelval['Bill Status'] == 1) {
                            $Billstatus = 'In Process';
                        } elseif ($excelval['Bill Status'] == 3) {
                            $Billstatus = 'Rejected';
                        } elseif ($excelval['Bill Status'] == 5) {
                            $Billstatus = 'Settled';
                        } else {
                            $Billstatus = 'NA';
                        }

                        $remark = '-';
                        if($excelval['Bill Status'] == 3 && isset($excelval['Rejection Remark']) && !empty($excelval['Rejection Remark'])){
                            $remark = $excelval['Rejection Remark'];
                        }elseif($excelval['Bill Status'] == 5 && isset($excelval['Remark']) && !empty($excelval['Remark'])){
                            $remark = $excelval['Remark'];
                        }

                        $CSdataArray[] = [
                            $excelval['Reference No_'],
                            $excelval['CenterNo'],
                            $excelval['Center City'],
                            $excelval['Exam Name'],
                            $excelval['Net Amount Payable'],
                            isset($excelval['Created on']) ? date('d-m-Y', strtotime($excelval['Created on'])) : 'NA',
                            $Billstatus,
                            $remark ?? '',
                        ];
                    }

                    $dataCollection = new Collection($CSdataArray);
                    $export = new CSReportsExport($dataCollection);
                    return Excel::download(new CSReportsExport($dataCollection), 'CSreports.xlsx');
                }
            }

            //Pagination Start
            $page = $request->input('page', 1);// Get the current page, default to 1
            $perPage = $request->input('per_page',10);// Default to 10 items per page
            $collection = Collection::make($CSReport);
            if( $perPage== 'all'){
                $currentPageItems = $collection->values();
             }else{
                $perPage = (int) $perPage;
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
            }
    
            $paginator = new LengthAwarePaginator(
                $currentPageItems,
                $collection->count(),
                $perPage == 'all' ? $collection->count() : $perPage,
                $page,
                ['path' => $request->url(), 'query' => $request->query()]
            );
            //Pagination end
            return view('report.cs-report', ['CSReports' => $paginator]);
        } catch (\Exception $e) {
            $message = "Error: " . $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }
    }
}
