<?php

namespace App\Http\Controllers;

use Auth;
use App\Traits\CommonBillData;
use Illuminate\Support\Facades\DB;
use App\Services\MasterServices;

use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Support\Collection;
use Illuminate\Http\Request;

class SubmitBillReportController extends Controller
{
    use CommonBillData;

    public function index(Request $request)
    {
        // try {

            $observerID = Auth::user()->UserName;
            $examType = session('examType');
            $role = session('role');
            $CentreBillTbl = config('constants.CentreBillTbl');
            $TATBL = config('constants.TABillHeaderTbl');
            $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');

            $billsDetails = [];
            if (isset($role) && ($role == 1 || $role == 11 || $role == 12 || $role == 13)) {
                $whrBill = '';
                if (isset($_GET['bill_status']) && $_GET['bill_status'] != '') {
                    $whrBill .= " AND cc.[Bill Status] = '{$_GET['bill_status']}'";
                }

                $CCBillsOffline = DB::select("exec getCommonDataSP :select, :input, :table , :orderBy", [
                    ':select' => 'cc.[Observer ID] as ObserverID,
                    cc.[Center City] as centerCity,
                    cc.[Reference No_] as ReferenceNo,
                    cc.[Created on] as billDate,
                    cc.[Rejection Remark] as RejectionRemark,
                    cc.Remark,cc.[Exam Name] as examName,
                    cc.[Bill Status] as billStatus,
                    cc.[Net Amount Payable] as netAmountPayable,
                    cc.[Exam Type] as ExamType,
                    cc.CenterNo as CENTNO,
                    cc.IsNewBill',
                    ':input' => "WHERE cc.[Observer ID] = '{$observerID}' AND  cc.[Exam Type] = '{$examType}' AND 1=1 $whrBill",
                    ':table' => "[$CityCoordinatorOfflineTbl] as cc",
                    ':orderBy' => 'order by cc.[Created on] DESC'
                ]);

                //Pagination Start
                $page = $request->input('page', 1);
                $perPage = 10;
                $collection = Collection::make($CCBillsOffline);
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
                $paginator = new LengthAwarePaginator(
                    $currentPageItems,
                    $collection->count(),
                    $perPage,
                    $page,
                    ['path' => $request->url(), 'query' => $request->query()]
                );
                //Pagination end

                $billsDetails = $paginator;
            } else if (isset($role) && ($role == 14)) {
                $whrBillcs = '';
                if (isset($_GET['bill_status']) && $_GET['bill_status'] != '') {
                    $whrBillcs .= " AND cs.[Bill Status] = '{$_GET['bill_status']}'";
                }

                $CSBills = DB::select("exec getCommonDataSP :select, :input, :table , :orderBy", [
                    ':select' => 'cs.[Observer ID] as ObserverID,
                        cs.[Center City] as centerCity,
                        cs.[Reference No_] as ReferenceNo,
                        cs.[Created on] as billDate,
                        cs.[Rejection Remark] as RejectionRemark,
                        cs.Remark,
                        cs.[Exam Name] as examName,
                        cs.[Bill Status] as billStatus,
                        cs.[Net Amount Payable] as netAmountPayable,
                        cs.[Exam Type] as ExamType,
                        cs.CenterNo as CENTNO,
                        cs.IsNewBill',
                    ':input' => "WHERE cs.[Observer ID] = '{$observerID}' AND  cs.[Exam Type] = '{$examType}' AND 1=1 $whrBillcs",
                    ':table' => "[$CentreBillTbl] as cs",
                    ':orderBy' => 'order by cs.[Created on] DESC'
                ]);

                //Pagination Start
                $page = $request->input('page', 1);
                $perPage = 10;
                $collection = Collection::make($CSBills);
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
                $paginator = new LengthAwarePaginator(
                    $currentPageItems,
                    $collection->count(),
                    $perPage,
                    $page,
                    ['path' => $request->url(), 'query' => $request->query()]
                );
                //Pagination end
                $billsDetails = $paginator;
            } else if (isset($role) && ($role == 5 || $role == 2 || $role == 3 || $role == 7 || $role == 10)) {

                $whrBillobs = '';
                if (isset($_GET['bill_status']) && $_GET['bill_status'] != '') {
                    $whrBillobs .= " AND obs.[Bill Status] = '{$_GET['bill_status']}'";
                }
                $Observerbills = DB::select("exec getCommonDataSP :select, :input, :table , :orderBy", [
                    ':select' => 'obs.[Observer ID] as ObserverID,
                        obs.[Centre City] as centerCity,
                        obs.IsNewBill,
                        obs.[Reference No_] as ReferenceNo,
                        obs.[Posting Date] as billDate,
                        obs.[Rejection Remark] as RejectionRemark,
                        obs.Remark,
                        obs.[Exam Name] as examName,
                        obs.[Bill Status] as billStatus,
                        obs.[Net Payable Amount]  as netAmountPayable,
                        obs.[Net Payable After Deduction] as netAmountPayableAfterDeduction,
                        obs.[Net Payable Amount] as netPayableAmount,
                        obs.[Exam Code] as ExamType,
                        obs.[Centre No_] as CENTNO',
                    ':input' => "WHERE obs.[Observer ID] = '{$observerID}' AND  obs.[Exam Code] = '{$examType}' AND 1=1 $whrBillobs",
                    ':table' => "[$TATBL] as obs",
                    ':orderBy' => 'order by obs.[CreatedDate]'
                ]);

                //Pagination Start
                $page = $request->input('page', 1);
                $perPage = 10;
                $collection = Collection::make($Observerbills);
                $currentPageItems = $collection->slice(($page - 1) * $perPage, $perPage)->values();
                $paginator = new LengthAwarePaginator(
                    $currentPageItems,
                    $collection->count(),
                    $perPage,
                    $page,
                    ['path' => $request->url(), 'query' => $request->query()]
                );
                //Pagination end
                $billsDetails = $paginator;

            }
            return view('submitbillsreport.index', [
                'billsDetails' => $billsDetails,
                'role' => $role
            ]);
        // } catch (\Exception $e) {
        //     $message = $e->getMessage();
        //     dd($message);
        //     return redirect()->back()->with('error', $message);
        // }
    }


    public function getCSBillData()
    {
        MasterServices::customlog('Report Download', 'User Download/view PDF Report.');
        $CSData = $this->getCSuperBilldata();
        // prd($CSData);
        return view('submitbillsreport.csbill', $CSData);
    }
    public function getOfflineCCBillData()
    {
         MasterServices::customlog('Report Download', 'User Download/view PDF Report.');
        $CCData = $this->getCCBilldata();
        return view('submitbillsreport.cc-preview-bill', $CCData);
    }

    public function getObserverBillData()
    {
        MasterServices::customlog('Report Download', 'User Download/view PDF Report.');
        $OBSData = $this->getObsBillData();
        // prd($OBSData);
        return view('submitbillsreport.obs-preview-bill', $OBSData);
    }

    function getObsDobsData($ReferenceNo, $Type)
    {
        $ObserversDeputyObserversData = $this->getObsDobsDataList($ReferenceNo);

        $observers = [];
        $deputyObservers = [];
        if (!empty($ObserversDeputyObserversData)) {
            foreach ($ObserversDeputyObserversData as $item) {
                if ($item->Observer_Type == 5) {
                    $observers[] = $item; // Add to Observers array
                } else {
                    $deputyObservers[] = $item; // Add to Deputy Observers array
                }
            }
        }

        return view('submitbillsreport.observer-deputy-observer-data', [
            'observers' => $Type == 5 ? $observers : [],
            'deputyObservers' => $Type == 2 ? $deputyObservers : [],
        ]);

    }
}
