<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Auth;
use Session;

class AdminDashboardController extends Controller
{
    public function index()
    {
        $examMode = config('constants.Exam_Mode', []);
        return view('admin.dashboard', ['examMode' => $examMode]);
    }

    public function serachExamByExamMode(Request $request)
    {

        $examMode = $request->post('examMode');
        $examTable = config('constants.ExamDates', []);
        $exams = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
            'select' => '[Exam Type Id] as Exam_Type_Id,[Exam Name] as Exam_Name',
            'input' => "WHERE Exam_Mode =  '{$examMode}' AND Is_Active=1",
            'table' => "[$examTable]",
            'orderBy' => 'ORDER BY [Exam Name] ASC'
        ]);

        return response()->json([
            'success' => true,
            'data' => $exams,
        ]);
    }

    public function getTotalCountBill()
    {

        $data = [
            [
                "type" => "OBSERVER BILL",
                "status" => [
                    "open" => 10,
                    "processing" => 20,
                    "rejected" => 30,
                    "completed" => 40,
                    "totalbill" => 100,
                    "unsubmitted" => 5
                ]
            ],
            [
                "type" => "CENTRE SUPERINTENDENT BILL",
                "status" => [
                    "open" => 50,
                    "processing" => 60,
                    "rejected" => 70,
                    "completed" => 80,
                    "totalbill" => 100,
                    "unsubmitted" => 5
                ]
            ],
            [
                "type" => "CITY COORDINATOR BILL",
                "status" => [
                    "open" => 90,
                    "processing" => 100,
                    "rejected" => 110,
                    "completed" => 120,
                    "totalbill" => 100,
                    "unsubmitted" => 5
                ]
            ]
        ];

        return response()->json([
            'success' => true,
            'data' => $data,
        ]);
    }


    public function AdminLogout(Request $request)
    {
        Auth::logout();
        Session::flush();
        Session::regenerateToken();
        Session::invalidate();
        return redirect('/admin/login');
    }

    public function getAllBilldata()
    {

        // $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');
        // $ExamProfile = config('constants.ExamProfile');
        // $AllBilldata = DB::select(DB::raw("exec getCommonDataSP :select, :input, :table, :orderBy"), [
        //     'select' => '[Reference No_] as ReferenceNo,[Observer ID] as ObserverID,[Observer Name] as ObserverName,[Exam ID] as ExamID,[Bill Status] as BillStatus,Role,EX.Mobile,EX.Email',
        //     'input' => "INNER JOIN $ExamProfile as EX ON $ExamProfile.[ObserverID]=$CityCoordinatorOfflineTbl.[Observer ID] WHERE Active=1",
        //     'table' => "[$CityCoordinatorOfflineTbl] as CCTbl",
        //     'orderBy' => 'ORDER BY [Reference No_] DESC'
        // ]);
        // $jsonData = response()->json($AllBilldata);

        // return $jsonData;

        $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');
        $ExamProfile = config('constants.ExamProfile');
        // Validate configuration constants
        if (empty($CityCoordinatorOfflineTbl) || empty($ExamProfile)) {
            return response()->json(['error' => 'Configuration constants are missing or invalid'], 400);
        }

        // Escape table names for SQL Server
        $CityCoordinatorOfflineTbl = '[' . str_replace(['[', ']'], '', $CityCoordinatorOfflineTbl) . ']';
        $ExamProfile = '[' . str_replace(['[', ']'], '', $ExamProfile) . ']';

        try {
            $query = "
                    exec getCommonDataSP 
                    @select = :select, 
                    @input = :input, 
                    @table = :table, 
                    @orderBy = :orderBy
                ";

            $bindings = [
                'select' => " DISTINCT
            [Reference No_] as ReferenceNo, 
            [Observer ID] as ObserverID, 
            [Observer Name] as ObserverName, 
            [Exam ID] as ExamID, 
            CASE 
                WHEN [Bill Status] = 0 THEN 'Open'
                WHEN [Bill Status] = 1 THEN 'Paid'
                WHEN [Bill Status] = 2 THEN 'Pending'
                ELSE 'Unknown'
            END as BillStatus,
            CASE 
                WHEN Role = 1 THEN 'City Coordinator'
                WHEN Role = 14 THEN 'Centre Superintendent'
                WHEN Role = 5 THEN 'Observer'
                ELSE 'Unknown'
            END as Role,  
            EX.Mobile, 
            EX.Email",
            'input' => "INNER JOIN $ExamProfile as EX ON EX.[ObserverID] = CCTbl.[Observer ID] WHERE CCTbl.Active = 1",
            'table' => "$CityCoordinatorOfflineTbl as CCTbl",
            'orderBy' => "ORDER BY CCTbl.[Reference No_] DESC"
            ];
            $AllBilldata = DB::select(DB::raw($query), $bindings);
            return response()->json($AllBilldata, 200);
        } catch (\Exception $e) {
            return response()->json([
                'error' => 'An error occurred while fetching data',
                'details' => $e->getMessage()
            ], 500);
        }
    }
}
