<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Admin\Changeslog;
use DB;

class ChangesLogController extends Controller
{
   public function index (Request $request)
    {

      $perPage = $request->perPage ?? 15; // Set perPage directly

      // Assign search filters
      $referenceNo = $request->referenceNo ?? null;
      $ntaId = $request->ntaId ?? null;
      $examType = $request->examType ?? null;
      $fromDate = $request->fromDate ?? null;
      $toDate = $request->toDate ?? null;

      // Start query
      $query = Changeslog::select('role_type', 'table_name', 'current_value', 'update_value', 'created_at', 'reference_no', 'observer_id', 'exam_type');
      // Apply filters only if values exist
      if (!empty($referenceNo)) {
         $query->where('reference_no', $referenceNo);
      }
      if (!empty($ntaId)) {
         $query->where('observer_id', $ntaId);
      }
      if (!empty($examType)) {
         $query->where('exam_type', $examType);
      }
      // Date filtering
      if (!empty($fromDate) && !empty($toDate)) {
         $query->whereBetween('created_at', [$fromDate . ' 00:00:00', $toDate . ' 23:59:59']);
      } else {
         if (!empty($fromDate)) {
            $query->whereDate('created_at', '=', $fromDate);
         }
         if (!empty($toDate)) {
            $query->whereDate('created_at', '=', $toDate);
         }
      }

      // Paginate results
      $logs = $query->orderBy('id', 'desc')->paginate($perPage);
      $title = 'Changes Log';

      return view('admin.changes_log.index', compact('logs','title'));
    }
}
