<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Illuminate\Contracts\Session\Session as SessionSession;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Session;

use Maatwebsite\Excel\Facades\Excel;
use Maatwebsite\Excel\HeadingRowImport;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\Validator;

class FormfieldsController extends Controller
{
    //
    public function index(Request $request)
    {   
        // try {
            $examType = $request->get('examType') ?? '';
            
            $RoleName = config('constants.RoleName');
            $perPage = 15;
            if($request->perPage){
                $perPage = $request->perPage;
            }
            $formFields  = getFormFieldData($perPage,$examType);
            
            $ExamCodes = config('constants.CentralizedFormFields');
            $ExamCodeExam = config('constants.ExamDates');
            $getExamName = DB::table($ExamCodes)->select('examType')->distinct()->get();
           
            $examNameData = DB::select("exec getCommonDataSP :select, :input, :table", [
                'select' => "[Exam Type] as examType",
                'input' => " where Is_Active=1 ",    
                'table' => "[$ExamCodeExam]"
            ]);


            $examTypes = $getExamName->pluck('examType')->toArray();
            $examTypesString = implode("','", $examTypes)."'";
            $examTypesStringRes = "'".$examTypesString;
            $getExamNameResult = DB::select("exec getCommonDataSP :select, :input, :table", [
                'select' => "[Exam Type] as examType ,[Exam Name] as ExamNames ",
                'input' => "WHERE [Exam Type] IN ($examTypesStringRes)",    
                'table' => "[$ExamCodeExam]"
            ]);
            
            $array1 = $examNameData;
            $array2 = $getExamName;
            $nonMatchingValues = [];
            foreach ($array1 as $value1) {
                $matchFound = false;
                foreach ($array2 as $value2) {
                    if ($value1 == $value2) {
                        $matchFound = true;
                        break;
                    }
                }
                if (!$matchFound) {
                    $nonMatchingValues[] = $value1;
                }
            }
            foreach ($array2 as $value2) {
                $matchFound = false; 
                foreach ($array1 as $value1) {
                    if ($value2 == $value1) {
                        $matchFound = true;
                        break;
                    }
                }
                if (!$matchFound) {
                    $nonMatchingValues[] = $value2;
                }
            }
            $examNameData = $nonMatchingValues;
            return view('admin.formfields.formFields', ['formFields' => $formFields,'RoleName' => $RoleName,'getExamName'=>$getExamName,'examNameData'=>$examNameData,'getExamNameResult'=>$getExamNameResult]);
        // } catch (\Exception $e) {
        //     return back()->with('error', 'Error: ' . $e->getMessage());
        // }      
    }
    public function add()
    {   
        $RoleName = config('constants.RoleName');
        $ExamCode = config('constants.ExamDates');
        
        $examData = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => "[Exam Type] as examCode",
            'input' => " where Is_Active=1 ",    
            'table' => "[$ExamCode]"
        ]);
        return view('admin.formfields.addEditFormFields', ['RoleName' => $RoleName,'examData'=>$examData]);
    }

    public function saveUpdate(Request $request){
        if(!empty($request->ntaId)){
            $eid = Crypt::decrypt($request->ntaId);
        }
        $ExamCodes = config('constants.CentralizedFormFields');
        $request->validate([
            'examCode'=>'required',
            'Role'=>'required',
            'fieldName'=>'required|max:30',
            'fieldLabel'=>'required|max:30',
            'displayOrder'=>'required',
            'isRequired'=>'required',
            'fieldType'=>'required',
            'maxLength'=>'required',
            'minLength'=>'required',
            'readonly'=>'required',
            'isActive'=>'required'
        ]);
        try {
            $dataSaveForm = [
                'examType'=>$request->examCode,  
                'Role'=>$request->Role,
                'fieldName'=>$request->fieldName,
                'fieldLabel'=>$request->fieldLabel,
                'displayOrder'=>$request->displayOrder,
                'isRequired'=>$request->isRequired,
                'fieldType'=>$request->fieldType,
                'maxLength'=>$request->maxLength,
                'minLength'=>$request->minLength,
                'readonly'=>$request->readonly,
                'isActive'=>$request->isActive
            ];
            if(!empty($eid)){
                DB::table($ExamCodes)->where('ID',$eid)->update($dataSaveForm);
            }else{
                DB::table($ExamCodes)->insert($dataSaveForm);
            }
            
            return redirect()->route('form-fields')->with('success', 'Form Fields Insert/Updated Successfully');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        } 
    }

    public function edit(Request $request,$edit)
    {   
        try {
            $editId = $edit;
            $RoleName = config('constants.RoleName');
            $ExamCode = config('constants.ExamDates');
            $ExamForms = config('constants.CentralizedFormFields');
            
            $examData = DB::select("exec getCommonDataSP :select, :input, :table", [
                'select' => "[Exam Type] as examCode",
                'input' => " where Is_Active=1 ",    
                'table' => "[$ExamCode]"
            ]);

            $ExamFormsData = DB::select("exec getCommonDataSP :select, :input, :table", [
                'select' => "*",
                'input' => " where ID = $editId ",    
                'table' => "[$ExamForms]"
            ]);
            return view('admin.formfields.addEditFormFields', ['RoleName' => $RoleName,'examData'=>$examData,'ExamFormsData'=>$ExamFormsData]);
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }

    public function fieldsCopy(Request $request){
        $request->validate([
            'examNames'=>'required',
        ]);

        $ExamCodes = config('constants.CentralizedFormFields');
        $getExamName = $request->examNames;
        $getCount = DB::table($ExamCodes)->where('examType',$getExamName)->get();
        if(count($getCount)>0){
            return back()->with('error', 'Error: '.'Fields already copy for this exam');
        }

        try {
            $getExamFields = DB::table($ExamCodes)->where('examType','CUETUG2024')->get();
            foreach($getExamFields as $val){
                $filedsData = [
                    'examType' => $getExamName,
                    'Role' => $val->Role,
                    'fieldName' => $val->fieldName,
                    'fieldLabel' => $val->fieldLabel,
                    'displayOrder' => $val->displayOrder,
                    'isRequired' => $val->isRequired,
                    'fieldType' => $val->fieldType,
                    'maxLength' => $val->maxLength,
                    'minLength' => $val->minLength,
                    'readonly' => $val->readonly,
                    'isActive' => $val->isActive
            ];  
            DB::table($ExamCodes)->insert($filedsData);
            }
            return back()->with('success', 'Fields copy successfully!');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }

    }

    public function updateFieldStatus(Request $request){
        $id=$request->id;
        $isStatus=$request->isActive;
        $ExamCodes = config('constants.CentralizedFormFields');
        $getExamFields = DB::table($ExamCodes)->where('ID',$id)->update(['isActive'=>$isStatus]);
        if ($getExamFields > 0) {
            return response()->json(['success' => true]);
        } else {
            return response()->json(['success' => false, 'message' => 'No rows were updated']);
        }
        //return response()->json(['success' => false, 'message' => 'Field not found']);        
    }

    public function saveDetail(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        } 

       
        try {
            $file = $request->file('file');
            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
          
            $expectedHeaders = [
                'observeridcccs',
                'user_type',
                'name',
                'address',
                'city',
                'state',
                'postcode',
                'mobileno',
                'e_mail',
                'bankaccountno',
                'fullname',
                'bankname',
                'ifsccode',
                'bankbranchname',
                'panno'  // Any of these is valid
            ];

            if (array_diff($expectedHeaders, $headings[0][0])) {
                // print_r($headings);die;
                return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            } 
            if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->with('error', 'Invalid file format. Please check the headers.');
            }
            
            if (array_diff_assoc($expectedHeaders, $headings[0][0])) {
                return back()->with('error', 'The uploaded file has incorrect headers.');
            }

            // Convert file data to an array
            $data = Excel::toArray([], $file);
            
           
          //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.VendorContactTbl');  
            $vendorBankTbl = config('constants.VendorBankTbl');
            $VendorPanTbl = config('constants.VendorPanTbl');
            

            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            $skippedRowsBank = []; // Array to store skipped row numbers or IDs
            $rowNumberBank = 1; // Track row number (or use an actual ID if available)
            $skippedRowsPan = []; // Array to store skipped row numbers or IDs
            $rowNumberPan = 1; // Track row number (or use an actual ID if available)

          //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);
             
    
                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                  //  Check if rowIndex is 1 (second row) and echo the value at index 1
                  //  if ($rowIndex == 1) {
                   
             //   try {

                    // $row = array_map(function ($value, $key) {
                    //     $columnsToReplace = [
                    //         10, 11, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 
                    //         38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49
                    //     ]; 

                    //     // Convert "NULL" string to actual NULL
                    //     if ($value === 'NULL' || $value === '') {
                    //         return null;
                    //     }
                
                    //     // Replace NULL with 0 for specific columns
                    //     return (in_array($key, $columnsToReplace) && is_null($value)) ? 0 : $value;
                    // }, $row, array_keys($row));
                 
                // Insert records in Vendor Contact Details
                $observerID = $row[0] ?? null;
                // Check if a record with the same values already exists
                $exists = DB::table($examDatesTableName)
                    ->where('No_', $observerID)
                    ->exists();
                if(!$exists) {
                    DB::table($examDatesTableName)->insert([
                        'No_'  => $row[0] ?? null,
                        'Name' => $row[2] ?? null,
                        'Address' => $row[3] ?? null,
                        'City' => $row[4] ?? null,
                        'Post Code' => $row[6] ?? null,
                        'Mobile Phone No_' => $row[7] ?? null,
                        'Search Name' => $row[2] ?? null,
                        'E-Mail' => $row[8] ?? null
                    ]);
                } else {
                    // Store row number or relevant ID in skippedRows array
                    $skippedRows[] = $rowNumber;
                }
                $rowNumber++; // Increment row number for next iteration

              

                 // Insert records in Vendor Bank Details
                 // Check if a record with the same values already exists
                 $existsBnk = DB::table($vendorBankTbl)
                     ->where('No_', $observerID)
                     ->exists();
                 if(!$existsBnk) {
                     DB::table($vendorBankTbl)->insert([
                         'No_'  => $row[0] ?? null,
                         'IFSC Code' => $row[12] ?? null,
                         'Bank Name' => $row[11] ?? null,
                         'Vendor Account No_' => $row[9] ?? null,
                         'Account Holder Name' => $row[10] ?? null,
                         'Branch' => $row[13] ?? null
                     ]);
                 } else {
                     // Store row number or relevant ID in skippedRows array
                     $skippedRowsBank[] = $rowNumberBank;
                 }
                 $rowNumberBank++; // Increment row number for next iteration
                

                // Insert records in Vendor Pan Details
                // Check if a record with the same values already exists
                $existsPan = DB::table($VendorPanTbl)
                     ->where('No_', $observerID)
                     ->exists();
                if(!$existsPan) {
                     DB::table($VendorPanTbl)->insert([
                         'No_'  => $row[0] ?? null,
                         'P_A_N_ No_' => $row[14] ?? null,
                     ]);
                 } else {
                     // Store row number or relevant ID in skippedRows array
                     $skippedRowsPan[] = $rowNumberPan;
                 }
                 $rowNumberPan++; // Increment row number for next iteration


                // echo "Row Inserted Successfully! <br>";
                // } catch (\Exception $e) {
                //     echo "Error: " . $e->getMessage() . "<br>";
                // }
            }
        }
           
            $messages = [];
            if (!empty($skippedRows)) {
                $messages[] = "Skipped rows vendors details (already exist): " . implode(", ", $skippedRows);
            }

            if (!empty($skippedRowsBank)) {
                $messages[] = "Skipped rows vendors bank details (already exist): " . implode(", ", $skippedRowsBank);
            }

            if (!empty($skippedRowsPan)) {
                $messages[] = "Skipped rows vendors pan details (already exist): " . implode(", ", $skippedRowsPan);
            }

            // If we have any skipped messages, we can combine them
            if (!empty($messages)) {
                // Check how many messages we need to show
                $message = implode(" | ", $messages);
                return back()->with('success', $message);
            }


           return back()->with('success', 'Vendors details saved successfully!');

        
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }    
    }
}