<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests\FinancialNormsRequest;
use App\Http\Requests\FinancialBulkRequest;
use Illuminate\Support\Facades\Validator;
use Maatwebsite\Excel\HeadingRowImport;
use Maatwebsite\Excel\Facades\Excel;
use JsValidator;
use DB;


class ImportFinancialNormsController extends Controller
{

    public function index(Request $request)
    {
        $perPage = 15;
        if ($request->perPage) {
            $perPage = $request->perPage;
        }
        $importList = getFinancialNormsList($perPage);
        $examType = $request->exam_type ?? null;
        $sourceType = $request->source_type ?? null;
        // die;
        // dd($examType);

        if ($examType || $sourceType) {
            $importList = getFinancialExamNormsList($perPage, $examType, $sourceType);
        }
        $importAllList  = getFinancialAllNormsList();

        $title = 'Financial Norms List';
        $RoleName = config('constants.RoleName');
        $RoleNameCheck = config('constants.RoleNameCheck');
        return view('admin.masters.importFinancialNormsList', ['importList' => $importList, 'importAllList' => $importAllList, 'title' => $title, 'RoleName' => $RoleName, 'RoleNameCheck' => $RoleNameCheck]);
    }


    public function add()
    {
        $SourceCodeList = getExaSourceCodeList();
        $ExamDateList = getExamDateList();
        $RoleName = config('constants.RoleName');
        $IsAttachment = config('constants.Is_Attachment');
        $IsReadonly = config('constants.Is_Readonly');
        $IsActive = config('constants.Is_Active');
        $IsExtrafield = config('constants.Is_Extrafield');
        $IsRequired = config('constants.Is_Required');
        $IsTds = config('constants.Is_Tds');
        // $role = sort($RoleName);
        $title = 'Add New Financial Norms';
        $Exam_Mode = config('constants.FinanceExamMode');
        $validator = JsValidator::make((new FinancialNormsRequest())->rules(), (new FinancialNormsRequest())->messages(), (new FinancialNormsRequest())->attributes());
        return view('admin.masters.addFinanceNorms', [
            'SourceCodeList' => $SourceCodeList,
            'ExamDateList' => $ExamDateList,
            'RoleName' => $RoleName,
            'ExamMode' => $Exam_Mode,
            'validator' => $validator,
            'IsAttachment' => $IsAttachment,
            'IsReadonly' => $IsReadonly,
            'IsActive' => $IsActive,
            'IsExtrafield' => $IsExtrafield,
            'IsRequired' => $IsRequired,
            'IsTds' => $IsTds,
            'title' => $title
        ]);
    }

    public function getExamDetails(Request $request)
    {
        $ExamDateList = getExamList($request->Exam_ID);
        return $ExamDateList;
    }

    public function addBulk()
    {
        $SourceCodeList = getExaSourceCodeList();
        $ExamDateList = getExamDateList();
        $RoleName = config('constants.RoleName');
        // $role = sort($RoleName);
        $title = 'Import Financial Norms';
        $Exam_Mode = config('constants.FinanceExamMode');
        $validator = JsValidator::make((new FinancialBulkRequest())->rules(), (new FinancialBulkRequest())->messages(), (new FinancialBulkRequest())->attributes());

        return view('admin.masters.addFinanceNormsbulk', [
            'SourceCodeList' => $SourceCodeList,
            'ExamDateList' => $ExamDateList,
            'RoleName' => $RoleName,
            'ExamMode' => $Exam_Mode,
            'validator' => $validator,
            'title' => $title
        ]);
    }


    public function savebulkdetail(FinancialBulkRequest $request)
    {
        // prd($request->all());
        try {
            if ($request->isMethod('post')) {
                $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
                $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

                $file = $request->file('file');
                $headings = (new HeadingRowImport)->toArray($file);
                $expectedHeaders = [
                    'Source_Type',
                    'Source_Code',
                    // 'Source_Name',
                    // 'Field_Name',
                    // 'Mock_Drill_Field_Name',
                    // 'field_name_deduction',
                    // 'mock_drill_field_name_deduction',
                    'Remuneration_Amount_Shift1',
                    'Remuneration_Amount_Shift2',
                    'Remuneration_Amount_Shift3',
                    'Remuneration_Amount_Shift4',
                    'Remuneration_Conveyance',
                    'Food_Amount',
                    'MockDrill_Conveyance',
                    'MockDrill_Amount',
                    'No_of_Candidates',
                    'No_of_Person',
                    'No_of_Days',
                    'Fixed_Amount',
                    'Remuneration_Text',
                    'Mock_Drill_Text',
                    'Attechment',
                    'AttechmentRequired',
                    'readonly',
                    'Required',
                    'displayOrder',
                    'Tds',
                    'tdsPrecentage',
                    'IsActive',
                    'Extrafield',
                ];
                if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                    return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);
                }

                // Normalize headers (trim spaces and convert to lowercase)
                $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
                $fileHeaders = array_map('trim', array_map('strtolower', $headings[0][0]));

                // pr($expectedHeaders);
                // prd($fileHeaders);


                // Check for missing headers
                $missingHeaders = array_diff($expectedHeaders, $fileHeaders);
                // Check for extra headers
                $extraHeaders = array_diff($fileHeaders, $expectedHeaders);
                // dd($missingHeaders, $missingHeaders);


                if (!empty($missingHeaders) || !empty($extraHeaders)) {
                    return back()->withErrors(['error', 'Error : Selected file headers do not match.
                    Missing: ' . implode(', ', $missingHeaders) .
                        ' | Extra: ' . implode(', ', $extraHeaders)]);
                }

                $data = Excel::toArray([], $file);

                $exmTypeCheck = $request->exam_type ? $request->exam_type : '';
                $ExamsListCheck = DB::table($CentralizedRemunerationHeaderTable)
                    ->where('Exam Type', $exmTypeCheck)
                    ->get();


                try {

                    DB::beginTransaction();

                    if ($ExamsListCheck->isNotEmpty()) {
                        $resultID = $ExamsListCheck[0]->ID;
                    } else {
                        $ExamsList = DB::table($CentralizedRemunerationHeaderTable)
                            ->select('ID')
                            ->orderBy('ID', 'desc')
                            ->first();

                        $string = $ExamsList->ID ?? 'REMU/00000';
                        $result = str_replace("REMU/", "", $string);
                        $number = (int)$result + 1;  // Convert to int and add 1
                        $result1 = str_pad($number, strlen($result), "0", STR_PAD_LEFT);  // Pad with leading zeros if needed
                        $resultID = "REMU/" . $result1;

                        $lastInsertId = DB::table($CentralizedRemunerationHeaderTable)->insert([
                            'ID'   => $resultID,
                            'Exam Type ID' => $request->exam_type_id ?? null,
                            'Exam Type' => $request->exam_type ?? null,
                            'Exam Mode' => $request->exam_mode ?? null,
                            'Exam Name' => $request->exam_name ?? null,
                            'Created By' => 'NTA-BC-STAGING\PPANDAY3',
                            'Created DateTime' => date('Y-m-d H:I:s'),
                        ]);
                    }

                    // Insert data into the database
                    $skippedRows = [];
                    $rowNumber = 1;
                    $insertCount = 0;
                    $skipCount = 0;

                    foreach ($data as $sheetIndex => $sheetData) {
                        // Remove the header row from the sheet data
                        array_shift($sheetData);
                        // Loop through the rows in the sheet

                        // foreach ($sheetData as $rowIndex => $row) {

                        //     // Getting Columns For data save dynamically
                        //    $SourceData = getExaSourceCodeList($row[0],$row[1]);

                        //     //    prd($SourceData);

                        //     $exists = DB::table($CentralizedRemunerationLineTableShiftWise)
                        //         ->where('Source Type', $row[0])
                        //         ->where('Source Code', $row[1])
                        //         ->where('Document No_',$resultID)
                        //         ->exists();

                        //     if (!$exists) {
                        //         $randomNumber = rand(100000, 999999);
                        //         DB::table($CentralizedRemunerationLineTableShiftWise)->insert([
                        //             'Document No_'                   => $resultID,
                        //             'Line No_'                       => $randomNumber,
                        //             'Exam Type ID'                   => $request->exam_type_id ?? null,
                        //             'Exam Type'                      => $request->exam_type ?? null,
                        //             'Exam Mode'                      => $request->exam_mode ?? null,
                        //             'Exam Name'                      => $request->exam_name ?? null,
                        //             'Source Type'                    => $row[0] ?? null,
                        //             'Source Code'                    => $row[1] ?? null,
                        //             'Source Name'                    => $SourceData[0]->{'Source Name'} ?? null,
                        //             'Field_Name'                     => $SourceData[0]->{'Field_Name'} ?? null,
                        //             'MockDrillFiledName'             => $SourceData[0]->{'Mock_Drill_Field_Name'} ?? null,
                        //             'Field_Name_Deduction'           => $SourceData[0]->{'Field Name Deduction'} ?? null,
                        //             'MockDrillFiledName_Deduction'   => $SourceData[0]->{'Mock Drill Field Name Deduction'} ?? null,
                        //             'Remuneration Amount_S1'         => $row[2] ?? 0,
                        //             'Remuneration Amount_S2'         => $row[3] ?? 0,
                        //             'Remuneration Amount_S3'         => $row[4] ?? 0,
                        //             'Remuneration Amount_S4'         => $row[5] ?? 0,
                        //             'Conveyance Amount'              => $row[6] ?? 0,
                        //             'Food Amount'                    => $row[7] ?? 0,
                        //             'Mock Drill Conveyance'          => $row[8] ?? 0,
                        //             'Mock Drill Charge'              => $row[14] ?? 0,
                        //             'No_ of Candidates'              => $row[15] ?? 0,
                        //             'No_ of Person'                  => $row[16] ?? 0,
                        //             'No_ of Days'                    => $row[17] ?? 0,
                        //             'Fixed Amount'                   => $row[18] ?? 0,
                        //             'Remuneration Text'              => $row[19] ?? null,
                        //             'Mock Drill Text'                => $row[20] ?? null,
                        //             'isAttechment'                   => $row[21] ?? 0,
                        //             'isAttechmentRequired'           => $row[22] ?? 0,
                        //             'readonly'                       => $row[23] ?? 0,
                        //             'isRequired'                     => $row[24] ?? 0,
                        //             'displayOrder'                   => $row[25] ?? '',
                        //             'isTds'                          => $row[26] ?? 0,
                        //             'tdsPrecentage'                  => $row[27] ?? 0,
                        //             'isActive'                       => 1,
                        //             'isExtrafield'                   => $row[29] ?? 0,
                        //             'Other Charges'                  => 0,
                        //             'ScribeRate'                     => 0,
                        //         ]);
                        //         $insertCount++; 
                        //     }else {
                        //         $skippedRows[] = $rowNumber;
                        //         $skipCount++;
                        //     }
                        //     $rowNumber++; 
                        // } // End foreach
                        $headers = $fileHeaders; // already normalized (lowercase, trimmed)

                        foreach ($sheetData as $rowIndex => $row) {
                            // Skip rows where columns don't match
                            if (count($headers) !== count($row)) {
                                $skippedRows[] = $rowNumber;
                                $skipCount++;
                                $rowNumber++;
                                continue;
                            }

                            // Combine headers and row data into associative array
                            $rowData = array_combine($headers, $row);

                            // Example access: $rowData['source_type'] (all keys are lowercase due to normalization)

                            // Fetch source info
                            $SourceData = getExaSourceCodeList($rowData['source_type'], $rowData['source_code']);

                            $exists = DB::table($CentralizedRemunerationLineTableShiftWise)
                                ->where('Source Type', $rowData['source_type'])
                                ->where('Source Code', $rowData['source_code'])
                                ->where('Document No_', $resultID)
                                ->exists();

                            if (!$exists) {
                                $randomNumber = rand(100000, 999999);
                                DB::table($CentralizedRemunerationLineTableShiftWise)->insert([
                                    'Document No_'                   => $resultID,
                                    'Line No_'                       => $randomNumber,
                                    'Exam Type ID'                   => $request->exam_type_id ?? null,
                                    'Exam Type'                      => $request->exam_type ?? null,
                                    'Exam Mode'                      => $request->exam_mode ?? null,
                                    'Exam Name'                      => $request->exam_name ?? null,
                                    'Source Type'                    => $rowData['source_type'] ?? null,
                                    'Source Code'                    => $rowData['source_code'] ?? null,
                                    'Source Name'                    => $SourceData[0]->{'Source Name'} ?? null,
                                    'Field_Name'                     => $SourceData[0]->{'Field_Name'} ?? null,
                                    'MockDrillFiledName'             => $SourceData[0]->{'Mock_Drill_Field_Name'} ?? null,
                                    'Field_Name_Deduction'           => $SourceData[0]->{'Field Name Deduction'} ?? null,
                                    'MockDrillFiledName_Deduction'   => $SourceData[0]->{'Mock Drill Field Name Deduction'} ?? null,
                                    'Remuneration Amount_S1'         => $rowData['remuneration_amount_shift1'] ?? 0,
                                    'Remuneration Amount_S2'         => $rowData['remuneration_amount_shift2'] ?? 0,
                                    'Remuneration Amount_S3'         => $rowData['remuneration_amount_shift3'] ?? 0,
                                    'Remuneration Amount_S4'         => $rowData['remuneration_amount_shift4'] ?? 0,
                                    'Conveyance Amount'              => $rowData['remuneration_conveyance'] ?? 0,
                                    'Food Amount'                    => $rowData['food_amount'] ?? 0,
                                    'Mock Drill Conveyance'          => $rowData['mockdrill_conveyance'] ?? 0,
                                    'Mock Drill Charge'              => $rowData['mockdrill_amount'] ?? 0,
                                    'No_ of Candidates'              => $rowData['no_of_candidates'] ?? 0,
                                    'No_ of Person'                  => $rowData['no_of_person'] ?? 0,
                                    'No_ of Days'                    => $rowData['no_of_days'] ?? 0,
                                    'Fixed Amount'                   => $rowData['fixed_amount'] ?? 0,
                                    'Remuneration Text'              => $rowData['remuneration_text'] ?? null,
                                    'Mock Drill Text'                => $rowData['mock_drill_text'] ?? null,
                                    'isAttechment'                   => $rowData['attechment'] ?? 0,
                                    'isAttechmentRequired'           => $rowData['attechmentrequired'] ?? 0,
                                    'readonly'                       => $rowData['readonly'] ?? 0,
                                    'isRequired'                     => $rowData['required'] ?? 0,
                                    'displayOrder'                   => $rowData['displayorder'] ?? '',
                                    'isTds'                          => $rowData['tds'] ?? 0,
                                    'tdsPrecentage'                  => $rowData['tdsprecentage'] ?? 0,
                                    'isActive'                       => 1,
                                    'isExtrafield'                   => $rowData['extrafield'] ?? 0,
                                    'Other Charges'                  => 0,
                                    'ScribeRate'                     => 0,
                                ]);
                                $insertCount++;
                            } else {
                                $skippedRows[] = $rowNumber;
                                $skipCount++;
                            }
                            $rowNumber++;
                        }
                    } // End Foreach

                    DB::commit();

                    // if (!empty($skippedRows)) {
                    //     if (!empty($skippedRows)) {
                    //     $skipp = "Skipped rows (already exist): " . implode(", ", $skippedRows);
                    //     return back()->with('success', $skipp);
                    // } 

                    if ($insertCount > 0 || $skipCount > 0) {
                        $message = " Imported rows: $insertCount.  Skipped rows : $skipCount.";

                        $ExamCodes = config('constants.CentralizedFormFields');
                        $getExamName = $request->exam_type;

                        $getCount = DB::table($ExamCodes)->where('examType', $getExamName)->get();
                        if (count($getCount) > 0) {
                            return back()->with('success', $message);
                            // return back()->with('success', 'Financial Norms excel file imported successfully!');
                        } else {
                            $getExamFields = DB::table($ExamCodes)->where('examType', 'CUETUG2024')->get();
                            foreach ($getExamFields as $val) {
                                $filedsData = [
                                    'examType' => $getExamName,
                                    'Role' => $val->Role,
                                    'fieldName' => $val->fieldName,
                                    'fieldLabel' => $val->fieldLabel,
                                    'displayOrder' => $val->displayOrder,
                                    'isRequired' => $val->isRequired,
                                    'fieldType' => $val->fieldType,
                                    'maxLength' => $val->maxLength,
                                    'minLength' => $val->minLength,
                                    'readonly' => $val->readonly,
                                    'isActive' => $val->isActive
                                ];
                                DB::table($ExamCodes)->insert($filedsData);
                            }
                            return back()->with('success', $message);
                            // return back()->with('success', 'Financial Norms excel file imported successfully!');
                        }
                    } else {
                    }
                } catch (\Exception $e) {
                    dd("error", $e);
                    DB::rollback();
                    // something went wrong
                }
            }
        } catch (\Exception $e) {
            dd($e->getMessage());
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }


    public function edit()
    {

        $document_id = convert_uudecode($_GET['document_id']);
        $line_id = convert_uudecode($_GET['line_id']);



        $normsData = getFinancialNormsEdit($document_id, $line_id);
        $SourceCodeList = getExaSourceCodeList($normsData->{'Source Type'});
        $ExamDateList = getExamDateList();
        $RoleName = config('constants.RoleNameCheck');
        $IsAttachment = config('constants.Is_Attachment');
        $IsReadonly = config('constants.Is_Readonly');
        $IsActive = config('constants.Is_Active');
        $IsExtrafield = config('constants.Is_Extrafield');
        $IsRequired = config('constants.Is_Required');
        $IsTds = config('constants.Is_Tds');
        $Exam_Mode = config('constants.FinanceExamMode');
        $validator = JsValidator::make((new FinancialNormsRequest())->rules(), (new FinancialNormsRequest())->messages(), (new FinancialNormsRequest())->attributes());

        return view('admin.masters.editFinanceNorms', [
            'SourceCodeList' => $SourceCodeList,
            'ExamDateList' => $ExamDateList,
            'RoleName' => $RoleName,
            'ExamMode' => $Exam_Mode,
            'validator' => $validator,
            'IsAttachment' => $IsAttachment,
            'IsReadonly' => $IsReadonly,
            'IsActive' => $IsActive,
            'IsExtrafield' => $IsExtrafield,
            'IsRequired' => $IsRequired,
            'IsTds' => $IsTds,
            'normsData' => $normsData
        ]);
    }


    public function savedetail(FinancialNormsRequest $request)
    {

        try {
            if ($request->isMethod('post')) {
                $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
                $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');
                $ExamsList = DB::table($CentralizedRemunerationHeaderTable)
                    ->select('ID')
                    ->orderBy('ID', 'desc')
                    ->first();

                $string = $ExamsList->ID;
                $result = str_replace("REMU/", "", $string);
                $number = (int)$result + 1;  // Convert to int and add 1
                $result1 = str_pad($number, strlen($result), "0", STR_PAD_LEFT);  // Pad with leading zeros if needed
                $resultID = "REMU/" . $result1;

                $lastInsertId = DB::table($CentralizedRemunerationHeaderTable)->insert([
                    'ID'   => $resultID,
                    'Exam Type ID' => $request->exam_type_id ?? null,
                    'Exam Type' => $request->exam_type ?? null,
                    'Exam Mode' => $request->exam_mode ?? null,
                    'Exam Name' => $request->exam_name ?? null,
                    'Created By' => 'NTA-BC-STAGING\PPANDAY3',
                    'Created DateTime' => date('Y-m-d H:I:s'),
                ]);

                if ($lastInsertId) {
                    $randomNumber = rand(100000, 999999);
                    DB::table($CentralizedRemunerationLineTableShiftWise)->insert([
                        'Document No_'   => $resultID,
                        'Line No_' =>  $randomNumber ?? null,
                        'Source Code' => $request->source_code ?? null,
                        'Source Name' => $request->source_name ?? null,
                        'Remuneration Text' => $request->remuneratlon ?? null,
                        'Source Type' => $request->source_type_id ?? null,
                        'Exam Type ID' => $request->exam_type_id ?? null,
                        'Remuneration Amount_S1' => $request->remuneratlon_amount_s1 ?? null,
                        'Remuneration Amount_S2' => $request->remuneratlon_amount_s2 ?? null,
                        'Remuneration Amount_S3' => $request->remuneratlon_amount_s3 ?? null,
                        'Remuneration Amount_S4' => $request->remuneratlon_amount_s4 ?? null,
                        'Mock Drill Charge' => $request->mock_drilling_amount ?? null,
                        'Mock Drill Conveyance' => $request->mock_drilling_conveyance ?? null,
                        'No_ of Candidates' =>  $request->candidates ?? null,
                        'Exam Type' => $request->exam_type ?? null,
                        'Exam Type ID' => $request->exam_type_id,
                        'Exam Mode' => $request->exam_mode ?? null,
                        'Exam Name' => $request->exam_name ?? null,
                        'Conveyance Amount' => $request->conveyance_amount ?? null,
                        'Food Amount' => $request->food_amount ?? null,
                        'No_ of Person' => $request->no_of_person ?? null,
                        'No_ of Days' => $request->no_of_days ?? null,
                        'Fixed Amount' => $request->fixed_amount ?? null,
                        'Mock Drill Text' => $request->mock_drill_text ?? null,
                        'isAttechment' => $request->attechment ?? null,
                        'isAttechmentRequired' => $request->attechment_required ?? 0,
                        'readonly' => $request->read_only ?? null,
                        'isRequired' => $request->required ?? null,
                        'displayOrder' => $request->display_order ?? null,
                        'isTds' => $request->tds ?? null,
                        'tdsPrecentage' => $request->tdsprecentage ?? 0,
                        // 'Field_Name' => $request->field_name ?? null,
                        // 'MockDrillFiledName' => $request->mock_drill_filed_name ?? null,
                        // 'isActive' => $request->is_active ?? null,
                        'isExtrafield' => $request->is_extra_field ?? null,
                        'Other Charges' => 0,
                        'ScribeRate' => 0,
                    ]);
                } else {
                    return back()->with('error', 'Something went wrong !');
                }
                return back()->with('success', 'Financial Norms Data save successfully!');
            }
        } catch (\Exception $e) {
            dd($e->getMessage());
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }


    public function updateFinanceDetail(FinancialNormsRequest $request)
    {

        try {
            if ($request->isMethod('post')) {
                $CentralizedRemunerationLineTableShiftWise = config('constants.CentralizedRemunerationLineTableShiftWise');
                $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');

                if (isset($request->mock_drilling_conveyance, $request->mock_drilling_amount) && ($request->mock_drilling_amount != 0 || $request->mock_drilling_conveyance != 0)) {
                    if (empty($request->mock_drill_text)) {
                        return back()->with('error', 'Mock drill description are required ');
                    }
                }

                $lastUpdated = DB::table($CentralizedRemunerationHeaderTable)
                    ->where('ID', $request->Document_No)
                    ->update([
                        'Exam Type ID' => $request->exam_type_id ?? null,
                        'Exam Type' => $request->exam_type ?? null,
                        'Exam Mode' => $request->exam_mode ?? null,
                        'Exam Name' => $request->exam_name ?? null,
                        'Created By' => 'NTA-BC-STAGING\PPANDAY3',
                        'Created DateTime' => date('Y-m-d H:I:s'),
                    ]);

                if ($lastUpdated) {
                    DB::table($CentralizedRemunerationLineTableShiftWise)
                        ->where(['Document No_' => $request->Document_No, 'Line No_' => $request->Line_No])
                        ->update([
                            'Source Code' => $request->source_code ?? null,
                            'Source Name' => $request->source_name ?? null,
                            'Remuneration Text' => $request->remuneratlon ?? null,
                            'Source Type' => $request->source_type_id ?? null,
                            'Exam Type ID' => $request->exam_type_id ?? null,
                            'Remuneration Amount_S1' => $request->remuneratlon_amount_s1 ?? null,
                            'Remuneration Amount_S2' => $request->remuneratlon_amount_s2 ?? null,
                            'Remuneration Amount_S3' => $request->remuneratlon_amount_s3 ?? null,
                            'Remuneration Amount_S4' => $request->remuneratlon_amount_s4 ?? null,
                            'Mock Drill Charge' => $request->mock_drilling_amount ?? null,
                            'Mock Drill Conveyance' => $request->mock_drilling_conveyance ?? null,
                            'No_ of Candidates' =>  $request->candidates ?? null,
                            'Exam Type' => $request->exam_type ?? null,
                            'Exam Type ID' => $request->exam_type_id,
                            'Exam Mode' => $request->exam_mode ?? null,
                            'Exam Name' => $request->exam_name ?? null,
                            'Conveyance Amount' => $request->conveyance_amount ?? null,
                            'Food Amount' => $request->food_amount ?? null,
                            'No_ of Person' => $request->no_of_person ?? null,
                            'No_ of Days' => $request->no_of_days ?? null,
                            'Fixed Amount' => $request->fixed_amount ?? null,
                            'Mock Drill Text' => $request->mock_drill_text ?? null,
                            'isAttechment' => $request->attechment ?? null,
                            'isAttechmentRequired' => $request->attechment_required ?? 0,
                            'readonly' => $request->read_only ?? null,
                            'isRequired' => $request->required ?? null,
                            'displayOrder' => $request->display_order ?? null,
                            'isTds' => $request->tds ?? null,
                            'tdsPrecentage' => $request->tdsprecentage ?? 0,
                            // 'Field_Name' => $request->field_name ?? null,
                            // 'MockDrillFiledName' => $request->mock_drill_filed_name ?? null,
                            // 'isActive' => $request->is_active ?? null,
                            'isExtrafield' => $request->is_extra_field ?? null,
                        ]);
                } else {
                    return back()->with('error', 'Something Went wrong ! ');
                }
                return back()->with('success', 'Financial Norms Data save successfully!');
            }
        } catch (\Exception $e) {
            dd($e->getMessage());
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }

    public function getGategoryList(Request $request){
        $roleCategory = getExaSourceCodeList($request->roleId, $SourceCode = '');
        // return $roleCategory;
        return response()->json($roleCategory);
    }
}
