<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Maatwebsite\Excel\Facades\Excel;
use Maatwebsite\Excel\HeadingRowImport;

class ImportremMasterController extends Controller
{
    //
    public function index(Request $request)
    {
        $perPage = 15;
        if ($request->perPage) {
            $perPage = $request->perPage;
        }
        $title = 'Duty Data List';
        $importList = getAllExamProfileList($perPage);
        // print_r($examList);die;
        return view('admin.masters.importremList', ['importList' => $importList, 'title' => $title]);
    }

    public function indexshift(Request $request)
    {
        $perPage = 15;
        if ($request->perPage) {
            $perPage = $request->perPage;
        }
        $importList = getAllExamProfileShiftList($perPage);
        $title = 'Shift Wise Duty Data List';
        return view('admin.masters.importremshiftList', ['importList' => $importList, 'title' => $title]);
    }

    public function add()
    {
        $title = 'Import Duty Data';
        return view('admin.masters.addimportre', ['title' => $title]);
    }
    public function addshift()
    {
        $title = 'Import Shift Wise Duty Data';
        return view('admin.masters.addimportreshift', ['title' => $title]);
    }
    public function edit()
    {
        $exam_id = $_GET['exam_id'];
        $ExamDates = config('constants.ExamDates');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $ExamShift = config('constants.ExamShift');
        $ExamShiftTable = config('constants.ExamShiftTable');

        $labelName = "Edit Shiftwise Duty Data";
        $examData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => "*",
            'input' => "LEFT join [$ExamDates] ED on EP.[Exam Type] = ED.[Exam Type]  WHERE ID= '$exam_id' ",
            'table' => "[$ExamProfileShiftWise ] EP",
        ]);


        $transformedArray = [];
        $transformedArray['Exam_Type_Id'] = $examData->{'Exam Type Id'};
        $transformedArray['exam_type'] = $examData->{'Exam Type'};
        $transformedArray['exam_name'] = $examData->{'Exam Name'};
        $transformedArray['Exam_Mode'] = $examData->{'Exam_Mode'};
        $transformedArray['Year'] = $examData->{'Year'};
        //prd($examData);

        $title = 'Edit Shiftwise Duty Data';

        return view('admin.shiftwiseDutydata.editshiftwisedutydata', ['examData' => $examData, 'labelName' => $labelName, 'transformedArray' => $transformedArray, 'ExamShift' => $ExamShift, 'title' => $title]);

    }


    public function saveDetail(Request $request)
    {
        // $request->validate([
        //     'file' => 'required|mimes:xlsx,xls'
        // ]);

        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }

        try {
            $file = $request->file('file');

            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
            //$expectedHeaders = ['Exam ID/OBS_ID,CCID,SCID', 'exam_type', 'exam_name', 'exam_mode', 'year', 'examdisp', 'is_examover'];

            $expectedHeaders = [
                //   ['Exam ID/OBS_ID', 'CCID', 'SCID'], // Any of these is valid
                'exam_idobs_idccidscid',
                'ObserverID',
                'ExamType',
                'Name',
                'Designation',
                'Mobile',
                'Email',
                'Address',
                'State',
                'City',
                'State_ID',
                'city_id',
                'City_code',
                'CENTNO',
                'CITY_CD',
                'TC_CODE',
                'TC_NAME',
                'TC_STATE',
                'TC_CITY',
                'Centre_Address',
                'MT',
                'D1',
                'D2',
                'D3',
                'D4',
                'D5',
                'D6',
                'D7',
                'D8',
                'D9',
                'D10',
                'D11',
                'D12',
                'Dutydays',
                'ExtraDutyAs',
                'ATT',
                'A_MT',
                'A_D1',
                'A_D2',
                'A_D3',
                'A_D4',
                'A_D5',
                'A_D6',
                'A_D7',
                'A_D8',
                'A_D9',
                'A_D10',
                'A_D11',
                'A_D12',
                'A_Dutydays',
                'Observer_Type',
                'Bill_Type',
            ];
            //   print_r($headings);
            //  echo '<br>';
            //  print_r($expectedHeaders);

            // die; return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);
            if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);

            }

            // Normalize headers (trim spaces and convert to lowercase)
            $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
            $fileHeaders = array_map('trim', array_map('strtolower', $headings[0][0]));

            // Check for missing headers
            $missingHeaders = array_diff($expectedHeaders, $fileHeaders);

            // Check for extra headers
            $extraHeaders = array_diff($fileHeaders, $expectedHeaders);

            if (!empty($missingHeaders) || !empty($extraHeaders)) {
                return back()->withErrors(['error', 'Error : Selected file headers do not match.
                Missing: ' . implode(', ', $missingHeaders) .
                    ' | Extra: ' . implode(', ', $extraHeaders)]);
            }
            //  print_r($headings[0][0]);die;
            // if (array_diff($expectedHeaders, $headings[0][0])) {
            //     print_r($headings);die;
            //     return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            // }
            // if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
            //     return back()->with('error', 'Invalid file format. Please check the headers.');
            // }

            // if (array_diff_assoc($expectedHeaders, $headings[0])) {
            //     return back()->with('error', 'The uploaded file has incorrect headers.');
            // }
            //  print_r($headings);die;
            // Convert file data to an array
            $data = Excel::toArray([], $file);

            //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.ExamProfile');
            $RoleName = config('constants.RoleName');


            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);

                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                    // Check if rowIndex is 1 (second row) and echo the value at index 1
                    //  if ($rowIndex == 1) {

                    //   try {
                    $row = array_map(function ($value, $key) {
                        $columnsToReplace = [
                            10, 11, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,
                            38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
                        ];

                        // Convert "NULL" string to actual NULL
                        if ($value === 'NULL' || $value === '') {
                            return null;
                        }

                        // Replace NULL with 0 for specific columns
                        return (in_array($key, $columnsToReplace) && is_null($value)) ? 0 : $value;
                    }, $row, array_keys($row));

                    // Check data before insert
                    //  print_r($row);
                    // echo "<br>";
                    $observerID = $row[1] ?? null;
                    $examType = $row[2] ?? null;
                    $CENTNO = $row[13] ?? null; // Example: Checking ObserverID, ExamType, and Mobile

                    // Check if a record with the same values already exists
                    $exists = DB::table($examDatesTableName)
                        ->where('ObserverID', $observerID)
                        ->where('ExamType', $examType)
                        ->where('CENTNO', $CENTNO)
                        ->exists();

                    if (!$exists) {

                        $searchValue = $row[50];
                        $key = array_search($searchValue, $RoleName);
                        DB::table($examDatesTableName)->insert([
                            'ObserverID' => $row[1] ?? null,
                            'ExamType' => $row[2] ?? null,
                            'Name' => $row[3] ?? null,
                            'Designation' => $row[4] ?? null,
                            'Mobile' => $row[5] ?? null,
                            'Email' => $row[6] ?? null,
                            'Address' => $row[7] ?? null,
                            'State' => $row[8] ?? null,
                            'City' => $row[9] ?? null,
                            'State_id' => $row[10] ?? null,
                            'city_id' => $row[11] ?? null,
                            'City_code' => $row[12] ?? null,
                            'CENTNO' => $row[13] ?? null,
                            'CITY_CD' => $row[14] ?? null,
                            'TC_CODE' => $row[15] ?? null,
                            'TC_NAME' => $row[16] ?? null,
                            'TC_STATE' => $row[17] ?? null,
                            'TC_CITY' => $row[18] ?? null,
                            'Centre_Address' => $row[19] ?? null,
                            'MT' => $row[20] ?? null,
                            'D1' => $row[21] ?? null,
                            'D2' => $row[22] ?? null,
                            'D3' => $row[23] ?? null,
                            'D4' => $row[24] ?? null,
                            'D5' => $row[25] ?? null,
                            'D6' => $row[26] ?? null,
                            'D7' => $row[27] ?? null,
                            'D8' => $row[28] ?? null,
                            'D9' => $row[29] ?? null,
                            'D10' => $row[30] ?? null,
                            'D11' => $row[31] ?? null,
                            'D12' => $row[32] ?? null,
                            'Dutydays' => $row[33] ?? null,
                            'ExtraDutyAs' => $row[34] ?? null,
                            'ATT' => $row[35] ?? null,
                            'A_MT' => $row[36] ?? null,
                            'A_D1' => $row[37] ?? null,
                            'A_D2' => $row[38] ?? null,
                            'A_D3' => $row[39] ?? null,
                            'A_D4' => $row[40] ?? null,
                            'A_D5' => $row[41] ?? null,
                            'A_D6' => $row[42] ?? null,
                            'A_D7' => $row[43] ?? null,
                            'A_D8' => $row[44] ?? null,
                            'A_D9' => $row[45] ?? null,
                            'A_D10' => $row[46] ?? null,
                            'A_D11' => $row[47] ?? null,
                            'A_D12' => $row[48] ?? null,
                            'A_Dutydays' => $row[49] ?? null,
                            'Observer Type' => $key ?? null,
                            'BillType' => $row[51] && strtolower($row[51]) == 'outstation' ? 2 : 1,

                        ]);
                    } else {
                        // Store row number or relevant ID in skippedRows array
                        $skippedRows[] = $rowNumber;

                    }
                    $rowNumber++; // Increment row number for next iteration

                    // echo "Row Inserted Successfully! <br>";
                    // } catch (\Exception $e) {
                    //     echo "Error: " . $e->getMessage() . "<br>";
                    // }
                }
            }

            if (!empty($skippedRows)) {
                $skipp = "Skipped rows (already exist): " . implode(", ", $skippedRows);
                return back()->with('success', $skipp);
            } else {
                return back()->with('success', 'Remunetion excel fie imported successfully!');
            }

            //    return back()->with('success', 'Remunetion excel fie imported successfully!');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }
    public function saveDetailshift(Request $request)
    {
        // $request->validate([
        //     'file' => 'required|mimes:xlsx,xls'
        // ]);

        $validator = Validator::make($request->all(), [
            'file' => 'required|mimes:xlsx,xls', // Valid file extensions
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }

        try {
            $file = $request->file('file');

            // Get the first row as headers to validate column names
            $headings = (new HeadingRowImport)->toArray($file);
            //$expectedHeaders = ['Exam ID/OBS_ID,CCID,SCID', 'exam_type', 'exam_name', 'exam_mode', 'year', 'examdisp', 'is_examover'];
            // print_r($headings);die;

            $expectedHeaders = [
                'observer_id', // Any of these is valid
                'exam_type',
                'centerno',
                'citycode',
                'tccode',
                'd1s1',
                'd1s2',
                'd1s3',
                'd2s1',
                'd2s2',
                'd2s3',
                'd3s1',
                'd3s2', 'd3s3', 'd4s1', 'd4s2', 'd4s3',
                'd5s1', 'd5s2', 'd5s3', 'd6s1', 'd6s2', 'd6s3',
                'd7s1', 'd7s2', 'd7s3', 'd8s1', 'd8s2', 'd8s3',
                'd9s1', 'd9s2', 'd9s3', 'd10s1', 'd10s2', 'd10s3',
                'd11s1', 'd11s2', 'd11s3', 'd12s1', 'd12s2', 'd12s3',
            ];

            if (!isset($headings[0][0]) || !is_array($headings[0][0])) {
                return back()->withErrors(['error' => 'Error: Invalid file format. Headers missing or incorrect.']);

            }

            // Normalize headers (trim spaces and convert to lowercase)
            $expectedHeaders = array_map('trim', array_map('strtolower', $expectedHeaders));
            $fileHeaders = array_map('trim', array_map('strtolower', $headings[0][0]));

            // Check for missing headers
            $missingHeaders = array_diff($expectedHeaders, $fileHeaders);

            // Check for extra headers
            $extraHeaders = array_diff($fileHeaders, $expectedHeaders);

            if (!empty($missingHeaders) || !empty($extraHeaders)) {
                return back()->withErrors(['error', 'Error : Selected file headers do not match.
                Missing: ' . implode(', ', $missingHeaders) .
                    ' | Extra: ' . implode(', ', $extraHeaders)]);
            }
            //  print_r($headings[0][0]);die;
            // if (array_diff($expectedHeaders, $headings[0][0])) {
            //     print_r($headings);die;
            //     return back()->with('error', 'Invalid Excel headers. Expected: ' . implode(', ', $expectedHeaders));
            // }
            // if (!isset($headings[0]) || !is_array($headings[0]) || !isset($headings[0][0]) || !is_array($headings[0][0])) {
            //     return back()->with('error', 'Invalid file format. Please check the headers.');
            // }

            // if (array_diff_assoc($expectedHeaders, $headings[0])) {
            //     return back()->with('error', 'The uploaded file has incorrect headers.');
            // }
            //  print_r($headings);die;
            // Convert file data to an array
            $data = Excel::toArray([], $file);

            //  $ExamDates = config('constants.ExamDates');
            $examDatesTableName = config('constants.ExamProfileShiftWise');
            // Remove the header row
            //     array_shift($data);
            // print_r($data);die;

            // Insert data into the database
            $skippedRows = []; // Array to store skipped row numbers or IDs
            $rowNumber = 1; // Track row number (or use an actual ID if available)
            //  foreach ($data as $row) {
            foreach ($data as $sheetIndex => $sheetData) {
                // Remove the header row from the sheet data
                array_shift($sheetData);

                // Loop through the rows in the sheet
                foreach ($sheetData as $rowIndex => $row) {
                    // Check if rowIndex is 1 (second row) and echo the value at index 1
                    //  if ($rowIndex == 1) {

                    //   try {

                    $columnsToReplace = range(5, 40); // Define column indexes outside

                    $row = array_map(function ($value, $key) use ($columnsToReplace) {
                        // Convert "NULL" string or empty string to actual NULL
                        if ($value === 'NULL' || $value === '') {
                            $value = null;
                        }

                        // Convert "Yes" to 1 and "No" to 0 (only if it's a string)
                        if (is_string($value)) {
                            $lowerValue = strtolower(trim($value));
                            if ($lowerValue === 'yes') {
                                return 1;
                            } elseif ($lowerValue === 'no') {
                                return 0;
                            }
                        }

                        // Replace NULL with 0 for specific columns
                        if (in_array($key, $columnsToReplace, true) && is_null($value)) {
                            return 0;
                        }

                        return $value;
                    }, $row, array_keys($row));

                    $observerID = $row[0] ?? null;
                    $examType = $row[1] ?? null;
                    $CENTNO = $row[2] ?? null; // Example: Checking ObserverID, ExamType, and Mobile

                    //    // Check if a record with the same values already exists
                    $exists = DB::table($examDatesTableName)
                        ->where('Observer ID', $observerID)
                        ->where('Exam Type', $examType)
                        ->where('CenterNo', $CENTNO)
                        ->exists();

                    if (!$exists) {

                        try {

                            DB::table($examDatesTableName)->insert([
                                'Observer ID' => $row[0] ?? null,
                                'Exam Type' => $row[1] ?? null,
                                'CenterNo' => $row[2] ?? null,
                                'CityCode' => $row[3] ?? null,
                                'TCCode' => $row[4] ?? null,
                                'D1S1' => $row[5] ?? null,
                                'D1S2' => $row[6] ?? null,
                                'D1S3' => $row[7] ?? null,
                                'D2S1' => $row[8] ?? null,
                                'D2S2' => $row[9] ?? null,
                                'D2S3' => $row[10] ?? null,
                                'D3S1' => $row[11] ?? null,
                                'D3S2' => $row[12] ?? null,
                                'D3S3' => $row[13] ?? null,
                                'D4S1' => $row[14] ?? null,
                                'D4S2' => $row[15] ?? null,
                                'D4S3' => $row[16] ?? null,
                                'D5S1' => $row[17] ?? null,
                                'D5S2' => $row[18] ?? null,
                                'D5S3' => $row[19] ?? null,
                                'D6S1' => $row[20] ?? null,
                                'D6S2' => $row[21] ?? null,
                                'D6S3' => $row[22] ?? null,
                                'D7S1' => $row[23] ?? null,
                                'D7S2' => $row[24] ?? null,
                                'D7S3' => $row[25] ?? null,
                                'D8S1' => $row[26] ?? null,
                                'D8S2' => $row[27] ?? null,
                                'D8S3' => $row[28] ?? null,
                                'D9S1' => $row[29] ?? null,
                                'D9S2' => $row[30] ?? null,
                                'D9S3' => $row[31] ?? null,
                                'D10S1' => $row[32] ?? null,
                                'D10S2' => $row[33] ?? null,
                                'D10S3' => $row[34] ?? null,
                                'D11S1' => $row[35] ?? null,
                                'D11S2' => $row[36] ?? null,
                                'D11S3' => $row[37] ?? null,
                                'D12S1' => $row[38] ?? null,
                                'D12S2' => $row[39] ?? null,
                                'D12S3' => $row[40] ?? null,
                                'A1S1' => $row[5] ?? null,
                                'A1S2' => $row[6] ?? null,
                                'A1S3' => $row[7] ?? null,
                                'A2S1' => $row[8] ?? null,
                                'A2S2' => $row[9] ?? null,
                                'A2S3' => $row[10] ?? null,
                                'A3S1' => $row[11] ?? null,
                                'A3S2' => $row[12] ?? null,
                                'A3S3' => $row[13] ?? null,
                                'A4S1' => $row[14] ?? null,
                                'A4S2' => $row[15] ?? null,
                                'A4S3' => $row[16] ?? null,
                                'A5S1' => $row[17] ?? null,
                                'A5S2' => $row[18] ?? null,
                                'A5S3' => $row[19] ?? null,
                                'A6S1' => $row[20] ?? null,
                                'A6S2' => $row[21] ?? null,
                                'A6S3' => $row[22] ?? null,
                                'A7S1' => $row[23] ?? null,
                                'A7S2' => $row[24] ?? null,
                                'A7S3' => $row[25] ?? null,
                                'A8S1' => $row[26] ?? null,
                                'A8S2' => $row[27] ?? null,
                                'A8S3' => $row[28] ?? null,
                                'A9S1' => $row[29] ?? null,
                                'A9S2' => $row[30] ?? null,
                                'A9S3' => $row[31] ?? null,
                                'A10S1' => $row[32] ?? null,
                                'A10S2' => $row[33] ?? null,
                                'A10S3' => $row[34] ?? null,
                                'A11S1' => $row[35] ?? null,
                                'A11S2' => $row[36] ?? null,
                                'A11S3' => $row[37] ?? null,
                                'A12S1' => $row[38] ?? null,
                                'A12S2' => $row[39] ?? null,
                                'A12S3' => $row[40] ?? null,
                            ]);
                        } catch (\Exception $e) {
                            echo "Error: " . $e->getMessage() . "<br>";
                        }
                    } else {
                        // Store row number or relevant ID in skippedRows array
                        $skippedRows[] = $rowNumber;

                    }
                    $rowNumber++; // Increment row number for next iteration

                    // echo "Row Inserted Successfully! <br>";
                    // } catch (\Exception $e) {
                    //     echo "Error: " . $e->getMessage() . "<br>";
                    // }
                }
            }

            if (!empty($skippedRows)) {
                $skipp = "Skipped rows (already exist): " . implode(", ", $skippedRows);
                return back()->with('success', $skipp);
            } else {
                return back()->with('success', 'Remunetion excel fie imported successfully!');
            }

            //    return back()->with('success', 'Remunetion excel fie imported successfully!');
        } catch (\Exception $e) {
            return back()->with('error', 'Error: ' . $e->getMessage());
        }
    }

    public function editExamDetail(Request $request)
    {
        $request->validate([
            'exam_name' => 'required|string|max:255',
            'exam_type' => 'required|string|max:15',
            'exam_disp' => 'required|string|max:255',
            'exam_mode' => 'required', // Assuming exam_mode is either Online or Offline
            'year' => 'required|digits:4',
            'is_exam_over' => 'required', // Assuming these are the options for exam status
            // 'ExamDate' => 'required',
            // 'ExamShift' => 'required', // An array of exam shifts
            // 'fromOne' => 'required',
            // 'toOne' => 'required',
        ]);
        $examData = $request->all();
        $exam_id = $examData['exam_id'];
        $examType = $examData['exam_type'];
        $examName = $examData['exam_name'];
        $examMode = $examData['exam_mode'];
        $examYear = $examData['year'];
        $ExamDisp = $examData['exam_disp'];
        $Is_ExamOver = $examData['is_exam_over'];
        $ExamDates = config('constants.ExamDates');
        $ExamShiftTable = config('constants.ExamShiftTable');

        $ExamDate = $examData['ExamDate'];
        $fromOne = $examData['fromOne'];
        $toOne = $examData['toOne'];
        $ExamShift = $examData['ExamShift'];
        $result = [];
        //Iterate through each shift array
        foreach ($ExamDate as $key => $value) {
            foreach ($ExamShift as $shiftIndex => $shiftArray) {
                foreach ($shiftArray as $date => $shiftValue) {
                    // Initialize the result array for the specific date if not already set
                    if (!isset($result[$date])) {
                        $result[$date] = [];
                    }

                    // Collect fromOne and toOne times for the current date
                    if (isset($fromOne[$shiftIndex][$date]) && isset($toOne[$shiftIndex][$date])) {
                        $fromTime = $fromOne[$shiftIndex][$date];
                        $toTime = $toOne[$shiftIndex][$date];
                        $result[$date][$shiftValue] = $fromTime . '-' . $toTime; // Store the time range with shift value as key
                    }
                }
            }
        }

        // Sort by date in ascending order
        uksort($result, function ($a, $b) {
            return strtotime($a) - strtotime($b);
        });

        DB::table($ExamDates)
            ->where('Exam Type Id', $exam_id)
            ->update([
                'Exam Type' => $examType,
                'Exam Name' => $examName,
                'Exam_Mode' => $examMode,
                'Year' => $examYear,
                'ExamDisp' => $ExamDisp,
                'Is_ExamOver' => $Is_ExamOver,
                'Is_Active' => 1,
            ]);

        // Insert exam details into ExamDates table

        // $lastInsertId = $newExamID;
        // // echo $lastInsertId;die;
        // //Update the exam dates table with the exam dates
        // $DateIndex = 0;
        // foreach ($result as $index => $examDate) {
        //     $DateIndex++;
        //     DB::table($ExamDates)
        //         ->where('Exam Type Id', $lastInsertId)
        //         ->update(['Date_' . $DateIndex => $index]);
        // }

        // // Insert into ExamShiftTable
        // DB::table($ExamShiftTable)->insert(['Exam Type' => $examType]);
        // $lastInsertIdShift = DB::getPdo()->lastInsertId();

        // $updayteString = '';
        // $dateIndex = 0;

        // // Iterate over the result array
        // foreach ($result as $dateKey => $shiftArray) {
        //     $dateIndex++; // Increment index for each date (D1, D2, etc.)

        //     // Iterate over each shift for the current date
        //     foreach ($shiftArray as $shiftIndex => $shiftvalue) {
        //         // $shiftIndex++; // Increment shift index for each shift (S1, S2, etc.)
        //         $updayteString .= "D{$dateIndex}S{$shiftIndex}='" . $shiftvalue . "',";
        //     }
        // }

        // // Remove the trailing comma from the final string
        // $updayteString = rtrim($updayteString, ',');
        // //print_r($updayteString);die;
        // // Use DB facade to run the stored procedure (if required in Laravel)
        // // DB::table('EXEC updateCommonDataSP :updatefields, :where, :table', [
        // //     'updatefields' => $updayteString,
        // //     'where' => "ID='$lastInsertIdShift' AND [Exam Type]='$examType'",
        // //     'table' => $ExamShiftTable
        // // ]);

        // // Parse the update string into an associative array
        // $updateParts = explode("=", $updayteString);
        // $updateArray = [
        //     $updateParts[0] => $updateParts[1]
        // ];

        // $updateArrayData = preg_replace("/^'(.*)'$/", "$1", $updateArray);

        // // Perform the update
        // DB::table($ExamShiftTable)
        //     ->where(['ID' => $lastInsertIdShift, 'Exam Type' => $examType])
        //     ->update($updateArrayData);
        return $this->index();
    }

}
