<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Services\MasterServices;

class ProfileController extends Controller
{
    public function showChangePasswordForm(){

        $title = 'Change Passsword';
        return view('admin.auth.change-password', compact('title'));
    }

    public function changePassword(Request $request) {


        $user = Auth::user();
       // $user = User::find(Auth::ID());
        // Check if current password matches
        if (!Hash::check($request->CurrentPassword, $user->PasswordHash)) {
            return back()->withErrors(['CurrentPassword' => 'The current password is incorrect']);
        }
        $AdminUserTbl = config('constants.AdminUserTbl');
        // Update the password
        $changePassword = Hash::make($request->NewPassword);
        // Logout and redirect to login page
        //Auth::logout();
        $update = DB::statement(DB::raw("exec updateCommonDataSP :updatefields, :where, :table"), [
            ':updatefields' => "PasswordHash='$changePassword'",
            ':where' => "WHERE ID= '$user->ID'",
            ':table' => $AdminUserTbl,
        ]);
        if($update){
            if(Auth::user()->Role_ID == 24){
                return redirect()->route('admin.dashboard')->with('success', 'Password changed successfully. Please login again.');
            }else if(Auth::user()->Role_ID == 27){
                return redirect()->route('admin.superdashboard')->with('success', 'Password changed successfully. Please login again.');
            }
        }else{
            //return redirect()->route('admin.superdashboard')->with('warning', 'Something went wrong. Please try again.');
            return back()->withErrors(['NewPassword' => 'Unable to update the password. Please try again later.']);
        }


    }


    public function AdminLogout(Request $request)
    {

        Auth::logout();
        $request->session()->invalidate();
        $request->session()->regenerateToken();
        return redirect('/admin/login');
    }

    public function viewProfile(){

        $title = 'View Profile';
        $user = Auth::user();
        $userdetails = User::find($user->ID);
        return view('admin.profile.index', ['title' => $title,'data' => $userdetails]);

    }

    public function updateProfile(Request $request){

        try {
            $loginInfo = Auth::user();
            $UserAdminTable = config('constants.AdminUserTbl');

            if ($loginInfo) {
                $destinationPath = public_path('admin/uploads/' . $loginInfo->UserName);
                if ($request->file('ProfileImage')) {
                    $file = $request->file('ProfileImage');
                    if (!file_exists($destinationPath)) {
                        mkdir($destinationPath, 0777, true);
                    }
                    $fileName = time().'_.' . $file->getClientOriginalExtension();
                    $file->move($destinationPath, $fileName);
                    $profileImagePath = 'uploads/' . $loginInfo->UserName . '/' . $fileName;
                } else {
                    $profileImagePath = $request->oldProfileImage ? $request->oldProfileImage : 'NULL';
                }

                $fullName =  $request->FullName ?  $request->FullName : null;
                $dob =  $request->DOB ?  $request->DOB : null;
                $ProfileImage =  $profileImagePath ?  $profileImagePath : null;

                $userUpdate = DB::statement(DB::raw("exec updateCommonDataSP :updatefields, :where, :table"), [
                    ':updatefields' => "[FullName] = '$fullName',DOB= '$dob',[ProfileImage]= '$ProfileImage' ",
                    ':where' => "WHERE ID= '$loginInfo->ID'",
                    ':table' => "[$UserAdminTable]",
                ]);

            }else{
                return redirect()->route('profile.view')->with('warning', 'Unauthorized user.');
            }
            MasterServices::customlog('Profile','User Update Profile.');
            return redirect()->route('profile.view')->with('success', 'Profile updated successfully.');
        } catch (\Exception $e) {
            $message = $e->getMessage();
            dd($message);
            return redirect()->back()->with('error', $message);
        }

    }
}
