<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use Illuminate\View\View;
use Illuminate\Support\Facades\DB;
use Auth;
use App\Services\MasterServices;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Collection;

class markAttendanceController extends Controller
{
    //
    public function index(Request $request): View
    {

        $mockDrillShow = 'yes';

        $TATBL = config('constants.TABillHeaderTbl');
        $OBSProfile = config('constants.ExamProfile');
        $ExamDates = config('constants.ExamDates');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        $ExamShift = config('constants.ExamShiftTable');

        $ExamType = Session::get('examType');
        MasterServices::CheckIsShift($ExamType); //setexam type session
        // $request->session()->set('ShiftWiseExam', 'Yes');
        Session::put('ShiftWiseExam', 'yes');

        // prd(Session::get('ShiftWiseExam'));

        $NTA_Unique_Admin_ID = Auth::user()->UserName;
        $observer = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'ExamType,CENTNO,TC_CODE',
            'input' => "WHERE ObserverID='$NTA_Unique_Admin_ID' and ExamType='$ExamType'",
            'table' => "[$OBSProfile]"
        ]);
        // prd($observer);

        $centerNoArr = array_column($observer, 'CENTNO');
        $tcCodeArr = array_column($observer, 'TC_CODE');

        if (count($centerNoArr) === count($tcCodeArr)) {
            $centerNoArr = array_combine($centerNoArr, $tcCodeArr);
        } else {
            // Handle the mismatch error
            $centerNoArr = []; // or log an error or throw an exception
        }

        // pr($centerNoArr);
        $GetFilter = '';
        $showData = 'All';
        $attenanceFilter = null;
        if ($request->input('filter')) {
            $GetFilter = $request->input('filter');
            $showData = $request->input('showData');
        }
        if ($request->input('showData')) {
            $showData = $request->input('showData');
        }
        if ($request->input('attendance')) {
            if ($request->input('attendance') == 'yes') {
                $attenanceFilter = 1;
            } elseif ($request->input('attendance') == 'no') {
                $attenanceFilter = 2;
            }
        }


        /************************************************** Shift wise******************************************************************/
        $centerNoString = implode(',', array_keys($centerNoArr));
        // prd($centerNoString);
        if ($request->session()->get('ShiftWiseExam') == 'yes') {
            $observerList = DB::select(DB::raw("getObserverListShiftSP '$ExamType','$centerNoString','$GetFilter','$attenanceFilter'"));
            // prd($observerList);
        } else {
            /************************************************** without Shift wise******************************************************************/
            $observerList = DB::select(DB::raw("getObserverListSP '$ExamType','$centerNoString','$GetFilter','$attenanceFilter'"));
        }

        $examDates = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => "Date_1,Date_2,Date_3,Date_4,Date_5,Date_6,Date_7,Date_8,Date_9,Date_10,Date_11,Date_12",
            'input' => "WHERE [Exam Type]='$ExamType'",
            'table' => "[$ExamDates]"
        ]);

        $aliases = [];

        for ($d = 1; $d <= 12; $d++) {
            for ($s = 1; $s <= 4; $s++) {
                $col = "D{$d}S{$s}";
                //$aliases[] = "EP.[$col] AS EP_$col";  // Alias columns from EP table
                $aliases[] = "ES.[$col] AS ES_$col";  // Alias columns from ES table
            }
        }

        // Convert alias array to a comma-separated string
        $aliasString = implode(", ", $aliases);

        $query = "SELECT EP.*, ED.*, $aliasString
          FROM [$ExamProfileShiftWise] EP
          LEFT JOIN [$ExamDates] ED ON EP.[Exam Type] = ED.[Exam Type]
          LEFT JOIN [$ExamShift] ES ON EP.[Exam Type] = ES.[Exam Type]
          WHERE EP.[Exam Type] = :ExamType";
        // Execute the query using Laravel's DB::selectOne
        $examDatesWithShifts = DB::selectOne($query, [
            'ExamType' => $ExamType,
        ]);

        if ($examDatesWithShifts) {

            $dutyDay = [];
            foreach ($examDatesWithShifts as $key => $value) {
                if (preg_match('/^ES_D(\d+)S(\d+)$/', $key, $matches) && !empty($value)) {
                    $day = "D" . $matches[1];
                    $shift = "S" . $matches[2];

                    if (!isset($dutyDay[$day])) {
                        $dutyDay[$day] = [];
                    }
                    $dutyDay[$day][$shift] = $value;
                }
            }
            // prd($dutyDay);
            $examDatesWithShifts->DutyDay = $dutyDay;
            $shiftDateCount = [];
            for ($day = 1; $day <= 12; $day++) {
                $dateKey = "Date_" . $day;
                if (!empty($examDatesWithShifts->$dateKey)) {
                    $shiftDateCount[] = $examDatesWithShifts->$dateKey;
                }
            }
        } else {
            $examDatesWithShifts = [];
            $shiftDateCount = [];
        }


        if (empty($observerList)) {
            return view('markattendance.index', [
                'data' => new LengthAwarePaginator([], 0, 1),
                'examDates' => [],
                'mockDrillShow' => false,
                'page' => 0,
                'shiftDateCount' => $shiftDateCount,
                'examDatesWithShifts' => $examDatesWithShifts,
            ]);
        }

        $currentPage = Paginator::resolveCurrentPage() ?? 1;
        $perPage = $showData == 'All' ? count($observerList) : (int) $showData;
        $collection = collect($observerList);
        $currentPageItems = $collection->slice(($currentPage - 1) * $perPage, $perPage)->all();
        $paginatedItems = new LengthAwarePaginator($currentPageItems, count($collection), $perPage, $currentPage, [
            'path' => Paginator::resolveCurrentPath(),
            'query' => $request->query(),
        ]);

        // prd($paginatedItems);

        $serialNo = ($perPage * $currentPage) - $perPage;

        return view('markattendance.index', [
            'data' => $paginatedItems,
            'examDates' => (array)$examDates,
            'mockDrillShow' => $mockDrillShow,
            'page' => $serialNo,
            'CenterNoList' => $centerNoArr ?? [],
            'shiftDateCount' => $shiftDateCount,
            'examDatesWithShifts' => $examDatesWithShifts
        ]);
    }
    public function marked(Request $request)
    {
        MasterServices::customlog('Mark Attendance', 'User Mark Attendance.');
        $OBSProfile = config('constants.ExamProfile');
        $ShiftWiseAttendance = config('constants.ExamProfileShiftWise');
        $ShiftWiseData = config('constants.ShiftWiseData');

        $return = array('status' => 0);
        if ($request->isMethod('post')) {
            $allval = $request->all();
            $data = $allval['jsonData'];
            // prd($data);
            $ExamType = $request->session()->get('examType');

            if ($request->session()->get('ShiftWiseExam') == 'yes') {
                /***************************************************** shift wise ***************************************************************/
                // prd($data);
                foreach ($data as $id => $rows) {
                    foreach ($rows as $row) {

                        $insertData = [];
                        $CENTNO = $row['CENTNO'];
                        $insertData['Observer ID'] = $row['ID'];
                        // $insertData['Total Shift'] = $row['totalAttendance'];

                        $obsData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                            'select' => "ExamType,CENTNO,City_code,TC_CODE",
                            'input' => "WHERE [ExamType]='$ExamType' and ObserverID='$row[ID]' and CENTNO='$CENTNO'",
                            'table' => "[$OBSProfile]"
                        ]);

                        // prd($obsData);
                        $insertData['Exam Type'] = $obsData->ExamType;
                        $insertData['CenterNo'] = $obsData->CENTNO;
                        $insertData['CityCode'] = $obsData->City_code;
                        $insertData['TCCode'] = $obsData->TC_CODE;
                        for ($i = 1; $i <= 12; $i++) {
                            for ($k = 1; $k <= 4; $k++) {
                                if (isset($row['D' . $i . 'S' . $k]) && ($row['D' . $i . 'S' . $k] == 1)) {
                                    $insertData['D' . $i . 'S' . $k] = 1;
                                } else {
                                    $insertData['D' . $i . 'S' . $k] = 0;
                                }
                            }
                        }
                        // prd($insertData);
                        $isblock = $row['isblock'];
                        $totalAtt = 0;
                        $days = [];
                        if (isset($row) && !empty($row)) {
                            foreach ($row as $key => $value) {
                                if (preg_match('/^D(\d+)S\d+$/', $key, $matches) && $value == 1) {
                                    $days[$matches[1]] = true;
                                }
                            }
                            $totalAtt = count($days);
                        }

                        //$totalAttendance = $row['totalAttendance'];
                        $totalAttendance = $totalAtt;
                        $mokedrill = $row['mokedrill']; //mokedrill
                        $reset_profile = array();

                        $shiftAtt_Total_Shift = $totalAttendance;
                        $shiftAtt = '';
                        for ($i = 1; $i <= 12; $i++) {
                            for ($k = 1; $k <= 4; $k++) {
                                if (isset($row['D' . $i . 'S' . $k]) && ($row['D' . $i . 'S' . $k] == 1)) {
                                    $shiftAtt .= "A{$i}S{$k}='1',";
                                }
                            }
                        }

                        //end attendance

                        //reset start
                        $reset_Attendance = '';
                        for ($ik = 1; $ik <= 12; $ik++) {
                            for ($kj = 1; $kj <= 4; $kj++) {
                                $reset_Attendance .= "A{$ik}S{$kj}='0',";
                            }
                        }
                        $reset_Attendance = rtrim($reset_Attendance, ','); //remove right ,
                        $shiftAtt = rtrim($shiftAtt, ','); //remove right ,
                        // set value
                        // prd($reset_Attendance);
                        $string_ATT = 0;
                        if ($totalAttendance > 0) {
                            $string_ATT = 1;
                        }
                        $string_A_Dutydays = $totalAttendance;
                        $string_A_MT = $mokedrill;

                        //Reset mark attendance
                        $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "ATT='0', A_Dutydays='0', IsBlocked='0', A_MT='0'",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);

                        $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "$reset_Attendance",
                            'where' => "where [Observer ID]='$row[ID]' and [Exam Type]='$ExamType' and CenterNo='$CENTNO' ",
                            'table' => "[$ShiftWiseAttendance]",
                        ]);
                        // echo $reset_Attendance;
                        // // echo $CENTNO;
                        // die;
                        //end reset

                        if ($isblock == 1) {
                            //update set block candidate
                            $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                'updatefields' => "IsBlocked='1'",
                                'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                                'table' => "[$OBSProfile]",
                            ]);
                        } else {
                            //set mark attendance
                            $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                'updatefields' => "ATT='$string_ATT', A_Dutydays='$string_A_Dutydays', A_MT='$string_A_MT'",
                                'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                                'table' => "[$OBSProfile]",
                            ]);
                            //check point exists
                            $checkDataExists = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                                'select' => "*",
                                'input' => "WHERE [Exam Type]='$ExamType' and [Observer ID]='$row[ID]' and CenterNo='$CENTNO'",
                                'table' => "[$ShiftWiseAttendance]"
                            ]);

                            //prd($shiftAtt);


                            $checkDataExists = (array) $checkDataExists; // convert array
                            $insert = 0;
                            if (isset($checkDataExists['Observer ID']) && !empty($checkDataExists['Observer ID'])) { //update
                                $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                                    'updatefields' => "{$shiftAtt}", //, [Total Shift]='$shiftAtt_Total_Shift'
                                    'where' => "where [Observer ID]='$row[ID]' and [Exam Type]='$ExamType' and CenterNo='$CENTNO' ",
                                    'table' => "[$ShiftWiseAttendance]",
                                ]);
                            } else {
                                //insert

                                $tableColumns = '[' . join('],[', array_keys($insertData)) . ']';
                                // echo $tableColumns;
                                // die;
                                $tableValues = "'" . join("','", array_values($insertData)) . "'";
                                // echo $tableValues;
                                // die;
                                DB::statement('exec insertCommonDataSP :fields, :values, :table', [
                                    'fields' => "$tableColumns",
                                    'values' => "$tableValues",
                                    'table' => "[$ShiftWiseAttendance]",
                                ]);
                            }
                        }

                        if ($resetVal == 1 && ($update == 1 || $insert == 1)) {
                            $message = "<span class='badge bg-success messageR'>Attendance updated successfully.</span>";
                            $return = ['status' => 'true', 'message' => $message];
                        } else {
                            $return = ['status' => 'false', 'message' => "<span class='badge bg-danger messageR'>Some thing went wrong.</span>"];
                        }
                    }
                }
            } else {
                /********************************************** without shift **********************************************************************/

                foreach ($data as $id => $row) {

                    $CENTNO = $row['CENTNO'];
                    $isblock = $row['isblock'];
                    $totalAttendance = $row['totalAttendance']; //totalAttendance
                    $mokedrill = $row['mokedrill']; //mokedrill
                    $string_ATT = 0;
                    if ($totalAttendance > 0) {
                        $string_ATT = 1;
                    }
                    $string_A_Dutydays = $totalAttendance;
                    $string_A_MT = $mokedrill;
                    $string_Attendance = '';
                    for ($i = 1; $i <= 12; $i++) {
                        if (isset($row['A_D' . $i]) && !empty($row['A_D' . $i])) {
                            $string_Attendance .= "A_D{$i}='1',";
                        }
                    }

                    //reset
                    $reset_Attendance = '';
                    for ($i = 1; $i <= 12; $i++) {
                        $reset_Attendance .= "A_D{$i}='0',";
                    }
                    $reset_Attendance = rtrim($reset_Attendance, ','); // remove right side ,
                    $string_Attendance = rtrim($string_Attendance, ','); // remove right side ,
                    //Reset mark attendance
                    $resetVal = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                        'updatefields' => "ATT='0', A_Dutydays='0', IsBlocked='0', A_MT='0', $reset_Attendance",
                        'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                        'table' => "[$OBSProfile]",
                    ]);

                    if ($isblock == 1) {
                        //update set block candidate
                        $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "IsBlocked='1'",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);
                    } else {
                        //set mark attendance
                        $update = DB::statement('exec updateCommonDataSP :updatefields, :where, :table', [
                            'updatefields' => "ATT='$string_ATT', A_Dutydays='$string_A_Dutydays', A_MT='$string_A_MT',$string_Attendance",
                            'where' => "where ObserverID='$row[ID]' and ExamType='$ExamType' and CENTNO='$CENTNO' ",
                            'table' => "[$OBSProfile]",
                        ]);
                    }
                    if ($update == 1 && $resetVal == 1) {
                        $message = "<span class='badge bg-success messageR'>Attendance updated successfully.</span>";
                        $return = ['status' => 'true', 'message' => $message];
                    } else {
                        $return = ['status' => 'false', 'message' => "<span class='badge bg-danger messageR'>Some thing went wrong.</span>"];
                    }
                }
                /********************************************end************************************************************************/
            }
        }
        return json_encode($return);
    }

    public function ckeckObserverDetails(Request $request)
    {
        $OBSProfile = config('constants.ExamProfile');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');

        if ($request->isMethod('post') && $request->ntaID) {
            $ntaID = $request->ntaID;
            $centerNo = $request->centerNo;
    
            $selectFields = implode(',', [
                'p.ObserverID', 'p.CENTNO', 'p.[Observer Type]', 'p.Name', 'p.Email', 'p.Mobile',
                // Shift fields
                'ps.[D1S1]','ps.[D1S2]','ps.[D1S3]','ps.[D2S1]','ps.[D2S2]','ps.[D2S3]',
                'ps.[D3S1]','ps.[D3S2]','ps.[D3S3]','ps.[D4S1]','ps.[D4S2]','ps.[D4S3]',
                'ps.[D5S1]','ps.[D5S2]','ps.[D5S3]','ps.[D6S1]','ps.[D6S2]','ps.[D6S3]',
                'ps.[D7S1]','ps.[D7S2]','ps.[D7S3]','ps.[D8S1]','ps.[D8S2]','ps.[D8S3]',
                'ps.[D9S1]','ps.[D9S2]','ps.[D9S3]','ps.[D10S1]','ps.[D10S2]','ps.[D10S3]',
                'ps.[D11S1]','ps.[D11S2]','ps.[D11S3]','ps.[D12S1]','ps.[D12S2]','ps.[D12S3]',
                'ps.[D1S4]','ps.[D2S4]','ps.[D3S4]','ps.[D4S4]','ps.[D5S4]','ps.[D6S4]',
                'ps.[D7S4]','ps.[D8S4]','ps.[D9S4]','ps.[D10S4]','ps.[D11S4]','ps.[D12S4]'
            ]);
    
            // First attempt: Try to get detailed data with shift info
            $obsData = DB::selectOne(
                "EXEC getCommonDataSP :select, :input, :table",
                [
                    'select' => $selectFields,
                    'input'  => "JOIN [$ExamProfileShiftWise] ps ON p.ObserverID = ps.[Observer ID] AND p.CENTNO = ps.CenterNo WHERE p.ObserverID = '$ntaID' AND p.CENTNO = '$centerNo'",
                    'table'  => "[$OBSProfile] p",
                ]
            );
    
            // Fallback: If no detailed shift data, get just the basic profile
            if (empty($obsData)) {
                $obsData = DB::selectOne(
                    "EXEC getCommonDataSP :select, :input, :table",
                    [
                        'select' => 'p.ObserverID, p.CENTNO, p.[Observer Type], p.Name, p.Email, p.Mobile',
                        'input'  => "WHERE p.ObserverID = '$ntaID'",
                        'table'  => "[$OBSProfile] p",
                    ]
                );
            }
    
            $filteredData = [];
    
            if ($obsData) {
                foreach ((array) $obsData as $key => $value) {
                    // Always include basic profile info
                    if (in_array($key, ['ObserverID', 'CENTNO', 'Observer Type', 'Name', 'Email', 'Mobile'])) {
                        $filteredData[$key] = $value;
                    }
                    // Include only shift fields with value 1
                    elseif (preg_match('/^D\d{1,2}S[1-4]$/', $key) && $value == 1) {
                        $filteredData[$key] = $value;
                    }
                }
            }
    
            return response()->json($filteredData);
        }
    
        return response()->json([], 404);
    }

    public function createAttendance(Request $request)
    {
        $ExamProfile          = config('constants.ExamProfile');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');

        if (!$request->isMethod('post')) {
            abort(405);
        }

        $centerNos    = $request->input('CenterNo', []);
        $TcCodes      = $request->input('TcCode', []);
        $observerTypes = $request->input('ObserverType', []);
        $ntaIds       = $request->input('NTA_ID', []);
        $names        = $request->input('Name', []);
        $emails       = $request->input('EmailID', []);
        $phones       = $request->input('Phone', []);
        $shiftWiseArr = $request->input('ShiftWise', []);
        $ExamType     = $request->session()->get('examType');

        $count = count($ntaIds);

        for ($i = 0; $i < $count; $i++) {
            $shiftData = $shiftWiseArr[$i] ?? [];
            $dayFlags  = [];
            $dutyDays  = 0;

            foreach ($shiftData as $key => $val) {
                if (preg_match('/^D(\d+)S(\d+)$/', $key, $m)) {
                    $day     = 'D' . $m[1];
                    $day_Att = 'A_D' . $m[1];
                    $value   = (int) $val;

                    if (!isset($dayFlags[$day]) || $value === 1) {
                        $dayFlags[$day] = $value;
                        $dayFlags[$day_Att] = $value;
                    }
                }

                if (preg_match('/^D(\d+S\d+)$/', $key, $m)) {
                    $shiftData['A' . $m[1]] = $val;
                }
            }

            foreach ($dayFlags as $day => $flag) {
                if ($flag === 1) {
                    $dutyDays++;
                }
            }

            $mainData = [
                'ObserverID'    => $ntaIds[$i],
                'CENTNO'        => $centerNos[$i],
                'TC_CODE'       => $TcCodes[$i],
                'Observer Type' => $observerTypes[$i],
                'Name'          => $names[$i],
                'Email'         => $emails[$i],
                'Mobile'        => $phones[$i],
                'ExamType'      => $ExamType,
                'BillType'      => 1,
                'ATT'           => 1,
                'A_MT'          => 1,
                'Dutydays'      => $dutyDays,
                'A_Dutydays'    => $dutyDays,
            ];

            foreach ($dayFlags as $day => $flag) {
                $mainData[$day] = $flag;
            }

            // Main table insert or update
            DB::table($ExamProfile)->updateOrInsert(
                [
                    'ObserverID' => $ntaIds[$i],
                    'ExamType'   => $ExamType,
                    'CENTNO' => $centerNos[$i],
                ],
                $mainData
            );

            // Prepare shift-wise data
            $shiftData['Observer ID'] = $ntaIds[$i];
            $shiftData['CenterNo']    = $centerNos[$i];
            $shiftData['Exam Type']   = $ExamType;
            $shiftData['TCCode']      = $TcCodes[$i];

            // Shift-wise check: update if exists, else insert
            $existingShift = DB::table($ExamProfileShiftWise)
                ->where('Observer ID', $ntaIds[$i])
                ->where('Exam Type', $ExamType)
                ->where('CenterNo', $centerNos[$i])
                ->first();

            if ($existingShift) {
                DB::table($ExamProfileShiftWise)
                    ->where('Observer ID', $ntaIds[$i])
                    ->where('Exam Type', $ExamType)
                    ->where('CenterNo', $centerNos[$i])
                    ->update($shiftData);
            } else {
                DB::table($ExamProfileShiftWise)->insert($shiftData);
            }
        }

        return redirect()->back()->with('success', 'Attendance saved successfully!');
    }

}
