<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;

class DynamicTitle
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        $routeName = $request->route()->getName();
        $title = $this->getTitle($routeName);
        // Ensure the title is shared before processing the request
        view()->share('title', $title);
        \Log::info('Title set in middleware: ' . $title);
        return $next($request);
    }

    protected function getTitle($routeName)
    {
        // Define your titles here based on route names
        $titles = [
            'login' => 'Login',
            'home' => 'Login',
            'dashboard' => 'Dashboard',
            'my-profile' => 'My Profile',
            'exam-dashboard' => 'Exam Dashboard',
            'exam-subdashboard' => 'Exam Dashboard',
            'tabill' => 'Create Bill',
            'submit-bill-report' => 'Bill Status',
            'contact' => 'Contact Us',
            'submit-feedback' => 'Submit Feedback',
            'change-password' => 'Change Password',
            'view-profile' => 'View Profile',
            'edit-profile' => 'Edit Profile',
            'exam-detail' => 'Exam Details',
            'contact-details' => 'City Coordinator Contact Details',
            'mark-attendance' => 'Mark Attendance',
            'observer-report' => 'Observer Report',
            'city-coordinator-report' => 'City Coordinator Report',
            'cs-report' => 'Centre Superintendent Report',
            'activitylog' => 'Activity Log'


            // Add more route titles here
        ];

        return $titles[$routeName] ?? 'NTA';
    }
}
