<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class RoleMiddleware
{
    public function handle($request, Closure $next, ...$allowedRoles)
    {
        $user = Auth::user();

        // Check if user is authenticated and their Role_ID matches allowed roles
        if (!$user || !in_array($user->Role_ID, $allowedRoles)) {
            //return redirect('/admin/login'); // Redirect to unauthorized page
            return redirect()->route('admin.loginpage');
        }

        return $next($request);
    }
}
