<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class ShiftWiseDutyDaysRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, mixed>
     */
    public function rules()
    {
        return [
            'CenterNo' => 'required|max:10',
            'CityCode' => 'required',
            'TCCode' => 'required',
        ];
    }

    public function messages()
    {
        return [
            'CenterNo.required' => ':attribute cannot be blank.',
            'CityCode.required' => ':attribute cannot be blank.',
            'TCCode.required' => ':attribute cannot be blank.'
        ];
    }

    public function attributes()
    {
        return [

            'CenterNo' => 'Center No.',
            'CityCode' => 'City Code',
            'TCCode' => 'TC Code'
        ];
    }
}
