<?php

namespace App\Traits;

use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;

trait CommonBillData
{

    public function getCCBilldata($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL)
    {


        /*=============Constants value Start====================*/
        $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
        $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');//CentralizedRemunerationLineTable
        $CentralizedFormFields = config('constants.CentralizedFormFields');
        $ExamProfile = config('constants.ExamProfile');
        $RoleName = config('constants.RoleName');
        $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');

        /*=============Constants value End====================*/

        //$ExamType =  Session::get('examType');
        //$ObserverID =  Session::get('ObserverID');
        $Role =   isset($role) && !empty($role) ? $role : Session::get('role');

        /*=============Request value start====================*/
        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('referenceID');
        $ObserverID = request()->input('ObserverID');
        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        /*=============Request value end====================*/
        $ObserverType = $RoleName[$Role];
        $FieldsArray = [];

        $query = "exec getCommonDataSP :select, :input, :table, :orderBy";
        $params = [
            'select' => 'fieldName, fieldLabel, displayOrder',
            'input' => "WHERE [ExamType]='{$ExamType}' AND Role=$Role",
            'table' => "[$CentralizedFormFields] as CZ",
            'orderBy' => 'order by CZ.[displayOrder] ASC'
        ];
        $FieldsDataObj = DB::select($query, $params);

        $FieldsData = $FieldsDataObj;

        if (isset($FieldsData) && !empty($FieldsData)) {
            $FieldsArray = json_decode(json_encode($FieldsData), true);
        }

        $CCOfflineData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
            ':table' => "[$CityCoordinatorOfflineTbl] as cc"
        ]);
        if (isset($CCOfflineData) && !empty($CCOfflineData)) {
            $UserDataToArray = (array) $CCOfflineData;
        } else {
            $UserDataToArray = [];
        }

        $CENTNO = Session::get('centers');
        $CENTNOArray = array_map(function ($item) {
            return "'" . $item . "'";
        }, $CENTNO);
        $CENTNOSTR = implode(',', $CENTNOArray);
        $ExtraFields = array();

        $observersCountArr = DB::select("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [ExamType] = '{$ExamType}' AND [Observer Type] = '{$Role}' AND CENTNO IN ($CENTNOSTR) ",
            ':table' => "[$ExamProfile] as cc"
        ]);
        $observersCount = count($observersCountArr);

        $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => "Name",
            'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
            'table' => "[$ExamProfile]",
        ]);
        if ($Role == 1 or $Role == 14) {
            $ExtraFields['Name of RC'] = $rcName->Name ?? 'NA';
            $ExtraFields['ExamName'] = Session::get('examName');
            $ExtraFields['City Coordinator Name'] = Session::get('Name');
            $ExtraFields['No_ of Alloted Centres'] = count(Session::get('centers'));
            $ExtraFields['No_ of Alloted Observer'] = $observersCount ?? 'NA';
        }

        foreach ($FieldsArray as $key => $val) {
            if (array_key_exists($val['fieldName'], $ExtraFields)) {
                $FieldsArray[$key]['fieldValue'] = $ExtraFields[$val['fieldName']]; //set value
            } else {
                $FieldsArray[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value
            }
        }

        $RemunerationFieldsArray = [];

        $rmQuery = "exec getCommonDataSP :select, :input, :table, :orderBy";
        $rmParams = [
            'select' => 'isExtrafield,Field_Name, MockDrillFiledName,Field_Name_Deduction, MockDrillFiledName_Deduction, [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text]',
            'input' => "INNER JOIN [$CRLTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
            'table' => "[$CRHTable] as CRH",
            'orderBy' => 'order by displayOrder ASC'
        ];
        $RemunerationFieldsData = DB::select($rmQuery, $rmParams);
        // prd($RemunerationFieldsData);
        $RemunerationFieldsArray = [];
        if (!empty($RemunerationFieldsData)) {
            $RemunerationFieldsArray = array_map(function ($item) {
                return (array) $item;
            }, $RemunerationFieldsData);
        }

        $NoofPerson = explode(',', $UserDataToArray['No_ of Person']);
        $NoofDays = explode(',', $UserDataToArray['No_ of Days']);
        foreach ($RemunerationFieldsArray as $key => $val) {

            $RemunerationFieldsArray[$key]['FieldValue'] = $UserDataToArray[$val['Field_Name']] ?? 'NA';
            $RemunerationFieldsArray[$key]['MockDrillFieldValue'] = $UserDataToArray[$val['MockDrillFiledName']] ?? 'NA';
        }

        $ccdata = ['RemunerationFieldsArray' => $RemunerationFieldsArray, 'FieldsArray' => $FieldsArray, 'UserDataToArray' => $UserDataToArray, 'ObserverType' => $ObserverType, 'pdf' => $pdf, 'NoofPerson' => $NoofPerson, 'NoofDays' => $NoofDays];

        return $ccdata;
    }

    public function getObsBillData($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL)
    {

        $IsNewBill = request()->input('IsNewBill');
        if($IsNewBill == '0'){
            $CRLTable = config('constants.CentralizedRemunerationLineTable');
        }else{
            $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        }
        $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
        $CentralizedFormFields = config('constants.CentralizedFormFields');
        $TATBL = config('constants.TABillHeaderTbl');
        $TABillLocalTbl = config('constants.TABillLocalTbl');
        $ExamProfile = config('constants.ExamProfile');
        $ExamDates = config('constants.ExamDates');
        $ExamProfileShiftWise = config('constants.ExamProfileShiftWise');
        //Outstation Table
        $TABillHotelTbl =  config('constants.TABillHotelTbl');
        $TABillOutstationTbl =  config('constants.TABillOutstationTbl');

        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('ReferenceNo');
        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        $Role =  isset($role) && !empty($role) ? $role : Session::get('role');
        $ObserverID = !empty(request()->input('ObserverID')) ? request()->input('ObserverID') : Session::get('ObserverID');
        $centers =  Session::get('centers');
        $CENTNOArray = array_map(function ($item) {
            return "'" . $item . "'";
        }, $centers);
        $CENTNOSTR = implode(',', $CENTNOArray);
        $RoleName = config('constants.RoleName');
        $ObserverType = (isset($Role) && !empty($Role)) ? $RoleName[$Role] : '';

        $checkBillType = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => 'IsNewBill',
            'input' => "WHERE [Reference No_]='{$ReferenceNo}'",
            'table' => "[$TATBL]"
        ]);
        // ++++++++++++++++++++++++++++++++++ Exam Date ====================================//
        $ExamDate = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => 'Exam_Duration',
            'input' => "WHERE [Exam Type]='{$ExamType}'",
            'table' => "[$ExamDates]"
        ]);
        // prd($ExamDate);
        // ++++++++++++++++++++++++++++++++++ Exam Date ====================================//
        $ObserverCCList = [];
        $ObserverCCList = (array)DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => "Name,Mobile",
            'input' => "WHERE [Observer Type]='1' and ExamType='$ExamType' and CENTNO in ($CENTNOSTR)",
            'table' => "[$ExamProfile]"
        ]);

        $UserDataToArray = [];
        $ObserverPersonalData = [];
        $ObserverPersonalDataOLD = [];
        // if($checkBillType->IsNewBill != 1)
        // {
        $ObserverPersonalDataOLD = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'Amount',
            'input' => "WHERE [Reference No_]='{$ReferenceNo}'",
            'table' => "[$TABillLocalTbl]"
        ]);
        //}
        $ObserverPersonalData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => 'TB.*, TL.Amount as Amount, TL.[File Path],EP.Name as [Observer Name]',
            'input' => "LEFT JOIN [$TABillLocalTbl] as TL ON TL.[Reference No_]=TB.[Reference No_] INNER JOIN [$ExamProfile] as EP ON TB.[Observer ID]=EP.ObserverID WHERE TB.[Reference No_]='{$ReferenceNo}'",
            'table' => "[$TATBL] as TB"
        ]);

        //prd($ObserverPersonalData);
        if (isset($ObserverPersonalData) && !empty($ObserverPersonalData)) {
            $UserDataToArray = (array) $ObserverPersonalData;
        }

       // prd($UserDataToArray);

        //Dynamic Field Name fetch for Billing Data Start
        $FieldsArray = [];
        $FieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
            'select' => 'fieldName, fieldLabel, displayOrder',
            'input' => "WHERE [ExamType]='{$ExamType}' AND Role=$Role",
            'table' => "[$CentralizedFormFields] as CZ",
            'orderBy' => 'order by CZ.[displayOrder] ASC'
        ]);

        if (isset($FieldsData) && !empty($FieldsData)) {

            $FieldsArray = json_decode(json_encode($FieldsData), true);
            foreach ($FieldsArray as $key => $val) {
                if (isset($val['fieldName']) && $val['fieldName'] == 'CcName') {
                    $FieldsArray[$key]['fieldValue'] = $ObserverCCList['Name'] . ', ' . $ObserverCCList['Mobile'] ?? 'NA';
                } elseif (isset($val['fieldName']) && $val['fieldName'] == 'Exam Date') {
                    $FieldsArray[$key]['fieldValue'] = $ExamDate->Exam_Duration ?? 'NA';
                } else {
                    $FieldsArray[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA';
                }
            }
        }

        //prd($UserDataToArray);
        //Dynamic Field Name fetch for Billing Data End
        //Travel Details Start
        $travelArray = [];
        $travel = DB::select("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
            ':table' => "[$TABillOutstationTbl] as TR"
        ]);

        if (!empty($travel)) {
            $travelArray = array_map(function ($item) {
                return (array) $item;
            }, $travel);
        }
        $travelExpenseTotal = 0;
        $EligibleTaxesTotal = 0;
        $travelDeductionAmount = 0;

        //prd($travelArray);

        if (isset($travelArray) && !empty($travelArray)) {
            foreach ($travelArray as $tExp) {
                $travelExpenseTotal += floatval(sprintf('%g', $tExp['Amount']));
                $EligibleTaxesTotal += floatval(sprintf('%g', $tExp['Approved Amount']));
                $travelDeductionAmount += floatval(sprintf('%g', $tExp['Deduction Amount']));
            }

            if ($travelDeductionAmount == 0) {
                $travelDeductionAmount = '-';
            }
        }

        //Travel Bill Details End

        //Hotel Bill Details Start

        $hotelArray = [];
        $hotel = DB::select("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
            ':table' => "[$TABillHotelTbl] as HT"
        ]);

        if (!empty($hotel)) {
            $hotelArray = array_map(function ($item) {
                return (array) $item;
            }, $hotel);
        }

        $hotelExpenseTotal = 0;
        $hotelDeductionAmount = 0;
        if (isset($hotelArray) && !empty($hotelArray)) {
            foreach ($hotelArray as $hExp) {
                $hotelExpenseTotal += floatval(sprintf('%g', $hExp['Total Amount']));
                $hotelDeductionAmount += floatval(sprintf('%g', $hExp['Deduction Amount']));
            }
            if ($hotelDeductionAmount == 0) {
                $hotelDeductionAmount = '-';
            }
        }

        $travelExpenseTotal = $travelExpenseTotal + $EligibleTaxesTotal;
        $totalOutstationExpense = $travelExpenseTotal + $hotelExpenseTotal;
        //Hotel Bill Details End
        // $totalPayableAmt = 0;
        // if (isset($travel) && !empty($travel)) {

        //     $totalPayableAmt = $UserDataToArray['Claimed Amount']  + $travelExpenseTotal + $hotelExpenseTotal;
        // } else {

        //     $totalPayableAmt = $UserDataToArray['Claimed Amount'] ?? 0;
        // }
        $totalPayableAmt = $UserDataToArray['Claimed Amount'] ?? 0;

        $totalAmountAfterDeduction = $totalPayableAmt - $UserDataToArray['Total Deduction Amount'];

        $BillData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => '*',
            'input' => "INNER JOIN [$ExamDates] as ED ON EP.[ExamType]=ED.[Exam Type] WHERE EP.[ObserverID]='{$ObserverID}' AND ED.[Exam Type] = '$ExamType' AND EP.[CENTNO] IN ($CENTNOSTR)",
            'table' => "[$ExamProfile] as EP"
        ]);

        $ShiftWiseBillData   = DB::selectOne(DB::raw("
                exec getCommonDataSP :select, :input, :table
            "), [
                'select' => "*",
                'input' => "join [$ExamDates] ON [$ExamProfileShiftWise].[Exam Type] = [$ExamDates].[Exam Type] WHERE [$ExamDates].[Exam Type] = '$ExamType' AND [$ExamProfileShiftWise].[Observer ID] ='$ObserverID' AND [$ExamProfileShiftWise].CenterNo in ($CENTNOSTR)",
                'table' => "[$ExamProfileShiftWise]",
            ]);

            $dutydays = [];
            $MockDutyDays = [];


            for ($i = 1; $i <= 12; $i++) {
                $aKeyS1 = "A{$i}S1";
                $aKeyS2 = "A{$i}S2";
                $aKeyS3 = "A{$i}S3";
                $aKeyS4 = "A{$i}S4";
                $dateKey = "Date_{$i}";

                if (!empty($ShiftWiseBillData->$aKeyS1) || !empty($ShiftWiseBillData->$aKeyS2) || !empty($ShiftWiseBillData->$aKeyS3) || !empty($ShiftWiseBillData->$aKeyS4)) {
                    if (!empty($ShiftWiseBillData->$dateKey)) {
                        $dutydays[] = date('d-m-Y', strtotime($ShiftWiseBillData->$dateKey));
                        $prevDate = date('d-m-Y', strtotime($ShiftWiseBillData->$dateKey . ' -1 day'));
                        $MockDutyDays[] = $prevDate;
                    }
                }
            }

        $amountMisc = 0;
        if (isset($ObserverPersonalDataOLD) && !empty($ObserverPersonalDataOLD)) {
            $amountMisc = array_sum(array_column($ObserverPersonalDataOLD, 'Amount'));
            $ObserverPersonalOldData = $ObserverPersonalDataOLD;
        } else {
            $ObserverPersonalOldData = array();
        }

        $RemunerationFieldsArray = [];
        if($IsNewBill == '1'){
            $RemunerationFieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
                'select' => 'CRH.[Exam Type],[Document No_],[No_ of Days],Field_Name,MockDrillFiledName,Field_Name_Deduction,MockDrillFiledName_Deduction , [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text], [Remuneration Amount_S1], [Remuneration Amount_S2], [Remuneration Amount_S3], [Remuneration Amount_S4]',
                'input' => "INNER JOIN [$CRLTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
                'table' => "[$CRHTable] as CRH",
                'orderBy' => 'order by displayOrder ASC'
            ]);


            if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData)) {
                $RemunerationFieldsArray = array_map(function ($item) {
                    return (array) $item;
                }, $RemunerationFieldsData);

                foreach ($RemunerationFieldsArray as $key => $val) {
                    if ($RemunerationFieldsArray[$key]['Field_Name'] == 'Amount') {
                        $RemunerationFieldsArray[$key]['FieldValue'] = $amountMisc ?? '';
                    } else {
                        $RemunerationFieldsArray[$key]['FieldValue'] = $UserDataToArray[$val['Field_Name']] ?? '';
                    }
                    $RemunerationFieldsArray[$key]['Field_Name_Deduction_Value'] = $UserDataToArray[$val['Field_Name_Deduction']] ?? '';
                    $RemunerationFieldsArray[$key]['MockDrillFieldValue'] = $UserDataToArray[$val['MockDrillFiledName']] ?? '';

                }
            }
        }
        //prd($RemunerationFieldsArray);

        $ShiftCountArr = (array)DB::selectOne('EXEC GetNonZeroShiftCountsObserverSP ?, ?', [$ObserverID, $ExamType]);

        $obsdata = [

            'RemunerationFieldsArray' => $RemunerationFieldsArray,
            'FieldsArray' => $FieldsArray,
            'dutydays' => $dutydays,
            'MockDutyDays' => $MockDutyDays,
            'BillData' => $BillData,
            'UserDataToArray' => $UserDataToArray,
            'ObserverType' => $ObserverType,
            'travel' => $travelArray,
            'hotel' => $hotelArray,
            'travelExpenseTotal' => $travelExpenseTotal,
            'travelDeductionAmount' => $travelDeductionAmount,
            'hotelExpenseTotal' => $hotelExpenseTotal,
            'hotelDeductionAmount' => $hotelDeductionAmount,
            'pdf' => $pdf,
            'totalPayableAmt' => $totalPayableAmt,
            'ObserverID' => $ObserverID,
            'ObserverPersonalData' => $ObserverPersonalData,
            'ObserverPersonalDataOLD' => $ObserverPersonalOldData,
            'ShiftCountArr' => $ShiftCountArr,
            'totalAmountAfterDeduction' => $totalAmountAfterDeduction
        ];
        return $obsdata;
    }

    public function getCSuperBilldata($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL, $CenterNo = NULL)
    {

        $CentreBillTbl = config('constants.CentreBillTbl');
        // $CentralizedRemunerationLineTable = config('constants.CentralizedRemunerationLineTable');
        $CentralizedRemunerationLineTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');
        $ExamProfile = config('constants.ExamProfile');
        $CandidateCountTable = config('constants.CandidateCountTable');

        //$data= $request()->only(['ObserverID','ExamType','ReferenceNo','role']);
        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('referenceID');
        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        $Role =  isset($role) && !empty($role) ? $role : request()->input('role');
        $ObserverID = !empty(request()->input('ObserverID')) ? request()->input('ObserverID') : Session::get('ObserverID');
        $centNo = isset($CenterNo) && !empty($CenterNo) ? $CenterNo : request()->input('CENTNO');

        $value = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => '*',
            'input' => "WHERE TB.[Observer ID]='{$ObserverID}' AND TB.[Exam Type]='{$ExamType}' AND TB.[Reference No_]='{$ReferenceNo}'",
            'table' => "[$CentreBillTbl] as TB"
        ]);

        $RemunerationFieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
            'select' => 'isExtrafield,Field_Name, MockDrillFiledName,Field_Name_Deduction, MockDrillFiledName_Deduction, [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text]',
            'input' => "INNER JOIN [$CentralizedRemunerationLineTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
            'table' => "[$CentralizedRemunerationHeaderTable] as CRH",
            'orderBy' => 'order by CRL.displayOrder ASC'
        ]);
        // prd($RemunerationFieldsData);
        $ID = auth()->user()->NTA_Unique_Admin_ID;
        $examType = Session::get('examType'); // Assuming you're storing ExamType in the session

        $DutyDays = DB::selectOne(DB::raw("SELECT p.* FROM [{$ExamProfile}] p WHERE p.ObserverID = :ID AND p.ExamType = :examType"), [
            'ID' => $ID,
            'examType' => $examType
        ]);
        // prd($DutyDays);
        // Convert the result to an array if it's not null
        $DutyDaysArray = $DutyDays ? (array) $DutyDays : [];
        $totalDutyDays = isset($DutyDaysArray['A_Dutydays']) && !empty($DutyDaysArray['A_Dutydays']) ? $DutyDaysArray['A_Dutydays'] : $DutyDaysArray['Dutydays'];

        $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            ':select' => '*',
            ':input' => "WHERE CenterNo='$centNo' AND [Exam Type] = '$examType'",
            ':table' => "[$CandidateCountTable]",
        ]);
        $ArrayData = [];
        if ($DaywiseCountDetails) {
            for ($i = 1; $i <= 12; $i++) {
                if ($DaywiseCountDetails['D' . $i . 'Max'] != 0) {
                    $ArrayData['allottedCandidatesCount'][] = $DaywiseCountDetails['D' . $i . 'Max'];
                }
            }
            $ArrayData['AllottedCandidates'] = $DaywiseCountDetails['Total Candidate Count in Exam'];
            $ArrayData['maxDayCount'] = $DaywiseCountDetails['Max Count Exam'];
        } else {
            $ArrayData['AllottedCandidates'] = 0;
            for ($i = 1; $i <= 12; $i++) {
                $ArrayData['allottedCandidatesCount'][] = 0;
            }
        }
        //prd($ArrayData);
        $csData = ['data' => $value, 'CentralizedRemuneration' => $RemunerationFieldsData, 'pdf' => $pdf, 'totalDutyDays' => $totalDutyDays, 'ArrayData' => $ArrayData];
        return  $csData;
    }



    public function getCCBilldataNewBulk($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL)
    {


        /*=============Constants value Start====================*/
        $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
        // $CRLTable = config('constants.CentralizedRemunerationLineTable');
        $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedFormFields = config('constants.CentralizedFormFields');
        $ExamProfile = config('constants.ExamProfile');
        $RoleName = config('constants.RoleName');
        $CityCoordinatorOfflineTbl = config('constants.CityCoordinatorOfflineTbl');

        /*=============Constants value End====================*/

        //$ExamType =  Session::get('examType');
        //$ObserverID =  Session::get('ObserverID');
        $Role =   isset($role) && !empty($role) ? $role : Session::get('role');

        /*=============Request value start====================*/
        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('referenceID');

        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        /*=============Request value end====================*/
        $ObserverType = $RoleName[$Role];
        $FieldsArray = [];

        $query = "exec getCommonDataSP :select, :input, :table, :orderBy";
        $params = [
            'select' => 'fieldName, fieldLabel, displayOrder',
            'input' => "WHERE [ExamType]='{$ExamType}' AND Role=$Role",
            'table' => "[$CentralizedFormFields] as CZ",
            'orderBy' => 'order by CZ.[displayOrder] ASC'
        ];


        $FieldsDataObj = DB::select($query, $params);

        $FieldsData = $FieldsDataObj;

        if (isset($FieldsData) && !empty($FieldsData)) {
            $FieldsArray = json_decode(json_encode($FieldsData), true);
        }

        if (is_array($ReferenceNo)) {
            $ReferenceNoList = "'" . implode("', '", $ReferenceNo) . "'"; // Converts the array to a comma-separated list with quotes
            $CCOfflineData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                ':select' => '*',
                ':input' => "WHERE [Reference No_] IN ($ReferenceNoList)", // Use the formatted list here
                ':table' => "[$CityCoordinatorOfflineTbl] as cc"
            ]);
            if (isset($CCOfflineData) && !empty($CCOfflineData)) {
                $UserDataToArray = (array) $CCOfflineData;
            } else {
                $UserDataToArray = [];
            }
        } else {
            $CCOfflineData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                ':select' => '*',
                ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
                ':table' => "[$CityCoordinatorOfflineTbl] as cc"
            ]);
            if (isset($CCOfflineData) && !empty($CCOfflineData)) {
                $UserDataToArray = (array) $CCOfflineData;
            } else {
                $UserDataToArray = [];
            }
        }



        // $ObserverID = request()->input('ObserverID');

        // $CENTNO = Session::get('centers');
        // $CENTNOArray = array_map(function ($item) {
        //     return "'" . $item . "'";
        // }, $CENTNO);
        // $CENTNOSTR = implode(',', $CENTNOArray);

        if (!empty(request()->input('ObserverID'))) {
            $ObserverID = !empty(request()->input('ObserverID')) ? request()->input('ObserverID') : Session::get('ObserverID');
        } else {
            $ObserverID = $ObserverID;
        }

        $centersOld =  Session::get('Old');
        if (isset($centersOld) and $centersOld == '') {
            $CENTNOArray = array_map(function ($item) {
                return "'" . $item . "'";
            }, $centersOld);
            $CENTNOSTR = implode(',', $CENTNOArray);
        } else {
            $CENTNOSTR =  $centers;
        }



        $ExtraFields = array();

        if (isset($centersOld) and $centersOld == '') {
            $observersCountArr = DB::select("exec getCommonDataSP :select, :input, :table", [
                ':select' => '*',
                ':input' => "WHERE [ExamType] = '{$ExamType}' AND [Observer Type] = '{$Role}' AND CENTNO IN ($CENTNOSTR) ",
                ':table' => "[$ExamProfile] as cc"
            ]);
        } else {
            $observersCountArr = DB::select("exec getCommonDataSP :select, :input, :table", [
                ':select' => '*',
                ':input' => "WHERE [ExamType] = '{$ExamType}' AND [Observer Type] = '{$Role}' AND CENTNO ='$CENTNOSTR' ",
                ':table' => "[$ExamProfile] as cc"
            ]);
        }



        $observersCount = count($observersCountArr);

        $rcName = DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            'select' => "Name",
            'input' => "where ExamType = '$ExamType' AND [Observer Type]='12'",
            'table' => "[$ExamProfile]",
        ]);
        if ($Role == 1 or $Role == 14) {
            $ExtraFields['Name of RC'] = $rcName->Name ?? 'NA';
            $ExtraFields['ExamName'] = Session::get('examName');
            $ExtraFields['City Coordinator Name'] = Session::get('Name');
            $ExtraFields['No_ of Alloted Centres'] = Session::get('centers') ? count(Session::get('centers')) : $CENTNOSTR;
            $ExtraFields['No_ of Alloted Observer'] = $observersCount ?? 'NA';
        }

        foreach ($FieldsArray as $key => $val) {
            if (array_key_exists($val['fieldName'], $ExtraFields)) {
                $FieldsArray[$key]['fieldValue'] = $ExtraFields[$val['fieldName']]; //set value
            } else {
                $FieldsArray[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA'; //set value
            }
        }

        $RemunerationFieldsArray = [];

        $rmQuery = "exec getCommonDataSP :select, :input, :table, :orderBy";
        $rmParams = [
            'select' => 'isExtrafield,Field_Name, MockDrillFiledName,Field_Name_Deduction, MockDrillFiledName_Deduction, [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text]',
            'input' => "INNER JOIN [$CRLTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
            'table' => "[$CRHTable] as CRH",
            'orderBy' => 'order by displayOrder ASC'
        ];
        $RemunerationFieldsData = DB::select($rmQuery, $rmParams);
        $RemunerationFieldsArray = [];
        if (!empty($RemunerationFieldsData)) {
            $RemunerationFieldsArray = array_map(function ($item) {
                return (array) $item;
            }, $RemunerationFieldsData);
        }

        $NoofPerson = explode(',', $UserDataToArray['No_ of Person']);
        $NoofDays = explode(',', $UserDataToArray['No_ of Days']);
        foreach ($RemunerationFieldsArray as $key => $val) {

            $RemunerationFieldsArray[$key]['FieldValue'] = $UserDataToArray[$val['Field_Name']] ?? 'NA';
            $RemunerationFieldsArray[$key]['MockDrillFieldValue'] = $UserDataToArray[$val['MockDrillFiledName']] ?? 'NA';
        }

        $ccdata = ['RemunerationFieldsArray' => $RemunerationFieldsArray, 'FieldsArray' => $FieldsArray, 'UserDataToArray' => $UserDataToArray, 'ObserverType' => $ObserverType, 'pdf' => $pdf, 'NoofPerson' => $NoofPerson, 'NoofDays' => $NoofDays];

        return $ccdata;
    }

    public function getObsBillDataNewBulk($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL)
    {

        $CRHTable = config('constants.CentralizedRemunerationHeaderTable');
        // $CRLTable = config('constants.CentralizedRemunerationLineTable');
        $CRLTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedFormFields = config('constants.CentralizedFormFields');
        $TATBL = config('constants.TABillHeaderTbl');
        $TABillLocalTbl = config('constants.TABillLocalTbl');
        $ExamProfile = config('constants.ExamProfile');
        $ExamDates = config('constants.ExamDates');
        //Outstation Table
        $TABillHotelTbl =  config('constants.TABillHotelTbl');
        $TABillOutstationTbl =  config('constants.TABillOutstationTbl');

        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('ReferenceNo');
        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        $Role =  isset($role) && !empty($role) ? $role : Session::get('role');


        if (!empty(request()->input('ObserverID'))) {
            $ObserverID = !empty(request()->input('ObserverID')) ? request()->input('ObserverID') : Session::get('ObserverID');
        } else {
            $ObserverID = $ObserverID;
        }

        $centersOld =  Session::get('Old');
        if (isset($centersOld) and $centersOld == '') {
            $CENTNOArray = array_map(function ($item) {
                return "'" . $item . "'";
            }, $centersOld);
            $CENTNOSTR = implode(',', $CENTNOArray);
        } else {
            $CENTNOSTR =  $centers;
        }

        # where in format
        $CENTNOSTR = "'" . implode("','", explode(',', $CENTNOSTR)) . "'";


        $RoleName = config('constants.RoleName');
        $ObserverType = (isset($Role) && !empty($Role)) ? $RoleName[$Role] : '';

        // $checkBillType = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
        //     'select' => 'IsNewBill',
        //     'input' => "WHERE [Reference No_]='{$ReferenceNo}'",
        //     'table' => "[$TATBL]"
        // ]);
        // ++++++++++++++++++++++++++++++++++ Exam Date ====================================//
        $ExamDate = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => 'Exam_Duration',
            'input' => "WHERE [Exam Type]='{$ExamType}'",
            'table' => "[$ExamDates]"
        ]);
        // prd($ExamDate);
        // ++++++++++++++++++++++++++++++++++ Exam Date ====================================//
        $ObserverCCList = [];

        if (isset($centersOld) and $centersOld == '') {
            $ObserverCCList = (array)DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                'select' => "Name,Mobile",
                'input' => "WHERE [Observer Type]='1' and ExamType='$ExamType' and CENTNO in ($CENTNOSTR)",
                'table' => "[$ExamProfile]"
            ]);
        } else {
            $ObserverCCList = (array)DB::selectOne("exec getCommonDataSP :select, :input, :table", [
                'select' => "Name,Mobile",
                'input' => "WHERE [Observer Type]='1' and ExamType='$ExamType' and CENTNO in ($CENTNOSTR) ",
                'table' => "[$ExamProfile]"
            ]);
        }



        $UserDataToArray = [];
        $ObserverPersonalData = [];
        $ObserverPersonalDataOLD = [];
        // if($checkBillType->IsNewBill != 1)
        // {
        $ObserverPersonalDataOLD = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => 'Amount',
            'input' => "WHERE [Reference No_]='{$ReferenceNo}'",
            'table' => "[$TABillLocalTbl]"
        ]);
        //}
        $ObserverPersonalData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => 'TB.*, TL.Amount as Amount, TL.[File Path],EP.Name as [Observer Name]',
            'input' => "LEFT JOIN [$TABillLocalTbl] as TL ON TL.[Reference No_]=TB.[Reference No_] INNER JOIN [$ExamProfile] as EP ON TB.[Observer ID]=EP.ObserverID WHERE TB.[Reference No_]='{$ReferenceNo}'",
            'table' => "[$TATBL] as TB"
        ]);

        //prd($ObserverCCList);
        if (isset($ObserverPersonalData) && !empty($ObserverPersonalData)) {
            $UserDataToArray = (array) $ObserverPersonalData;
        }

        //Dynamic Field Name fetch for Billing Data Start
        $FieldsArray = [];
        $FieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
            'select' => 'fieldName, fieldLabel, displayOrder',
            'input' => "WHERE [ExamType]='{$ExamType}' AND Role=$Role",
            'table' => "[$CentralizedFormFields] as CZ",
            'orderBy' => 'order by CZ.[displayOrder] ASC'
        ]);

        if (isset($FieldsData) && !empty($FieldsData)) {

            $FieldsArray = json_decode(json_encode($FieldsData), true);
            foreach ($FieldsArray as $key => $val) {
                if (isset($val['fieldName']) && $val['fieldName'] == 'CcName') {
                    $FieldsArray[$key]['fieldValue'] = $ObserverCCList['Name'] . ', ' . $ObserverCCList['Mobile'] ?? 'NA';
                } elseif (isset($val['fieldName']) && $val['fieldName'] == 'Exam Date') {
                    $FieldsArray[$key]['fieldValue'] = $ExamDate->Exam_Duration ?? 'NA';
                } else {
                    $FieldsArray[$key]['fieldValue'] = $UserDataToArray[$val['fieldName']] ?? 'NA';
                }
            }
        }
        //Dynamic Field Name fetch for Billing Data End

        //Travel Details Start
        $travelArray = [];
        $travel = DB::select("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
            ':table' => "[$TABillOutstationTbl] as TR"
        ]);

        if (!empty($travel)) {
            $travelArray = array_map(function ($item) {
                return (array) $item;
            }, $travel);
        }
        $travelExpenseTotal = 0;
        $EligibleTaxesTotal = 0;
        $travelDeductionAmount = 0;

        if (isset($travelArray) && !empty($travelArray)) {
            foreach ($travelArray as $tExp) {
                $travelExpenseTotal += floatval(sprintf('%g', $tExp['Amount']));
                $EligibleTaxesTotal += floatval(sprintf('%g', $tExp['Approved Amount']));
                $travelDeductionAmount += floatval(sprintf('%g', $tExp['Deduction Amount']));
            }

            if ($travelDeductionAmount == 0) {
                $travelDeductionAmount = '-';
            }
        }

        //Travel Bill Details End

        //Hotel Bill Details Start

        $hotelArray = [];
        $hotel = DB::select("exec getCommonDataSP :select, :input, :table", [
            ':select' => '*',
            ':input' => "WHERE [Reference No_] = '{$ReferenceNo}'",
            ':table' => "[$TABillHotelTbl] as HT"
        ]);

        if (!empty($hotel)) {
            $hotelArray = array_map(function ($item) {
                return (array) $item;
            }, $hotel);
        }

        $hotelExpenseTotal = 0;
        $hotelDeductionAmount = 0;
        if (isset($hotelArray) && !empty($hotelArray)) {
            foreach ($hotelArray as $hExp) {
                $hotelExpenseTotal += floatval(sprintf('%g', $hExp['Total Amount']));
                $hotelDeductionAmount += floatval(sprintf('%g', $hExp['Deduction Amount']));
            }
            if ($hotelDeductionAmount == 0) {
                $hotelDeductionAmount = '-';
            }
        }

        $travelExpenseTotal = $travelExpenseTotal + $EligibleTaxesTotal;
        $totalOutstationExpense = $travelExpenseTotal + $hotelExpenseTotal;

        //Hotel Bill Details End

        // $totalPayableAmt = 0;
        // if (isset($travel) && !empty($travel)) {
        //     $totalPayableAmt = $UserDataToArray['Claimed Amount'] ?? 0 + $travelExpenseTotal + $hotelExpenseTotal;
        // } else {
        //     $totalPayableAmt = $UserDataToArray['Claimed Amount'] ?? 0;
        // }

        $totalPayableAmt = $UserDataToArray['Claimed Amount'] ?? 0;
        $totalAmountAfterDeduction = $totalPayableAmt - $UserDataToArray['Total Deduction Amount'];

    
        $BillData = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => '*',
            'input' => "INNER JOIN [$ExamDates] as ED ON EP.[ExamType]=ED.[Exam Type] WHERE EP.[ObserverID]='{$ObserverID}' AND ED.[Exam Type] = '$ExamType' AND EP.[CENTNO] IN ($CENTNOSTR)",
            'table' => "[$ExamProfile] as EP"
        ]);



        $dutydays = array();
        $i = 1;
        for ($i; $i <= 12; $i++) {
            if ($BillData->{'D' . $i} == 1) {
                $dutydays[] = date('d-m-Y', strtotime($BillData->{'Date_' . $i}));
            }
        }

        $amountMisc = 0;
        if (isset($ObserverPersonalDataOLD) && !empty($ObserverPersonalDataOLD)) {
            $amountMisc = array_sum(array_column($ObserverPersonalDataOLD, 'Amount'));
            $ObserverPersonalOldData = $ObserverPersonalDataOLD;
        } else {
            $ObserverPersonalOldData = array();
        }
        // prd($amountMisc);

        $RemunerationFieldsArray = [];
        $RemunerationFieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
            'select' => '[No_ of Days],Field_Name, Field_Name_Deduction,MockDrillFiledName_Deduction ,MockDrillFiledName, [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text], [Remuneration Amount_S1], [Remuneration Amount_S2], [Remuneration Amount_S3], [Remuneration Amount_S4]',
            'input' => "INNER JOIN [$CRLTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
            'table' => "[$CRHTable] as CRH",
            'orderBy' => 'order by displayOrder ASC'
        ]);

        if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData)) {
            $RemunerationFieldsArray = array_map(function ($item) {
                return (array) $item;
            }, $RemunerationFieldsData);

            foreach ($RemunerationFieldsArray as $key => $val) {
                if ($RemunerationFieldsArray[$key]['Field_Name'] == 'Amount') {
                    $RemunerationFieldsArray[$key]['FieldValue'] = $amountMisc ?? '';
                } else {
                    $RemunerationFieldsArray[$key]['FieldValue'] = $UserDataToArray[$val['Field_Name']] ?? '';
                }

                $RemunerationFieldsArray[$key]['Field_Name_Deduction_Value'] = $UserDataToArray[$val['Field_Name_Deduction']] ?? '';
                $RemunerationFieldsArray[$key]['MockDrillFieldValue'] = $UserDataToArray[$val['MockDrillFiledName']] ?? '';

            }
        }
        $ShiftCountArr = (array)DB::selectOne('EXEC GetNonZeroShiftCountsObserverSP ?, ?', [$ObserverID, $ExamType]);

        // prd($ShiftCountArr);
        $obsdata = [

            'RemunerationFieldsArray' => $RemunerationFieldsArray,
            'FieldsArray' => $FieldsArray,
            'dutydays' => $dutydays,
            'BillData' => $BillData,
            'UserDataToArray' => $UserDataToArray,
            'ObserverType' => $ObserverType,
            'travel' => $travelArray,
            'hotel' => $hotelArray,
            'travelExpenseTotal' => $travelExpenseTotal,
            'travelDeductionAmount' => $travelDeductionAmount,
            'hotelExpenseTotal' => $hotelExpenseTotal,
            'hotelDeductionAmount' => $hotelDeductionAmount,
            'pdf' => $pdf,
            'totalPayableAmt' => $totalPayableAmt,
            'ObserverID' => $ObserverID,
            'ObserverPersonalData' => $ObserverPersonalData,
            'ObserverPersonalDataOLD' => $ObserverPersonalOldData,
            'ShiftCountArr'=>$ShiftCountArr,
            'totalAmountAfterDeduction' => $totalAmountAfterDeduction

        ];
        return $obsdata;
    }

    public function getCSuperBilldataNewBulk($referenceNo = NULL, $examType = NULL, $role = NULL, $pdf = NULL, $ObserverID = NULL, $centers = NULL)
    {

        // die('innnn');
        $CentreBillTbl = config('constants.CentreBillTbl');
        // $CentralizedRemunerationLineTable = config('constants.CentralizedRemunerationLineTable');
        $CentralizedRemunerationLineTable = config('constants.CentralizedRemunerationLineTableShiftWise');
        $CentralizedRemunerationHeaderTable = config('constants.CentralizedRemunerationHeaderTable');
        $ExamProfile = config('constants.ExamProfile');
        $CandidateCountTable = config('constants.CandidateCountTable');

        //$data= $request()->only(['ObserverID','ExamType','ReferenceNo','role']);
        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('referenceID');
        $ExamType = isset($examType) && !empty($examType) ? $examType : request()->input('ExamType');
        $Role =  isset($role) && !empty($role) ? $role : request()->input('role');

        if (empty(Session::get('ObserverID'))) {
            $ObserverID = $ObserverID;
        } else {
            $ObserverID = !empty(request()->input('ObserverID')) ? request()->input('ObserverID') : Session::get('ObserverID');
        }

        $centNo = isset($centers) && !empty($centers) ? $centers : request()->input('CENTNO');

        $value = DB::selectOne("exec getCommonDataSP :select, :input, :table", [
            'select' => '*',
            'input' => "WHERE TB.[Observer ID]='{$ObserverID}' AND TB.[Exam Type]='{$ExamType}' AND TB.[Reference No_]='{$ReferenceNo}'",
            'table' => "[$CentreBillTbl] as TB"
        ]);


        $RemunerationFieldsData = DB::select("exec getCommonDataSP :select, :input, :table, :orderBy", [
            'select' => 'isExtrafield,Field_Name, MockDrillFiledName,Field_Name_Deduction, MockDrillFiledName_Deduction, [Source Name],[Source Code],[Remuneration Text],[Mock Drill Text]',
            'input' => "INNER JOIN [$CentralizedRemunerationLineTable] as CRL ON CRH.ID=CRL.[Document No_] WHERE CRH.[Exam Type]='{$ExamType}' AND CRL.[Source Type]=$Role",
            'table' => "[$CentralizedRemunerationHeaderTable] as CRH",
            'orderBy' => 'order by CRL.displayOrder ASC'
        ]);
        // prd($RemunerationFieldsData);
        if (empty(Session::get('examType'))) {
            $ID = $ObserverID;
            $examType = $ExamType;
        } else {
            $ID = auth()->user()->NTA_Unique_Admin_ID;
            $examType = Session::get('examType'); // Assuming you're storing ExamType in the session
        }


        $DutyDays = DB::selectOne(DB::raw("SELECT p.* FROM [{$ExamProfile}] p WHERE p.ObserverID = :ID AND p.ExamType = :examType"), [
            'ID' => $ID,
            'examType' => $examType
        ]);
        // prd($centNo);
        // Convert the result to an array if it's not null
        $DutyDaysArray = $DutyDays ? (array) $DutyDays : [];
        $totalDutyDays = isset($DutyDaysArray['A_Dutydays']) && !empty($DutyDaysArray['A_Dutydays']) ? $DutyDaysArray['A_Dutydays'] : $DutyDaysArray['Dutydays'];

        $DaywiseCountDetails = (array)DB::selectOne(DB::raw("exec getCommonDataSP :select, :input, :table"), [
            ':select' => '*',
            ':input' => "WHERE CenterNo='$centNo' AND [Exam Type] = '$examType'",
            ':table' => "[$CandidateCountTable]",
        ]);
        $ArrayData = [];
        if ($DaywiseCountDetails) {
            for ($i = 1; $i <= 12; $i++) {
                if ($DaywiseCountDetails['D' . $i . 'Max'] != 0) {
                    $ArrayData['allottedCandidatesCount'][] = $DaywiseCountDetails['D' . $i . 'Max'];
                }
            }
            $ArrayData['AllottedCandidates'] = $DaywiseCountDetails['Total Candidate Count in Exam'];
            $ArrayData['maxDayCount'] = $DaywiseCountDetails['Max Count Exam'];
        } else {
            $ArrayData['AllottedCandidates'] = 0;
            for ($i = 1; $i <= 12; $i++) {
                $ArrayData['allottedCandidatesCount'][] = 0;
            }
        }
        // pr($centNo);
        // pr($examType);
        // prd($DaywiseCountDetails);
        $csData = ['data' => $value, 'CentralizedRemuneration' => $RemunerationFieldsData, 'pdf' => $pdf, 'totalDutyDays' => $totalDutyDays, 'ArrayData' => $ArrayData];
        return  $csData;
    }

    public function getObsDobsDataList($referenceNo)
    {

        $CityCoordinatorObservrTbl = config('constants.ObserverDetailsTable');
        $ReferenceNo = isset($referenceNo) && !empty($referenceNo) ? $referenceNo : request()->input('referenceID');
        $ObserverData = DB::select("exec getCommonDataSP :select, :input, :table", [
            'select' => '*',
            'input' => "WHERE Reference_No='{$ReferenceNo}'",
            'table' => "[$CityCoordinatorObservrTbl]"
        ]);

        return $ObserverData;
    }
}
