
@extends('layouts.adminLayout.app')

@section('content')
<style>
    .field-icon {
        cursor: pointer;
        position: absolute;
        font-size: 20px;
        right: 40px;
        /* top: 50px; */
        transform: translateY(-170%);
    }
    /* Styles for Font Awesome icons */
    .fa-eye {
        color: #818080;
    }
    .fa-eye-slash {
        color: #333;
    }
</style>
<main role="main" class="flex-shrink-0">
    <div class="container custom-container">

        <div class="login-5 mt-50 mb-50">
            <div class="col-sm-12">
                <!-- @if ($errors->any())
                    <div class="d-flex justify-content-between alert alert-danger mt-3">
                    @foreach ($errors->all() as $error)
                        {{ $error }}
                    @endforeach
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                @endif -->
               
                @if(session('success'))
                    <div class="d-flex justify-content-between alert alert-primary mt-3">
                        {{ session('success') }}
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                @endif
            <div>
            <div class="row align-items-stretch">
                <div class="col-sm-6">
                    <div class="card card-white custom-card ovrflw h-100">
                        <div class="form-inner login-outside-container h-100">
                            <h3 class="mb-5 fw-bold">Login</h3>
                            <form method="POST" action="{{ route('admin.login') }}">
                                @csrf
                                <div class="mb-3">
                                    <label for="username" class="field-loginformmodel-username required">{{ __('Username') }} <span class="astric-sign text-danger">*</span></label>
                                    <input id="username" type="text" class="form-control  form-control-lg @error('username') is-invalid @enderror" autocomplete="off" name="username" placeholder="Enter Username" value="{{ old('username') }}" autocomplete="username" autofocus>
                                    @error('username')
                                    <div class="invalid-feedback fs-6">
                                        {{ $message }}
                                    </div>
                                    @enderror
                                </div>
                                <div class="mb-3">
                                    <label for="password" class="col-form-label form-label text-start required-asterisk">{{ __(' Password') }} <span class="astric-sign text-danger">*</span></label>

                                    <input id="password" type="password" class="form-control form-control-lg @error('password') is-invalid @enderror" name="password" autocomplete="current-password" placeholder="Enter Password" autofocus maxlength="15">
                                    <span toggle="#password" class="fa fa-fw fa-eye-slash field-icon toggle-password me-2"></span>
                                    @error('password')
                                    <span class="invalid-feedback fs-6" role="alert">
                                        {{ $message }}
                                    </span>
                                    @enderror
                                </div>
                                    <button type="submit" class="mt-5 btn btn-primary btn-lg btn-theme">
                                        Submit <i class="fa fa-angle-right" aria-hidden="true"></i>
                                    </button>
                                    <a href="{{route('admin.forgot-password')}}"><b>Forgot Password?</b></a>
                                  </div>
                                  
                            </form>
                        </div>
                </div>
                <div class="col-sm-6">
                    <div class="custom-card cust-crd overflow-hidden rounded">
                        <img class="img-fluid login-image" src="{{ URL::asset('assets/images/img-6.jpg') }}" alt="img-6.jpg" width="100%" height="100%">
                    </div>
                </div>
            </div>
        </div>

    </div>
</main>
@endsection
@section('script')
<script>
    $(document).on('click', '.toggle-password', function() {
        $(this).toggleClass('fa-eye fa-eye-slash');
        var input = $($(this).attr('toggle'));
        if (input.attr('type') == 'password') {
            input.attr('type', 'text');
        } else {
            input.attr('type', 'password');
        }
    });
    </script>
@endsection
