@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .small {
            display: none;
        }

        .filterSection {
            margin-top: 20px;
        }
        .form-label{
            font-weight: bold;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('ChangesLog',$logs) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <div class="d-flex">
                                            <a href="{{ route('admin.superdashboard') }}"
                                                class="btn btn-danger text-white fs-5">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>
                                        </div>
                                    </div>

                                    <div class="card-body">
                                        <div class="filterSection mt-0">

                                            <form action="{{ route('changesLog') }}" method="GET" id="perPageForm">
                                                <div class="row">
                                                    <!-- Left side: Per page dropdown -->
                                                    <div class="col-md-2 mb-2 d-flex align-items-center">
                                                        <select name="perPage" id="perPageSelect" class="form-select"
                                                            style="width: 70px" onchange="getloader()">
                                                            <option value="15"
                                                                {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                            <option value="50"
                                                                {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                            <option value="100"
                                                                {{ request('perPage') == 100 ? 'selected' : '' }}>100
                                                            </option>
                                                            <option value="200"
                                                                {{ request('perPage') == 200 ? 'selected' : '' }}>200
                                                            </option>
                                                            <option value="500"
                                                                {{ request('perPage') == 500 ? 'selected' : '' }}>500
                                                            </option>
                                                        </select>
                                                        <span class="ms-2">Per page</span>
                                                    </div>

                                                    <!-- Right side: Search input (with content aligned to the right) -->
                                                    <div class="col-md-10 mb-2 d-flex justify-content-end">
                                                        <div class="d-flex flex-wrap align-items-end gap-2">
                                                            <!-- Observer Search -->
                                                            <div>
                                                                <label class="form-label">Reference No </label>
                                                                <input type="text" class="form-control form-control-sm" name="referenceNo" placeholder="Search..."
                                                                    value="{{ request('referenceNo') }}" autocomplete="off">
                                                            </div>
                                                    
                                                            <!-- Name Search -->
                                                            <div>
                                                                <label class="form-label">NTA ID </label>
                                                                <input type="text" class="form-control form-control-sm" name="ntaId" placeholder="Search..."
                                                                    value="{{ request('ntaId') }}" autocomplete="off">
                                                            </div> 
                                                            <div>
                                                                <label class="form-label">Exam Name </label>
                                                                <select class="form-control form-control-sm" name="examType">
                                                                <option value="">Select...</option>
                                                                @forEach(getExamDateList() as $val)
                                                                <option value="{{ $val->{'Exam Type'} }}"   {{ request('examType') == $val->{'Exam Type'} ? 'selected' : '' }}>{{ $val->{'Exam Name'} }}</option>
                                                                @endforeach
                                                                </select>
                                                                 
                                                            </div> 
                                                    
                                                            <!-- Date Search -->
                                                            <div>
                                                                <label class="form-label">Date From </label>
                                                                <input type="date" class="form-control form-control-sm" name="fromDate"
                                                                    value="{{ request('fromDate') }}">
                                                            </div>
                                                    
                                                            <!-- Date Between Search -->
                                                            <div>
                                                                <label class="form-label">Date To</label>
                                                                <input type="date" class="form-control form-control-sm" name="toDate"
                                                                    value="{{ request('toDate') }}">
                                                            </div>
                                                    
                                                            <!-- Buttons -->
                                                            <div>
                                                                <button type="submit" class="btn btn-primary btn-md">Search</button>
                                                                <a href="{{ route('changesLog') }}" class="btn btn-danger text-white btn-md">Reset</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <hr class="border-4"/>   
                                                </div>
                                            </form>
                                        </div>
                                        <div class="table-responsive">
                                            <table class="table table-bordered table-striped">
                                                <thead>
                                                    <tr>
                                                        <th>#</th>
                                                        <th>Reference No</th>
                                                        <th>NTA ID</th>
                                                        <th>Exam</th>
                                                        <th>User Type</th>
                                                        <th>Current Value</th>
                                                        <th>Update Value</th>
                                                        <th>Log DateTime</th>
                                                        <th>Updated By</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 0;
                                                    @endphp
                                                    @foreach ($logs as $log)
                                                        @php
                                                            $userType = '-';
                                                            if (
                                                                $log->table_name ==
                                                                '[' .
                                                                    config('constants.CityCoordinatorOfflineTbl') .
                                                                    ']'
                                                            ) {
                                                                $userType = 'City Coordinator';
                                                            } elseif (
                                                                $log->table_name ==
                                                                '[' . config('constants.TABillHeaderTbl') . ']'
                                                            ) {
                                                                $userType = 'Observer';
                                                            } elseif (
                                                                $log->table_name ==
                                                                '[' . config('constants.CentreBillTbl') . ']'
                                                            ) {
                                                                $userType = 'Center superintendent';
                                                            }
                                                            $current_value_json = json_decode(
                                                                $log->current_value,
                                                                true,
                                                            );
                                                            $current_value = implode(
                                                                '<br/>',
                                                                array_map(
                                                                    fn($key, $value) => "$key=$value",
                                                                    array_keys($current_value_json[0]),
                                                                    $current_value_json[0],
                                                                ),
                                                            );

                                                            $update_value_json = json_decode($log->update_value, true);
                                                            $update_value = implode(
                                                                '<br/>',
                                                                array_map(
                                                                    fn($key, $value) => "$key=$value",
                                                                    array_keys($update_value_json),
                                                                    $update_value_json,
                                                                ),
                                                            );
                                                        @endphp
                                                        <tr>
                                                            <td>{{ ++$i }}</td>
                                                            <td>{{ $log->reference_no }}</td>
                                                            <td>{{ $log->observer_id }}</td>
                                                            <td>{{ getExamNameByExamType($log->exam_type) }}</td>
                                                            <td>{{ $userType }}</td>
                                                            <td>{!! $current_value !!}</td>
                                                            <td>{!! $update_value !!}</td>
                                                            <td>{{ date('d-m-Y h:i:s', strtotime($log->created_at)) }}</td>
                                                            <td>{{ $log->role_type }}</td>
                                                        </tr>
                                                    @endforeach
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-end">
                                                {{ $logs->links('pagination::bootstrap-5') }}
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection

@section('script')
    <script>
        function getloader() {
            $('.overlay').show();
            $('#perPageForm').submit();
        }
    </script>
    <script>
        let timeout;

        function debounceLoader() {
            // Clear the previous timeout if the user is still typing
            clearTimeout(timeout);

            // Set a new timeout to call getloader after 2 seconds
            timeout = setTimeout(function() {
                getloader();
            }, 500);
        }
    </script>
@endsection
