@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <style>
        .btnAlignment {
            margin-top: 2rem;
        }
    </style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                @if (isset($examData) && !empty($examData->{'Exam Type Id'}))
                                    {{ Breadcrumbs::render('examedits') }}
                                @else
                                    {{ Breadcrumbs::render('examadd') }}
                                @endif
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Add New Exam' }}</h4>
                                        <a href="{{ route('exam.index') }}" class="btn btn-danger text-white fs-5"> <i
                                                class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                       
                                    </div>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form method="post" action="{{ route('exam.savedetail') }}"
                                                id="examDetailsForm" autocomplete="off">
                                                @csrf
                                                <div class="row">
                                                    <div class="col-md-6">

                                                        <div class="form-group mb-3">
                                                            <label class="form-label">Exam Name <span
                                                                    class="astric-sign text-danger">*</span></label>
                                                            <input type="text"
                                                                class="form-control form-control-lg common-fields required"
                                                                name="exam_name" placeholder="Enter the exam name"
                                                                id="exam_name"
                                                                value="{{ isset($examData) && !empty($examData->{'Exam Name'}) ? $examData->{'Exam Name'} : old('exam_name') }}">
                                                            <input type="hidden" name="hiddenExamID"
                                                                value="{{ isset($examData) && !empty($examData->{'Exam Type Id'}) ? $examData->{'Exam Type Id'} : old('hiddenExamID') }}">
                                                            <input type="hidden" name="hiddenExamType"
                                                                value="{{ isset($examData) && !empty($examData->{'Exam Type'}) ? $examData->{'Exam Type'} : old('hiddenExamType') }}">
                                                            <input type="hidden" name="hiddenExamDisp"
                                                                value="{{ isset($examData) && !empty($examData->{'ExamDisp'}) ? $examData->{'ExamDisp'} : old('hiddenExamDisp') }}">
                                                            @error('exam_name')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    
                                                    <div class="col-md-6">
                                                        <div class="form-group mb-3">
                                                            <label class="form-label">Exam Mode <span
                                                                    class="astric-sign text-danger">*</span></label>
                                                            <select
                                                                class="form-control form-select form-select-lg common-fields required"
                                                                name="exam_mode" id="exam_mode">
                                                                <option value="">Select Exam Mode</option>
                                                                @if (isset($Exam_Mode) & !empty($Exam_Mode))
                                                                    @foreach ($Exam_Mode as $key => $mode)
                                                                        <option value="{{ $key }}"
                                                                            {{ isset($examData->Exam_Mode) && $key == $examData->Exam_Mode ? 'selected' : '' }}>
                                                                            {{ $mode }}</option>
                                                                    @endforeach
                                                                @endif
                                                            </select>
                                                            @error('exam_mode')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group mb-3">
                                                            <label class="form-label">Exam Year <span
                                                                    class="astric-sign text-danger">*</span></label>

                                                            <select
                                                                class="form-control form-select form-select-lg common-fields required"
                                                                name="ExamYear" id="ExamYear">
                                                                <option value="">Select</option>
                                                                @foreach (range(2020, date('Y')) as $examYear)
                                                                    <option value="{{ $examYear }}"
                                                                        {{ isset($examData->Year) && $examYear == $examData->Year ? 'selected' : '' }}>
                                                                        {{ $examYear }}
                                                                    </option>
                                                                @endforeach
                                                            </select>

                                                            @error('ExamYear')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>

                                                    </div>
                                                   

                                               <?php 
                                                   $activeRes = isset($examData->Is_Active) ? $examData->Is_Active : 1;
                                                ?>
                                                 <input type="hidden" name="exam_status" value="{{ $activeRes }}" >

                                                    <!-- <div class="col-md-6" style="display:none;">
                                                        <div class="form-group mb-3">
                                                            <label class="form-label">Status <span
                                                                    class="astric-sign text-danger">*</span></label>
                                                            <select
                                                                class="form-control form-select form-select-lg common-fields required"
                                                                name="exam_status" id="exam_status">
                                                                <option value="" >Select</option>
                                                                @if (isset($Is_ExamOver) & !empty($Is_ExamOver))
                                                                    @foreach ($Is_ExamOver as $key => $info)
                                                                        <option value="{{ $key }}"
                                                                            {{ $key == $activeRes ? 'selected' : '' }}>
                                                                            {{ $info }}</option>
                                                                    @endforeach
                                                                @endif
                                                            </select>
                                                            @error('exam_status')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div> -->

                                                    <div id="fieldsContainer" class="row">
                                                        {{-- @php prd($transformedArray['ExamDetails']); @endphp --}}
                                                        @if (isset($transformedArray['ExamDetails']) && !empty($transformedArray['ExamDetails']))
                                                            @foreach ($transformedArray['ExamDetails'] as $DateIndex => $val)
                                                                <div class="col-12 d-flex align-items-start dateRow">
                                                                    <div class="col-md-6">
                                                                        <div class="form-group">
                                                                            <label class="form-label labelName">Exam Date
                                                                                <span
                                                                                    class="astric-sign text-danger">*</span></label>
                                                                            <input type="date" name="ExamDate[]"
                                                                                class="form-control form-control-lg DatePreference ExamDate required"
                                                                                id="ExamDate0"
                                                                                value="{{ isset($val['ExamDate']) && !empty($val['ExamDate']) ? $val['ExamDate'] : old('ExamDate') }}">
                                                                            @error('ExamDate0')
                                                                                <div class="text-danger mb-4">
                                                                                    {{ $message }}
                                                                                </div>
                                                                            @enderror


                                                                        </div>
                                                                    </div>
                                                                    <div class="col-6 d-flex flex-column mx-4">
                                                                        @php $m = 0;@endphp
                                                                        @if (isset($val['Examshift']) && !empty($val['Examshift']))
                                                                            @foreach ($val['Examshift'] as $ShifIndex => $shiftval)
                                                                                <div
                                                                                    class="shift-block mb-3 shiftRow ShiftColumnEdit">
                                                                                    <div
                                                                                        class="d-flex justify-content-between align-items-center">

                                                                                        <div
                                                                                            class="flex-grow-1 d-flex flex-column">
                                                                                            <div
                                                                                                class="d-flex align-items-center">
                                                                                                <div class="mr-2 mx-2 mt-1">
                                                                                                    <label>Shift From <span
                                                                                                            class="astric-sign text-danger">*</span></label>
                                                                                                    <input type="time"
                                                                                                        class="fromOne form-control form-control-lg required"
                                                                                                        id="fromOne"
                                                                                                        name="ExamMaster[fromOne][{{ $ShifIndex }}][{{ isset($val['ExamDate']) && !empty($val['ExamDate']) ? $val['ExamDate'] : old('ExamDate') }}]"
                                                                                                        value="{{ isset($shiftval['fromOne']) && !empty($shiftval['fromOne']) ? $shiftval['fromOne'] : old('fromOne') }}">

                                                                                                </div>
                                                                                                <div class="mr-2 mx-2 mt-1">
                                                                                                    <label>Shift To <span
                                                                                                            class="astric-sign text-danger">*</span></label>
                                                                                                    <input type="time"
                                                                                                        class="toOne form-control form-control-lg required"
                                                                                                        id="toOne"
                                                                                                        name="ExamMaster[toOne][{{ $ShifIndex }}][{{ isset($val['ExamDate']) && !empty($val['ExamDate']) ? $val['ExamDate'] : old('ExamDate') }}]"
                                                                                                        value="{{ isset($shiftval['ToOne']) && !empty($shiftval['ToOne']) ? $shiftval['ToOne'] : old('ToOne') }}">

                                                                                                </div>
                                                                                                <div
                                                                                                    class="col-6 d-flex justify-content-start mt-4">
                                                                                                    @if ($m == 0)
                                                                                                        <a
                                                                                                            class="btn btn-success text-white btnAddShift mx-2"><i
                                                                                                                class="fa fa-plus"></i>
                                                                                                            Add More
                                                                                                            Shift</a>
                                                                                                        <a
                                                                                                            class="text-danger custom-white-text btnRemoveRow"><i
                                                                                                                class="fa fa-trash"
                                                                                                                style="cursor:pointer;font-size: 22px;"></i></a>

                                                                                                        {{-- @elseif($DateIndex)
                                                                                                <a
                                                                                                class="text-danger custom-white-text btnRemoveRow"><i
                                                                                                    class="fa fa-trash" style="cursor:pointer;font-size: 22px;"></i></a>
                                                                                                --}}
                                                                                                    @else
                                                                                                        <a
                                                                                                            class="text-danger custom-white-text btnRemoveShiftRow"><i
                                                                                                                class="fa fa-trash"
                                                                                                                style="cursor:pointer;font-size: 22px;"></i></a>
                                                                                                    @endif
                                                                                                    {{-- <a
                                                                                                    class="text-danger custom-white-text btnRemoveRow"><i
                                                                                                        class="fa fa-trash" style="cursor:pointer;font-size: 22px;"></i></a> --}}
                                                                                                    <a
                                                                                                        class="btn btn-info text-white btnAddRow"><i
                                                                                                            class="fa fa-plus"></i>
                                                                                                        Add More
                                                                                                        Date</a>
                                                                                                </div>
                                                                                            </div>
                                                                                        </div>
                                                                                    </div>
                                                                                </div>
                                                                                @php  $m++; @endphp
                                                                            @endforeach
                                                                        @else
                                                                            <div
                                                                                class="shift-block mb-3 shiftRow ShiftColumnEdit">
                                                                                <div
                                                                                    class="d-flex justify-content-between align-items-center">

                                                                                    <div
                                                                                        class="flex-grow-1 d-flex flex-column">
                                                                                        <div
                                                                                            class="d-flex align-items-center">
                                                                                            <div class="mr-2 mx-2 mt-2">
                                                                                                <label>Shift From <span
                                                                                                        class="astric-sign text-danger">*</span></label>
                                                                                                <input type="time"
                                                                                                    class="fromOne form-control form-control-lg required"
                                                                                                    id="fromOne"
                                                                                                    name="ExamMaster[fromOne][0][]">

                                                                                            </div>
                                                                                            <div class="mr-2 mx-2 mt-1">
                                                                                                <label>Shift To <span
                                                                                                        class="astric-sign text-danger">*</span></label>
                                                                                                <input type="time"
                                                                                                    class="toOne form-control form-control-lg required"
                                                                                                    id="toOne"
                                                                                                    name="ExamMaster[toOne][0][]">

                                                                                            </div>
                                                                                            <div
                                                                                                class="col-6 d-flex justify-content-start btnAlignment">

                                                                                                <a
                                                                                                    class="btn btn-primary text-white btnAddShift mx-2"><i
                                                                                                        class="fa fa-plus"></i>
                                                                                                    Add
                                                                                                    More
                                                                                                    Shift</a>
                                                                                                <a
                                                                                                    class="text-danger custom-white-text btnRemoveRow"><i
                                                                                                        class="fa fa-trash"
                                                                                                        style="cursor:pointer;font-size: 22px;"></i></a>
                                                                                                <a
                                                                                                    class="btn btn-info text-white btnAddRow"><i
                                                                                                        class="fa fa-plus"></i>
                                                                                                    Add
                                                                                                    More
                                                                                                    Date</a>
                                                                                            </div>
                                                                                        </div>
                                                                                    </div>
                                                                                </div>
                                                                            </div>
                                                                        @endif
                                                                    </div>
                                                                </div>
                                                            @endforeach
                                                        @else
                                                            <div class="col-12 d-flex align-items-start dateRow">
                                                                <div class="col-md-6">
                                                                    <div class="form-group">
                                                                        <label class="form-label labelName">Exam Date <span
                                                                                class="astric-sign text-danger">*</span></label>
                                                                        <input type="date" name="ExamDate[]"
                                                                            class="form-control form-control-lg DatePreference ExamDate required"
                                                                            id="ExamDate0">
                                                                        @error('ExamDate0')
                                                                            <div class="text-danger mb-4">{{ $message }}
                                                                            </div>
                                                                        @enderror
                                                                    </div>
                                                                </div>
                                                                <div class="col-6 d-flex flex-column mx-4">
                                                                    <div class="shift-block mb-3 shiftRow ShiftColumnEdit">
                                                                        <div
                                                                            class="d-flex justify-content-between align-items-center">

                                                                            <div class="flex-grow-1 d-flex flex-column">
                                                                                <div class="d-flex align-items-center">
                                                                                    <div class="mr-2 mx-2 mt-2">
                                                                                        <label>Shift From <span
                                                                                                class="astric-sign text-danger">*</span></label>
                                                                                        <input type="time"
                                                                                            class="fromOne form-control form-control-lg required"
                                                                                            id="fromOne"
                                                                                            name="fromOne[0][]">

                                                                                    </div>
                                                                                    <div class="mr-2 mx-2 mt-1">
                                                                                        <label>Shift To <span
                                                                                                class="astric-sign text-danger">*</span></label>
                                                                                        <input type="time"
                                                                                            class="toOne form-control form-control-lg required"
                                                                                            id="toOne"
                                                                                            name="toOne[0][]">

                                                                                    </div>
                                                                                    <div
                                                                                        class="col-6 d-flex justify-content-start btnAlignment">

                                                                                        <a
                                                                                            class="btn btn-primary text-white btnAddShift mx-2"><i
                                                                                                class="fa fa-plus"></i> Add
                                                                                            More
                                                                                            Shift</a>
                                                                                        <a
                                                                                            class="text-danger custom-white-text btnRemoveRow"><i
                                                                                                class="fa fa-trash"
                                                                                                style="cursor:pointer;font-size: 22px;"></i></a>
                                                                                        <a
                                                                                            class="btn btn-info text-white btnAddRow"><i
                                                                                                class="fa fa-plus"></i> Add
                                                                                            More
                                                                                            Date</a>
                                                                                    </div>
                                                                                </div>
                                                                            </div>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        @endif
                                                    </div>
                                                    
                                                    <div class="row">
                                                        <div class="col-12 d-flex align-items-start dateRow">
                                                            <div class="col-md-3">
                                                                <input class="form-check-input fs-3" type="checkbox" name="daysMock" value="1" {{ isset($examData->mockval) && $examData->mockval == 1 || (isset($request->daysMock) && $request->daysMock == 1) ? 'checked' : '' }}> <label class="form-check-label fs-5 mt-1" for="flexCheckDefault">Days wise mock</label>
                                                            </div>
                                                        </div>
                                                    </div>    
                                                </div>

                                                @if (isset($examData) && !empty($examData->{'Exam Type Id'}))
                                                    <div class="text-end">
                                                        <button class="btn btn-warning text-white me-4 mb-2 mt-0"
                                                            id="Submit" type="submit">Update</button>
                                                    </div>
                                                @else
                                                    <div class="text-end">
                                                        <button class="btn btn-warning text-white me-4 mb-2 mt-0"
                                                            id="Submit" type="submit">Submit</button>
                                                    </div>
                                                @endif


                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script src="{{ asset('admin/assets/js/pages/addexams.js') }}"></script>
    {{-- {!! $validator->selector('#examDetailsForm') !!} --}}
    <script>
        $(function() {
            //const urlParams = new URLSearchParams(window.location.search);
            //const exam_id = urlParams.get('exam_id');

            $('#ExamYear, #exam_name').on('change', function() {
                let ExamName = $('#exam_name').val().trim();
                let ExamYear = $('#ExamYear').val().trim(); // Explicitly get ExamYear

                if (ExamName !== "" && ExamYear !== "") { // Prevent empty requests
                    $.ajax({
                        type: "POST",
                        url: "{{ route('check.exam.type.exist') }}", // Ensure route is correct
                        data: {
                            ExamName: ExamName,
                            ExamYear: ExamYear,
                            _token: '{{ csrf_token() }}'
                        },
                        success: function(data) {
                            if (data.status === true) {
                                Swal.fire({
                                    title: "Alert!",
                                    text: data.message,
                                    icon: "warning",
                                    confirmButtonText: "OK"
                                }).then(() => {
                                    $('#exam_type').val('');
                                    $('#exam_name').val('');
                                    $('#ExamYear').val('');
                                });
                            }
                        },
                        error: function(xhr, status, error) {
                            console.error("AJAX error:", error);
                        }
                    });
                }
            });



        });
    </script>
@endsection
