
@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')
<?php


?>
<main role="main" class="flex-shrink-0">
    <div class="container custom-container">
        <div class="login-5 mt-50 mb-50">
            <div class="container-fluid">
                <div class="row no-gutters">
                    <div class="col-sm-12">
                        <div class="container-fluid">
                            {{-- @if(isset($ExamFormsData[0]) && !empty($ExamFormsData[0]))
                            {{ Breadcrumbs::render('EditFormFields'),$ExamFormsData[0] }}
                            @else
                            {{ Breadcrumbs::render('AddFormFields') }}
                            @endif --}}
                            {{ Breadcrumbs::render('AddFormFields') }}

                            <div class="card">
                                {{-- <div class="card-header">
                                    <h4 class="mb-0 p-2 fw-bold">{{ $labelName ?? 'Add New Vendor Details ' }}</h4>
                                </div> --}}
                                <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                    <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Add Form Fields ' }}</h4>
                                    <a href="{{route('form-fields')}}" class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                </div>
                                    <div class="card-body">
                                        <form action="{{ route('form-fields-submit') }}" method="POST" enctype="multipart/form-data">
                                            @csrf
                                            <div class="row">

                                                <input type="hidden"  name="ntaId" value="{{isset($ExamFormsData[0]->ID ) ? Crypt::encrypt($ExamFormsData[0]->ID ): '' }}" >
                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Exam Type <span style="color:red">*</span></label>
                                                        <select class="form-select form-select-lg" name="examCode">
                                                            <option disabled selected>-Select-</option>
                                                            @foreach($examData as  $val)
                                                            <option value="{{$val->examCode}}" @if(isset($ExamFormsData[0]->examType) && $ExamFormsData[0]->examType == $val->examCode) selected @endif >{{$val->examCode}}</option>
                                                            @endforeach
                                                        </select>
                                                        @error('examCode')
                                                        <span style="color:red">{{$message}}</span>
                                                        @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Role <span style="color:red">*</span></label>
                                                        <select class="form-select form-select-lg" name="Role">
                                                            <option disabled selected>-Select-</option>
                                                            @foreach($RoleName as $key => $val)
                                                            <option value="{{$key}}" @if(isset($ExamFormsData[0]->Role) && $ExamFormsData[0]->Role == $key) selected @endif>{{$val}}</option>
                                                            @endforeach
                                                        </select>
                                                        @error('Role')
                                                        <span style="color:red">{{$message}}</span>
                                                        @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Field Name <span style="color:red">*</span></label>
                                                        <input type="text" class="form-control form-control-lg" name="fieldName" maxlength="30" value="{{old('fieldName',isset($ExamFormsData[0]->fieldName) ? $ExamFormsData[0]->fieldName: '') }}" placeholder="Enter Field Name" >
                                                            @error('fieldName')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Field Label <span style="color:red">*</span></label>
                                                        <input type="text" class="form-control form-control-lg" name="fieldLabel" maxlength="30" value="{{old('fieldLabel',isset($ExamFormsData[0]->fieldLabel) ? $ExamFormsData[0]->fieldLabel: '') }}" placeholder="Enter Field Label" >
                                                            @error('fieldLabel')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>

                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Display Order <span style="color:red">*</span></label>
                                                        <input type="text" class="form-control form-control-lg" name="displayOrder" maxlength="3" onkeypress="return blockSpecialChar(event, 'numeric')" value="{{old('displayOrder',isset($ExamFormsData[0]->displayOrder) ? $ExamFormsData[0]->displayOrder: '') }}" placeholder="Enter Display Order" >
                                                            @error('displayOrder')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                            <label class="text-left labelName">is Required <span style="color:red">*</span></label>
                                                            <select class="form-select form-select-lg" name="isRequired">
                                                                <option disabled selected>-Select-</option>
                                                                <option value="1" @if(isset($ExamFormsData[0]->isRequired) && $ExamFormsData[0]->isRequired == 1) selected @endif >Yes</option>
                                                                <option value="0" @if(isset($ExamFormsData[0]->isRequired) && $ExamFormsData[0]->isRequired == 0) selected @endif>No</option>
                                                            </select>
                                                            @error('isRequired')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Field Type <span style="color:red">*</span></label>
                                                        <select class="form-select form-select-lg" name="fieldType">
                                                                <option disabled selected>-Select-</option>
                                                                <option value="number"  @if(isset($ExamFormsData[0]->fieldType) && $ExamFormsData[0]->fieldType == "number") selected @endif >Number</option>
                                                                <option value="select"  @if(isset($ExamFormsData[0]->fieldType) && $ExamFormsData[0]->fieldType == "select") selected @endif>Select</option>
                                                                <option value="text"    @if(isset($ExamFormsData[0]->fieldType) && $ExamFormsData[0]->fieldType == "text") selected @endif>Text</option>
                                                                <option value=""        @if(isset($ExamFormsData[0]->fieldType) && $ExamFormsData[0]->fieldType == "") selected @endif>None</option>
                                                        </select>
                                                            @error('fieldType')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">	Max Length <span style="color:red">*</span></label>
                                                        <input type="text" class="form-control form-control-lg" name="maxLength" maxlength="3" onkeypress="return blockSpecialChar(event, 'numeric')"  value="{{old('maxLength',isset($ExamFormsData[0]->maxLength) ? $ExamFormsData[0]->maxLength: '') }}" placeholder="Enter Max Length" >
                                                            @error('maxLength')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Min Length <span style="color:red">*</span></label>
                                                        <input type="text" class="form-control form-control-lg" name="minLength" onkeypress="return blockSpecialChar(event, 'numeric')"  maxlength="3" value="{{old('minLength',isset($ExamFormsData[0]->minLength) ? $ExamFormsData[0]->minLength: '') }}" placeholder="Enter Min Length" >
                                                            @error('minLength')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">Readonly <span style="color:red">*</span></label>
                                                            <select class="form-select form-select-lg" name="readonly">
                                                                <option disabled selected>-Select-</option>
                                                                <option value="1" @if(isset($ExamFormsData[0]->readonly) && $ExamFormsData[0]->readonly == 1) selected @endif>Yes</option>
                                                                <option value="0" @if(isset($ExamFormsData[0]->readonly) && $ExamFormsData[0]->readonly == 0) selected @endif>No</option>
                                                            </select>
                                                            @error('readonly')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>


                                                <div class="col-md-4">
                                                    <div class="form-group">
                                                        <label class="text-left labelName">is Active <span style="color:red">*</span></label>
                                                        <select class="form-select form-select-lg" name="isActive">
                                                                <option disabled selected>-Select-</option>
                                                                <option value="1" @if(isset($ExamFormsData[0]->isActive) && $ExamFormsData[0]->isActive == 1) selected @endif >Yes</option>
                                                                <option value="0" @if(isset($ExamFormsData[0]->isActive) && $ExamFormsData[0]->isActive == 0) selected @endif >No</option>
                                                        </select>
                                                            @error('isActive')
                                                            <span style="color:red">{{$message}}</span>
                                                            @enderror
                                                    </div>
                                                </div>

                                                <div class="form-group text-end">
                                                    <button type="submit" class="btn btn-success text-white mt-2">Submit</button>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</main>

<script>
    // Function to allow only alphabetic characters (A-Z, a-z)
    function blockSpecialChar(event, type) {
        const keyCode = event.keyCode || event.which;
        const key = String.fromCharCode(keyCode);
        // Allow only alphabetic characters (A-Z, a-z)
        const isAlphabet = /^[a-zA-Z]$/.test(key);
        // Block any key that is not alphabetic
        if (!isAlphabet && keyCode !== 8) { // Allow backspace (keyCode 8)
            event.preventDefault();
            return false;
        }
        return true;
    }
</script>

@endsection

@section('script')
