@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
<style>
    .small {
        display: none;
    }
    .filterSection{
        margin-top:20px;
    }
</style>
<style type="text/css">
	/* Style for the toggle button */
.switch {
    position: relative;
    display: inline-block;
    width: 60px;
    height: 34px;
}

.switch input {
    opacity: 0;
    width: 0;
    height: 0;
}

.slider {
    position: absolute;
    cursor: pointer;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: #ccc;
    transition: 0.4s;
    border-radius: 34px;
}

.slider:before {
    position: absolute;
    content: "";
    height: 26px;
    width: 26px;
    border-radius: 50%;
    left: 4px;
    bottom: 4px;
    background-color: white;
    transition: 0.4s;
}

input:checked + .slider {
    background-color: #4CAF50;
}

input:checked + .slider:before {
    transform: translateX(26px);
}

/* Label to show status */
#statusLabel {
    margin-left: 10px;
    margin-top: 100px;
    font-size: 18px;
}

</style>
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('FormFieldList') }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">Form Fields List</h4>
                                        <div class="d-flex">
                                            <a href="{{route('admin.superdashboard')}}" class="btn btn-danger text-white fs-5 me-2">
                                                <i class="fa fa-angle-double-left" aria-hidden="true"></i> Back
                                            </a>
                                        </div>
                                    </div>
                                     @if (session('success'))
                                        <div class="alert alert-primary alert-dismissible fade show mt-5" role="alert">
                                            {{ session('success') }}
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                    @endif
                                    @if (session('error'))
                                        <div class="alert alert-danger alert-dismissible fade show mt-5" role="alert">
                                            {{ session('error') }}
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                    @endif
                                    <div class="card-body">
                                        <div class="filterSection mt-0 d-flex justify-content-between align-items-center mb-3">
                                            <!-- Show per page -->
                                            <form action="{{ route('form-fields') }}" method="GET" id="perPageForm" class="d-inline">
                                          <span class="d-flex">
                                          <div class="me-2">
                                                <span class="me-2">Show per page</span>

                                                    <select name="perPage" id="perPageSelect" class="form-select form-select-lg" onchange="getloader()">
                                                        <option value="15" {{ request('perPage') == 15 ? 'selected' : '' }}>15</option>
                                                        <option value="50" {{ request('perPage') == 50 ? 'selected' : '' }}>50</option>
                                                        <option value="100" {{ request('perPage') == 100 ? 'selected' : '' }}>100</option>
                                                        <option value="200" {{ request('perPage') == 200 ? 'selected' : '' }}>200</option>
                                                        <option value="100000" {{ request('perPage') == 100000 ? 'selected' : '' }}>All</option>
                                                    </select>

                                            </div>
                                            <div class="me-2">
                                                <span class="me-2">Filter by exam</span>
                                                <select name="examType" id="examTypeSelect" class="form-select form-select-lg" onchange="getloader()">
                                                    <option value="">--Select--</option>
                                                    @foreach($getExamNameResult as $valExam)
                                                        <option value="{{ $valExam->examType }}" {{ request('examType') == $valExam->examType ? 'selected' : '' }} >{{ $valExam->ExamNames }}</option>
                                                    @endforeach
                                                </select>
                                            </div>
                                          </span>
                                          </form>

                                            <!-- Select Exam and Fields Copy -->
                                            <form action="{{ route('fields-copy') }}" method="POST" class="d-flex align-items-center">
                                                @csrf
                                                <!-- Exam Code Selection -->
                                                <div class="me-3">
                                                    <span class="me-2">Select Exam</span>
                                                    <select name="examNames" id="examCodeSelect" class="form-select form-select-lg">
                                                        <option selected disabled>--Select--</option>
                                                        @foreach($examNameData as $exmVal)
                                                            <option value="{{ $exmVal->examType }}">{{ $exmVal->examType }}</option>
                                                        @endforeach
                                                    </select>
                                                    @error('examNames')
                                                    <span style="color:red">{{$message}}</span>
                                                    @enderror
                                                </div>
                                                <!-- Submit Button -->
                                                <div><br>
                                                    <button type="submit" class="btn btn-info text-white" onchange="getloader()">Create</button>
                                                </div>
                                            </form>
                                        </div>

                                        <div class="table-responsive">
                                            <table class="table">
                                                <thead class="custom-header">
                                                    <tr>
                                                        <th>Sr.No.</th>
                                                        <th>Exam Type</th>
                                                        <th>Role</th>
                                                        <th>Fields Name</th>
                                                        <th>Display Order</th>
                                                        <th>Required</th>
                                                        <th>Status</th>
                                                        <th>Action</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    @php
                                                        $i = 1;
                                                    @endphp
                                                    @if(isset($formFields) && !empty($formFields))
                                                        @foreach ($formFields as $index => $field)
                                                            @php
                                                                $isRequirede = $field->isRequired == 1 ? "Yes" : "No";
                                                                $isActive = $field->isActive == 1
                                                                            ? '<span class="btn btn-primary btn-sm">Active</span>'
                                                                            : '<span class="btn btn-danger btn-sm">In-active</span>';

                                                                $roldeVal = '';
                                                                foreach($RoleName as $key => $val){
                                                                    if($key==$field->Role){
                                                                        $roldeVal = $val;
                                                                    }
                                                                }
                                                                $statusChecked = $field->isActive == 1 ? 'checked' : '';
                                                            @endphp
                                                            <tr>
                                                                <td>{{ $i++ }}</td>
                                                                <td>{{ $field->examType ?? '-' }}</td>
                                                                <td>{{ $roldeVal ?? '-' }}</td>
                                                                <td>{{ $field->fieldLabel ?? '-' }}</td>
                                                                <td>{{ $field->displayOrder ?? '-' }}</td>
                                                                <td>{{ $isRequirede }}</td>
                                                                <td>
                                                                    <label class="switch">
                                                                        <input type="checkbox" class="toggleStatus" data-id="{{ $field->ID }}" {{ $statusChecked }}>
                                                                        <span class="slider round"></span>
                                                                    </label>
                                                                    <span class="statusLabel"></span>
                                                                </td>
                                                                <td>
                                                                    <a href="{{ route('admin.form-fields-edit', ['edit' => $field->ID ]) }}" class="btn btn-success text-white">Edit</a>
                                                                </td>
                                                            </tr>
                                                        @endforeach
                                                    @endif
                                                </tbody>
                                            </table>

                                            <!-- Pagination links -->
                                            <div class="d-flex justify-content-between align-items-center">
                                                <div>
                                                    <span class="mb-0 text-muted">
                                                        Showing {{ $formFields->firstItem() }} to {{ $formFields->lastItem() }}
                                                        of {{ $formFields->total() }} results
                                                    </span>
                                                </div>
                                                <!-- Pagination (Right) -->
                                                <div>
                                                    {{ $formFields->appends([
                                                        'perPage' => request('perPage'),
                                                        'examType' => request('examType')
                                                    ])->links('pagination::bootstrap-5') }}
                                                </div>
                                            </div>

                                        </div>

                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>

    function getloader() {
        $('.overlay').show();
        $('#perPageForm').submit();
    }

    function getloaderExam() {
        $('.overlay').show();
        $('#filterByExam').submit();
    }

    $(document).ready(function() {



        $('.toggleStatus').change(function() {
            var fieldId = $(this).data('id');
            var isChecked = $(this).prop('checked');
                var toggleSwitch = $(this);
                Swal.fire({
                    title: "Are you sure?",
                    text: "Do you want to change the status?",
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    cancelButtonColor: "#d33",
                    confirmButtonText: "Yes, change it!"
                }).then((result) => {
                    if (!result.isConfirmed) {
                        toggleSwitch.prop('checked', !isChecked); // Revert toggle if canceled
                    } else {
                        $.ajax({
                            url: "{{ route('updateFieldStatus') }}",
                            type: 'POST',
                            data: {
                                id: fieldId,
                                isActive: isChecked ? 1 : 0,
                                _token: '{{ csrf_token() }}'
                            },
                            success: function(response) {
                                if (response.success) {
                                    Swal.fire({
                                        title: "Success!",
                                        text: "Status has been changed successfully.",
                                        icon: "success",
                                        //timer: 2000,
                                        //showConfirmButton: true
                                    });
                                } else {
                                    Swal.fire({
                                        title: "Success!",
                                        text: response.message,
                                        icon: "success",
                                        //timer: 2000,
                                        //showConfirmButton: true
                                    });
                                }
                            },
                            error: function(xhr, status, error) {
                                alert('An error occurred. Please try again.');
                                $(this).prop('checked', !isChecked);
                                $(this).siblings('.statusLabel').text(isChecked ?
                                    'OFF' : 'ON');
                            }
                        });
                    }
                });
            });



        // $('.toggleStatus').change(function() {

        //     var fieldId = $(this).data('id');
        //     var isChecked = $(this).prop('checked');
        //     var statusText = isChecked ? 'ON' : 'OFF';
        //     $(this).siblings('.statusLabel').text(statusText)
        //     $.ajax({
        //         url: "{{ route('updateFieldStatus') }}",
        //         type: 'POST',
        //         data: {
        //             id: fieldId,
        //             isActive: isChecked ? 1 : 0,
        //             _token: '{{ csrf_token() }}'
        //         },
        //         success: function(response) {
        //             if(response.success) {
        //                 $(this).siblings('.statusLabel').text(isChecked ? 'OFF' : 'ON');  // Revert the label text
        //                     //console.log('Status updated successfully');
        //             } else {
        //                  alert('Error updating status');
        //                 $(this).prop('checked', !isChecked);
        //                 $(this).siblings('.statusLabel').text(isChecked ? 'OFF' : 'ON');  // Revert label
        //             }
        //         },
        //         error: function(xhr, status, error) {
        //             alert('An error occurred. Please try again.');
        //             $(this).prop('checked', !isChecked);
        //             $(this).siblings('.statusLabel').text(isChecked ? 'OFF' : 'ON');  // Revert label
        //         }
        //     });
        // });
    });



</script>


@endsection
