@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
    <style>
        .error {
            color: red;
        }

        .labelName::after {
            content: " *";
            color: red;
            /* You can change the color if needed */
        }
    </style>
@endsection
@section('content')
    <?php
    
    ?>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                @if (isset($countData) && !empty($countData))
                                    {{ Breadcrumbs::render('EditCountPayment', $countData) }}
                                @else
                                    {{ Breadcrumbs::render('AddCountPayment') }}
                                @endif

                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4"><?= $title ?></h4>
                                        <a href="{{ route('list-count') }}" class="btn btn-danger text-white fs-5"> <i
                                                class="fa fa-angle-double-left" aria-hidden="true"> Back</i></a>
                                    </div>
                                    <?php 
                                        // echo "<pre>";
                                        // print_r($examsList);die;
                                    ?>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{route('update-count')}}" method="POST" enctype="multipart/form-data">
                                                @csrf
                                                <div class="row">
                                                    <div class="col-md-4">
                                                        <div class="form-group mb-3">
                                                        <label class="text-left labelName">Exam Name</label>
                                                            <select class="form-control" required name="Exam_Type">
                                                            <option selected disabled>--Select--</option>
                                                            @foreach($examsList as $key => $val)
                                                                <option value="{{$key}}">{{$val}}</option>
                                                            @endforeach
                                                            </select>
                                                            @error('Exam_Type')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>
                                                    <div class="col-md-4">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Upload File</label>
                                                            <input type="file"  name="uploadFilesCandidateWiseCount" class="form-control">
                                                            @error('uploadFilesCandidateWiseCount')
                                                                <div class="text-danger mb-4">{{ $message }}</div>
                                                            @enderror
                                                        </div>
                                                    </div>

                                                    <div class="col-md-2">
                                                        <div class="form-group mb-3">
                                                            <label class="text-left labelName">Download Sample</label>
                                                            <a href="{{asset('candidateWiseCount.xlsx')}}" class="form-control" style="background:#99e9b6">Download Sample</a>
                                                        </div>
                                                    </div>

                                                </div>
                                                <br>

                                                <div class="row">
                                                    <div class="col-auto">
                                                        <div class="form-group">
                                                            <button type="submit" class="btn btn-success DatePreference file">Submit</button>
                                                        </div>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    
@endsection
