@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')
    <style>
        .size {
            font-size: 25px;
            padding-left: 10px;
        }
        .help-block{
            color: red;
        }
    </style>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('ImportFinancialNorms') }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $title ?? 'Import Financial Normsss' }}</h4>
                                        <a href="{{ route('import-financial-norms') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a>
                                    </div>
                                    @if ($errors->any())
                                        <div class="alert alert-danger">
                                            <ul>
                                                @foreach ($errors->all() as $error)
                                                    <li>{{ $error }}</li>
                                                @endforeach
                                            </ul>
                                        </div>
                                    @endif
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{ route('financial-norms-save-bulk-detail') }}" method="POST"
                                                enctype="multipart/form-data" id="financialNorms">
                                                @csrf
                                                <div class="row">

                                                    @php
                                                        $array = collect($ExamDateList)->sortBy('Exam Type')->toArray();
                                                    @endphp

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="exam_type" onchange="ExamTypeId(this)">
                                                                <option value="">Select Here</option>
                                                                @foreach ($array as $rowExamDate)
                                                                    <option value="{{ $rowExamDate->{'Exam Type'} }}"
                                                                        data-key="{{ $rowExamDate->{'Exam Type Id'} }}"
                                                                        {{ old('exam_type') == $rowExamDate->{'Exam Type'} ? 'selected' : '' }}>
                                                                        {{ $rowExamDate->{'Exam Name'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        <input type ="hidden" name="exam_type_id"
                                                            value="{{ old('exam_type_id') }}" class="form-control"
                                                            id="examtypeid" />

                                                        @error('exam_type')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6 d-none">
                                                        <div class="form-group">
                                                            <input type ="hidden" name="exam_name"
                                                                value="{{ old('exam_name') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder ="Enter Exam Name" id="exam_name_data"
                                                                readonly />

                                                        </div>
                                                        @error('exam_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6 mt-2 d-none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Mode <span
                                                                    class="astric-sign">*</span></label>

                                                            <input type ="text" name="exam_mode"
                                                                value="{{ old('exam_mode') }}"
                                                                class="form-control form-control-lg"
                                                                placeholder="Enter Exam Mode" id="exam_mode_data"
                                                                readonly />


                                                        </div>
                                                        @error('exam_mode')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-2">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attach Excel File <span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="file" name="file"
                                                                class="form-control form-select-lg DatePreference file"
                                                                required>
                                                        </div>
                                                        @error('file')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-4 mt-5">
                                                        <div class="form-group"><br>
                                                            <a href="{{ url('Financial_Norms_Sample.xlsx') }}">Download
                                                                Sample Here<i class="fa fa-download size me-3"></i></a>

                                                            <a href="{{ url('Financial_Norms_Required_Parameter.xlsx') }}">Download
                                                                Required
                                                                Parameter<i class="fa fa-download size"></i></a>
                                                        </div>
                                                    </div> <br />
                                                    <div class="form-group mt-5 text-end">
                                                        <button type="submit"
                                                            class="btn btn-success DatePreference file btn btn-success">Submit</button>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script>
        function SourceTypeId(selectElement) {
            var selectedOption = selectElement.options[selectElement.selectedIndex];
            var roleNameKey = selectedOption.getAttribute('data-key');
            $('#sourcetypeid').val(roleNameKey);
        }

        function SourceCodeId(selectCodeElement) {
            var selectedCodeOption = selectCodeElement.options[selectCodeElement.selectedIndex];
            var roleCodeKey = selectedCodeOption.getAttribute('data-key');
            $('#sourcecodeid').val(roleCodeKey);
        }

        function ExamTypeId(examid) {
            var selectedExamOption = examid.options[examid.selectedIndex];
            var roleExamNameKey = selectedExamOption.getAttribute('data-key');
            $('#examtypeid').val(roleExamNameKey);

            $.ajax({
                url: "{{ route('get_exam_name') }}",
                method: 'GET',
                data: {
                    _token: '{{ csrf_token() }}',
                    Exam_ID: roleExamNameKey
                },
                dataType: 'json',
                success: function(response) {
                    console.log('response', response['Exam Name']);
                    $('#exam_name_data').val(response['Exam Name']);
                    $('#exam_mode_data').val(response['Exam_Mode']);
                },
                error: function(data) {
                    console.error("Error fetching data");
                }
            });
        }
    </script>

    {!! $validator->selector('#financialNorms') !!}
@endsection
