@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('EditFinancialNorms', $normsData) }}
                                <div class="card">
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Edit Financial Norms  ' }}</h4>
                                        <!-- <a href="{{ route('import-financial-norms') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a> -->
                                        <a href="{{ route('import-financial-norms', [
                                                'perPage' => request('perPage', ''),
                                                'exam_type' => request('exam_type', ''),
                                                'source_type' => request('source_type','')
                                            ]) }}"
                                            class="btn btn-danger text-white fs-5" aria-hidden="true">Back</a>

                                    </div>
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <form action="{{ route('financial-norms-update-detail') }}" method="POST"
                                                enctype="multipart/form-data" id="financialNorms">
                                                @csrf

                                                <input type ="hidden" name="Document_No" class="form-control"
                                                    value="{{ $normsData->{'Document No_'} }}" />
                                                <input type ="hidden" name="Line_No" class="form-control"
                                                    value="{{ $normsData->{'Line No_'} }}" />

                                                <div class="row">
                                                    @php
                                                        $array = collect($ExamDateList)->sortBy('Exam Type')->toArray();
                                                    @endphp

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name <span
                                                                    class="astric-sign">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="exam_type" onchange="ExamTypeId(this)">
                                                                <option value="">Select Here</option>
                                                                @foreach ($array as $rowExamDate)
                                                                    <option value="{{ $rowExamDate->{'Exam Type'} }}"
                                                                        data-key="{{ $rowExamDate->{'Exam Type Id'} }}"
                                                                        {{ $normsData->{'Exam Type ID'} == $rowExamDate->{'Exam Type Id'} ? 'selected' : '' }}>
                                                                        {{ $rowExamDate->{'Exam Name'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        <input type ="hidden" name="exam_type_id"
                                                            value="{{ $normsData->{'Exam Type ID'} }}" class="form-control"
                                                            id="examtypeid" />

                                                        @error('exam_type')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" style="display:none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Name <span
                                                                    class="astric-sign">*</span></label>

                                                            <input type ="text" name="exam_name"
                                                                value="{{ $normsData->{'Exam Name'} }}"
                                                                class="form-control" id="exam_name_data" readonly />

                                                            <!-- <select class="form-control form-control-lg" name="exam_name">
                                                                    <option value="">Select Here</option>
                                                                    @foreach ($ExamDateList as $rowExamDate)
    <option {{ old('exam_name') == $rowExamDate->{'Exam Name'} ? 'selected' : '' }}>{{ $rowExamDate->{'Exam Name'} }}</option>
    @endforeach
                                                                </select>  -->

                                                        </div>
                                                        @error('exam_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6" style="display:none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Exam Mode <span
                                                                    class="astric-sign">*</span></label>

                                                            <input type ="text" name="exam_mode"
                                                                value="{{ $normsData->{'Exam Mode'} }}"
                                                                class="form-control" id="exam_mode_data" readonly />

                                                            <!-- <select class="form-control form-control-lg" name="exam_mode">
                                                                    <option value="">Select Here</option>
                                                                    @foreach ($ExamMode as $rowExamDate)
    <option value="{{ $rowExamDate }}" {{ old('exam_mode') == $rowExamDate ? 'selected' : '' }}>{{ $rowExamDate }}</option>
    @endforeach
                                                                </select>  -->
                                                        </div>
                                                        @error('exam_mode')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    
                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Role<span
                                                            class="astric-sign" style="color:red">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                onchange="SourceTypeId(this)" name="source_type">
                                                                <option value="">Select Here</option>
                                                                @foreach ($RoleName as $RoleNameKey => $rowrole)
                                                                    <option value="{{ $rowrole }}"
                                                                        data-key="{{ $RoleNameKey }}"
                                                                        {{ $normsData->{'Source Type'} == $RoleNameKey ? 'selected' : '' }}>
                                                                        {{ $rowrole }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>

                                                        <input type ="hidden" name="source_type_id" class="form-control"
                                                            value="{{ $normsData->{'Source Type'} }}" id="sourcetypeid" />
                                                        @error('source_type')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Category <span
                                                            class="astric-sign" style="color:red">*</span></label>
                                                            <select class="form-control form-select form-select-lg"
                                                                onchange="SourceCodeId(this)" name="source_code" id="SourceCodeIdCheck">
                                                                <option value="">Select Here</option>
                                                                @foreach ($SourceCodeList as $rowsourcecode)
                                                                    <option value="{{ $rowsourcecode->{'Source Code'} }}"
                                                                        data-key="{{ $rowsourcecode->{'Source Name'} }}"
                                                                        {{ $normsData->{'Source Code'} == $rowsourcecode->{'Source Code'} ? 'selected' : '' }}>
                                                                        {{ $rowsourcecode->{'Source Code'} }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        <input type ="hidden" name="source_name" class="form-control"
                                                            id="sourcecodeid" />
                                                        @error('source_code')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attachment</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="attechment" id="attechment">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsAttachment as $keyAttribute => $rowAttachment)
                                                                    <option value="{{ $keyAttribute }}"
                                                                        {{ $normsData->{'isAttechment'} == $keyAttribute ? 'selected' : '' }}>
                                                                        {{ $rowAttachment }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('attechment')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" id="Main_AttechmentNameDiv">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Attachment Required</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="attechment_required" id="attechment_required">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsAttachment as $keyAttributeReq => $rowAttachmentReq)
                                                                    <option value="{{ $keyAttributeReq }}"
                                                                        {{ $normsData->{'isAttechmentRequired'} == $keyAttributeReq ? 'selected' : '' }}>
                                                                        {{ $rowAttachmentReq }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('attechment_required')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Non-Editable Field</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="read_only">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsReadonly as $keyReadOnly => $rowReadOnly)
                                                                    <option value="{{ $keyReadOnly }}"
                                                                        {{ $normsData->{'readonly'} == $keyReadOnly ? 'selected' : '' }}>
                                                                        {{ $rowReadOnly }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('read_only')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Required</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="required">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsRequired as $keyRequired => $rowRequired)
                                                                    <option value="{{ $keyRequired }}"
                                                                        {{ $normsData->{'isRequired'} == $keyRequired ? 'selected' : '' }}>
                                                                        {{ $rowRequired }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('required')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Display Order</label>
                                                            <input type ="number" name="display_order"
                                                                value="{{ $normsData->{'displayOrder'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('display_order')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Category Text<span
                                                                    class="astric-sign">*</span></label>
                                                            <input type="text"
                                                                value="{{ $normsData->{'Source Name'} }}"
                                                                class="form-control" name="source_name">
                                                        </div>
                                                        @error('source_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneration Description</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ $normsData->{'Remuneration Text'} }}"
                                                                name="remuneratlon">
                                                        </div>
                                                        @error('remuneratlon')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneration Amount
                                                                For Shift 1</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Remuneration Amount_S1'}, 0)) }}"
                                                                name="remuneratlon_amount_s1">
                                                        </div>
                                                        @error('remuneratlon_amount_s1')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneration Amount
                                                                For Shift 2</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Remuneration Amount_S2'}, 0)) }}"
                                                                name="remuneratlon_amount_s2">
                                                        </div>
                                                        @error('remuneratlon_amount_s2')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneration Amount
                                                                For Shift 3</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Remuneration Amount_S3'}, 0)) }}"
                                                                name="remuneratlon_amount_s3">
                                                        </div>
                                                        @error('remuneratlon_amount_s3')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Remuneration Amount
                                                                For Shift 4</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Remuneration Amount_S4'}, 0)) }}"
                                                                name="remuneratlon_amount_s4">
                                                        </div>
                                                        @error('remuneratlon_amount_s4')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Conveyance Amount</label>
                                                            <input type ="text" name="conveyance_amount"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Conveyance Amount'}, 0)) }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('conveyance_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Description</label>
                                                            <input type ="text" name="mock_drill_text"
                                                                value="{{ $normsData->{'Mock Drill Text'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('mock_drill_text')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Amount</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Mock Drill Charge'}, 0)) }}"
                                                                name="mock_drilling_amount">
                                                        </div>
                                                        @error('mock_drilling_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill
                                                                Conveyance</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Mock Drill Conveyance'}, 0)) }}"
                                                                name="mock_drilling_conveyance">
                                                        </div>
                                                        @error('mock_drilling_conveyance')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Max No Of Candidates</label>
                                                            <input type="text" class="form-control"
                                                                value="{{ $normsData->{'No_ of Candidates'} }}"
                                                                name="candidates">
                                                        </div>
                                                        @error('candidates')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Food Amount</label>
                                                            <input type ="text" name="food_amount"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Food Amount'}, 0)) }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('food_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Max No of Person</label>
                                                            <input type ="text" name="no_of_person"
                                                                value="{{ $normsData->{'No_ of Person'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('no_of_person')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Duty Days</label>
                                                            <input type ="text" name="no_of_days"
                                                                value="{{ $normsData->{'No_ of Days'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('no_of_days')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Fixed Amount</label>
                                                            <input type ="text" name="fixed_amount"
                                                                value="{{ str_replace(',', '', number_format($normsData->{'Fixed Amount'}, 0)) }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('fixed_amount')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>

                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">TDS Applicable?</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="tds" id="tds">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsTds as $keyTds => $rowTds)
                                                                    <option value="{{ $keyTds }}"
                                                                        {{ $normsData->{'isTds'} == $keyTds ? 'selected' : '' }}>
                                                                        {{ $rowTds }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('tds')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6" id ="Main_TdsPersentageNameDiv">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">TDS Precentage</label>
                                                            <input type ="number" name="tdsprecentage" id="tdsprecentage"
                                                                value="{{ $normsData->{'tdsPrecentage'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('tdsprecentage')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>



                                                    <div class="col-md-6 d-none">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Is Active</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="is_active">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsActive as $keyActive => $rowActive)
                                                                    <option value="{{ $keyActive }}"
                                                                        {{ $normsData->{'isActive'} == $keyActive ? 'selected' : '' }}>
                                                                        {{ $rowActive }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('is_active')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>


                                                    <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Is Extra Field</label>
                                                            <select class="form-control form-select form-select-lg"
                                                                name="is_extra_field">
                                                                <option value="">Select Here</option>
                                                                @foreach ($IsExtrafield as $keyExtrafield => $rowExtraField)
                                                                    <option value="{{ $keyExtrafield }}"
                                                                        {{ $normsData->{'isExtrafield'} == $keyExtrafield ? 'selected' : '' }}>
                                                                        {{ $rowExtraField }}</option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        @error('is_extra_field')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div>
                                                    {{-- <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Field Name</label>
                                                            <input type ="text" name="field_name"
                                                                value="{{ $normsData->{'Field_Name'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('field_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div> --}}


                                                    {{-- <div class="col-md-6">
                                                        <div class="form-group">
                                                            <label class="text-left labelName">Mock Drill Filed
                                                                Name</label>
                                                            <input type ="text" name="mock_drill_filed_name"
                                                                value="{{ $normsData->{'MockDrillFiledName'} }}"
                                                                class="form-control" />
                                                        </div>
                                                        @error('mock_drill_filed_name')
                                                            <div class="text-danger mb-4">{{ $message }}</div>
                                                        @enderror
                                                    </div> --}}
                                                </div>

                                                @if(isset($normsData->{'Exam Type ID'}) && !empty($normsData->{'Exam Type ID'}) )
                                                    <div class="col-md-12 mt-5">
                                                        <div class="form-group text-end">
                                                            <button type="submit" class="btn btn-success">Update</button>
                                                        </div>
                                                    </div>
                                                    @else
                                                    <div class="col-md-12 mt-5">
                                                        <div class="form-group text-end">
                                                            <button type="submit" class="btn btn-success">Submit</button>
                                                        </div>
                                                    </div>
                                                @endif
                                               
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script>
        function SourceTypeId(selectElement) {
            var selectedOption = selectElement.options[selectElement.selectedIndex];
            var roleNameKey = selectedOption.getAttribute('data-key');
            $('#sourcetypeid').val(roleNameKey);
           
            if(roleNameKey == null){
                let $select = $('#SourceCodeIdCheck');
                $select.val(''); // Resets the selected value
                $select.empty();  // Clears current options
                $select.append('<option value="">-- Select Category --</option>');
                return false;
            }

            $.ajax({
                url: "{{ route('get_gategory_list') }}",
                method: 'GET',
                data: {
                    _token: '{{ csrf_token() }}',
                    roleId: roleNameKey
                },
                dataType: 'json',
                success: function(response) {
                    let $select = $('#SourceCodeIdCheck');
                    $select.empty();

                    $select.append('<option value="">-- Select Category --</option>');

                    $.each(response, function(index, item) {
                        $select.append('<option value="' + item['Source Code'] + '" data-key="'+ item['Source Code'] +'">' + item['Source Code'] + '</option>');
                    });
                },
                error: function(data) {
                    console.error("Error fetching data");
                }
            });
            
        }

        function SourceCodeId(selectCodeElement) {
            var selectedCodeOption = selectCodeElement.options[selectCodeElement.selectedIndex];
            var roleCodeKey = selectedCodeOption.getAttribute('data-key');
            $('#sourcecodeid').val(roleCodeKey);
        }

        function ExamTypeId(examid) {
            var selectedExamOption = examid.options[examid.selectedIndex];
            var roleExamNameKey = selectedExamOption.getAttribute('data-key');
            $('#examtypeid').val(roleExamNameKey);

            $.ajax({
                url: "{{ route('get_exam_name') }}",
                method: 'GET',
                data: {
                    _token: '{{ csrf_token() }}',
                    Exam_ID: roleExamNameKey
                },
                dataType: 'json',
                success: function(response) {
                    console.log('response', response['Exam Name']);
                    $('#exam_name_data').val(response['Exam Name']);
                    $('#exam_mode_data').val(response['Exam_Mode']);

                    // BillData = response;
                    // buildIndex(); // Build index after fetching data
                    // filterResults(); // Display all data initially
                },
                error: function(data) {
                    console.error("Error fetching data");
                }
            });
        }


        $("#attechment").change(function() {
            var attechmentID = $.trim($("#attechment").val());
            if (attechmentID == 1) {
                $('#Main_AttechmentNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_AttechmentNameDiv').hide();
            }
        });


        $("#tds").change(function() {
            var tdsID = $.trim($("#tds").val());
            if (tdsID == 1) {
                $('#Main_TdsPersentageNameDiv').show();
            } else {
                $('#tdsprecentage').val('');
                $('#Main_TdsPersentageNameDiv').hide();
            }
        });


        $(document).ready(function() {

            var attechmentID = $.trim($("#attechment").val());
            if (attechmentID == 1) {
                $('#Main_AttechmentNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_AttechmentNameDiv').hide();
            }

            var tdsID = $.trim($("#tds").val());
            if (tdsID == 1) {
                $('#Main_TdsPersentageNameDiv').show();
            } else {
                $('#attechment_required').val('');
                $('#Main_TdsPersentageNameDiv').hide();
            }

        });
    </script>


    {!! $validator->selector('#financialNorms') !!}
@endsection
