@extends('layouts.adminLayout.dashboardLayout')
@section('styles')
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/sweetalert2@11.7.4/dist/sweetalert2.min.css">
@endsection
@section('content')

    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">

            <div class="login-5 mt-50 mb-50">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div class="container-fluid">
                                {{ Breadcrumbs::render('AddVendor') }}
                                <div class="card">
                                    {{-- <div class="card-header">
                                    <h4 class="mb-0 p-2 fw-bold">{{ $labelName ?? 'Add New Vendor Details ' }}</h4>
                                </div> --}}
                                    <div class="card-header d-flex align-items-center justify-content-between py-3 px-3">
                                        <h4 class="mb-0 fw-bold fs-4">{{ $labelName ?? 'Add New Functionary Details ' }}</h4>
                                        <a href="{{ route('import-vendor-details') }}"
                                            class="btn btn-danger text-white fs-5"> <i class="fa fa-angle-double-left"
                                                aria-hidden="true"> Back</i></a>

                                    </div>

                                    @if ($errors->any())
                                        <div class="alert alert-danger">
                                            <ul>
                                                @foreach ($errors->all() as $error)
                                                    <li>{{ $error }}</li>
                                                @endforeach
                                            </ul>
                                        </div>
                                    @endif
                                    @if (session('successR'))
                                    <div class="container custom-container">
                                        <div class="d-flex justify-content-between alert alert-primary mt-3">
                                            {!! session('successR') !!}    
                                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                        </div>
                                    </div>
                                    @endif

                                    <div class="card-body custom-form">
                                        <form action="{{ route('vendor-save-detail') }}" method="POST"
                                            enctype="multipart/form-data">
                                            @csrf
                                            <div class="row">
                                                <div class="col-auto">
                                                    <div class="row">
                                                        <div class="col-auto">
                                                            <div class="form-group">
                                                                <label class="text-left labelName">Attach Excel
                                                                    File</label>
                                                                <input type="file" name="file"
                                                                    class="form-control form-control-lg DatePreference file"
                                                                    required>

                                                            </div>
                                                        </div>

                                                        <div class="col-auto mt-30 d-flex gap-2">
                                                            <a href="{{ asset('MasterDataSample.xlsx') }}"
                                                                class="btn btn-info text-white  fw-bold">Download Sample</a>
                                                            <a href="{{ asset('RolesDataSample.xlsx') }}"
                                                                class="btn btn-warning text-white fw-bold">Download
                                                                Roles</a>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <br />
                                            <div class="row">
                                                <div class="col-md-6">
                                                    <div class="row">
                                                        <div class="col-md-9">
                                                            <div class="form-group">
                                                                <button type="submit"
                                                                    class="btn btn-success DatePreference file">Submit</button>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        </div>
    </main>


@endsection
@section('script')
