@extends('layouts.admin')
@section('content')
    <style>
        .btn-header-link::after {
            display: none !important;
        }

        .modal-dialog {
            max-width: 90%;
        }

        .disable-input {
            cursor: none;
            pointer-events: none;
        }

        .file-upload {
            display: flex;
            align-items: center;
            font-family: Arial, sans-serif;
            margin-bottom: 10px;
        }

        .file-input {
            display: none;
        }

        .file-label {
            display: inline-block;
            padding: 8px 12px;
            border: 1px solid #ccc;
            border-radius: 4px;
            background-color: #f8f9fa;
            cursor: pointer;
            margin-right: 10px;
            white-space: nowrap;
        }

        .file-label:hover {
            background-color: #e2e6ea;
        }

        .file-name {
            font-size: 14px;
            color: #6c757d;
            max-width: 200px;
            /* Adjust the max-width as needed */
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
        }


        .field-centrebillmst-observerfile {
            margin-bottom: 0px !important;
        }


        /* .form-control:disabled, .form-control[readonly] {
                                                            background-color: #e9ecef00;
                                                        } */
    </style>
    <?php $Role = Session::get('role');
    $RoleName = config('constants.RoleName');
    $VendorDetails = getCurrentUserDataById();
    //prd($VendorDetails);
    ?>
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5 mt-50 mb-50">
                <div class="accordion" id="faq">
                    <div class="card ">
                        <div class="card-header" id="faqhead1">
                            <a href="javascript:void(0)" class="btn-header-link fs-4 fw-bold d-block text-center"
                                aria-expanded="true" aria-controls="faq1">Annexure A-2 (TO BE FILLED BY
                                {{ $RoleName[$Role] }} AND SUBMITTED TO RC )</a>
                        </div>
                        <div class="custom-form RemunerationMain">
                            <form method="POST"
                                action="{{ $Role == 14 ? route('examBillSaveCS') : route('examBillSave') }}"
                                enctype="multipart/form-data" autocomplete="off">
                                @csrf
                                <div id="faq1" class="collapse show" aria-labelledby="faqhead1" data-parent="#faq1">
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <div class="row">
                                                @php
                                                $examDaysMock=($examDaysMock==1)?$totalDutyDays:1;
                                                $totalCountObserver = 0;
                                                // prd($ArrayFields);
                                                @endphp 
                                                @if (isset($ArrayFields) && !empty($ArrayFields))
                                                    @foreach ($ArrayFields as $row)
                                                        <?php $colSize = $row['fieldName'] === 'Center##Address' ? 'col-md-12' : 'col-md-6';
                                                            if($row['fieldLabel'] == 'No. of Allotted Observers'){
                                                                $totalCountObserver = $row['fieldValue'];
                                                            }
                                                        ?>
                                                        <div class="{{ $colSize }}">
                                                            <div class="form-group">
                                                                <label class="form-label">{{ $row['fieldLabel'] }}
                                                                    @if ($row['isRequired'] == 1)
                                                                        <span class="text-danger">* @if($row['fieldLabel'] == 'Allotted Candidates' && $totalCountObserver > 0) <span class="text-primary">Note: Total allotted candidate should be {{$totalCountObserver * 360}} as per Observers Duty.</span> @endif</span>
                                                                    @endif
                                                                </label>
                                                                @if ($row['fieldType'] == 'textarea')
                                                                    <textarea rows="1"
                                                                        class="form-control form-control-lg common-fields {{ $row['isRequired'] == 1 ? 'valid-field' : '' }}"
                                                                        @if ($row['readonly'] == 1) readonly @endif maxlength="{{ $row['maxLength'] }}"
                                                                        minlength="{{ $row['minLength'] }}">{{ $row['fieldValue'] }}</textarea>
                                                                @elseif($row['fieldType'] == 'select')
                                                                    <select id="CentreNumber"
                                                                        class="form-select-lg required form-select common-fields {{ $row['isRequired'] == 1 ? 'valid-field' : '' }}"
                                                                        name="CentrebillMst[CentreNumberList]">
                                                                        <option value="">--Select--</option>
                                                                        @if (isset($row['fieldValue']))
                                                                            @foreach ($row['fieldValue'] as $centerNo)
                                                                                <option value="{{ $centerNo }}">
                                                                                    {{ $centerNo }}</option>
                                                                            @endforeach
                                                                        @endif
                                                                    </select>
                                                                @else
                                                                    <input onkeypress="return blockSpecialChar(event,'numeric')"
                                                                        @if ($row['fieldType'] == 'number') type="text" 
                                                            @else 
                                                                type="{{ $row['fieldType'] }}" @endif
                                                                        @if (in_array($row['fieldName'], [
                                                                                'No_##of##Candidate##Alloted',
                                                                                'No_##of##Candidate##Present',
                                                                                'No_##of##Candidate##Absent',
                                                                            ])) id="{{ $row['fieldName'] === 'No_##of##Candidate##Alloted' ? 'AllottedCandidates' : ($row['fieldName'] === 'No_##of##Candidate##Present' ? 'PresentCandidates' : 'AbsentCandidates') }}" 
                                                                name="{{ $row['fieldName'] }}" @endif
                                                                        @if ($row['fieldName'] === 'Center##Address') id="CentreNameWithAddress"  name="{{ $row['fieldName'] }}" @endif
                                                                        @if ($row['fieldName'] === 'Center##City') id="CentreCity"  name="{{ $row['fieldName'] }}" @endif
                                                                        @if ($row['fieldName'] === 'No_##of##Alloted##Observer') id="No_ofAllotedObserver" @endif
                                                                        class="form-control form-control-lg common-fields {{ $row['isRequired'] == 1 ? 'valid-field' : '' }}"
                                                                        value="{{ isset($row['fieldValue']) && !empty($row['fieldValue']) && is_array($row['fieldValue']) ? implode(',', $row['fieldValue']) : $row['fieldValue'] }}"
                                                                        @if ($row['readonly'] == 1) readonly @endif
                                                                        maxlength="{{ $row['maxLength'] }}"
                                                                        minlength="{{ $row['minLength'] }}">
                                                                @endif
                                                                <div class="invalid-feedback"></div>
                                                            </div>
                                                        </div>
                                                        @if (Session::get('role') == 14)
                                                            @if ($row['fieldName'] === 'No_##of##Candidate##Alloted' && isset($totalDutyDays))
                                                                @for ($lt = 1; $lt <= $totalDutyDays; $lt++)
                                                                    <div
                                                                        class="form-group col-md-1 d-flex flex-column daywiseCountSection">
                                                                        <label
                                                                            for="allottedCandidatesCount{{ $lt }}"
                                                                            class="form-label text-nowrap">Day
                                                                            {{ $lt }} Max
                                                                            Count</label>
                                                                        <input type="text"
                                                                            name="AllottedCandidatesCount[]"
                                                                            id="allottedCandidatesCount{{ $lt }}"
                                                                            class="form-control form-control-lg required DutyDaysInput AllottedCandidatesCount mx-2"
                                                                            maxlength="8" readonly
                                                                            onkeypress="return blockSpecialChar(event, 'numeric')"
                                                                            value="0" />
                                                                    </div>
                                                                @endfor
                                                            @endif
                                                        @endif
                                                    @endforeach
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="dynamicShiftwiseCount d-none">

                                </div>
                                <div class="table-responsive m-4">
                                    <table class="table cco-table table-bordered RemunerationOnlineTable"
                                        id="RemunerationOnlineTable">
                                        <thead>
                                            <tr>
                                                <th>S.No</th>
                                                <th>Category</th>
                                                <th width="40%">Remuneration And Conveyance Payable</th>
                                                <th>No. Of Persons</th>
                                                <th>No. Of Duty Days</th>
                                                <th>Amount</th>

                                            </tr>
                                        </thead>
                                        <tbody>
                                            @php
                                                $ObserverPerDayAmount = 0;
                                                $ObserverPerDayConveyanceAmount = 0;
                                                $ObserverPerDayAmountMock = 0;
                                                $ObserverPerDayConveyanceAmountMock = 0;
                                                $DeputyObserverPerDayAmount = 0;
                                                $DeputyObserverPerDayConveyanceAmount = 0;
                                                $DeputyObserverPerDayAmountMock = 0;
                                                $DeputyObserverPerDayConveyanceAmountMock = 0;
                                            @endphp
                                            @if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData))
                                                @php
                                                // prd($RemunerationFieldsData);
                                                    $i = 0;
                                                    $TDSPercentage = config('constants.Amount')['RemunerationTDS'];

                                                    //   prd($RemunerationFieldsData);  
                                                    @endphp
                                                @foreach ($RemunerationFieldsData as $k => $Remuneration)
                                                @php
                                                        $Remuneration = (array) $Remuneration;
                                                        $CCRemunerationAndConvence = ($RemunerationAmountTotalR + ($Remuneration['Conveyance Amount']*$totalDutyDays));
                                                        $totalRemuneratinAmt = 0;

                                                        if($Remuneration['Source Code'] == 'OBSERVER LOCAL'){
                                                            $ObserverPerDayAmount = number_format($Remuneration['Remuneration Amount_S1'] ?? 0, 0, '', '');
                                                            $ObserverPerDayConveyanceAmount = number_format($Remuneration['Conveyance Amount'] ?? 0, 0, '', '');
                                                            $ObserverPerDayAmountMock = number_format($Remuneration['Mock Drill Charge'] ?? 0, 0, '', '');
                                                            $ObserverPerDayConveyanceAmountMock = number_format($Remuneration['Mock Drill Conveyance'] ?? 0, 0, '', '');
                                                            $OBfoodAmount = number_format($Remuneration['Food Amount'] ?? 0, 0, '', '');

                                                        }
                                                        if($Remuneration['Source Code'] == 'DEPUTY OBSERVER'){
                                                            $DeputyObserverPerDayAmount = number_format($Remuneration['Remuneration Amount_S1'] ?? 0,0,'','');
                                                            $DeputyObserverPerDayConveyanceAmount = number_format($Remuneration['Conveyance Amount'] ?? 0,0,'','');
                                                            $DeputyObserverPerDayAmountMock = number_format($Remuneration['Mock Drill Charge'] ?? 0,0,'','');
                                                            $DeputyObserverPerDayConveyanceAmountMock = number_format($Remuneration['Mock Drill Conveyance'] ?? 0,0,'','');
                                                            $DOBfoodAmount = number_format($Remuneration['Food Amount'] ?? 0, 0, '', '');
                                                        }

                                                    @endphp
                                                    @for ($h=1;$h<=4;$h++)
                                                        @php
                                                            $totalRemuneratinAmt =
                                                                $totalRemuneratinAmt +
                                                                $Remuneration[
                                                                    'Remuneration Amount_S' . $h
                                                                ];
                                                        @endphp
                                                    @endfor
                                                    <!-- If Remuneration & MockDrill Available -->
                                                    @if ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] != '')
                                                        <tr>
                                                            <td rowspan="2">{{ ++$i }}</td>
                                                            <td rowspan="2">{{ $Remuneration['Source Name'] }}</td>
                                                            <td>{!! nl2br(str_replace("\\n", "\n", $Remuneration['Remuneration Text'])) !!}</td>
                                                            @if ($Remuneration['isTds'] == 1)
                                                                <input type="hidden" class="tds"
                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                    name="TDSPer" />

                                                            @endif
                                                            <input type="hidden" class="RemunerationAmount" value="{{ $Remuneration['Remuneration Amount_S1'] + $Remuneration['Remuneration Amount_S2'] + $Remuneration['Remuneration Amount_S3'] + $Remuneration['Remuneration Amount_S4'] }}" />
                                                            <input type="hidden" class="ConvenceAmount"
                                                                value="{{ $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="NoOfCandidates"
                                                                value="{{ $Remuneration['No_ of Candidates'] }}" />
                                                            <input type="hidden" class="ManPowerInput"
                                                                value="{{isset($Remuneration['Source Code']) && $Remuneration['Source Code'] === 'CITY COORDINATOR' ? $CCRemunerationAndConvence  : ($totalRemuneratinAmt + $Remuneration['Conveyance Amount']) }}" />
                                                            <td>
                                                                @if ($Remuneration['No_ of Person'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT') unsetValue @endif form-control-lg valid-field ManPower calculateTDS CandidateWiseCount"
                                                                        lang="{{ $Remuneration['No_ of Person'] }}"
                                                                        name="ManPower[]" @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR') value="1" readonly @endif
                                                                        @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                        readonly @endif
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="ManPower[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if ($Remuneration['No_ of Days'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT') unsetValue @endif form-control-lg valid-field DutyDays remunerationDutyDay calculateTDS"
                                                                        lang="{{ $Remuneration['No_ of Days'] }}"
                                                                        name="DutyDays[]" @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR') value="{{$totalDutyDays}}" readonly @endif
                                                                        @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                        readonly @endif
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="DutyDays[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if($Remuneration['Source Code'] === 'CITY COORDINATOR')
                                                                <input type="hidden" name="City##Coor_##Conveyance##Amount" value="<?=$Remuneration['Conveyance Amount']*$totalDutyDays?>">
                                                                <input type="hidden" name="City##Coor_##Remuneration##Amount" value="<?=$RemunerationAmountTotalR?>">
                                                                @endif
                                                                <div class="d-flex">
                                                                    
                                                                <input type="text" maxlength="8"
                                                                    class="form-control  @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT') unsetValue @endif form-control-lg RemunerationSection"
                                                                    id="{{ preg_replace('/[^a-zA-Z0-9_-]/', '', str_replace(' ', '_', $Remuneration['Source Code'])) }}"
                                                                    @if ($Remuneration['isExtrafield'] == 1) name="ExtraRemunerationSection[][{{ $Remuneration['Field_Name'] }}]" @else name="{{ $Remuneration['Field_Name'] }}" @endif
                                                                    onkeypress="return blockSpecialChar(event,'numeric')"
                                                                    @if ($Remuneration['readonly'] == 1) readonly @endif 
                                                                    @if($Remuneration['Source Code'] === 'CITY COORDINATOR') value="{{ $CCRemunerationAndConvence }}" @endif>
                                                                    @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR')
                                                                    <span><i class="fa fa-eye text-info fs-4 ms-3 me-1 mt-15 cursor-pointer shiftwise-payment-Amount-modal-btn" style="display:none" data-bs-toggle="modal"
                                                                        data-bs-target="#shiftwise-payment-Amount-modal"></i></span>
                                                                    @endif

                                                                    @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                    <span><i class="fa fa-pencil text-info fs-4 ms-3 me-1 mt-15 cursor-pointer shiftwise-modal-btn" style="display:none" data-bs-toggle="modal"
                                                                        data-bs-target="#shiftwise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-modal"></i></span>
                                                                    @endif
                                                                    
                                                                </div>
                                                                @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL' || $Remuneration['Source Code'] == 'DEPUTY OBSERVER')
                                                                    <span
                                                                        class="btn btn-success {{ str_replace('##', '-', $Remuneration['Field_Name']) }}-modal-btn my-1"
                                                                        data-bs-toggle="modal"
                                                                        data-bs-target="#{{ str_replace('##', '-', $Remuneration['Field_Name']) }}-modal">Add 
                                                                        Details +</span>

                                                                        {{-- <span><i class="fa fa-eye text-info fs-4 ms-3 me-1 mt-15 cursor-pointer OBDOB" id="{{ str_replace(' ', '_', $Remuneration['Source Code']) }}_previewR" data-bs-toggle="modal"
                                                                            data-bs-target="#PreviewModal_OB_DOB"></i></span> --}}


                                                                @endif
                                                            </td>
                                                        </tr>
                                                        @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                        {{-- Dynamic Modal for shiftwise calculation --}}
                                                        <div class="modal fade" tabindex="-1" id="shiftwise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-modal">
                                                            <div class="modal-dialog">
                                                                <div class="modal-content">
                                                                    <div class="modal-header">
                                                                        <h3 class="modal-title">Shift Wise Payment Details</h3>
                                                        
                                                                        <!--begin::Close-->
                                                                        <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
                                                                            <i class="ki-duotone ki-cross fs-1"><span class="path1"></span><span class="path2"></span></i>
                                                                        </div>
                                                                        <!--end::Close-->
                                                                    </div>
                                                        
                                                                    <div class="modal-body shift-wise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-payment">
                                                                        <div class="custom-form">
                                                                            <input type="hidden" shift1="{{$Remuneration['Remuneration Amount_S1']}}" shift2="{{$Remuneration['Remuneration Amount_S2']}}" shift3="{{$Remuneration['Remuneration Amount_S3']}}" 
                                                                            shift4="{{$Remuneration['Remuneration Amount_S4']}}" value="{{ $Remuneration['No_ of Candidates'] }}" role-id="{{ preg_replace('/[^a-zA-Z0-9_-]/', '', str_replace(' ', '_', $Remuneration['Source Code'])) }}" class="NoOfPersonsDynamic">
                                                                            <div class="row shiftwise-html text-center justify-content-center">
                                                                                
                                                                            </div>
                                                                            <div class="text-end">
                                                                                <button type="button" class="btn btn-success mt-3 calculateAmount">Calculate Amount</button>
                                                                            </div>
                                                                            <div class="mt-3 calculation-result"></div>
                                                                        </div>
                                                                    </div>
                                                        
                                                                    <div class="modal-footer">
                                                                        <button type="button" class="btn btn-light" data-bs-dismiss="modal">Save & Close</button>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        @endif
                                                        <tr>
                                                            <td>{!! nl2br(str_replace("\\n", "\n", $Remuneration['Mock Drill Text'])) !!}</td>
                                                            @if ($Remuneration['isTds'] == 1)
                                                                <input type="hidden" class="tds"
                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                    name="TDSPer" />

                                                            @endif
                                                            <input type="hidden" class="RemunerationAmount"
                                                                value="{{ $Remuneration['Mock Drill Charge'] }}" />
                                                            <input type="hidden" class="ConvenceAmount"
                                                                value="{{ $Remuneration['Mock Drill Conveyance'] }}" />
                                                            <input type="hidden" class="ManPowerInput"
                                                                value="{{ $Remuneration['Mock Drill Charge'] + $Remuneration['Mock Drill Conveyance'] }}" />
                                                            <input type="hidden" class="NoOfCandidates"
                                                                value="{{ $Remuneration['No_ of Candidates'] }}" />
                                                            <td>
                                                                @if ($Remuneration['No_ of Person'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control unsetValue form-control-lg valid-field ManPower calculateTDS CandidateWiseCount"
                                                                        lang="{{ $Remuneration['No_ of Person'] }}"
                                                                        name="ManPower[]"
                                                                        @if(Session::get('role') == 14 && $Remuneration['Source Code'] === 'CENTRE SUPERITENDENT') value ="1" readonly @endif
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="ManPower[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if ($Remuneration['No_ of Days'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control form-control-lg valid-field DutyDays remunerationDutyDay calculateTDS"
                                                                        value="1" readonly
                                                                        lang="{{ $Remuneration['No_ of Days'] }}"
                                                                        name="DutyDays[]"
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="DutyDays[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if($Remuneration['Source Code'] === 'CITY COORDINATOR')
                                                                <input type="hidden" name="City##Coor_##MockDrill##Remuneration" value="<?=$Remuneration['Mock Drill Charge']?>">
                                                                <input type="hidden" name="City##Coor_##MockDrill##Conveyance" value="<?=$Remuneration['Mock Drill Conveyance']?>">
                                                                @endif
                                                                <input
                                                                    @if (
                                                                        $Remuneration['MockDrillFiledName'] == 'Mock##Drill##Amount##Observer' ||
                                                                            $Remuneration['MockDrillFiledName'] == 'Mock##Drill##Amount##DObserver') type="hidden" @else type="text" @endif
                                                                    maxlength="8"
                                                                    class="form-control unsetValue form-control-lg RemunerationSection"
                                                                    @if ($Remuneration['isExtrafield'] == 1) name="ExtraRemunerationSection[][{{ $Remuneration['MockDrillFiledName'] }}]" @else name="{{ $Remuneration['MockDrillFiledName'] }}" @endif
                                                                    onkeypress="return blockSpecialChar(event,'numeric')"
                                                                    @if ($Remuneration['readonly'] == 1) readonly @endif 
                                                                    @if(Session::get('role') == 14 && $Remuneration['Source Code'] === 'CENTRE SUPERITENDENT') value ="{{$Remuneration['Mock Drill Charge'] + $Remuneration['Mock Drill Conveyance']}}" @endif>
                                                                @if ($Remuneration['isAttechment'] == 1)
                                                                    <div class="file-upload mt-3 mb-3" data-upload-id="1">
                                                                        <label for="fileInput1"
                                                                            class="file-label fw-semi-bold mb-0"
                                                                            data-label-id="1">Attach Document</label>
                                                                        <input type="file"
                                                                            name="files[{{ $Remuneration['MockDrillFiledName'] }}]"
                                                                            class="form-control file-input mt-3 mb-3 fileUpload form-control-lg @if ($Remuneration['isAttechmentRequired'] == 1) valid-field @endif">
                                                                        <span class="file-name" data-name-id="2">No file
                                                                            chosen</span>
                                                                    </div>
                                                                @endif
                                                            </td>
                                                        </tr>

                                                        <!-- If Remuneration Available Only -->
                                                    @elseif($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] == '')
                                                        <tr>
                                                            <td>{{ ++$i }}</td>
                                                            <td>{{ $Remuneration['Source Name'] }}</td>
                                                            <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                                            @if ($Remuneration['isTds'] == 1)
                                                                <input type="hidden" class="tds"
                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                    name="TDSPer" />

                                                            @endif
                                                            <input type="hidden" class="RemunerationAmount"
                                                                value="{{ $Remuneration['Remuneration Amount_S1'] + $Remuneration['Remuneration Amount_S2'] + $Remuneration['Remuneration Amount_S3'] + $Remuneration['Remuneration Amount_S4'] }}" />
                                                            <input type="hidden" class="ConvenceAmount"
                                                                value="{{ $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden"
                                                                value="{{ $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="ManPowerInput"
                                                                value="{{ $totalRemuneratinAmt + $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="NoOfCandidates"
                                                                value="{{ $Remuneration['No_ of Candidates'] }}" />
                                                            <td>
                                                                @if ($Remuneration['No_ of Person'] > 0)
                                                                    <input type="text" maxlength="8" 
                                                                        class="form-control @if($Remuneration['Source Code'] != 'CITY COORDINATOR') unsetValue @endif @if($Remuneration['Source Code'] == 'PURCHASE WALLCLOCK') AutoCalculatedByCandidateNew @endif form-control-lg valid-field ManPower calculateTDS CandidateWiseCount"
                                                                        lang="{{ $Remuneration['No_ of Person'] }}"
                                                                        name="ManPower[]" @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR') value="1" readonly @endif
                                                                        onkeypress="return blockSpecialChar(event,'numeric')" 
                                                                        @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                        readonly @endif>
                                                                @else
                                                                    <input type="hidden" name="ManPower[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if ($Remuneration['No_ of Days'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control @if($Remuneration['Source Code'] != 'CITY COORDINATOR') unsetValue @endif form-control-lg valid-field DutyDays remunerationDutyDay calculateTDS"
                                                                        lang="{{ $Remuneration['No_ of Days'] }}"
                                                                        name="DutyDays[]" @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR') value="{{$totalDutyDays}}" readonly @endif
                                                                        onkeypress="return blockSpecialChar(event,'numeric')" @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                        readonly @endif>
                                                                @else
                                                                    <input type="hidden" name="DutyDays[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if($Remuneration['Source Code'] === 'CITY COORDINATOR')
                                                                <input type="hidden" name="City##Coor_##Conveyance##Amount" value="<?=$Remuneration['Conveyance Amount']*$totalDutyDays?>">
                                                                <input type="hidden" name="City##Coor_##Remuneration##Amount" value="<?=$RemunerationAmountTotalR?>">
                                                                @endif
                                                                <div class="d-flex">
                                                                <input type="text"
                                                                    @if ($Remuneration['Source Name'] == 'TDS Amount') id="tds"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Observer TDS Amount') id="ObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Deputy Observer TDS Amount') id="DeputyObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                @elseif($Remuneration['Source Name'] == 'Advance Payment')
                                                                    id="advancePayment"
                                                                    @if ($advancePayment > 0) readonly value="{{ number_format($advancePayment ?? 0, 0, '', '') }}" @endif
                                                                @elseif($Remuneration['readonly'] == 1) readonly
                                                                    @endif
                                                                @if (
                                                                    $Remuneration['Fixed Amount'] > 0 &&
                                                                        $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                        $Remuneration['Source Name'] != 'TDS Amount') value="{{ number_format($Remuneration['Fixed Amount'], 0, '', '') }}" @endif
                                                                        id="{{ preg_replace('/[^a-zA-Z0-9_-]/', '', str_replace(' ', '_', $Remuneration['Source Code'])) }}"
                                                                class="form-control form-control-lg @if ($Remuneration['Fixed Amount'] > 0) RemunerationSection @endif 
                                                                @if (
                                                                        $Remuneration['Source Name'] != 'Observer TDS Amount' &&
                                                                        $Remuneration['Source Name'] != 'Deputy Observer TDS Amount' &&
                                                                        $Remuneration['Source Name'] != 'TDS Amount' &&
                                                                        $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                        $Remuneration['Fixed Amount'] <= 0) RemunerationSection {{ $Remuneration['isRequired'] == 1 ? 'valid-field' : '' }} 
                                                                @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment > 0) 
                                                                @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment == 0) 
                                                                    unsetValue 
                                                                    @if ($Remuneration['isRequired'] == 1) 
                                                                    valid-field @endif   
                                                                @endif"
                                                                maxlength="8" 
                                                                @if ($Remuneration['isExtrafield'] == 1) name="ExtraRemunerationSection[][{{ $Remuneration['Field_Name'] }}]" @else name="{{ $Remuneration['Field_Name'] }}" @endif
                                                                onkeypress="return blockSpecialChar(event,'numeric')"  @if($Remuneration['Source Code'] === 'CITY COORDINATOR') value="{{ $CCRemunerationAndConvence }}" @endif>
                                                                @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                                    <span><i class="fa fa-pencil text-info fs-4 ms-3 me-1 mt-15 cursor-pointer shiftwise-modal-btn" style="display:none" data-bs-toggle="modal"
                                                                        data-bs-target="#shiftwise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-modal"></i></span>
                                                                @endif
                                                               
                                                                    @if($Remuneration['Source Code'] == 'CENTRE SUPERITENDENT' || $Remuneration['Source Code'] == 'CITY COORDINATOR')
                                                                    <span><i class="fa fa-eye text-info fs-4 ms-3 me-1 mt-15 cursor-pointer shiftwise-payment-Amount-modal-btn" style="display:none" data-bs-toggle="modal"
                                                                        data-bs-target="#shiftwise-payment-Amount-modal"></i></span>
                                                                @endif
                                                                </div>

                                                                @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL' || $Remuneration['Source Code'] == 'DEPUTY OBSERVER')
                                                                    <span
                                                                        class="btn btn-success {{ str_replace('##', '-', $Remuneration['Field_Name']) }}-modal-btn my-1"
                                                                        data-bs-toggle="modal"
                                                                        data-bs-target="#{{ str_replace('##', '-', $Remuneration['Field_Name']) }}-modal">Add
                                                                        Details +</span>
                                                                @endif
                                                                

                                                                @if ($Remuneration['isAttechment'] == 1)
                                                                    <div class="file-upload mt-3 mb-3" data-upload-id="1">
                                                                        <label for="fileInput1"
                                                                            class="file-label fw-semi-bold mb-0"
                                                                            data-label-id="1">Attach Document</label>
                                                                        <input type="file"
                                                                            name="files[{{ $Remuneration['Field_Name'] }}]"
                                                                            class="form-control file-input mt-3 mb-3 form-control-lg fileUpload @if ($Remuneration['isAttechmentRequired'] == 1) valid-field @endif">
                                                                        <span class="file-name" data-name-id="2">No file
                                                                            chosen</span>
                                                                    </div>
                                                                @endif

                                                            </td>
                                                        </tr>
                                                       @if(Session::get('role') == 14 && ($Remuneration['Source Code'] == 'ROOM INVIGILATOR' || $Remuneration['Source Code'] == 'ADMIN. STAFF/CLERK' || $Remuneration['Source Code'] == 'DEPUTY CENTRE SUPER.' || $Remuneration['Source Code'] == 'WATERBOY' || $Remuneration['Source Code'] == 'WATCHMAN/GUARD'))
                                                        {{-- Dynamic Modal for shiftwise calculation --}}
                                                        <div class="modal fade" tabindex="-1" id="shiftwise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-modal">
                                                            <div class="modal-dialog">
                                                                <div class="modal-content">
                                                                    <div class="modal-header">
                                                                        <h3 class="modal-title">Shift Wise Payment Details</h3>
                                                        
                                                                        <!--begin::Close-->
                                                                        <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
                                                                            <i class="ki-duotone ki-cross fs-1"><span class="path1"></span><span class="path2"></span></i>
                                                                        </div>
                                                                        <!--end::Close-->
                                                                    </div>
                                                        
                                                                    <div class="modal-body shift-wise-{{ str_replace(' ', '_', $Remuneration['Source Code']) }}-payment">
                                                                        <div class="custom-form">
                                                                            <input type="hidden" shift1="{{$Remuneration['Remuneration Amount_S1']}}" shift2="{{$Remuneration['Remuneration Amount_S2']}}" shift3="{{$Remuneration['Remuneration Amount_S3']}}" 
                                                                            shift4="{{$Remuneration['Remuneration Amount_S4']}}" value="{{ $Remuneration['No_ of Candidates'] }}" role-id="{{ preg_replace('/[^a-zA-Z0-9_-]/', '', str_replace(' ', '_', $Remuneration['Source Code'])) }}" class="NoOfPersonsDynamic">
                                                                            <div class="row shiftwise-html text-center justify-content-center">
                                                                                
                                                                            </div>
                                                                            <div class="text-end">
                                                                                <button type="button" class="btn btn-success mt-3 calculateAmount">Calculate Amount</button>
                                                                            </div>
                                                                            <div class="mt-3 calculation-result"></div>
                                                                        </div>
                                                                    </div>
                                                        
                                                                    <div class="modal-footer">
                                                                        <button type="button" class="btn btn-light" data-bs-dismiss="modal">Save & Close</button>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        @endif

                                                        <!-- If MockDrill Available Only -->
                                                    @elseif($Remuneration['Remuneration Text'] == '' && $Remuneration['Mock Drill Text'] != '')
                                                        <tr>
                                                            <td>{{ ++$i }}</td>
                                                            <td>{{ $Remuneration['Source Name'] }}</td>
                                                            <td>{{ $Remuneration['Mock Drill Text'] }}</td>
                                                            @if ($Remuneration['isTds'] == 1)
                                                                <input type="hidden" class="tds"
                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                    name="TDSPer" />

                                                            @endif
                                                            <input type="hidden" class="RemunerationAmount"
                                                                value="{{ $Remuneration['Remuneration Amount_S1'] + $Remuneration['Remuneration Amount_S2'] + $Remuneration['Remuneration Amount_S3'] + $Remuneration['Remuneration Amount_S4'] }}" />
                                                            <input type="hidden" class="ConvenceAmount"
                                                                value="{{ $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="ManPowerInput"
                                                                value="{{ $totalRemuneratinAmt + $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="NoOfCandidates"
                                                                value="{{ $Remuneration['No_ of Candidates'] }}" />
                                                            <td>
                                                                @if ($Remuneration['No_ of Person'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control unsetValue form-control-lg valid-field ManPower CandidateWiseCount"
                                                                        lang="{{ $Remuneration['No_ of Person'] }}"
                                                                        name="ManPower[]"
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                 @else
                                                                    <input type="hidden" name="ManPower[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if ($Remuneration['No_ of Days'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control unsetValue form-control-lg valid-field DutyDays remunerationDutyDay"
                                                                        lang="{{ $Remuneration['No_ of Days'] }}"
                                                                        name="DutyDays[]"
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                 @else
                                                                    <input type="hidden" name="DutyDays[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                <input type="text"
                                                                    @if ($Remuneration['Source Name'] == 'TDS Amount') id="tds"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Observer TDS Amount') id="ObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Deputy Observer TDS Amount') id="DeputyObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                @elseif($Remuneration['Source Name'] == 'Advance Payment')
                                                                    id="advancePayment"
                                                                    @if ($advancePayment > 0) readonly value="{{ $advancePayment }}" @endif
                                                                @elseif($Remuneration['readonly'] == 1) readonly
                                                                    @endif
                                                                class="form-control form-control-lg
                                                                    @if ($Remuneration['Source Name'] != 'Observer TDS Amount' &&  $Remuneration['Source Name'] != 'Deputy Observer TDS Amount' && $Remuneration['Source Name'] != 'TDS Amount' && $Remuneration['Source Name'] != 'Advance Payment') RemunerationSection unsetValue {{ $Remuneration['isRequired'] == 1 ? 'valid-field' : '' }}
                                                                    @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment > 0)
                                                                        {{-- No additional class needed --}}
                                                                    @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment == 0)
                                                                        unsetValue
                                                                        @if ($Remuneration['isRequired'] == 1) 
                                                                        valid-field @endif   
                                                                    @endif"
                                                                maxlength="8"
                                                                @if ($Remuneration['isExtrafield'] == 1) name="ExtraRemunerationSection[][{{ $Remuneration['MockDrillFiledName'] }}]" @else name="{{ $Remuneration['MockDrillFiledName'] }}" @endif
                                                                onkeypress="return blockSpecialChar(event, 'numeric')"
                                                                >
                                                                @if ($Remuneration['isAttechment'] == 1)
                                                                    <div class="file-upload mt-3 mb-3" data-upload-id="1">
                                                                        <label for="fileInput1"
                                                                            class="file-label fw-semi-bold mb-0"
                                                                            data-label-id="1">Attach Document</label>
                                                                        <input type="file"
                                                                            name="files[{{ $Remuneration['MockDrillFiledName'] }}]"
                                                                            class="form-control file-input mt-3 mb-3 fileUpload form-control-lg @if ($Remuneration['isAttechmentRequired'] == 1) valid-field @endif">
                                                                        <span class="file-name" data-name-id="2">No file
                                                                            chosen</span>
                                                                    </div>
                                                                @endif
                                                            </td>
                                                        </tr>

                                                        <!-- Default Case -->
                                                    @else
                                                        <tr>
                                                            <td>{{ ++$i }}</td>
                                                            <td>{{ $Remuneration['Source Name'] }}</td>
                                                            <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                                            @if ($Remuneration['isTds'] == 1)
                                                                <input type="hidden" class="tds"
                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                    name="TDSPer" />

                                                            @endif
                                                            <input type="hidden" class="RemunerationAmount"
                                                                value="{{ $totalRemuneratinAmt }}" />
                                                            <input type="hidden" class="ConvenceAmount"
                                                                value="{{ $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="ManPowerInput"
                                                                value="{{ $totalRemuneratinAmt + $Remuneration['Conveyance Amount'] }}" />
                                                            <input type="hidden" class="NoOfCandidates"
                                                                value="{{ $Remuneration['No_ of Candidates'] }}" />
                                                            <td>
                                                                @if ($Remuneration['No_ of Person'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control unsetValue form-control-lg valid-field ManPower CandidateWiseCount"
                                                                        lang="{{ $Remuneration['No_ of Person'] }}"
                                                                        name="ManPower[]"
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="ManPower[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                @if ($Remuneration['No_ of Days'] > 0)
                                                                    <input type="text" maxlength="8"
                                                                        class="form-control unsetValue form-control-lg valid-field DutyDays remunerationDutyDay"
                                                                        lang="{{ $Remuneration['No_ of Days'] }}"
                                                                        name="DutyDays[]"
                                                                        onkeypress="return blockSpecialChar(event,'numeric')">
                                                                @else
                                                                    <input type="hidden" name="DutyDays[]" value="-">
                                                                @endif
                                                            </td>
                                                            <td>
                                                                <input type="text"
                                                                    @if ($Remuneration['Source Name'] == 'TDS Amount') id="tds"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Observer TDS Amount') id="ObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                    @elseif ($Remuneration['Source Name'] == 'Deputy Observer TDS Amount') id="DeputyObserverTDSAmount"
                                                                    @if ($Remuneration['readonly'] == 1) 
                                                                        readonly @endif
                                                                @elseif($Remuneration['Source Name'] == 'Advance Payment')
                                                                    id="advancePayment"
                                                                    @if ($advancePayment > 0) readonly 
                                                                value="{{ $advancePayment }}" @endif
                                                                @elseif($Remuneration['readonly'] == 1) readonly
                                                                    @endif
                                                                @if (
                                                                    $Remuneration['Fixed Amount'] > 0 &&
                                                                        $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                        $Remuneration['Source Name'] != 'TDS Amount') value="{{ number_format($Remuneration['Fixed Amount'], 0, '', '') }}" @endif
                                                                class="form-control form-control-lg @if ($Remuneration['Fixed Amount'] > 0) RemunerationSection @endif 
                                                            @if (
                                                                $Remuneration['Source Name'] != 'Observer TDS Amount' &&
                                                                $Remuneration['Source Name'] != 'Deputy Observer TDS Amount' &&                                                            
                                                                $Remuneration['Source Name'] != 'TDS Amount' &&
                                                                    $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                    $Remuneration['Fixed Amount'] <= 0) RemunerationSection {{ $Remuneration['isRequired'] == 1 ? 'valid-field' : '' }} 
                                                            @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment > 0)  
                                                            @elseif($Remuneration['Source Name'] == 'Advance Payment' && $advancePayment == 0) 
                                                                unsetValue @if ($Remuneration['isRequired'] == 1) 
                                                                    valid-field @endif   
                                                            @endif"
                                                                maxlength="8"
                                                                @if ($Remuneration['isExtrafield'] == 1) name="ExtraRemunerationSection[][{{ $Remuneration['Field_Name'] }}]" @else name="{{ $Remuneration['Field_Name'] }}" @endif
                                                                onkeypress="return blockSpecialChar(event,'numeric')">

                                                                @if ($Remuneration['isAttechment'] == 1)
                                                                    <div class="file-upload mt-3 mb-3" data-upload-id="1">
                                                                        <label for="fileInput1"
                                                                            class="file-label fw-semi-bold mb-0"
                                                                            data-label-id="1">Attach Document</label>
                                                                        <input type="file"
                                                                            name="files[{{ $Remuneration['Field_Name'] }}]"
                                                                            class="form-control file-input mt-3 mb-3 form-control-lg fileUpload
                                                                    @if ($Remuneration['isAttechmentRequired'] == 1) valid-field @endif">
                                                                        <span class="file-name" data-name-id="2">No file
                                                                            chosen</span>
                                                                    </div>
                                                                @endif

                                                            </td>
                                                        </tr>
                                                    @endif
                                                @endforeach
                                                <tr>
                                                    <td>{{ ++$i }}</td>
                                                    <td class='fw-bold'>TOTAL CLAIM</td>
                                                    <td></td>
                                                    <td></td>
                                                    <td></td>
                                                    <input type="hidden" class="ManPowerInput"
                                                        value="{{ $Remuneration['Remuneration Amount_S1'] + $Remuneration['Remuneration Amount_S2'] + $Remuneration['Remuneration Amount_S3'] + $Remuneration['Remuneration Amount_S4'] + $Remuneration['Conveyance Amount'] }}" />
                                                    <td>
                                                        <input type="text"
                                                            class="form-control unsetValue form-control-lg required"
                                                            id="NetPaybleAmount" maxlength=8 minlength=1
                                                            name="Net##Amount##Payable"
                                                            onkeypress="return blockSpecialChar(event,'numeric')" readonly>
                                                            <input type="hidden" name="Total##Expenditure##Amount" id="Expenditure">
                                                    </td>
                                                </tr>
                                            @endif
                                        </tbody>

                                    </table>

                                </div>
                                <!-- ================================================================================================================== -->
                                <!-- Observer Details Modal -->
                                <div class="modal fade" tabindex="-1" id="Observer-Amount-modal">
                                    <div class="modal-dialog modal-dialog-scrollable modal-lg">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title">Add Observer's Details</h5>
                                                <input type="hidden" value="1" id="observerIndex">
                                                <!--begin::Close-->
                                                <div class="btn btn-icon btn-sm btn-active-light-primary ms-2"
                                                    data-bs-dismiss="modal" aria-label="Close">
                                                    <i class="ki-duotone ki-cross fs-2x"><span class="path1"></span><span
                                                            class="path2"></span></i>
                                                </div>
                                                <!--end::Close-->
                                            </div>

                                            <div class="modal-body" id="observer-details-form">
                                                <!-- Section 1: Basic Details -->
                                                <div class="observer-section-1" data-index="1">
                                                    <div class="text-center">
                                                        <h4 class="pb-0 mb-0">Observer 1</h4>
                                                    </div>
                                                    <div>
                                                        <h5 class="mb-1">Basic Details</h5>
                                                        <div class="row g-3">
                                                            <div class="form-group col-sm-6 col-md-3">
                                                                <div class="d-flex align-items-center">
                                                                    <!-- Observer Dropdown -->
                                                                    <div class="form-group col-sm-6 col-md-12">
                                                                        <select name="observers[observer_id][]"
                                                                            class="form-control ob-required obchangeR"
                                                                            id="observer-id-1" data-id="#">
                                                                            <option value="">Select Observer</option>
                                                                            @if (isset($ObserversList) && !empty($ObserversList))
                                                                                @foreach ($ObserversList as $key => $value)
                                                                                    <option value="{{ $value }}">
                                                                                        {{ $value }}</option>
                                                                                @endforeach
                                                                            @endif
                                                                        </select>
                                                                    </div>
                                                                    <input type="hidden" name="observers[observer_id_sec][]" id="observers-kk-1">
                                                                   
                                                                    {{-- <div>
                                                                        <!-- Add New Observer Button -->
                                                                       <button type="button" id="add-observer-btn"
                                                                            class="btn btn-link p-0 fs-4 ms-2"
                                                                            title="Add New Observer"
                                                                            style="vertical-align: middle;">
                                                                            <i class="fa fa-plus-circle"></i>
                                                                        </button>
                                                                    </div> --}}
                                                                </div>

                                                                <!-- Hidden Input Field for Adding New Observer -->
                                                                <div id="new-observer-input"
                                                                    style="display: none; margin-top: 10px;">
                                                                    <div class="d-flex align-items-center">
                                                                        <input type="text" id="new-observer-value"
                                                                            class="form-control"
                                                                            placeholder="Enter New Observer ID" />
                                                                        <button type="button" id="ok-btn"
                                                                            class="btn btn-success btn-sm ms-2">OK</button>
                                                                        <button type="button" id="cancel-btn"
                                                                            class="btn btn-danger btn-sm ms-2">X</button>
                                                                    </div>
                                                                </div>
                                                                <p id="validation-msg" style="color: red; display: none;">
                                                                </p>
                                                            </div>
                                                            <div class="form-group col-sm-6 col-md-3">
                                                                {{-- <label>Observer Name <span
                                                                        class="text-danger">*</span></label> --}}
                                                                <input type="text" name="observers[observer_name][]"
                                                                    class="form-control ob-required"
                                                                    placeholder="Enter Observer Name" id="observer-name-1"
                                                                    maxlength="50" minlength="2" data-id="#"
                                                                    onkeypress="return blockSpecialChar(event,'alpha')">
                                                            </div>
                                                            
                                                            <div class="form-group col-sm-6 col-md-3">
                                                                {{-- <label>Observer Phone No. <span
                                                                        class="text-danger">*</span></label> --}}
                                                                <input type="text" name="observers[observer_phone][]"
                                                                    class="form-control ob-required"
                                                                    placeholder="Enter Observer Phone No."
                                                                    id="observer-phone-1" maxlength="10" minlength="10"
                                                                    data-id="#"
                                                                    onkeypress="return blockSpecialChar(event,'numeric')">
                                                            </div>
                                                            <div class="form-group col-sm-6 col-md-3">
                                                                {{-- <label>Observer Email <span
                                                                        class="text-danger">*</span></label> --}}
                                                                <input type="email" name="observers[observer_email][]"
                                                                    class="form-control ob-required"
                                                                    placeholder="Enter Observer Email"
                                                                    id="observer-email-1" maxlength="50" minlength="2"
                                                                    data-id="email">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <hr>

                                                    <!-- Section 2: Account Details -->
                                                    <h5 class="mb-2">Account Details</h5>
                                                    <div class="row g-3">
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            {{-- <label>Account Holder Name <span
                                                                    class="text-danger">*</span></label> --}}
                                                            <input type="text" name="observers[account_holder_name][]"
                                                                class="form-control ob-required"
                                                                placeholder="Enter Account Holder Name"
                                                                id="account-holder-name-1" maxlength="50" minlength="2"
                                                                onkeypress="return blockSpecialChar(event,'alpha')">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            {{-- <label>Account Number <span
                                                                    class="text-danger">*</span></label> --}}
                                                            <input type="text" name="observers[account_number][]"
                                                                class="form-control ob-required"
                                                                placeholder="Enter Account Number" id="account-number-1"
                                                                maxlength="16" minlength="11"
                                                                onkeypress="return blockSpecialChar(event,'numeric')">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            {{-- <label>IFSC Code <span class="text-danger">*</span></label> --}}
                                                            <input type="text" name="observers[ifsc_code][]"
                                                                class="form-control ob-required"
                                                                placeholder="Enter IFSC Code" id="ifsc-code-1"
                                                                maxlength="20" minlength="10"
                                                                onkeypress="return blockSpecialChar(event,'alphanumeric')">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            {{-- <label>Branch Name <span class="text-danger">*</span></label> --}}
                                                            <input type="text" name="observers[branch_name][]"
                                                                class="form-control ob-required"
                                                                placeholder="Enter Branch Name" id="branch-name-1"
                                                                maxlength="200" minlength="2">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            {{-- <label>PAN Number <span class="text-danger">*</span></label> --}}
                                                            <input type="text" name="observers[pan_number][]"
                                                                class="form-control ob-required"
                                                                placeholder="Enter PAN Number" id="pan-number-1"
                                                                maxlength="15" minlength="10"
                                                                onkeypress="return blockSpecialChar(event,'alphanumeric')">
                                                        </div>
                                                    </div>
                                                    <hr>
                                                    @php 
                                                    if(Session::get('role') == 1){
                                                        $ObserverTds = (($ObserverPerDayAmount + $ObserverPerDayAmountMock) * 10) / 100;
                                                        $DeputyObserverTds = (($DeputyObserverPerDayAmount + $DeputyObserverPerDayAmountMock) * 10) / 100;
                                                        $ObserverNetPayable = ($ObserverPerDayAmount + $ObserverPerDayAmountMock + $ObserverPerDayConveyanceAmount + $ObserverPerDayConveyanceAmountMock + $OBfoodAmount ) - $ObserverTds;
                                                        $DeputyObserverNetPayable = ($DeputyObserverPerDayAmount + $DeputyObserverPerDayAmountMock + $DeputyObserverPerDayConveyanceAmount + $DeputyObserverPerDayConveyanceAmountMock + $DOBfoodAmount ) - $DeputyObserverTds;
                                                    }
                                                    @endphp
                                                    <!-- Section 3: Payment Details -->
                                                    <h5 class="mb-1">Payment Details</h5>
                                                    <div class="row g-3">
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Duty Days <span class="text-danger">*</span></label>
                                                            <input type="number" name="observers[duty_days][]"
                                                                class="form-control ob-required duty_days" readonly
                                                                placeholder="Duty Days" min="0" max="1" id="duty-days-1" value="1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Duty Days <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[mock_duty_days][]"
                                                                class="form-control ob-required mock_duty_days" readonly
                                                                placeholder="Mock Duty Days" min="0" id="mock-duty-days-1" value="1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Remuneration<span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[Observer_Remuneration][]"
                                                                class="form-control ob-required" readonly
                                                                placeholder="Remuneration" value="{{ $ObserverPerDayAmount }}" id="Observer-Remuneration-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Conveyance <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[Observer_Conveyance][]"
                                                                class="form-control ob-required" readonly
                                                                placeholder="Conveyance" value="{{ $ObserverPerDayConveyanceAmount }}" id="Observer-Conveyance-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Remuneration <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[Observer_Mock_Remuneration][]"
                                                                class="form-control ob-required" readonly
                                                                placeholder="Mock Remuneration" value="{{ $ObserverPerDayAmountMock }}" id="Observer-Mock-Remuneration-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Conveyance <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[Observer_Mock_Conveyance][]"
                                                                class="form-control ob-required" readonly
                                                                placeholder="Observer Mock Conveyance" value="{{ $ObserverPerDayConveyanceAmountMock }}" id="Observer-Mock-Conveyance-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Refereshment Charge <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[Observer_Foods][]"
                                                                class="form-control ob-required" readonly
                                                                placeholder="Refereshment Charge" value="{{ $OBfoodAmount ?? 0 }}" id="Observer-Food-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Advance Payment <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="observers[advance_payment][]"
                                                                class="form-control ob-required advance_payment"
                                                                placeholder="Enter Advance Payment"
                                                                id="advance-payment-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>TDS Amount <span class="text-danger">*</span></label>
                                                            <input type="number" name="observers[tds_percent][]"
                                                                class="form-control ob-required tds_percent"
                                                                placeholder="Enter TDS Amount" value="{{ $ObserverTds ?? 0 }}" id="tds-percent-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Amount to be paid</label>
                                                            <input type="number" name="observers[amount_to_paid][]" placeholder="Amount to be paid" readonly
                                                                class="form-control amount_to_paid" value="{{ $ObserverNetPayable ?? 0 }}" id="amount_to_paid-1">
                                                        </div>
                                                    </div>

                                                    <div class="text-end">
                                                        <button type="button"
                                                            class="btn btn-danger delete-section d-none">Delete
                                                            Section</button>
                                                    </div>
                                                </div>
                                                <div class="text-end mt-3">
                                                    <button type="button" class="btn btn-orange add-more">Add More
                                                        +</button>
                                                </div>
                                            </div>

                                            <div class="modal-footer">
                                                <button type="button" class="btn btn-light close-observer-modal"
                                                    data-bs-dismiss="modal">Close</button>
                                                <button type="button" class="btn btn-primary"
                                                    id="save-observer-details">Save changes</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>


                                <!-- Deputy Observer Details Modal -->
                                <div class="modal fade" tabindex="-1" id="Deputy-Observer-Amount-modal">
                                    <div class="modal-dialog modal-dialog-scrollable modal-lg">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title">Add Deputy Observer's Details</h5>
                                                <input type="hidden" value="1" id="deputy-observerIndex">
                                                <button type="button"
                                                    class="btn btn-icon btn-sm btn-active-light-primary ms-2"
                                                    data-bs-dismiss="modal" aria-label="Close">
                                                    <i class="fas fa-times fs-2x"></i>
                                                </button>
                                            </div>


                                            <div class="modal-body" id="deputy-observer-details-form">
                                                <!-- Section 1: Basic Details -->
                                                <div class="deputy-observer-section-1" data-index="1">
                                                    <div class="text-center">
                                                        <h4 class="pb-0 mb-0">Deputy Observer 1</h4>
                                                    </div>

                                                    <h5 class="mb-1">Basic Details</h5>
                                                    <div class="row g-3">
                                                        <!-- Observer Dropdown with Add New Option -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <div class="d-flex align-items-center">
                                                                <div class="form-group col-sm-6 col-md-12">
                                                                    <select name="deputy_observers[deputy_observer_id][]"
                                                                        class="form-control dob-required dobchangeR"
                                                                        id="deputy-observer-id-1">
                                                                        <option value="">Select Deputy Observer
                                                                        </option>
                                                                        @if (isset($DeputyObserversList) && !empty($DeputyObserversList))
                                                                            @foreach ($DeputyObserversList as $id => $name)
                                                                                <option value="{{ $name }}">
                                                                                    {{ $name }}</option>
                                                                            @endforeach
                                                                        @endif
                                                                    </select>
                                                                </div>
                                                                <input type="hidden" name="deputy_observers[deputy_observer_id_sec][]" id="deputy-observers-kk-1">
                                                                {{-- <div>
                                                                    <!-- Add New Observer Button -->
                                                                    <button type="button" id="add-deputy-observer-btn"
                                                                        class="btn btn-link p-0 fs-4 ms-2"
                                                                        title="Add New Deputy Observer">
                                                                        <i class="fa fa-plus-circle"></i>
                                                                    </button>
                                                                </div> --}}
                                                            </div>
                                                            <!-- Hidden Input Field for Adding New Observer -->
                                                            <div id="new-deputy-observer-input"
                                                                style="display: none; margin-top: 10px;">
                                                                <div class="d-flex align-items-center">
                                                                    <input type="text" id="new-deputy-observer-value"
                                                                        class="form-control"
                                                                        placeholder="Enter New Observer ID">
                                                                    <button type="button" id="dob-ok-btn"
                                                                        class="btn btn-success btn-sm ms-2">OK</button>
                                                                    <button type="button" id="dob-cancel-btn"
                                                                        class="btn btn-danger btn-sm ms-2">X</button>
                                                                </div>
                                                            </div>
                                                            <p id="dob-validation-msg" style="color: red; display: none;">
                                                            </p>
                                                        </div>

                                                        <!-- Deputy Observer Name -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_observer_name][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Deputy Observer Name" maxlength="50"
                                                                id="deputy-observer-name-1">
                                                        </div>

                                                        <!-- Deputy Observer Phone -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_observer_phone][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Deputy Observer Phone No."
                                                                maxlength="10" id="deputy-observer-phone-1">
                                                        </div>

                                                        <!-- Deputy Observer Email -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="email"
                                                                name="deputy_observers[deputy_observer_email][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Deputy Observer Email" maxlength="50"
                                                                id="deputy-observer-email-1">
                                                        </div>
                                                    </div>
                                                    <hr>

                                                    <h5 class="mb-1">Account Details</h5>
                                                    <div class="row g-3">
                                                        <!-- Account Holder Name -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_account_holder_name][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Account Holder Name"
                                                                id="deputy-account-holder-name-1">
                                                        </div>

                                                        <!-- Account Number -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_account_number][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Account Number" maxlength="16"
                                                                id="deputy-account-number-1">
                                                        </div>

                                                        <!-- IFSC Code -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_ifsc_code][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter IFSC Code" id="deputy-ifsc-code-1">
                                                        </div>

                                                        <!-- Branch Name -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_branch_name][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter Branch Name" id="deputy-branch-name-1">
                                                        </div>

                                                        <!-- PAN Number -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <input type="text"
                                                                name="deputy_observers[deputy_pan_number][]"
                                                                class="form-control dob-required"
                                                                placeholder="Enter PAN Number" id="deputy-pan-number-1">
                                                        </div>
                                                    </div>
                                                    <hr>
                                                    <h5 class="mb-1">Payment Details</h5>
                                                    <div class="row g-3">
                                                        <!-- Duty Days -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Duty Days <span
                                                                class="text-danger">*</span></label>
                                                            <input type="number"
                                                                name="deputy_observers[deputy_duty_days][]"
                                                                class="form-control dob-required deputy_duty_days"
                                                                placeholder="Duty Days" min="0" value="1" id="deputy-duty-days-1">
                                                        </div>

                                                        <!-- Mock Duty Days -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Duty Days <span
                                                                class="text-danger">*</span></label>
                                                            <input type="number"
                                                                name="deputy_observers[deputy_mock_duty_days][]"
                                                                class="form-control dob-required deputy_mock_duty_days" value="1" min="0"
                                                                placeholder="Mock Duty Days"
                                                                id="deputy-mock-duty-days-1">
                                                        </div>

                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Remuneration <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="deputy_observers[Observer_Remuneration][]"
                                                                class="form-control dob-required" readonly
                                                                placeholder="Remuneration" value="{{ $DeputyObserverPerDayAmount }}" id="Deputy-Observer-Remuneration-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Conveyance <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="deputy_observers[Observer_Conveyance][]"
                                                                class="form-control dob-required" readonly
                                                                placeholder="Conveyance" value="{{ $DeputyObserverPerDayConveyanceAmount }}" id="Deputy-Observer-Conveyance-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Remuneration <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="deputy_observers[Observer_Mock_Remuneration][]"
                                                                class="form-control dob-required" readonly
                                                                placeholder="Mock Remuneration" value="{{ $DeputyObserverPerDayAmountMock }}" id="Deputy-Observer-Mock-Remuneration-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Mock Conveyance <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="deputy_observers[Observer_Mock_Conveyance][]"
                                                                class="form-control dob-required" readonly
                                                                placeholder="Observer Mock Conveyance" value="{{ $DeputyObserverPerDayConveyanceAmountMock }}" id="Deputy-Observer-Mock-Conveyance-1">
                                                        </div>
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Refereshment Charge <span
                                                                    class="text-danger">*</span></label>
                                                            <input type="number" name="deputy_observers[Observer_Foods][]"
                                                                class="form-control dob-required" readonly
                                                                placeholder="Refereshment Charge" value="{{ $DOBfoodAmount ?? 0 }}" id="Deputy-Observer-Food-1">
                                                        </div>

                                                        <!-- Advance Payment -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Advance Payment <span
                                                                class="text-danger">*</span></label>
                                                            <input type="number"
                                                                name="deputy_observers[deputy_advance_payment][]"
                                                                class="form-control dob-required deputy_advance_payment"
                                                                placeholder="Enter Advance Payment"
                                                                id="deputy-advance-payment-1">
                                                        </div>

                                                        <!-- TDS Amount -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>TDS Amount <span
                                                                class="text-danger">*</span></label>
                                                            <input type="number"
                                                                name="deputy_observers[deputy_tds_percent][]"
                                                                class="form-control dob-required deputy_tds_percent"
                                                                placeholder="Enter TDS Percent" value="{{ $DeputyObserverTds ?? 0 }}" id="deputy-tds-percent-1">
                                                        </div>
                                                        <!-- Amount To Be Paid -->
                                                        <div class="form-group col-sm-6 col-md-3">
                                                            <label>Amount to be paid <span
                                                                class="text-danger">*</span></label>
                                                            <input type="number"
                                                                name="deputy_observers[deputy_amount_to_paid][]" readonly
                                                                class="form-control dob-required deputy_amount_to_paid"
                                                                placeholder="Amount to be paid" value="{{ $DeputyObserverNetPayable ?? 0 }}" id="deputy_amount_to_paid-1">
                                                        </div>
                                                    </div>
                                                    <div class="text-end">
                                                        <button type="button"
                                                            class="btn btn-danger deputy-delete-section d-none">Delete
                                                            Section</button>
                                                    </div>
                                                </div>

                                                <div class="text-end mt-3">
                                                    <button type="button" class="btn btn-orange deputy-add-more">Add
                                                        More +</button>
                                                </div>
                                            </div>

                                            <div class="modal-footer">
                                                <button type="button" class="btn btn-light close-dobserver-modal"
                                                    data-bs-dismiss="modal">Close</button>
                                                <button type="button" class="btn btn-primary"
                                                    id="save-deputy-observer-details">Save changes</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>


                                <input type="hidden" id="ObserverTotalAdvanceAmount" name="ObserverTotalAdvanceAmount"
                                    value="0">
                                <input type="hidden" id="ObserverTotalTDSAmount" name="ObserverTotalTDSAmount"
                                    value="0">
                                <input type="hidden" id="ObserverNetAmount" name="ObserverNetAmount" value="0">

                                <input type="hidden" id="DObserverTotalAdvanceAmount" name="DObserverTotalAdvanceAmount"
                                    value="0">
                                <input type="hidden" id="DObserverTotalTDSAmount" name="DObserverTotalTDSAmount"
                                    value="0">
                                <input type="hidden" id="DObserverNetAmount" name="DObserverNetAmount" value="0">

                                <!-- ================================================================================================================== -->
                                <?php if(!empty($RemunerationFieldsData) && !empty($ArrayFields)){ ?>
                                <div class="text-end">
                                    <button class="btn btn-warning me-4 mb-2 mt-0" id="preview"
                                        type="button">Preview</button>
                                    <input type="Submit" class = 'btn btn-success  d-none finalSubmitOfflineBtn'
                                        name="submit" value="2">
                                </div>
                                <?php } ?>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!--ob/dob view popup--->
        <div class="modal fade" id="PreviewModal_OB_DOB" tabindex="-1" aria-labelledby="PreviewModalLabelObDOB"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="PreviewModalLabelObDOB">Preview</h5>
                        <button type="button" class="btn-close EditBill" data-bs-dismiss="modal"
                            aria-label="Close"></button>
                    </div>
                    <div class="modal-body ">

                        <div class="RemunerationModal_OB_DOB">

                        </div>
                    </div>
                    <div class="modal-footer">                        
                        <button type="button" class="btn btn-primary EditBill clearHtml"
                            data-bs-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
        <!----end---->
        <!-- Modal Offline -->
        <div class="modal fade" id="PreviewModal" tabindex="-1" aria-labelledby="PreviewModalLabel"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="PreviewModalLabel">Preview</h5>
                        <button type="button" class="btn-close EditBill" data-bs-dismiss="modal"
                            aria-label="Close"></button>
                    </div>
                    <div class="modal-body ">

                        <div class="RemunerationModal">

                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-success verifyAadhaarBtn" data-id="1"
                            id="verifyAadhaarBtn">Verify Email</button>
                        <button type="button" class="btn btn-primary EditBill clearHtml"
                            data-bs-dismiss="modal">Edit</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="AadharModal" tabindex="-1" aria-labelledby="AadharModalLabel" aria-hidden="true"
            data-bs-backdrop="static">
            <div class="overlay">
                <div id="loader"><img src="{{ asset('assets/images/loader.gif') }}" width="200"
                        alt="Loading...">
                </div>
            </div>
            <div class="modal-dialog" style="max-width: 700px!important">
                <div class="modal-content">
                    <div class="modal-header">
                        <h1 class="modal-title fs-5" id="exampleModalLabel">{{ $RoleName[$Role] }} Verification</h1>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                        <div class="my-4 aadharverify">
                            <p class="text-center fs-4 text-danger">Kindly Generate Email OTP For Verification </p>
                        </div>

                        <div class="row text-center" id="divMessage">
                            <span id="spnResult" class=""
                                style="color: green; font-weight: bold; font-size: 14px;"></span>
                        </div>
                        <div class="my-4 otpverify d-none">
                            <label class="fs-5 fw-bold">Enter OTP</label>
                            <input type="text" name="Otp" id="Otp" class="form-control form-control-lg"
                                placeholder="Enter OTP" autocomplete="off" maxlength="4"
                                onkeypress="return blockSpecialChar(event,'numeric')">
                            <span class="OTPTxt text-danger d-block overflow-auto visibility-hidden"></span>
                            <span class="control-label" id="OtpLabel"
                                style="text-align:left;margin-left:5px;font-size:12px;font-weight:bold; ">Please validate
                                the OTP within 10 minutes of receiving it</span>
                        </div>

                    </div>


                    <div class="modal-footer">
                        <div class="fw-bold" id="countdown"></div>
                        <button type="button" class="btn btn-info my-3" style="display:none" id="resendOTPBtn"
                            onclick="onGenerateEmailOTP()">Resend OTP</button>
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"
                            onclick="resetAadharVerification()">Cancel</button>
                        <button type="button" class="btn btn-warning my-3" id="generateAadhaarOTPBtn"
                            onclick="onGenerateEmailOTP()">Generate OTP</button>
                        <button id="btnValidateOTP" class="btn btn-warning my-3" style="display:none"
                            onclick="onValidateEmailOtp()">Validate OTP</button>
                        <button type="button" class="btn btn-success FinalSubmit d-none">Final Submit</button>
                    </div>
                </div>
            </div>
        </div>
        {{-- Sihiftwise CS Payment Modal --}}
        <div class="modal fade" tabindex="-1" id="shiftwise-payment-Amount-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h3 class="modal-title">Shift Wise Payment Details</h3>
        
                        <!--begin::Close-->
                        <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
                            <i class="ki-duotone ki-cross fs-1"><span class="path1"></span><span class="path2"></span></i>
                        </div>
                        <!--end::Close-->
                    </div>
        
                    <div class="modal-body shift-wise-payment">
                    </div>
        
                    <div class="modal-footer">
                        <button type="button" class="btn btn-light" data-bs-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>

        {{-- Sihiftwise Invglators Payment Modal --}}
        {{-- <div class="modal fade" tabindex="-1" id="shiftwise-invg-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h3 class="modal-title">Shift Wise Payment Details</h3>
        
                        <!--begin::Close-->
                        <div class="btn btn-icon btn-sm btn-active-light-primary ms-2" data-bs-dismiss="modal" aria-label="Close">
                            <i class="ki-duotone ki-cross fs-1"><span class="path1"></span><span class="path2"></span></i>
                        </div>
                        <!--end::Close-->
                    </div>
        
                    <div class="modal-body shift-wise-invg-payment">
                        <div class="custom-form">
                            <div class="row">
                                @for ($t = 1; $t <= $totalDutyDays; $t++)
                                <div class="col-auto">
                                    <label for="">Day {{ $t }}</label>
                                    @for ($y = 1; $y <= 4; $y++)
                                        <input type="text" class="form-control form-control-sm mt-1" placeholder="Shift {{ $y }}" id="shift{{ $y }}-day{{ $t }}-count{{ $y }}">
                                    @endfor
                                </div>
                                @endfor
                            </div>
                        </div>
                    </div>
        
                    <div class="modal-footer">
                        <button type="button" class="btn btn-light" data-bs-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div> --}}
    </main>
@endsection

@section('script')
    <script>
            $('.OBDOB').click(function () {
                $('#PreviewModal_OB_DOB').modal('show');

                // Clone the form
                var id = $(this).attr('id');
                var previewSection = '';

                if (id === 'OBSERVER_LOCAL_previewR') {
                    previewSection = 'observer-details-form';
                } else {
                    previewSection = 'deputy-observer-details-form';
                }
                var tableHtml = $(`#${previewSection}`).clone();

                // Handle all inputs
                tableHtml.find('input:not(.common-fields)').addClass('border-0').prop({
                    'readonly': true
                }).css('pointer-events', 'none');

                tableHtml.find('input.common-fields').prop({
                    'readonly': true
                }).css('pointer-events', 'none');

                // ✅ Handle all repeated <select> fields
                tableHtml.find('select').each(function () {
                    var clonedSelect = $(this);
                    var originalSelect = $(`#${previewSection}`).find(`#${clonedSelect.attr('id')}`);
                    var selectedVal = originalSelect.val();

                    // Set selected value in clone
                    clonedSelect.val(selectedVal);

                    // Manually apply selected attribute for correct rendering
                    clonedSelect.find('option').each(function () {
                        if ($(this).val() === selectedVal) {
                            $(this).prop('selected', true);
                        } else {
                            $(this).prop('selected', false);
                        }
                    });

                    // Disable the select
                    clonedSelect.prop('disabled', true).addClass('border-0').css('pointer-events', 'none');
                });

                // Hide buttons and specific elements
                tableHtml.find('#preview').hide();
                tableHtml.find('.shiftwise-payment-Amount-modal-btn').hide();
                tableHtml.find('.shiftwise-modal-btn').hide();
                tableHtml.find('.file-label').hide();
                tableHtml.find('.Observer-Amount-modal-btn').hide();
                tableHtml.find('.Deputy-Observer-Amount-modal-btn').hide();
                tableHtml.find('button').hide();

                // Handle CentreNumber
                var CenterNo = $('#CentreNumber').val();
                tableHtml.find('#CentreNumber').val(CenterNo).prop({
                    'readonly': true
                }).css('pointer-events', 'none');

                // Render modified content
                $('.RemunerationModal_OB_DOB').html(tableHtml);
            });



        $('#preview').click(function() {
            var formIsValid = true;
            $('.valid-field').each(function() {
                if ($(this).val().trim() === '') {
                    // Remove existing error message if present
                    $(this).next('span.text-danger').remove();
                    // Add error message
                    $(this).after('<span class="text-danger">*This field is required</span>');
                    // Set focus to the first field that fails validation
                    if (formIsValid) {
                        $(this).focus();
                        formIsValid = false; // Set formIsValid to false to prevent further focus changes
                    }
                } else {
                    // Remove existing error message if the field is not empty
                    $(this).next('span.text-danger').remove();
                }
            });

            if (!formIsValid) {
                return false;
            } else {
                var total = 0;
                // 2. Loop through all inputs inside .RemunerationSection and add their values
                $('.RemunerationSection').each(function() {
                    var val = parseFloat($(this).val()) || 0; // safely parse, default to 0 if invalid
                    total += val;
                });

                // 3. Set the sum into the hidden input
                $('#Expenditure').val(total);
                // alert(total);
                // -----------------------------------------------------------------

                $('select[name^="deputy_observers[deputy_observer_id]"]').each(function(index) {
                    var selectID = $(this).attr('id'); // Get the ID
                    var value = $(this).val(); // Get selected value

                    // Extract the last number from ID
                    var lastNumber = selectID.match(/\d+$/); 
                    lastNumber = lastNumber ? lastNumber[0] : ''; 

                    // Corrected selector using backticks
                    $(`#deputy-observers-kk-${lastNumber}`).val(value);
                });
                $('select[name^="observers[observer_id]"]').each(function(index) {
                    var selectID = $(this).attr('id'); // Get the ID
                    var value = $(this).val(); // Get selected value

                    // Extract the last number from ID
                    var lastNumber = selectID.match(/\d+$/); 
                    lastNumber = lastNumber ? lastNumber[0] : ''; 

                    // Corrected selector using backticks
                    $(`#observers-kk-${lastNumber}`).val(value);
                });
                // -------------------------------------------------------                

                $('#PreviewModal').modal('show');
                // Clone the element
                var tableHtml = $('.RemunerationMain').clone();
                // Find inputs inside the cloned element
                tableHtml.find('input:not(.common-fields)').addClass('border-0').prop({
                    'readonly': true, // Set inputs as readonly
                }).css('pointer-events', 'none'); // Disable pointer events

                // Find inputs with class '.common-fields' and apply readonly and pointer-events
                tableHtml.find('input.common-fields').prop({
                    'readonly': true, // Set inputs as readonly
                }).css('pointer-events', 'none'); // Add border-0 class for styling

                // Hide elements as needed (e.g., with specific IDs or classes)
                tableHtml.find('#preview').hide();
                tableHtml.find('.shiftwise-payment-Amount-modal-btn').hide();
                tableHtml.find('.shiftwise-modal-btn').hide();
                tableHtml.find('.file-label').hide();
                tableHtml.find('.Observer-Amount-modal-btn').hide();
                tableHtml.find('.Deputy-Observer-Amount-modal-btn').hide();
                var CenterNo = $('#CentreNumber').val();
                tableHtml.find('#CentreNumber').val(CenterNo).prop({'readonly': true}).css('pointer-events', 'none'); // Add border-0 class for styling
                // Update the content of the target element with the modified HTML

                $('.RemunerationModal').html(tableHtml);

            }
        });
        /*------------------------------------------------------------------------------------------------*/
        $('.ManPower').on('input', function() {
            var val = parseInt(this.value);
            var $errorSpan = $(this).next('span.text-danger');
            if ($errorSpan.length === 0) {
                $(this).after('<span class="text-danger"></span>');
                $errorSpan = $(this).next('span.text-danger');
            }
            var lang = parseInt($(this).attr('lang'));
            if (val > lang) {
                $(this).val('');
                $errorSpan.text('Max ' + lang + ' Persons allowed');
            } else {
                $errorSpan.text('');
            }
        });
        $('.DutyDays').on('input', function() {
            var val = parseInt(this.value);
            var $errorSpan = $(this).next('span.text-danger');
            if ($errorSpan.length === 0) {
                $(this).after('<span class="text-danger"></span>');
                $errorSpan = $(this).next('span.text-danger');
            }
            var lang = parseInt($(this).attr('lang'));
            if (val > lang) {
                $(this).val('');
                $errorSpan.text('Max ' + lang + ' days allowed');
            } else {
                $errorSpan.text('');
            }
        });




        $(document).on('click', '.verifyAadhaarBtn', function() {
            $('#PreviewModal').modal('hide');
            var FormId = $(this).data('id');
            if (FormId == 1) {
                $('#exampleModal').modal('hide');
            } else {
                $('#exampleModalOnline').modal('hide');
            }
            resetAadharVerification();
            $('#AadharModal').modal('show').attr('data-id', +FormId);
        });


        function resetAadharVerification() {
            $('#Otp').val('');
            $('.otpverify').addClass('d-none');
            $('.aadharverify ').removeClass('d-none');
            $('#aadhaarNumberTxt').val('');
            $('.aadhaarNumberTxt').text('');
            $('.aadhaarNumberTxt').addClass('visibility-hidden');
            $('#btnValidateOTP').hide();
            $('#generateAadhaarOTPBtn').show();
            $('.OTPTxt').text('');
            $('#resendOTPBtn').hide();
            $('#spnResult').text('');
            $('.FinalSubmit').removeClass('d-block');
            $('.FinalSubmit').addClass('d-none');

        }

        function onGenerateEmailOTP() {
            var ExamType = '<?php echo session('examType'); ?>'
            var BillType = $('#AadharModal').data('id');
            var ObsDetails = {
                'Email': '<?php echo $VendorDetails->Email; ?>',
                'Name': '<?php echo $VendorDetails->FullName; ?>',
                'ObserverId': '<?php echo session('ObserverID'); ?>',
                'examType': ExamType
            };
            // console.log(BillType);
            $('#resendOTPBtn').hide();
            $('.OTPTxt').text('');

            $.ajax({
                type: 'POST',
                url: "{{ route('generatemailotp') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    ObsDetails: ObsDetails,
                    BillType: BillType,
                    ExamType: ExamType,
                },
                "beforeSend": function(response) {
                    $('.overlay').show();
                },
                success: function(resp) {
                    $('.overlay').hide();
                    if (!resp) {
                        $('#spnResult').html('Error in sending mail!');
                        $('#spnResult').css("color", "red");
                        $('.overlay').hide();
                        return false;
                    }

                    var message = "OTP sent successfully";
                    message = message + " to " + ObsDetails.Email;
                    var seconds = 60;

                    function updateCountdown() {
                        $('#countdown').show();
                        $('#countdown').text('Resend OTP In: ' + seconds + ' seconds');
                        seconds--;
                        if (seconds < 0) {
                            clearInterval(timer);
                            $('#resendOTPBtn').show();
                            $('#countdown').text('');
                        }
                    }
                    timer = setInterval(updateCountdown, 1000);
                    $('.aadharverify').addClass('d-none');
                    $('.otpverify').removeClass('d-none');
                    $('#spnResult').html(message);
                    $('#btnValidateOTP').show();
                    $('#generateAadhaarOTPBtn').hide();
                    $('#spnResult').css("color", "green");

                },
                error: function(xhr, textStatus, error) {
                    var errorMessage = xhr.status + ': ' + xhr.statusText;
                    // alert(errorMessage)
                    $('#spnResult').html('Error - ' + errorMessage);
                    $('#spnResult').css("color", "red");
                    $('#divMessage').show();
                    //$('#divMessage').delay(3000).fadeOut("slow");
                    $('.overlay').hide();
                    return false;
                }
            });
        }

        function onValidateEmailOtp() {
            var formId = $('#AadharModal').data('id');
            var otpValue = $('#Otp').val();
            var ExamType = '<?php echo session('examType'); ?>';

            if (otpValue == '') {
                $('#Otp').focus();
                $('.OTPTxt').text('OTP cannot be blank');
                $('.overlay').hide();
                return false;
            } else if (otpValue && otpValue.trim().length !== 4) {
                $('#Otp').focus();
                $('.overlay').hide();
                $('.OTPTxt').text('OTP Length Should be 4 Digits');
                return false;
            } else {
                $('.OTPTxt').text('');
            }

            $.ajax({
                type: 'POST',
                url: "{{ route('validatemailotp') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    OTPVALUE: otpValue,
                    ExamType: ExamType,
                },
                "beforeSend": function(response) {
                    $('.overlay').show();
                },
                success: function(data) {

                    if (data.status == 0) {
                        $('.OTPTxt').text(data.message);
                        $('.OTPTxt').removeClass('visibility-hidden');
                        $('.overlay').hide();
                        return false;
                    }
                    $('.overlay').hide();
                    // alert('Otp Verified Successfully!');
                    clearInterval(timer);
                    $('#spnResult').text(data.message);
                    $('.otpverify').addClass('d-none');
                    $('#spnResult').css('color', 'green');
                    $('#btnValidateOTP').hide();
                    $('#countdown').text('');
                    $('#resendOTPBtn').hide();
                    $('#countdown').hide();
                    $('.FinalSubmit').removeClass('d-none');

                    if (formId == 1) {
                        $('.FinalSubmit').addClass('finalSubmitOffline');
                    } else {
                        $('.FinalSubmit').addClass('finalSubmitOnline');

                    }
                },
                error: function(xhr, textStatus, error) {
                    $('#spnResult').html(error.message);
                    $('#spnResult').css("color", "red");
                    $('#divMessage').show();
                    $('.overlay').hide();
                    return false;
                }
            });
        }

        $(document).on('click', '.finalSubmitOffline', function() {
            // alert(123);
            var btn = $(".finalSubmitOfflineBtn");
            btn.trigger("click"); // First click
            // Second click after a small delay
            // setTimeout(function() {
            //     btn.trigger("click");
            // }, 300); // You can adjust the delay as needed
        });

        $(document).on('click', '.finalSubmitOnline', function() {

            var btn = $(".finalSubmitOnlineBtn");
            btn.trigger("click"); // First click
            // Second click after a small delay
            // setTimeout(function() {
            //     btn.trigger("click");
            // }, 300); // You can adjust the delay as needed
        });
        $(document).on('click', '.clearHtml', function() {
            $('.RemunerationModal').html('');
        });


        //set manpower and Dutydays
        $('#AllottedCandidates').on('input', function() {
            var AllottedCandidates = $(this).val(); // Fetch value from #AllottedCandidates
            $('#PresentCandidates').val('');
            $('#AbsentCandidates').val('');
            $('#RemunerationOnlineTable tr').each(function() {
                if ($(this).find('.NoOfCandidates').length > 0) {
                    var NoOfCandidates = $(this).find('.NoOfCandidates').val();
                    $('.unsetValue').val('');
                    // Calculate allowCondidate
                    if (NoOfCandidates > 0) {
                        var allowCondidate = Math.ceil(AllottedCandidates / NoOfCandidates);

                        // Update lang attribute for elements with class .ManPower if it exists
                        if ($(this).find('.ManPower').attr('lang') !== undefined) {
                            $(this).find('.ManPower').attr('lang', allowCondidate);
                        }

                        // Update lang attribute for elements with class .DutyDays if it exists
                        // if ($(this).find('.DutyDays').attr('lang') !== undefined) {
                        //     $(this).find('.DutyDays').attr('lang', allowCondidate);
                        // }
                    }
                }
            });
        });

        $('.DutyDays,.ManPower,.RemunerationSection,#advancePayment').on('input', function() {
            var AllottedCandidates = $('#AllottedCandidates').val();
            var Role = '<?= $Role ?>';
            if (Role == 1 && AllottedCandidates == '') {
                $(this).val('');
                alert('Please enter allotted candidates first!');
                $('#AllottedCandidates').focus();
                return false;
            }
            if (Role == 14 && AllottedCandidates == '') {
                $(this).val('');
                alert('Please select center number first!');
                $('#CentreNumber').focus();
                return false;
            }
            var row = $(this).closest('tr');
            var manpowerValue = parseInt(row.find('.ManPower').val()) || 0; // Get value from ManPower
            var dutyDaysValue = parseInt(row.find('.DutyDays').val()) || 0; // Get value from DutyDays
            var manpowerInputValue = parseFloat(row.find('.ManPowerInput').val()) ||
                0; // Get value from ManPowerInput
            if ((row.find('.ManPower').length > 0) && (row.find('.DutyDays').length > 0)) {
                if (!isNaN(manpowerInputValue) && !isNaN(manpowerValue) && !isNaN(dutyDaysValue)) {
                    var result = manpowerInputValue * manpowerValue * dutyDaysValue;
                    result = Math.round(result * 100) / 100; // Round to 2 decimal places
                    row.find('.RemunerationSection').val(result);
                }
            }
            var totalRemuneration = 0;
            var totalTDS = 0;
            $('#RemunerationOnlineTable tr').each(function() {

                if ($(this).find('.RemunerationSection').length > 0) {
                    var remuneration = parseInt($(this).find('.RemunerationSection').val()) || 0;
                    if (!isNaN(remuneration)) {
                        totalRemuneration += remuneration;
                    }
                }

                if (($(this).find('.RemunerationSection').length > 0) && ($(this).find('.tds').length >
                        0)) {
                    var remuneration = 0;
                    remuneration = parseInt($(this).find('.RemunerationSection').val()) || 0;
                    //  alert(remuneration);

                    var tdsPercentage = parseInt($(this).find('.tds').val()) || 0;
                    var ConvenceAmount = 0;

                    if ($(this).find('.ConvenceAmount').length > 0) {
                        if ($(this).find('.ManPower').length > 0 && $(this).find('.DutyDays').length > 0) {
                            var manpowerValue = parseInt($(this).find('.ManPower').val()) || 0;
                            var dutyDaysValue = parseInt($(this).find('.DutyDays').val()) || 0;
                            var conve = parseInt($(this).find('.ConvenceAmount').val()) || 0;
                            ConvenceAmount = parseInt(conve * manpowerValue * dutyDaysValue);
                        } else {
                            ConvenceAmount = parseInt($(this).find('.ConvenceAmount').val()) || 0;
                        }

                        if (!isNaN(ConvenceAmount) && (ConvenceAmount > 0) && !isNaN(remuneration) && !
                            isNaN(tdsPercentage) && remuneration > ConvenceAmount) {
                            totalTDS += parseFloat(((remuneration - ConvenceAmount) * tdsPercentage) / 100);
                        } else {
                            if (!isNaN(remuneration) && !isNaN(tdsPercentage)) {
                                totalTDS += parseFloat((remuneration * tdsPercentage) / 100);
                            }
                        }
                    }
                }
            });
            // alert(totalTDS);
            var advanceP = parseFloat($('#advancePayment').val()) || 0;
            // var ObserverNetAmount = parseFloat($('#ObserverNetAmount').val()) || 0; // Get value from DutyDaysTd
            // var DObserverNetAmount = parseFloat($('#DObserverNetAmount').val()) || 0; // Get value from DutyDaysTd
            var ObserverNetTDSAmount = parseFloat($('#ObserverTotalTDSAmount').val()) || 0; // Get value from DutyDaysTd
            var DObserverNetTDSAmount = parseFloat($('#DObserverTotalTDSAmount').val()) || 0; // Get value from DutyDaysTd

            $('#NetPaybleAmount').val(parseFloat((totalRemuneration) -
                advanceP - totalTDS - ObserverNetTDSAmount - DObserverNetTDSAmount));
            // $('#NetPaybleAmount').val(parseFloat((totalRemuneration + ObserverNetAmount + DObserverNetAmount) -
            //     advanceP - totalTDS));            
            $('#tds').val(totalTDS);


        });
        

        $(document).ready(function() {
            $('#PresentCandidates').on('input', function() {
                let allotted = parseInt($('#AllottedCandidates').val()) || 0;
                let present = parseInt($('#PresentCandidates').val()) || 0;
                // Ensure PresentCandidates cannot be greater than AllottedCandidates
                if (present > allotted) {
                    present = allotted;
                    $('#PresentCandidates').val(present);
                }
                // Calculate AbsentCandidates
                let absent = allotted - present;
                $('#AbsentCandidates').val(absent);

            });
        });

        document.querySelectorAll('.file-upload').forEach(uploadContainer => {
            const fileInput = uploadContainer.querySelector('.file-input');
            const fileLabel = uploadContainer.querySelector('.file-label');
            const fileName = uploadContainer.querySelector('.file-name');

            // Create a span element for error messages
            const fileError = document.createElement('span');
            fileError.style.color = 'red';
            uploadContainer.appendChild(fileError); // Append it to the container

            fileLabel.addEventListener('click', function() {
                fileInput.click();
            });

            fileInput.addEventListener('change', function() {
                if (fileInput.files.length > 0) {
                    const file = fileInput.files[0];
                    const allowedExtensions =
                        /(\.pdf|\.xls|\.xlsx|\.jpg|\.jpeg|\.png|\.doc|\.docx)$/i; // Add more extensions as needed 'jpg','jpeg', 'png', 'pdf','doc','docx','xls','xlsx'
                    const maxSize = 2 * 1024 * 1024; // 2MB in bytes
                    const filePath = file.name;
                    const fileSize = file.size;

                    // Reset error message
                    fileError.textContent = '';

                    // Check for allowed file extensions
                    if (!allowedExtensions.exec(filePath)) {
                        fileError.textContent =
                            'Invalid file type. Only jpg, jpeg, png, pdf, doc, docx, xls, xlsx files are allowed.';
                        fileInput.value = ''; // Clear the input
                        fileName.textContent = 'No file chosen';
                        return false;
                    }

                    // Check for file size
                    if (fileSize > maxSize) {
                        fileError.textContent = 'File size must not exceed 2MB.';
                        fileInput.value = ''; // Clear the input
                        fileName.textContent = 'No file chosen';
                        return false;
                    }

                    // If valid, display the file name
                    fileName.textContent = file.name;
                } else {
                    fileName.textContent = 'No file chosen';
                }
            });
        });
    </script>

    {{-- ========================================= Observer/Deputy Observer Modal Section Here ===================================== --}}
    <script>
        $(document).on('click', '#save-observer-details', function() {
            var isValid = true; // Variable to track overall form validity

            // Clear previous validation messages first
            $('.ob-required').next('span.text-danger').remove();

            // Iterate over each required field with the class 'ob-required'
            $('.ob-required').each(function() {
                var value = $(this).val();
                var minlength = $(this).attr('minlength');
                var maxlength = $(this).attr('maxlength');
                var datatype = $(this).attr('data-id');
                var emailPattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/; // Email regex pattern
                var ifscPattern = /^[A-Z]{4}0[A-Z0-9]{6}$/; // IFSC regex pattern
                var panPattern = /^[A-Z]{5}[0-9]{4}[A-Z]{1}$/;
                // alert(datatype);

                // Check if the field is empty
                if (value == '') {
                    $(this).after('<span class="text-danger">This is a required field.</span>');
                    isValid = false;
                } else if (value && minlength && value.length < minlength) {
                    $(this).after('<span class=\"text-danger\">Minimum ' + minlength +
                        ' characters required.</span>');
                    isValid = false;
                } else if (value && maxlength && value.length > maxlength) {
                    $(this).after('<span class=\"text-danger\">Maximum ' + maxlength +
                        ' characters allowed.</span>');
                    isValid = false;
                } else if (value && datatype === 'email') { //alert();
                    if (!emailPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid email address.</span>');
                        isValid = false;
                    }
                } else if (value && datatype === 'pan') {
                    if (!panPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid PAN number (e.g., ABCDE1234F).</span>'
                        );
                        isValid = false;
                    }
                } else if (value && datatype === 'ifsc') {
                    if (!ifscPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid IFSC code (e.g., SBIN0001234).</span>'
                        );
                        isValid = false;
                    }
                }
            });

            // If validation passes, run the observer functions
            if (isValid) {

                updateTotals(); // Update the totals for observers

                $('.close-observer-modal').trigger('click'); // Hide the modal if form is valid
            }

            // Prevent form submission if any validation fails
            return isValid;
        });

        $(document).on('click', '#save-deputy-observer-details', function() {
            var isValid = true; // Variable to track overall form validity
            // Clear previous validation messages first
            $('.dob-required').next('span.text-danger').remove();

            // Iterate over each required field with the class 'dob-required'
            $('.dob-required').each(function() {
                var value = $(this).val();
                var minlength = $(this).attr('minlength');
                var maxlength = $(this).attr('maxlength');
                var datatype = $(this).attr('data-id');
                var emailPattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/; // Email regex pattern
                var ifscPattern = /^[A-Z]{4}0[A-Z0-9]{6}$/; // IFSC regex pattern
                var panPattern = /^[A-Z]{5}[0-9]{4}[A-Z]{1}$/;

                // Check if the field is empty
                if (value == '') {
                    $(this).after('<span class=\"text-danger\">This is a required field.</span>');
                    isValid = false;
                } else if (value && minlength && value.length < minlength) {
                    $(this).after('<span class="text-danger">Minimum ' + minlength +
                        ' characters required.</span>');
                    isValid = false;
                } else if (value && maxlength && value.length > maxlength) {
                    $(this).after('<span class=\"text-danger\">Maximum ' + maxlength +
                        ' characters allowed.</span>');
                    isValid = false;
                } else if (value && datatype === 'email') {
                    if (!emailPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid email address.</span>');
                        isValid = false;
                    }
                } else if (value && datatype === 'pan') {
                    if (!panPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid PAN number (e.g., ABCDE1234F).</span>'
                        );
                        isValid = false;
                    }
                } else if (value && datatype === 'ifsc') {
                    if (!ifscPattern.test(value)) {
                        $(this).after(
                            '<span class=\"text-danger\">Please enter a valid IFSC code (e.g., SBIN0001234).</span>'
                        );
                        isValid = false;
                    }
                }
            });

            // If validation passes, run the deputy observer functions
            if (isValid) {
                
                updateTotalsDOB(); // Update the totals for deputy observers

                $('.close-dobserver-modal').trigger('click'); // Hide the modal if form is valid
            }

            // Prevent form submission if any validation fails
            return isValid;
        });

        //=========================== Observer Details Section ==============================//
        $(document).on('click', '.add-more', function() { //alert()
            // Initial observer index is fetched from the hidden input
            var observerIndex = parseInt($('#observerIndex').val(), 10);
            var maxIndexAllowed = parseInt($('#No_ofAllotedObserver').val());
            if(observerIndex < maxIndexAllowed){
                observerIndex++; // Increment index for the new section
                $('#observerIndex').val(observerIndex); // Update the hidden field with the new index

                // Clone the first section
                var newSection = $('.observer-section-1:first').clone();

                // Update cloned section to have unique IDs and names
                newSection.find('input').each(function() {
                    var oldId = $(this).attr('id');
                    // Update the IDs and names to match the new observerIndex
                    $(this).attr('id', oldId.replace(/\d+$/, '') + observerIndex);
                    $(this).val(''); // Clear input fields
                });
                newSection.find('select').each(function() {
                    var oldId = $(this).attr('id');
                    // Update the IDs and names to match the new observerIndex
                    $(this).attr('id', oldId.replace(/\d+$/, '') + observerIndex);
                    $(this).val(''); // Clear input fields
                });

                // Update section heading
                newSection.find('h4').text('Observer ' + observerIndex);
                newSection.find('#add-observer-btn').hide();

                // Add delete button and make it visible
                newSection.find('.delete-section').removeClass('d-none');

                // Append the new section to the form
                newSection.appendTo('#observer-details-form');
            }else{
                alert('Maximum '+maxIndexAllowed+' observers allowed.');
            }
        });

        // Function to delete observer section
        $(document).on('click', '.delete-section', function() {
            // Remove the observer section
            $(this).closest('.observer-section-1').remove();

            // No need to decrement the observerIndex, it should remain as is,
            // as we are not reassigning the indexes of the remaining sections.

            // Optional: You can renumber the remaining sections after deletion if needed.
            // This is not necessary unless you want sequential numbering after deletion.
            renumberObservers();
        });

        // Optional function to renumber observer sections after deletion
        function renumberObservers() {
            var count = 1;
            $('.observer-section-1').each(function() {
                $(this).find('h4').text('Observer ' + count); // Update section heading
                $(this).find('input').each(function() {
                    var oldId = $(this).attr('id');
                    $(this).attr('id', oldId.replace(/\d+$/, '') + count);
                });
                count++;
            });

            // Update observerIndex with the current number of sections
            $('#observerIndex').val(count - 1);
        }



        //=========================== Deputy Observer Details Section ==============================//
        $(document).on('click', '.deputy-add-more', function() {

            // Initial observer index is fetched from the hidden input
            var observerIndex = parseInt($('#deputy-observerIndex').val(), 10);
            var maxIndexAllowed = parseInt($('#No_ofAllotedObserver').val());
            if(observerIndex < maxIndexAllowed){
                observerIndex++; // Increment index for the new section
                $('#deputy-observerIndex').val(observerIndex); // Update the hidden field with the new index

                // Clone the first section
                var newSection = $('.deputy-observer-section-1:first').clone();

                // Update cloned section to have unique IDs and names
                newSection.find('input').each(function() {
                    var oldId = $(this).attr('id');
                    if (oldId) { // Ensure the element has an id
                        // Update the IDs and names to match the new observerIndex
                        $(this).attr('id', oldId.replace(/\d+$/, '') + observerIndex);
                    }
                    $(this).val(''); // Clear input fields
                });

                newSection.find('select').each(function() {
                    var oldId = $(this).attr('id');
                    if (oldId) { // Ensure the element has an id
                        // Update the IDs and names to match the new observerIndex
                        // $(this).attr('id', oldId.replace(/\d+$/, '') + observerIndex);
                        $(this).attr('id', oldId.replace(/\d+$/, '') + observerIndex);
                        $(this).attr('name', $(this).attr('name').replace(/\d+$/, '') + observerIndex);
                    }
                    $(this).val(''); // Clear select fields
                });

                // Hide the add button in the cloned section
                newSection.find('#add-deputy-observer-btn').hide();

                // Update section heading
                newSection.find('h4').text('Deputy-Observer ' + observerIndex);

                // Add delete button and make it visible
                newSection.find('.deputy-delete-section').removeClass('d-none');

                // Append the new section to the form
                newSection.appendTo('#deputy-observer-details-form');
            }else{
                alert('Maximum '+maxIndexAllowed+' deputy observers allowed.');
            }
        });
        
     

        // Function to delete observer section
        $(document).on('click', '.deputy-delete-section', function() {
            // Remove the observer section
            $(this).closest('.deputy-observer-section-1').remove();

            // No need to decrement the observerIndex, it should remain as is,
            // as we are not reassigning the indexes of the remaining sections.

            // Optional: You can renumber the remaining sections after deletion if needed.
            // This is not necessary unless you want sequential numbering after deletion.
            renumberDeputyObservers();
        });

        // Optional function to renumber observer sections after deletion
        function renumberDeputyObservers() {
            var count = 1;
            $('.deputy-observer-section-1').each(function() {
                $(this).find('h4').text('Deputy-Observer ' + count); // Update section heading
                $(this).find('input').each(function() {
                    var oldId = $(this).attr('id');
                    $(this).attr('id', oldId.replace(/\d+$/, '') + count);
                });
                count++;
            });

            // Update observerIndex with the current number of sections
            $('#deputy-observerIndex').val(count - 1);
        }
    </script>
    <script>
        // Show input field when the + icon is clicked
        document.getElementById('add-observer-btn').addEventListener('click', function() {
            document.getElementById('new-observer-input').style.display = 'block';
        });

        // Add new observer ID to dropdown when OK is clicked
        document.getElementById('ok-btn').addEventListener('click', function() {
            var newObserver = document.getElementById('new-observer-value').value.trim();
            var dropdown = document.getElementById('observer-id-1');

            if (newObserver !== '') {
                // Check if the newObserver already exists in the dropdown
                var exists = Array.from(dropdown.options).some(function(option) {
                    return option.value === newObserver;
                });

                if (exists) {
                    // Show validation message if the value already exists
                    document.getElementById('validation-msg').textContent =
                        'Observer ID already exists. Please enter a unique value.';
                    document.getElementById('validation-msg').style.display = 'block';
                } else {
                    // If unique, add the new observer ID to the dropdown
                    var newOption = document.createElement('option');
                    newOption.text = newObserver;
                    newOption.value = newObserver;
                    dropdown.add(newOption);

                    // Hide the validation message if it was shown earlier
                    document.getElementById('validation-msg').style.display = 'none';

                    // Reset the dropdown to the default prompt value (e.g., "Select Observer")
                    dropdown.value = '';

                    // Hide input and reset its value
                    document.getElementById('new-observer-input').style.display = 'none';
                    document.getElementById('new-observer-value').value = '';
                }
            }
        });

        // Close the input field when X is clicked
        document.getElementById('cancel-btn').addEventListener('click', function() {
            document.getElementById('new-observer-input').style.display = 'none';
            document.getElementById('new-observer-value').value = '';
            document.getElementById('validation-msg').style.display =
                'none'; // Hide validation message when canceled
        });
    </script>

    <script>
        // Generalize function to handle multiple rows
        $('body').on('change', 'select[id^="observer-id-"]', function() {
            var observerId = $(this).val(); // Get the selected observer ID
            var rowId = $(this).attr('id').split('-').pop(); // Extract the dynamic row ID (e.g., 1, 2, 3, ...)

            if (observerId) {
                // Perform AJAX request to fetch observer details
                $.ajax({
                    url: "{{ route('get-observer-details', '') }}/" +
                        observerId, // Append observer ID to the URL
                    type: 'GET',
                    success: function(response) {
                        if (!response.error) {

                            if(response.ATT == '0'){
                                Swal.fire({
                                    title: 'Warning!',
                                    text: 'Please mark the attendance fo this observer first!',
                                    icon: 'error'
                                });
                                $('#observer-name-' + rowId).val('');
                                $('#observer-phone-' + rowId).val('');
                                $('#observer-email-' + rowId).val('');
                                $('#account-holder-name-' + rowId).val('');
                                $('#account-number-' + rowId).val('');
                                $('#ifsc-code-' + rowId).val('');
                                $('#branch-name-' + rowId).val('');
                                $('#pan-number-' + rowId).val('');
                                return false;

                            }
                            // Update the corresponding fields with the observer details
                            $('#observer-name-' + rowId).val(response.observer_name);
                            $('#observer-phone-' + rowId).val(response.observer_phone);
                            $('#observer-email-' + rowId).val(response.observer_email);
                            $('#account-holder-name-' + rowId).val(response.account_holder_name);
                            $('#account-number-' + rowId).val(response.account_no);
                            $('#ifsc-code-' + rowId).val(response.ifsc_code);
                            $('#branch-name-' + rowId).val(response.branch);
                            $('#pan-number-' + rowId).val(response.pan_no);
                            $('#duty-days-' + rowId).val(response.DutyDays);
                            $('#Observer-Remuneration-' + rowId).val(response.TotalRemunerationAmount);
                            $('#Observer-Conveyance-' + rowId).val(response.TotalConveyanceAmount);
                        } else {
                            Swal.fire({
                                title: 'Warning!',
                                text: response.error,
                                icon: 'error'
                            });
                            // Clear the fields if observer details are not found
                            $('#observer-name-' + rowId).val('');
                            $('#observer-phone-' + rowId).val('');
                            $('#observer-email-' + rowId).val('');
                            $('#account-holder-name-' + rowId).val('');
                            $('#account-number-' + rowId).val('');
                            $('#ifsc-code-' + rowId).val('');
                            $('#branch-name-' + rowId).val('');
                            $('#pan-number-' + rowId).val('');
                            $('#duty-days-' + rowId).val('');
                            $('#Observer-Remuneration-' + rowId).val('');
                            $('#Observer-Conveyance-' + rowId).val('');
                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error!',
                            text: 'Error fetching observer details. Please try again.',
                            icon: 'error'
                        });
                    }
                });
            }

        });
    </script>
    <script>
        // Force input to uppercase on keyup
        document.getElementById('new-observer-value').addEventListener('input', function() {
            this.value = this.value.toUpperCase();
        });
    </script>

    <!-- ================================== Deputy Observer Section =============================== -->
    <script>
        // Show input field when the + icon is clicked
        document.getElementById('add-deputy-observer-btn').addEventListener('click', function() {
            document.getElementById('new-deputy-observer-input').style.display = 'block';
        });

        // Add new observer ID to dropdown when OK is clicked
        document.getElementById('dob-ok-btn').addEventListener('click', function() {
            var newObserver = document.getElementById('new-deputy-observer-value').value.trim();
            var dropdown = document.getElementById('deputy-observer-id-1');

            if (newObserver !== '') {
                // Check if the newObserver already exists in the dropdown
                var exists = Array.from(dropdown.options).some(function(option) {
                    return option.value === newObserver;
                });

                if (exists) {
                    // Show validation message if the value already exists
                    document.getElementById('dob-validation-msg').textContent =
                        'Deputy Observer ID already exists. Please enter a unique value.';
                    document.getElementById('dob-validation-msg').style.display = 'block';
                } else {
                    // If unique, add the new observer ID to the dropdown
                    var newOption = document.createElement('option');
                    newOption.text = newObserver;
                    newOption.value = newObserver;
                    dropdown.add(newOption);

                    // Hide the validation message if it was shown earlier
                    document.getElementById('dob-validation-msg').style.display = 'none';

                    // Reset the dropdown to the default prompt value (e.g., "Select Observer")
                    dropdown.value = '';

                    // Hide input and reset its value
                    document.getElementById('new-deputy-observer-input').style.display = 'none';
                    document.getElementById('new-deputy-observer-value').value = '';
                }
            }
        });

        // Close the input field when X is clicked
        document.getElementById('dob-cancel-btn').addEventListener('click', function() {
            document.getElementById('new-deputy-observer-input').style.display = 'none';
            document.getElementById('new-deputy-observer-value').value = '';
            document.getElementById('validation-msg').style.display =
                'none'; // Hide validation message when canceled
        });
    </script>

    <script>
        // Generalize function to handle multiple rows
        $('body').on('change', 'select[id^="deputy-observer-id-"]', function() {
            var observerId = $(this).val(); // Get the selected observer ID
            var rowId = $(this).attr('id').split('-').pop(); // Extract the dynamic row ID (e.g., 1, 2, 3, ...)

            if (observerId) {
                // Perform AJAX request to fetch observer details
                $.ajax({
                    url: "{{ route('get-observer-details', '') }}/" +
                        observerId, // Append observer ID to the URL
                    type: 'GET',
                    success: function(response) {
                        if (!response.error) {
                            if(response.ATT == '0'){
                                Swal.fire({
                                    title: 'Warning!',
                                    text: 'Please mark the attendance fo this deputy observer first!',
                                    icon: 'error'
                                });
                                $('#deputy-observer-name-' + rowId).val('');
                                $('#deputy-observer-phone-' + rowId).val('');
                                $('#deputy-observer-email-' + rowId).val('');
                                $('#deputy-account-holder-name-' + rowId).val('');
                                $('#deputy-account-number-' + rowId).val('');
                                $('#deputy-ifsc-code-' + rowId).val('');
                                $('#deputy-branch-name-' + rowId).val('');
                                $('#deputy-pan-number-' + rowId).val('');
                                return false;

                            }
                            // Update the corresponding fields with the observer details
                            $('#deputy-observer-name-' + rowId).val(response.observer_name);
                            $('#deputy-observer-phone-' + rowId).val(response.observer_phone);
                            $('#deputy-observer-email-' + rowId).val(response.observer_email);
                            $('#deputy-account-holder-name-' + rowId).val(response.account_holder_name);
                            $('#deputy-account-number-' + rowId).val(response.account_no);
                            $('#deputy-ifsc-code-' + rowId).val(response.ifsc_code);
                            $('#deputy-branch-name-' + rowId).val(response.branch);
                            $('#deputy-pan-number-' + rowId).val(response.pan_no);
                            $('#deputy-duty-days-' + rowId).val(response.DutyDays);
                            $('#Deputy-Observer-Remuneration-' + rowId).val(response.TotalRemunerationAmount);
                            $('#Deputy-Observer-Conveyance-' + rowId).val(response.TotalConveyanceAmount);
                        } else {
                            Swal.fire({
                                title: 'Warning!',
                                text: response.error,
                                icon: 'error'
                            });
                            // Clear the fields if observer details are not found
                            $('#deputy-observer-name-' + rowId).val('');
                            $('#deputy-observer-phone-' + rowId).val('');
                            $('#deputy-observer-email-' + rowId).val('');
                            $('#deputy-account-holder-name-' + rowId).val('');
                            $('#deputy-account-number-' + rowId).val('');
                            $('#deputy-ifsc-code-' + rowId).val('');
                            $('#deputy-branch-name-' + rowId).val('');
                            $('#deputy-pan-number-' + rowId).val('');
                            $('#deputy-duty-days-' + rowId).val('');
                            $('#Deputy-Observer-Remuneration-' + rowId).val('');
                            $('#Deputy-Observer-Conveyance-' + rowId).val('');
                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error!',
                            text: 'Error fetching deputy observer details. Please try again.',
                            icon: 'error'
                        });
                    }
                });
            }
        });
    </script>
    <script>
        // Force input to uppercase on keyup
        document.getElementById('new-deputy-observer-value').addEventListener('input', function() {
            this.value = this.value.toUpperCase();
        });
    </script>
    <script>
        function updateTotals() {
            let totalTDS = 0;
            let totalAdvance = 0;
            let totalNetAmount = 0;
            let DObserverNetAmount = parseFloat($('#DObserverNetAmount').val()) || 0;
            // Sum up all advance amounts
            $('.advance_payment').each(function() {
                let advanceValue = parseFloat($(this).val()) || 0;
                totalAdvance += advanceValue;
            });

            // Sum up all TDS amounts
            $('.tds_percent').each(function() {
                let tdsValue = parseFloat($(this).val()) || 0;
                totalTDS += tdsValue;
            });

            // Sum up all net observer amounts
            $('.amount_to_paid').each(function() {
                let netValue = parseFloat($(this).val()) || 0;
                totalNetAmount += netValue;
            });

            var initialTotalClaimedAmount = allCalculation();
            //alert(initialTotalClaimedAmount);
            // Update the hidden fields
            $('#ObserverTotalAdvanceAmount').val(totalAdvance);
            $('#ObserverTotalTDSAmount').val(totalTDS);
            $('#ObserverTDSAmountOffline').val(totalTDS);
            $('#ObserverNetAmount').val(totalNetAmount);

            $('#ObserverTDSAmount').val(totalTDS);

            // Add totalNetAmount to the initial value of NetPaybleAmount, not the updated one
            $('#NetPaybleAmount').val(initialTotalClaimedAmount + totalNetAmount);
            // Update the displayed text with the net amount
            //$('.ObserverAdvanceAmountText').text(totalAdvance);
            $('#OBSERVER_LOCAL').val(totalNetAmount+totalTDS+totalAdvance);
        }
        // Trigger the function when the user inputs a value in advance_payment or tds_percent
        $(document).on('input', '.advance_payment, .tds_percent', function() {
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID
            // updateRowNetAmount(rowId);
            let advancePayment = parseFloat($('#advance-payment-' + rowId).val()) || 0;
            let tdsPercent = parseFloat($('#tds-percent-' + rowId).val()) || 0;
            let netAmount = advancePayment - tdsPercent;
            $('#amount_to_paid-' + rowId).val(netAmount);
        });

        function updateTotalsDOB() {
            let totalAdvance = 0;
            let totalTDS = 0;
            let totalNetAmount = 0;
            let ObserverNetAmount = parseFloat($('#ObserverNetAmount').val()) || 0;

            // Sum up all advance amounts
            $('.deputy_advance_payment').each(function() {
                let advanceValue = parseFloat($(this).val()) || 0;
                totalAdvance += advanceValue;
            });

            // Sum up all TDS amounts
            $('.deputy_tds_percent').each(function() {
                let tdsValue = parseFloat($(this).val()) || 0;
                totalTDS += tdsValue;
            });

            // Sum up all net observer amounts
            $('.deputy_amount_to_paid').each(function() {
                let netValue = parseFloat($(this).val()) || 0;
                totalNetAmount += netValue;
            });

            var initialTotalClaimedAmount = allCalculation();
            // Update the hidden fields
            $('#DObserverTotalAdvanceAmount').val(totalAdvance);
            $('#DObserverTotalTDSAmount').val(totalTDS);
            $('#DObserverTDSAmountOffline').val(totalTDS);
            $('#DObserverNetAmount').val(totalNetAmount);
            
            $('#DeputyObserverTDSAmount').val(totalTDS);

            // Add totalNetAmount to the initial value of totalAmtClaimed, not the updated one
            $('#NetPaybleAmount').val(initialTotalClaimedAmount + totalNetAmount);

            // Update the displayed text with the net amount
            //$('.DObserverAdvanceAmountText').text(totalAdvance);
            $('#DEPUTY_OBSERVER').val(totalNetAmount+totalTDS+totalAdvance);
        }

        // Trigger the function when the user inputs a value in advance_payment or tds_percent
        $(document).on('input', '.deputy_advance_payment, .deputy_tds_percent', function() {
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID
            //updateRowNetAmountDOB(rowId);
            let advancePayment = parseFloat($('#deputy-advance-payment-' + rowId).val()) || 0;
            let tdsPercent = parseFloat($('#deputy-tds-percent-' + rowId).val()) || 0;
            let netAmount = advancePayment - tdsPercent;
            $('#deputy_amount_to_paid-' + rowId).val(netAmount);
        });

        function allCalculation() {
            let totalExpAmount = 0;
            let ExtraExpenseDataAmount = 0;
            var AdvancedAmountCC = $('#advancePayment').val() || 0;
            var TDSValue = $('#tds').val()||0;
            var ObserverTDS = $('#ObserverTotalTDSAmount').val()||0;
            var DeputyObserverTDS = $('#DObserverTotalTDSAmount').val()||0;
            $('.RemunerationSection').each(function() {
                var value = parseFloat($(this).val());
                if (!isNaN(value)) {
                    totalExpAmount += value;
                }
            });
            
            let totalExpAmountAndSum = totalExpAmount - AdvancedAmountCC;
            let finalAmtClaimed = parseFloat(totalExpAmountAndSum) - TDSValue - ObserverTDS - DeputyObserverTDS;
            let finalAmtClaimedVal = finalAmtClaimed;
            initialTotalClaimedAmount = Math.round(finalAmtClaimedVal * 100) / 100;
            return initialTotalClaimedAmount;
        }

        $(document).on('change', '#CentreNumber', function() {
            var CenterValue = this.value;
            if (CenterValue !='') {
                $.ajax({
                    type: 'POST',
                    url: "{{ route('check-bill-status') }}",
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                    },
                    data: {
                        centerno: CenterValue,
                    },
                    beforeSend: function() {
                        $('.overlay').show();
                    },
                    success: function(data) { //alert(data);
                        if (data == false) {
                            getcenterdetails(CenterValue);
                            getdaywisecountdetails(CenterValue);
                            getshiftwisepayment(CenterValue);

                        } else {

                            // alert('Bill has been already submitted for the selected Centre No!');
                            Swal.fire({
                                title: "Warning",
                                text: "Bill has been already submitted for the selected Centre No!",
                                icon: "error"
                            });
                            $('#CentreNumber').val('');
                        }
                    },
                    error: function(xhr, textStatus, error) {
                        console.error('Error:', textStatus, error);
                        alert('An error occurred: ' + error);
                        $('.overlay').hide();
                    },
                    complete: function() {
                        $('.overlay').hide();
                    }
                });
            }

        });

        function getcenterdetails(CenterValue) {

            $.ajax({
                type: 'POST',
                url: "{{ route('get-center-details') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    centerno: CenterValue,
                },
                dataType: 'json',
                success: function(data) { //alert(data)
                    $('#CentreNameWithAddress').val(data.centerAddress);
                    $('#CentreCity').val(data.cityName);
                },
                error: function(xhr, textStatus, error) {
                    console.error('Error:', textStatus, error);
                    alert('An error occurred: ' + error);
                },
            });
        }

        function getdaywisecountdetails(CenterValue) {
            $.ajax({
                type: 'POST',
                url: "{{ route('get-daywise-count-details') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    centerno: CenterValue,
                },
                dataType: 'json',
                success: function(response) {
                        // var data = JSON.parse(response);
                        if (response) {
                            
                            if(response.AllottedCandidates == 0){
                                Swal.fire({
                                    title: "Warning",
                                    text: "Candidate count data not found for the selected Centre No!, kindly contact NTA!",
                                    icon: "error"
                                });
                                $('#CentreNumber').val('');
                            }
                            let dynamicHtml = '';
                            
                            //if(response.shiftwisecount){
                                $.each(response.allottedCandidatesCount, function(index, value) {
                                    $('#allottedCandidatesCount' + (index + 1)).val(value);
                                });

                                $('#AllottedCandidates').val(response.AllottedCandidates);
                                cappingMapping(response.maxDayCount);

                                $.each(response.shiftwisecount, function(index, value) {

                                    dynamicHtml += `<input id="${index}" type="hidden" value="${value}"/>`;
                                });
                                
                                $('.dynamicShiftwiseCount').html(dynamicHtml);
                            // }
                            // else{
                            //     alert('Shift Wise attendance data not found');
                            // }
                            
                        } else {
                            alert('Your Duty data is not proper');
                        }
                    
                },
                error: function(xhr, textStatus, error) {
                    console.error('Error:', textStatus, error);
                    alert('An error occurred: ' + error);
                },
            });
        }

        function getshiftwisepayment(CenterValue) {
            $.ajax({
                type: 'POST',
                url: "{{ route('get-shiftwise-data') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    centerno: CenterValue,
                },
                dataType: 'json',
                success: function(data) {
                    $('.shiftwise-payment-Amount-modal-btn').show();
                    $('.shiftwise-modal-btn').show();
                    $('#CENTRE_SUPERITENDENT').val(data.GrandTotal);

                    let tableHTML = `
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>Duty Days</th>
                                    <th>Shifts Done</th>
                                    <th>Remuneration Amount</th>
                                    <th>Conveyance Amount</th>
                                </tr>
                            </thead>
                            <tbody>
                    `;

                    // Extract data
                    let dayWiseShiftCount = data.DayWiseShiftCount;
                    let shiftWiseAmount = data.shiftWiseAmount;
                    let totalAmount = parseFloat(data.TotalRemunerationAmount) || 0;
                    let totalConveyance = parseFloat(data.TotalConveyanceAmount) || 0;
                    let shiftwiseTableHTML = '';
                    // let tableHTML = ''; // Make sure this is declared

                    // Iterate over DayWiseShiftCount and shiftWiseAmount
                    for (let key in dayWiseShiftCount) {
                        let dayNumber = key.split(" ")[1]; // Extract day number from "Day X"
                        let shiftCount = dayWiseShiftCount[key];

                        let remunerationKey = "Remuneration" + dayNumber;
                        let conveyanceKey = "Conveyance" + dayNumber;

                        let remunerationAmount = shiftWiseAmount[remunerationKey] ? parseFloat(shiftWiseAmount[remunerationKey]).toFixed(2) : "0.00";
                        let conveyanceAmount = shiftWiseAmount[conveyanceKey] ? parseFloat(shiftWiseAmount[conveyanceKey]).toFixed(2) : "0.00";

                        tableHTML += `
                            <tr>
                                <td>${dayNumber}</td>
                                <td>${shiftCount}</td>
                                <td>${remunerationAmount}</td>
                                <td>${conveyanceAmount}</td>
                            </tr>
                        `;

                        shiftwiseTableHTML += `
                            <div class="col-auto">
                                <label class="fw-bold">Day ${dayNumber}</label>`;
                                let shiftname = '';
                                for (let i = 1; i <= shiftCount; i++) {
                                    if (i == 1) {
                                        shiftname = 'Single';
                                    } else if (i == 2) {
                                        shiftname = 'Double';
                                    } else if (i == 3) {
                                        shiftname = 'Triple';
                                    } else {
                                        shiftname = 'Quadra';
                                    }

                                    shiftwiseTableHTML += ` 
                                        <input type="number" min="0" style="min-width: 200px;" class="form-control form-control-sm mt-1 D${dayNumber}S${i}" lang="D${dayNumber}S${i}" placeholder="${shiftname} Shift">`;
                                }
                        shiftwiseTableHTML += ` </div>`;
                    }


                    // Append total remuneration and total conveyance row
                    tableHTML += `
                        <tr>
                            <td colspan="2"><strong>Total</strong></td>
                            <td><strong>${totalAmount.toFixed(2)}</strong></td>
                            <td><strong>${totalConveyance.toFixed(2)}</strong></td>
                        </tr>
                        <tr>
                            <td colspan="3"><strong>Grand Total (Remuneration + Conveyance)</strong></td>
                            <td><strong>${(totalAmount + totalConveyance).toFixed(2)}</strong></td>
                        </tr>
                    </tbody>
                    </table>`;

                    // Append the table to the div
                    $('.shift-wise-payment').html(tableHTML);
                    $('.shiftwise-html').html(shiftwiseTableHTML);
                },

                error: function(xhr, textStatus, error) {
                    console.error('Error:', textStatus, error);
                    // alert('An error occurred: ' + error);
                },
            });
        }


        $(document).ready(function() {
            let maxValue = '';
            cappingMapping(maxValue);
        });

        function cappingMapping(maxValue) {

            var totalAllotedCandidates = parseInt($('#AllottedCandidates').val()) || '';

            $('table td').each(function() {
                var cellText = $(this).text().trim(); // Get the text content of the td
                if (cellText.toLowerCase().includes("per candidate fixed")) {
                    var nextTd = $(this).nextAll('td').first(); // Get the next td element after hidden inputs
                    var nextInput = nextTd.find('input[name="ManPower[]"]');
                    if (nextInput.length > 0) {
                        if (!nextInput.hasClass('AutoCalculatedByCandidateNew')) {
                            nextInput
                                .addClass('AutoCalculatedByCandidate')
                                .attr('readonly', true)
                                .val(maxValue);
                            $('#AllottedCandidates').attr('readonly', true);
                        } else {
                            nextInput.attr('readonly', true).val(totalAllotedCandidates);
                        }
                    }

                }
            });

            $('.NoOfCandidates').each(function() {
                var DayCountValue = parseInt($(this).val()) || 0; // Parse the value as an integer
                var remainderCount;
                if (DayCountValue !== 0) {
                    remainderCount = Math.ceil(totalAllotedCandidates / DayCountValue); // Calculate remainder if DayCountValue is not 0 or 1
                    $(this).closest('tr').find('.CandidateWiseCount').attr('lang', remainderCount);
                } else {
                    $(this).closest('tr').find('.CandidateWiseCount').removeAttr('lang', remainderCount);
                }

            });
        }
    </script>
    {{-- ========================================= Observer/Deputy Observer Modal Section Here ===================================== --}}
    {{-- ========================================= Observer/Deputy Observer Modal Calculation On Duty & Mock Change ===================================== --}}
    <script>
        $(document).on('input', '.advance_payment, .duty_days, .mock_duty_days', function() {
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID

            // Input values
            let dutyDays = parseFloat($('#duty-days-' + rowId).val()) || 0;
            let mockDutyDays = parseFloat($('#mock-duty-days-' + rowId).val()) || 0;
            let advancePayment = parseFloat($('#advance-payment-' + rowId).val()) || 0;
            let observerRemuneration = '<?= $ObserverPerDayAmount ?>';
            let observerMock = '<?= $ObserverPerDayAmountMock ?>';
            let observerConveyance = '<?= $ObserverPerDayConveyanceAmount ?>';
            let observerMockConveyance = '<?= $ObserverPerDayConveyanceAmountMock ?>';
            let observerFood = '<?= $OBfoodAmount ?? 0 ?>'; // Base food amount for 1 duty day
            let tdsPercent = 10; // Fixed TDS percentage

            if(mockDutyDays > <?= json_encode($examDaysMock) ?>){
                alert('Mock Duty Days cannot be greater then ' + <?= json_encode($examDaysMock) ?>);
                $('#mock-duty-days-' + rowId).val('');
                return false;
            }
            if(dutyDays > <?= json_encode($totalDutyDays) ?>){
                alert('Duty Days cannot be greater then ' + <?= json_encode($totalDutyDays) ?>);
                $('#duty-days-' + rowId).val('');
                return false;
            }

            // Calculate observer remuneration, conveyance, and food charges
            let totalObserverRemuneration = (dutyDays * observerRemuneration);
            let totalObserverMock = (mockDutyDays * observerMock);
            let totalObserverConveyance = (dutyDays * observerConveyance);
            let totalObserverMockConveyance = (mockDutyDays * observerMockConveyance);
            let totalObserverFood = dutyDays * observerFood;

            // Total before deductions (include mock fields in calculations)
            let totalPayableBeforeDeductions = totalObserverRemuneration +
                totalObserverMock +
                totalObserverConveyance +
                totalObserverMockConveyance +
                totalObserverFood;

            // TDS calculation (10% of total observer remuneration)
            let tdsAmount = ((totalObserverRemuneration + totalObserverMock) * tdsPercent) / 100;

            // Net payable calculation
            let totalPayable = totalPayableBeforeDeductions - advancePayment - tdsAmount;

            // Update the respective fields
            $('#Observer-Remuneration-' + rowId).val(totalObserverRemuneration.toFixed(2));
            $('#Observer-Mock-Remuneration-' + rowId).val(totalObserverMock.toFixed(2));
            $('#Observer-Conveyance-' + rowId).val(totalObserverConveyance.toFixed(2));
            $('#Observer-Mock-Conveyance-' + rowId).val(totalObserverMockConveyance.toFixed(2));
            $('#Observer-Food-' + rowId).val(totalObserverFood.toFixed(2));
            $('#tds-percent-' + rowId).val(tdsAmount.toFixed(2));
            $('#amount_to_paid-' + rowId).val(totalPayable.toFixed(2));
        });

        $(document).on('input', '.tds_percent', function() { //alert();
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID

            // Input values
            let dutyDays = parseFloat($('#duty-days-' + rowId).val()) || 0;
            let mockDutyDays = parseFloat($('#mock-duty-days-' + rowId).val()) || 0;
            let advancePayment = parseFloat($('#advance-payment-' + rowId).val()) || 0;
            let observerRemuneration = '<?= $ObserverPerDayAmount ?>';
            let observerMock = '<?= $ObserverPerDayAmountMock ?>';
            let observerConveyance = '<?= $ObserverPerDayConveyanceAmount ?>';
            let observerMockConveyance = '<?= $ObserverPerDayConveyanceAmountMock ?>';
            let observerFood = '<?= $OBfoodAmount ?? 0 ?>'; // Base food amount for 1 duty day
            let tdsPercent = 10; // Fixed TDS percentage
            let tdsPercentVal = parseFloat($(this).val()) || 0;

            // Calculate observer remuneration, conveyance, and food charges
            let totalObserverRemuneration = (dutyDays * observerRemuneration);
            let totalObserverMock = (mockDutyDays * observerMock);
            let totalObserverConveyance = (dutyDays * observerConveyance);
            let totalObserverMockConveyance = (mockDutyDays * observerMockConveyance);
            let totalObserverFood = dutyDays * observerFood;

            // Total before deductions (include mock fields in calculations)
            let totalPayableBeforeDeductions = totalObserverRemuneration +
                totalObserverMock +
                totalObserverConveyance +
                totalObserverMockConveyance +
                totalObserverFood;
            let totalPayable = totalPayableBeforeDeductions - advancePayment;

            // Update the payable amount
            $('#amount_to_paid-' + rowId).val((totalPayable - tdsPercentVal).toFixed(2));
        });
        
        //choose unique ob
        $(document).on('change', '.dobchangeR', function() {
            var currentval=$(this).val();
            let rowId = $(this).attr('id').split('-').pop(); 
            if(rowId>1){
                for (let i = 1; i < rowId; i++) 
                {  
                   if($(`#deputy-observers-id-${i}`).val()==currentval)
                   {
                    alert("This value is already selected! Please choose a different one.");
                    $(this).val(''); // Clear the selection
                   }
                }
            }
          });
        //choose unique ob
        $(document).on('change', '.obchangeR', function() {
            var currentval=$(this).val();
            let rowId = $(this).attr('id').split('-').pop(); 
            // alert(rowId);
            if(rowId>1){
                for (let i = 1; i < rowId; i++) 
                {
                   if($(`#observer-id-${i}`).val()==currentval)
                   {
                    alert("This value is already selected! Please choose a different one.");
                    $(this).val(''); // Clear the selection
                   }
                }
            }
          });
        // Deputy Observer 
        $(document).on('input', '.deputy_advance_payment, .deputy_duty_days, .deputy_mock_duty_days', function() {
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID
            // Input values
            let dutyDays = parseFloat($('#deputy-duty-days-' + rowId).val()) || 0;
            let mockDutyDays = parseFloat($('#deputy-mock-duty-days-' + rowId).val()) || 0;
            let advancePayment = parseFloat($('#deputy-advance-payment-' + rowId).val()) || 0;
            let observerRemuneration = '<?= $DeputyObserverPerDayAmount ?>';
            let observerMock = '<?= $DeputyObserverPerDayAmountMock ?>';
            let observerConveyance = '<?= $DeputyObserverPerDayConveyanceAmount ?>';
            let observerMockConveyance = '<?= $DeputyObserverPerDayConveyanceAmountMock ?>';
            let observerFood = '<?= $DOBfoodAmount ?? 0 ?>'; // Base food amount for 1 duty day
            let tdsPercent = 10; // Fixed TDS percentage

            if (mockDutyDays > <?= json_encode($examDaysMock) ?>) {
                alert("Mock Duty Days cannot be greater than " + <?= json_encode($examDaysMock) ?>);
                $('#deputy-mock-duty-days-' + rowId).val('');
                return false;
            }

            if (dutyDays > <?= json_encode($totalDutyDays) ?>) {
                alert("Duty Days cannot be greater than " + <?= json_encode($totalDutyDays) ?>);
                $('#deputy-duty-days-' + rowId).val('');
                return false;
            }

            // Calculate observer remuneration, conveyance, and food charges
            let totalObserverRemuneration = (dutyDays * observerRemuneration);
            let totalObserverMock = (mockDutyDays * observerMock);
            let totalObserverConveyance = (dutyDays * observerConveyance);
            let totalObserverMockConveyance = (mockDutyDays * observerMockConveyance);
            let totalObserverFood = dutyDays * observerFood;

            // Total before deductions (include mock fields in calculations)
            let totalPayableBeforeDeductions = totalObserverRemuneration +
                totalObserverMock +
                totalObserverConveyance +
                totalObserverMockConveyance +
                totalObserverFood;

            // TDS calculation (10% of total observer remuneration)
            let tdsAmount = ((totalObserverRemuneration + totalObserverMock) * tdsPercent) / 100;

            // Net payable calculation
            let totalPayable = totalPayableBeforeDeductions - advancePayment - tdsAmount;

            // Update the respective fields
            $('#Deputy-Observer-Remuneration-' + rowId).val(totalObserverRemuneration.toFixed(2));
            $('#Deputy-Observer-Mock-Remuneration-' + rowId).val(totalObserverMock.toFixed(2));
            $('#Deputy-Observer-Conveyance-' + rowId).val(totalObserverConveyance.toFixed(2));
            $('#Deputy-Observer-Mock-Conveyance-' + rowId).val(totalObserverMockConveyance.toFixed(2));
            $('#Deputy-Observer-Food-' + rowId).val(totalObserverFood.toFixed(2));
            $('#deputy-tds-percent-' + rowId).val(tdsAmount.toFixed(2));
            $('#deputy_amount_to_paid-' + rowId).val(totalPayable.toFixed(2));
        });

        $(document).on('input', '.deputy_tds_percent', function() { //alert();
            let rowId = $(this).attr('id').split('-').pop(); // Get the row ID from the element's ID

            // Input values
            let dutyDays = parseFloat($('#deputy-duty-days-' + rowId).val()) || 0;
            let mockDutyDays = parseFloat($('#deputy-mock-duty-days-' + rowId).val()) || 0;
            let advancePayment = parseFloat($('#deputy-advance-payment-' + rowId).val()) || 0;
            let observerRemuneration = '<?= $DeputyObserverPerDayAmount ?>';
            let observerMock = '<?= $DeputyObserverPerDayAmountMock ?>';
            let observerConveyance = '<?= $DeputyObserverPerDayConveyanceAmount ?>';
            let observerMockConveyance = '<?= $DeputyObserverPerDayConveyanceAmountMock ?>';
            let observerFood = '<?= $DOBfoodAmount ?? 0 ?>'; // Base food amount for 1 duty day
            let tdsPercent = 10; // Fixed TDS percentage
            let tdsPercentVal = parseFloat($(this).val()) || 0;

            // Calculate observer remuneration, conveyance, and food charges
            let totalObserverRemuneration = (dutyDays * observerRemuneration);
            let totalObserverMock = (mockDutyDays * observerMock);
            let totalObserverConveyance = (dutyDays * observerConveyance);
            let totalObserverMockConveyance = (mockDutyDays * observerMockConveyance);
            let totalObserverFood = dutyDays * observerFood;

            // Total before deductions (include mock fields in calculations)
            let totalPayableBeforeDeductions = totalObserverRemuneration +
                totalObserverMock +
                totalObserverConveyance +
                totalObserverMockConveyance +
                totalObserverFood;
            let totalPayable = totalPayableBeforeDeductions - advancePayment;

            // Update the payable amount
            $('#deputy_amount_to_paid-' + rowId).val((totalPayable - tdsPercentVal).toFixed(2));
        });
        $('#AllottedCandidates').on('blur', function(){
            var CenterNo = '<?= $CC_center_nO ?>';
            if(this.value > 0){
                $('.shiftwise-payment-Amount-modal-btn').show();
                getshiftwisepayment(CenterNo);
            }
        })

        $(document).on('input', '.shiftwise-html input', function () {
        var $input       = $(this);
            var lang         = $input.attr('lang');
            var CandiadteCnt = parseFloat($('#' + lang).val());
            var $form        = $input.closest('.custom-form');
            var persons      = parseFloat($form.find('.NoOfPersonsDynamic').val());
            var role         = $form.find('.NoOfPersonsDynamic').attr('role-id');
            var $existingErr = $input.siblings('.max-error');

            // compute & store max-allowed
            if (CandiadteCnt && persons && role) {
                let amount = (role === 'ROOM_INVIGILATOR')
                            ? Math.ceil(CandiadteCnt / persons) * 2
                            : Math.ceil(CandiadteCnt / persons);

                $input
                .attr('max', amount)
                .data('max-allowed', amount);
            }

            // re-validate
            let val = parseFloat($input.val());
            let max = parseFloat($input.data('max-allowed'));

            // ensure there's exactly one error element
            if (!$existingErr.length) {
                $existingErr = $('<span class="max-error text-danger" style="display:none;"></span>');
                $input.after($existingErr);
            }

            if (val > max) {
                $input.val(max);
                $existingErr
                .text('Maximum '  + max + ' persons allowed.')
                .show();
            } else {
                $existingErr.hide();
            }
        });



        $(document).on('click', '.calculateAmount', function () {
            var parentForm = $(this).closest('.custom-form');
            var Role = parentForm.find('.NoOfPersonsDynamic').attr('role-id');
            let totalAmount = 0;
            let totalDutyDays = 0;   // To count days with RI
            let totalRIOverall = 0;  // To sum all RIs
            let resultHtml = "<table class='table table-bordered'><tr><th>Day</th><th>Max Person</th><th>Total Person</th><th>Amount</th></tr>";
            
            let shiftRates = {
                S1: parseFloat(parentForm.find('.NoOfPersonsDynamic').attr('shift1')), // 600
                S2: parseFloat(parentForm.find('.NoOfPersonsDynamic').attr('shift2')), // 1000
                S3: parseFloat(parentForm.find('.NoOfPersonsDynamic').attr('shift3')), // 1500
                S4: parseFloat(parentForm.find('.NoOfPersonsDynamic').attr('shift4'))  // user-defined (e.g., 0)
            };

            for (let day = 1; day <= 12; day++) {
                let totalRI = 0;
                let amount = 0;

                let shiftCounts = {
                    S1: parseFloat(parentForm.find('.D' + day + 'S1').val()) || 0,
                    S2: parseFloat(parentForm.find('.D' + day + 'S2').val()) || 0,
                    S3: parseFloat(parentForm.find('.D' + day + 'S3').val()) || 0,
                    S4: parseFloat(parentForm.find('.D' + day + 'S4').val()) || 0
                };

                // Calculate total RI: remove overlapping counts
                // Total RI = S4 + (S3 - S4) + (S2 - S3) + (S1 - S2)
                totalRI = shiftCounts.S4
                        + Math.max(0, shiftCounts.S3 - shiftCounts.S4)
                        + Math.max(0, shiftCounts.S2 - shiftCounts.S3)
                        + Math.max(0, shiftCounts.S1 - shiftCounts.S2);

                // Calculate amount
                amount += shiftCounts.S4 * shiftRates.S4;
                amount += (shiftCounts.S3 - shiftCounts.S4) * shiftRates.S3;
                amount += (shiftCounts.S2 - shiftCounts.S3) * shiftRates.S2;
                amount += (shiftCounts.S1 - shiftCounts.S2) * shiftRates.S1;

                totalAmount += amount;

                if (totalRI > 0) {
                    totalDutyDays += 1;
                    totalRIOverall += totalRI;
                    resultHtml += `<tr>
                        <td>Day ${day}</td>
                        <td>${Math.max(...Object.values(shiftCounts))}</td>
                        <td>${totalRI}</td>
                        <td>${amount}</td>
                    </tr>`;
                }
            }

            resultHtml += `<tr><th colspan="3">Total Amount</th><th>${totalAmount}</th></tr></table>`;
            parentForm.find('.calculation-result').html(resultHtml);
            $('#'+Role).val(totalAmount);
            let $row = $("#" + Role).closest("tr");
            $row.find("input.DutyDays").val(totalDutyDays).prop('readonly', true); // Total days with RI
            $row.find("input.ManPower").val(totalRIOverall).prop('readonly', true); // Sum of totalRI
        });


    </script>
@endsection