@extends('layouts.admin')
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <style>
                .btn-header-link::after {
                    display: none !important;
                }

                .modal-dialog {
                    max-width: 90%;
                }

                /* file upload */
                .file-upload {
                    display: flex;
                    align-items: center;
                    font-family: Arial, sans-serif;
                    margin-bottom: 10px;
                }

                .file-input {
                    display: none;
                }

                .file-label {
                    display: inline-block;
                    padding: 8px 12px;
                    border: 1px solid #ccc;
                    border-radius: 4px;
                    background-color: #f8f9fa;
                    cursor: pointer;
                    margin-right: 10px;
                    white-space: nowrap;
                }

                .file-label:hover {
                    background-color: #e2e6ea;
                }

                .file-name {
                    font-size: 14px;
                    color: #6c757d;
                    max-width: 200px;
                    /* Adjust the max-width as needed */
                    white-space: nowrap;
                    overflow: hidden;
                    text-overflow: ellipsis;
                }

                .field-centrebillmst-observerfile {
                    margin-bottom: 0px !important;
                }

                /* .disabled-input {
                             pointer-events: none;
                         } */
            </style>
            <?php if (isset($checkfrom) && !empty($checkfrom)) {
                if ($checkfrom->Submitted == 1) {
                    $fromvalue = 1;
                } else {
                    $fromvalue = 0;
                }
            }
            $dutydays = [];
            $MockDutyDays = [];

          
            if(count($UserData) > 1){
                foreach ($ShiftWiseBillDataMultiple as $index => $ShiftWiseBillData) {
                    $dutydays = [];
                    $MockDutyDays = [];
                    for ($i = 1; $i <= 12; $i++) {
                        $aKeyS1 = "A{$i}S1";
                        $aKeyS2 = "A{$i}S2";
                        $aKeyS3 = "A{$i}S3";
                        $aKeyS4 = "A{$i}S4";
                        $dateKey = "Date_{$i}";
                
                        if (
                            !empty($ShiftWiseBillData->$aKeyS1) ||
                            !empty($ShiftWiseBillData->$aKeyS2) ||
                            !empty($ShiftWiseBillData->$aKeyS3) ||
                            !empty($ShiftWiseBillData->$aKeyS4)
                        ) {
                            if (!empty($ShiftWiseBillData->$dateKey)) {
                                $dateStr = $ShiftWiseBillData->$dateKey;
                                $timestamp = strtotime($dateStr);
                                if ($timestamp) {
                                    $dutydays[] = date('d-m-Y', $timestamp);
                                    $MockDutyDays[] = date('d-m-Y', strtotime('-1 day', $timestamp));
                                }
                            }
                        }
                    }
    
                    $AllDutyDays[$index] = $dutydays;
                    $AllMockDutyDays[$index] = $MockDutyDays;

                    
                }
               
                
                // $dutydayss = [];
                foreach ($AllDutyDays as $recordDays) {
                    foreach ($recordDays as $dateStr) {
                        $dutydays[] = date('d-m-Y', strtotime($dateStr));
                    }
                }
               $dutydays = array_unique($dutydays);
               $totalDutyDays =  count($dutydays);
            //    prd($dutydays);

            }else{
                for ($i = 1; $i <= 12; $i++) {
                    $aKeyS1 = "A{$i}S1";
                    $aKeyS2 = "A{$i}S2";
                    $aKeyS3 = "A{$i}S3";
                    $aKeyS4 = "A{$i}S4";
                    $dateKey = "Date_{$i}";
    
                    if (!empty($ShiftWiseBillData->$aKeyS1) || !empty($ShiftWiseBillData->$aKeyS2) || !empty($ShiftWiseBillData->$aKeyS3) || !empty($ShiftWiseBillData->$aKeyS4)) {
                        if (!empty($ShiftWiseBillData->$dateKey)) {
                            $dutydays[] = date('d-m-Y', strtotime($ShiftWiseBillData->$dateKey));
                            $prevDate = date('d-m-Y', strtotime($ShiftWiseBillData->$dateKey . ' -1 day'));
                            $MockDutyDays[] = $prevDate;
                        }
                    }
                }
            }
            


            ?>
            <div class="login-5 mt-50 mb-50">
                <ul class="nav nav-pills justify-content-left mb-3">
                    @if ($BillData->BillType == 1)
                        <li class="active">
                            <a href="#local" id="localBtn" class="d-none btn btn-success me-3 mb-2 tablinks"
                                style="padding:13px; font-size: 18px;color:white" data-toggle="tab"
                                onclick="openTab(event, 'local')">Remuneration</a>
                        </li>
                    @elseif($BillData->BillType == 2)
                        <li class="active">
                            <a href="#local" id="localBtn" class="btn btn-success me-3 mb-2 tablinks"
                                style="padding:13px; font-size: 18px;color:white" data-toggle="tab"
                                onclick="openTab(event, 'local')">Remuneration</a>
                        </li>
                        <input type="hidden" value="<?= $fromvalue ?? '' ?>" id="fromvalue">
                        <li id="outstation_li">
                            <a href="#outstation" id="outstationBtn" class="btn btn-secondary tablinks"
                                style="padding:13px; font-size: 18px;color:white" data-toggle="tab"
                                onclick="openTab(event, 'outstation')">Outstation TA Bill
                            </a>
                        </li>
                    @endif
                </ul>
                <div class="accordion">
                    <div class="card local" id="local">
                        <div class="card-header" id="faqhead1">
                            <a href="javascript:void(0)" class="btn-header-link fs-4 fw-bold d-block text-center"
                                aria-expanded="true" aria-controls="faq1">
                                @if (Session::get('role') == config('constants.RoleName')['10'])
                                    Annexure A-4 (TO BE FILLED BY VIRTUAL OBSERVER AND SUBMITTED TO RC )
                                @elseif(Session::get('role') == config('constants.RoleName')['3'])
                                    Annexure A-4 (TO BE FILLED BY FLYING SQUAD OBSERVER AND SUBMITTED TO RC )
                                @else
                                    Annexure A-4 (TO BE FILLED BY OBSERVER/SPECIAL
                                    Observer AND SUBMITTED TO RC )
                                @endif


                            </a>
                        </div>
                        <div class="custom-form RemunerationMain">
                            <form method="POST" action="{{ route('tabillSave') }}" enctype="multipart/form-data">
                                @csrf
                                <input type="hidden" name="event_type" value ="1">
                                <div id="faq1" class="collapse show" aria-labelledby="faqhead1" data-parent="#faq1">
                                    <div class="card-body">
                                        <div class="custom-form">
                                            <div class="row">

                                                @if (Session::get('role') != config('constants.RoleName')['10'])
                                                    <div class="col-md-12">
                                                        <div class="d-flex align-items-center">
                                                            <label class="form-label fs-5 fw-bold">Select Bill
                                                                Type</label><br>
                                                            @if ($BillData->BillType == 1)
                                                                <input type="radio" style="margin:10px" name="billType"
                                                                    value="1" checked> Local
                                                            @elseif($BillData->BillType == 2)
                                                                <input type="radio" class="d-none" style="margin:10px"
                                                                    name="billType" value="1" checked><b
                                                                    class="d-none"> Local</b>
                                                                <input type="radio" checked style="margin:10px"
                                                                    name="billType" value="2">
                                                                Local + Outstation
                                                            @endif
                                                            <div class="invalid-feedback"></div>
                                                        </div>
                                                    </div><br>
                                                @endif
                                                @if (isset($ArrayFields) && !empty($ArrayFields))
                                                    @foreach ($ArrayFields as $row)
                                                        <div class="col-md-6">
                                                            <div class="form-group">
                                                                <label class="form-label">{{ $row['fieldLabel'] }}
                                                                    @if ($row['isRequired'] == 1)
                                                                        <span class="text-danger">*</span>
                                                                    @endif
                                                                </label>
                                                                <input
                                                                    @if ($row['fieldType'] == 'number') type="text"
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')"
                                                                                @else
                                                                                    type="{{ $row['fieldType'] }}" @endif
                                                                    class="form-control form-control-sm common-fields"
                                                                    value="{{ $row['fieldValue'] }}"
                                                                    @if ($row['readonly'] == 1) readonly @endif
                                                                    maxlength="{{ $row['maxLength'] }}"
                                                                    minlength="{{ $row['minLength'] }}">
                                                                <div class="invalid-feedback"></div>
                                                            </div>
                                                        </div>
                                                    @endforeach
                                                @endif

                                                <div class="table-responsive mt-30">
                                                    <table class="table cco-table table-bordered RemunerationOnlineTable">
                                                        <thead>
                                                            <tr>
                                                                <th width="5%">#</th>
                                                                <th width="40%">Details</th>
                                                                <th width="15%">Duty Dates </th>
                                                                <th width="10%">Duty days </th>
                                                                <th width="30%">Amount<span class="text-danger"> *
                                                                    </span> </th>

                                                            </tr>
                                                        </thead>
                                                        <tbody>
                                                            @php
                                                                $i = 0;
                                                                //echo "Hello ".$BillData->A_MT;
                                                                // prd($ShiftCountArr);
                                                            @endphp
                                                            @if (isset($RemunerationFieldsData) && !empty($RemunerationFieldsData))
                                                                @foreach ($RemunerationFieldsData as $k => $Remuneration)
                                                                    @php
                                                                        $i++;
                                                                        $Remuneration = (array) $Remuneration;
                                                                        $totalRemuneratinAmt = 0;
                                                                        $shiftAmount_Separate = [];
                                                                    @endphp
                                                                    @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL')
                                                                        @foreach ($ShiftCountArr as $shiftVal)
                                                                            @php
                                                                                $shiftAmount_Separate[] =
                                                                                    $Remuneration[
                                                                                        'Remuneration Amount_S' .
                                                                                            $shiftVal
                                                                                    ];
                                                                                $shiftAmount =
                                                                                    $Remuneration[
                                                                                        'Remuneration Amount_S' .
                                                                                            $shiftVal
                                                                                    ];
                                                                                $totalRemuneratinAmt += $shiftAmount;
                                                                            @endphp
                                                                        @endforeach
                                                                    @else
                                                                        @php
                                                                            $totalRemuneratinAmt =
                                                                                $Remuneration['Remuneration Amount_S1'];
                                                                        @endphp
                                                                    @endif

                                                                    {{-- @php prd($shiftAmount_Separate);@endphp --}}

                                                                    @if ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] != '')
                                                                        <tr>
                                                                            <input type="hidden"
                                                                                value="{{ $BillData->A_Dutydays }}"
                                                                                name="Remuneration##Days" />
                                                                            @if ($Remuneration['isTds'] == 1)
                                                                                <input type="hidden" class="tds"
                                                                                    value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                                    name="TDS##Percent" />
                                                                            @endif

                                                                            <input type="hidden" class="RemunerationAmount"
                                                                                name="Remuneration##Rate"
                                                                                value="{{ $totalRemuneratinAmt }}" />


                                                                            <td>*</td>
                                                                            <td>{{ $Remuneration['Remuneration Text'] }}
                                                                            </td>
                                                                            <td> <?php echo str_replace(',', '<br>', implode(',', $dutydays)) ?? ''; ?> </td>
                                                                            <td> <?php echo $BillData->A_Dutydays ?? ''; ?> </td>
                                                                            <td><input type="text"
                                                                                    class="form-control form-control-sm RemunerationSection "
                                                                                    readonly="readonly" maxlength=8
                                                                                    name="{{ $Remuneration['Field_Name'] }}"
                                                                                    value=""
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')">
                                                                            </td>
                                                                        </tr>
                                                                    @else
                                                                        @if ($BillData->A_MT == 1)
                                                                            <tr>
                                                                                @if ($Remuneration['isTds'] == 1)
                                                                                    <input type="hidden" class="tds"
                                                                                        value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                                        name="TDS##Percent" />
                                                                                @endif
                                                                                <input type="hidden"
                                                                                    class="RemunerationAmount"
                                                                                    value="{{ $totalRemuneratinAmt }}" />

                                                                                <td>*</td>
                                                                                <td>{{ $Remuneration['Remuneration Text'] }}
                                                                                </td>
                                                                                @if (
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 0)
                                                                                    <td>{{ isset($BillData->Mock_Date) && !empty($BillData->Mock_Date) ? date('d-m-Y', strtotime($BillData->Mock_Date)) : '' }}
                                                                                    </td>
                                                                                @elseif(
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 1)
                                                                                    <td>{!! str_replace(',', '<br>', implode(',', $MockDutyDays)) ?? '' !!} </td>
                                                                                @else
                                                                                    @if ($Remuneration['No_ of Days'] == 1)
                                                                                        <td>{!! str_replace(',', '<br>', implode(',', $dutydays)) ?? '' !!} </td>
                                                                                    @else
                                                                                        <td> - </td>
                                                                                    @endif
                                                                                @endif

                                                                                @if (
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 0)
                                                                                    <td> 1 </td>
                                                                                @elseif(
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 1)
                                                                                    <td>
                                                                                        {{ $BillData->A_Dutydays ?? '' }}
                                                                                    </td>
                                                                                @elseif($Remuneration['No_ of Person'] == 1)
                                                                                    <td>
                                                                                        @if(isset($UserData) && count($UserData) > 1)
                                                                                            {{ $totalDutyDays ?? '' }}
                                                                                        @else
                                                                                           {{ $BillData->A_Dutydays ?? '' }}
                                                                                        @endif
                                                                                      
                                                                                    </td>
                                                                                @else
                                                                                    <td> - </td>
                                                                                @endif
                                                                                <td>


                                                                                    <input type="text"
                                                                                        @if ($Remuneration['Source Name'] == 'TDS Amount') id="tds"
                                                         @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                             id="advancePayment" @endif
                                                                                        @if ($Remuneration['readonly'] == 1) readonly="readonly" @endif
                                                                                        class="form-control form-control-sm
                                                             @if ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') mockdrilldutydays @endif
                                                             @if (
                                                                 $Remuneration['Source Name'] != 'TDS Amount' &&
                                                                     $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                     $Remuneration['Source Name'] != 'Miscellanous Charge') RemunerationSection
                                                             @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                                 valid-field-1
                                                             @elseif ($Remuneration['Source Name'] == 'Miscellanous Charge')
                                                                 RemunerationSection valid-field-1 MiscellanousCharge @endif"
                                                                                        maxlength="8"
                                                                                        @if ($Remuneration['isExtrafield'] == 1) name="Extrafields[{{ $Remuneration['Field_Name'] }}]" @else name="{{ $Remuneration['Field_Name'] }}" @endif
                                                                                        onkeypress="return blockSpecialChar(event, 'numeric')"
                                                                                        @if ($Remuneration['Source Name'] == 'Miscellanous Charge') value="{{ isset($getlocalbillDetail->Amount) ? number_format($getlocalbillDetail->Amount, 0, '', '') : '' }}"
                                                         @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                             value="{{ isset($getlocalbillDetail->{'Advance Payment'}) ? number_format($getlocalbillDetail->{'Advance Payment'}, 0, '', '') : '' }}" @endif>
                                                                                    @if ($Remuneration['isAttechment'] == 1)
                                                                                        <div class="file-upload mt-3 mb-3"
                                                                                            data-upload-id="1">
                                                                                            <label for="fileInput1"
                                                                                                class="file-label fw-semi-bold mb-0"
                                                                                                data-label-id="1">Attach
                                                                                                Document</label>
                                                                                            <input type="file"
                                                                                                name="files[{{ $Remuneration['Field_Name'] }}]"
                                                                                                id="AttachDocument"
                                                                                                class="form-control file-input mt-3 mb-3 form-control-sm @if ($Remuneration['isAttechmentRequired'] == 1)  @endif">
                                                                                            <span class="file-name"
                                                                                                data-name-id="2">No file
                                                                                                chosen</span>
                                                                                        </div>
                                                                                    @endif
                                                                                    @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL')
                                                                                        <a href="javascript:void(0);"
                                                                                            data-dutyDate="{{ json_encode($dutydays) ?? '' }}"
                                                                                            data-shiftcount="{{ json_encode($ShiftCountArr) ?? 0 }}"
                                                                                            data-shiftamount="{{ json_encode($shiftAmount_Separate) ?? 0 }}"
                                                                                            data-totalamount="{{ $totalRemuneratinAmt ?? 0 }}"
                                                                                            class="float-right text-success text-bold detailsModal"><b>View
                                                                                                Details</b></a>
                                                                                    @endif
                                                                                </td>
                                                                            </tr>
                                                                        @elseif($Remuneration['Source Code'] != 'MOCKDRILL' && $Remuneration['Source Code'] != 'MOCKDRILL CONVEYANCE')
                                                                            <tr>
                                                                                @if ($Remuneration['isTds'] == 1)
                                                                                    <input type="hidden" class="tds"
                                                                                        value="{{ $Remuneration['tdsPrecentage'] }}"
                                                                                        name="TDS##Percent" />
                                                                                @endif
                                                                                <input type="hidden"
                                                                                    class="RemunerationAmount"
                                                                                    value="{{ $totalRemuneratinAmt }}" />


                                                                                <td>*</td>
                                                                                <td>{{ $Remuneration['Remuneration Text'] }}
                                                                                </td>
                                                                                @if ($Remuneration['No_ of Days'] == 1)
                                                                                    <td>{!! str_replace(',', '<br>', implode(',', $dutydays)) ?? '' !!} </td>
                                                                                @else
                                                                                    <td></td>
                                                                                @endif

                                                                                @if (
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 0)
                                                                                    <td> 1 </td>
                                                                                @elseif(
                                                                                    ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                                                        $BillData->mockval == 1)
                                                                                    <td>{{ $BillData->A_Dutydays ?? '' }}
                                                                                    </td>
                                                                                @elseif($Remuneration['No_ of Person'] == 1)
                                                                                    <td>
                                                                                        {{ $BillData->A_Dutydays ?? '' }}
                                                                                    </td>
                                                                                @else
                                                                                    <td> - </td>
                                                                                @endif
                                                                                <td>


                                                                                    <input type="text"
                                                                                        @if ($Remuneration['Source Name'] == 'TDS Amount') id="tds"
                                                            @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                                id="advancePayment" @endif
                                                                                        @if ($Remuneration['readonly'] == 1) readonly="readonly" @endif
                                                                                        class="form-control form-control-sm
                                                                @if ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') mockdrilldutydays @endif
                                                                @if (
                                                                    $Remuneration['Source Name'] != 'TDS Amount' &&
                                                                        $Remuneration['Source Name'] != 'Advance Payment' &&
                                                                        $Remuneration['Source Name'] != 'Miscellanous Charge') RemunerationSection
                                                                @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                                    valid-field-1
                                                                @elseif ($Remuneration['Source Name'] == 'Miscellanous Charge')
                                                                    RemunerationSection valid-field-1 MiscellanousCharge @endif"
                                                                                        maxlength="8"
                                                                                        @if ($Remuneration['isExtrafield'] == 1) name="Extrafields[{{ $Remuneration['Field_Name'] }}]" @else name="{{ $Remuneration['Field_Name'] }}" @endif
                                                                                        onkeypress="return blockSpecialChar(event, 'numeric')"
                                                                                        @if ($Remuneration['Source Name'] == 'Miscellanous Charge') value="{{ isset($getlocalbillDetail->Amount) ? number_format($getlocalbillDetail->Amount, 0, '', '') : '' }}"
                                                            @elseif ($Remuneration['Source Name'] == 'Advance Payment')
                                                                value="{{ isset($getlocalbillDetail->{'Advance Payment'}) ? number_format($getlocalbillDetail->{'Advance Payment'}, 0, '', '') : '' }}" @endif>

                                                                                    @if ($Remuneration['isAttechment'] == 1)
                                                                                        <div class="file-upload mt-3 mb-3"
                                                                                            data-upload-id="1">
                                                                                            <label for="fileInput1"
                                                                                                class="file-label fw-semi-bold mb-0"
                                                                                                data-label-id="1">Attach
                                                                                                Document</label>
                                                                                            <input type="file"
                                                                                                name="files[{{ $Remuneration['Field_Name'] }}]"
                                                                                                id="AttachDocument"
                                                                                                class="form-control uploaded_file uploaded_file file-input mt-3 mb-3 form-control-sm @if ($Remuneration['isAttechmentRequired'] == 1)  @endif">
                                                                                            <span class="file-name"
                                                                                                data-name-id="2">No file
                                                                                                chosen</span>
                                                                                        </div>
                                                                                    @endif
                                                                                    @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL')
                                                                                        <a href="javascript:void(0);"
                                                                                            data-dutyDate="{{ json_encode($dutydays) ?? '' }}"
                                                                                            data-shiftcount="{{ json_encode($ShiftCountArr) ?? 0 }}"
                                                                                            data-shiftamount="{{ json_encode($shiftAmount_Separate) ?? 0 }}"
                                                                                            data-totalamount="{{ $totalRemuneratinAmt ?? 0 }}"
                                                                                            class="float-right text-success text-bold detailsModal"><b>View
                                                                                                Details</b></a>
                                                                                    @endif
                                                                                </td>
                                                                            </tr>
                                                                        @endif
                                                                    @endif
                                                                @endforeach

                                                                <tr>
                                                                    <td>*</td>
                                                                    <td class='fw-bold' colspan="3">TOTAL AMOUNT
                                                                        CLAIMED</td>

                                                                    <td><input type="text"
                                                                            class="form-control unsetValue form-control-sm required"
                                                                            id="NetPaybleAmount" maxlength=8 minlength=1
                                                                            name="Net##Payable##After##Deduction"
                                                                            onkeypress="return blockSpecialChar(event,'numeric')"
                                                                            readonly></td>
                                                                </tr>
                                                            @endif
                                                        </tbody>
                                                    </table>

                                                </div>
                                            </div>
                                        </div>

                                        <?php  if(isset($checkfrom) && ($checkfrom->Submitted == 1 || $checkfrom->Submitted == 0)) {  ?>
                                        <p>
                                        <h3 class="text-center text-danger">This Bill Already Submited</h3>
                                        </p>
                                        <?php } else { ?>
                                        <div class="text-end">
                                            <button class="btn btn-warning me-4 mb-2 mt-0" id="preview"
                                                type="button">Preview</button>
                                            <!-- <button type="Submit" id="outsideFormPreviewBt111111" class="btn btn-warning me-2 modalPopupOut">Preview</button>                  -->
                                            <input type="Submit" class='btn btn-success d-none  finalSubmitOfflineBtn'
                                                name="submit" value="1">


                                        </div>
                                        <?php } ?>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                <!-- Outstaion from  -->

                <div class="tab-pane active local" id="outstation">
                    <div class="row no-gutters">
                        <div class="col-sm-12">
                            <div id="main">
                                <div class="">
                                    <form id="outstation-form" action="{{ route('tabillSave') }}" method="post"
                                        autocomplete="off" enctype="multipart/form-data">
                                        @csrf
                                        <div class="accordion" id="faq">
                                            <div class="card">
                                                <div class="card-header" id="faqhead1">
                                                    <a href="#" class="btn btn-header-link fs-4 text-center"
                                                        data-toggle="collapse" data-target="#faq3" aria-expanded="true"
                                                        aria-controls="faq3">Outstation TA Claim Form (TO BE FILLED BY
                                                        OUTSTAION TRAVELERS ONLY)</a>
                                                </div>
                                                <div id="faq1" class="collapse show" aria-labelledby="faqhead1"
                                                    data-parent="#faq1">
                                                    <div class="card-body">
                                                        <div class="custom-form">
                                                            <div class="row">
                                                                @if (isset($ArrayFields) && !empty($ArrayFields))
                                                                    @foreach ($ArrayFields as $row)
                                                                        <div class="col-md-6">
                                                                            <div class="form-group">
                                                                                <label
                                                                                    class="form-label">{{ $row['fieldLabel'] }}
                                                                                    @if ($row['isRequired'] == 1)
                                                                                        <span class="text-danger">*</span>
                                                                                    @endif
                                                                                </label>
                                                                                <input
                                                                                    @if ($row['fieldType'] == 'number') type="text"
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')"
                                                                                @else
                                                                                    type="{{ $row['fieldType'] }}" @endif
                                                                                    class="form-control form-control-sm common-fields"
                                                                                    name="{{ $row['fieldName'] }}"
                                                                                    value="{{ $row['fieldValue'] }}"
                                                                                    id= "{{ $row['fieldName'] }}"
                                                                                    @if ($row['readonly'] == 1) readonly @endif
                                                                                    maxlength="{{ $row['maxLength'] }}"
                                                                                    minlength="{{ $row['minLength'] }}">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                        </div>
                                                                    @endforeach
                                                                @endif
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="card">
                                                <div class="card-header" id="faqhead2">
                                                    <a href="#" class="btn btn-header-link fs-4 text-center"
                                                        data-toggle="collapse" data-target="#faq4" aria-expanded="true"
                                                        aria-controls="faq4">Amount Claimed (Details Overleaf)</a>
                                                </div>
                                                <div id="faq4" class="collapse show" aria-labelledby="faqhead2"
                                                    data-parent="#faq">
                                                    <div class="card-body">
                                                        <div class="table-responsive">
                                                            <!-- <div class="summary">Showing <b>1-15</b> of <b>20</b> items.</div> -->
                                                            <table
                                                                class="table table-striped table-bordered TableAmountClaimed">
                                                                <thead class="thead-light">
                                                                    <tr>
                                                                        <th>Sr. No.</th>
                                                                        <th>Expenditure Head</th>
                                                                        <th>Amount </th>
                                                                        <!-- <th>Receipt Serial Number</th> -->
                                                                    </tr>
                                                                </thead>
                                                                <tbody>
                                                                    <tr>
                                                                        <td>1</td>
                                                                        <td>Transportation</td>
                                                                        <td id="fare-amount"> </td>
                                                                        <!-- <td> </td> -->
                                                                    </tr>
                                                                    <tr>
                                                                        <td>2</td>
                                                                        <td>Hotel (Boarding) Expenses</td>
                                                                        <td id="room-rent"> </td>
                                                                        <!-- <td> </td> -->
                                                                    </tr>
                                                                    <tr>
                                                                        <td>3</td>
                                                                        <td>Food Expenses</td>
                                                                        <td id="food-expense"></td>
                                                                        <!-- <td> </td> -->
                                                                    </tr>
                                                                    <tr>
                                                                        <td></td>
                                                                        <td><strong>TOTAL AMOUNT</strong></td>
                                                                        <td id="expense-total-amount"> </td>
                                                                        <!-- <input type="hidden" id="expense-total-amount-input" name="OutstationTotalAmount" class="expense-total-amount" readonly> -->
                                                                    </tr>
                                                                </tbody>
                                                            </table>

                                                            <p>
                                                                Certified that the particulars filled in above are
                                                                correct and true. All the expenditure incurred/money
                                                                paid is in the intrest of organisation.
                                                            </p>
                                                            <!-- <p><b>This document does not require a physical signature as it contains a computer-generated name.</b></p> -->
                                                            <div class="row">
                                                                <div class="col-md-8 mb-0 pb-0">
                                                                    <p>
                                                                        <span><strong>(Signature, ID &amp; Seal of City
                                                                                Coordinator)</strong></span>
                                                                    </p>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="card">
                                                <div class="card-header" id="faqhead6">
                                                    <a href="#" class="btn btn-header-link fs-4 text-center"
                                                        data-toggle="collapse" data-target="#faq6" aria-expanded="true"
                                                        aria-controls="faq6">(A) Travelling Details:</a>
                                                </div>
                                                <div id="faq6" class="collapse show" aria-labelledby="faqhead6"
                                                    data-parent="#faq6">
                                                    <div class="card-body">
                                                        <div class="table-responsive">
                                                            <table
                                                                class="table table-striped table-bordered travel-details-tbl">
                                                                <thead class="thead-light">
                                                                    <tr>
                                                                        <th colspan="3">Departure</th>
                                                                        <th colspan="3">Arrival</th>
                                                                        <th>Mode of</th>
                                                                        <th>Travel Type</th>
                                                                        <th>Distance</th>
                                                                        <th>Air/Rail/Taxi</th>
                                                                        <th>Amount of</th>
                                                                        <th>Eligible Taxes</th>
                                                                        <th style="min-width: 200px !important;">File
                                                                        </th>
                                                                        <th>Action</th>
                                                                    </tr>
                                                                </thead>
                                                                <tbody>
                                                                    <tr>
                                                                        <td>Date</td>
                                                                        <td>Time</td>
                                                                        <td>From</td>
                                                                        <td>Date</td>
                                                                        <td>Time</td>
                                                                        <td>To</td>
                                                                        <td>Journey</td>
                                                                        <td></td>
                                                                        <td>in Kms</td>
                                                                        <td>Receipt No</td>
                                                                        <td>Fare Paid (Air/Rail/Taxi)</td>
                                                                        <td></td>
                                                                        <td>Copy of Bill/RC</td>
                                                                        <td>Action</td>
                                                                    </tr>
                                                                    <tr class="travel-row">
                                                                        <td>
                                                                            <div>
                                                                                <input type="date"
                                                                                    name="TabillMst[DepartureDate][]"
                                                                                    class="hasDatepicker date-input p-2 valid-field"
                                                                                    placeholder="dd-mm-yyyy"
                                                                                    id="DepartureDate0"
                                                                                    onchange="dateTime(this.id,this.value,0)">
                                                                                <div class="invalid-feedback d-none">
                                                                                </div>
                                                                            </div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-DepartureTime0">
                                                                                <input type="time" id="DepartureTime0"
                                                                                    class="p-2 valid-field time-input"
                                                                                    name="TabillMst[DepartureTime][]"
                                                                                    autocomplete="off"
                                                                                    onchange="dateTime(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-DepartureFrom0">
                                                                                <input type="text" id="DepartureFrom0"
                                                                                    class="p-2 valid-field"
                                                                                    name="TabillMst[DepartureFrom][]"
                                                                                    placeholder="From"
                                                                                    oninput="inputData(this.id,this.value,0)"
                                                                                    onkeypress="return lettersOnly(event)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <input type="date"
                                                                                name="TabillMst[ArrivalDate][]"
                                                                                class="hasDatepicker date-input p-2 valid-field"
                                                                                placeholder="dd-mm-yyyy" id="ArrivalDate0"
                                                                                onchange="dateTime(this.id,this.value,0)">
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-ArrivalTime0">
                                                                                <input type="time" id="ArrivalTime0"
                                                                                    class="p-2 valid-field time-input"
                                                                                    name="TabillMst[ArrivalTime][]"
                                                                                    autocomplete="off"
                                                                                    onchange="dateTime(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-ArrivalTo0">
                                                                                <input type="text" id="ArrivalTo0"
                                                                                    class="p-2 valid-field"
                                                                                    name="TabillMst[ArrivalTo][]"
                                                                                    placeholder="To"
                                                                                    oninput="inputData(this.id,this.value,0)"
                                                                                    onkeypress="return lettersOnly(event)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td id="">
                                                                            <select name="TabillMst[JourneyMode][]"
                                                                                placeholder="Journey"
                                                                                class="p-2 valid-field" id="JourneyMode0"
                                                                                onchange="dateTime(this.id,this.value,0);addTextBoxFun(0,this.value)">
                                                                                <option value=" ">--Select--</option>
                                                                                <option value="By Air">By Air</option>
                                                                                <option value="By Railways">By Railways
                                                                                </option>
                                                                                <option value="By roadways">By roadways
                                                                                </option>
                                                                                <option value="By own vehicle">By own
                                                                                    vehicle</option>
                                                                                <option value="Others">Others</option>
                                                                            </select>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                            <input type="text"
                                                                                name="TabillMst[OtherJourneyMode][]"
                                                                                placeholder="Enter other journey mode"
                                                                                class="p-2 mt-1 d-none"
                                                                                id="OtherJourneyMode0"
                                                                                oninput="inputData(this.id,this.value,0)">
                                                                        </td>
                                                                        <td id="">
                                                                            <select name="TabillMst[TravelType][]"
                                                                                placeholder="Journey"
                                                                                class="p-2 valid-field" id="TravelType0"
                                                                                onchange="dateTime(this.id,this.value,0);makeReadonlyFun(0,this.value)">
                                                                                <option value=" ">--Select--</option>
                                                                                <option value="local">Local</option>
                                                                                <option value="outstation">Outstation
                                                                                </option>
                                                                            </select>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-Distance0">
                                                                                <input type="text" id="Distance0"
                                                                                    class="p-2 valid-field"
                                                                                    name="TabillMst[Distance][]"
                                                                                    maxlength="8"
                                                                                    placeholder="Distance(km)"
                                                                                    oninput="inputData(this.id,this.value,0);calculateDistAmt(0,this.value)"
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-ReceiptNo0">
                                                                                <input type="text" id="ReceiptNo0"
                                                                                    class="p-2 valid-field"
                                                                                    name="TabillMst[ReceiptNo][]"
                                                                                    placeholder="Receipt No"
                                                                                    oninput="inputData(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-FareAmount0">
                                                                                <input type="text" id="FareAmount0"
                                                                                    class="fare-amount p-2 valid-field"
                                                                                    name="TabillMst[FareAmount][]"
                                                                                    placeholder="Fare Paid"
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')"
                                                                                    oninput="inputData(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-EligibleTax0">
                                                                                <input type="text" id="EligibleTax0"
                                                                                    class="fare-amount p-2 valid-field"
                                                                                    name="TabillMst[EligibleTax][]"
                                                                                    placeholder="Eligible Tax"
                                                                                    onkeypress="blockSpecialChar(event,'numeric')"
                                                                                    oninput="inputData(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-TravelFile0">
                                                                                <input type="hidden"
                                                                                    name="TabillMst[TravelFile][]"
                                                                                    value=""><input type="file"
                                                                                    id="TravelFile0"
                                                                                    class="new p-2 valid-field uploaded_file"
                                                                                    name="TabillMst[TravelFile][]">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            NA
                                                                        </td>
                                                                    </tr>
                                                                </tbody>
                                                            </table>
                                                            <div class="text-center mb-2">
                                                                <button type="button" class="btn btn-success me-2"
                                                                    onclick="addMoreTravel()">Add More+</button>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="card">
                                                <div class="card-header" id="faqhead7">
                                                    <a href="#" class="btn btn-header-link fs-4 text-center"
                                                        data-toggle="collapse" data-target="#faq7" aria-expanded="true"
                                                        aria-controls="faq7">(B) Details of Hotel / Food Bill etc. (if
                                                        applicable):</a>
                                                </div>
                                                <div id="faq7" class="collapse show" aria-labelledby="faqhead7"
                                                    data-parent="#faq7">
                                                    <div class="card-body">
                                                        <div class="table-responsive">
                                                            <table class="table table-striped table-bordered">
                                                                <thead class="thead-light">
                                                                    <tr>
                                                                        <th>Name &amp; Address of Hotel/Guest House with
                                                                            Phone No</th>
                                                                        <th>No. of days</th>
                                                                        <th>Bill No.</th>
                                                                        <th>Bill Date</th>
                                                                        <th>Room Rent Paid</th>
                                                                        <th>Food Charges</th>
                                                                        <th>Total Amount</th>
                                                                        <th style="min-width: 200px !important;">File
                                                                        </th>
                                                                        <th>Action</th>
                                                                    </tr>
                                                                </thead>
                                                                <tbody>
                                                                    <tr>
                                                                        <td>
                                                                            <div class="mb-3 field-HotelName0">
                                                                                <textarea id="HotelName0" class="" name="TabillHotel[HotelName][]" maxlength="100" placeholder="Name/Address"
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)"></textarea>
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-DaysNumber0">
                                                                                <input type="text" id="DaysNumber0"
                                                                                    class="p-2"
                                                                                    name="TabillHotel[DaysNumber][]"
                                                                                    maxlength="8"
                                                                                    placeholder="No. of days"
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)"
                                                                                    onkeypress="return blockSpecialChar(event,'numeric')">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-BillNoDate0">
                                                                                <input type="text" id="BillNoDate0"
                                                                                    class="p-2"
                                                                                    name="TabillHotel[BillNoDate][]"
                                                                                    maxlength="100" placeholder="Bill No."
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <input type="date"
                                                                                name="TabillHotel[BillDate][]"
                                                                                placeholder="dd-mm-yyyy"
                                                                                class="hasDatepicker p-2" id="BillDate0"
                                                                                onchange="dateTime(this.id,this.value,0);chkValidation(this.id,this.value,0)">
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-RoomRentPaid0">
                                                                                <input type="text" id="RoomRentPaid0"
                                                                                    class="room-rent p-2"
                                                                                    name="TabillHotel[RoomRentPaid][]"
                                                                                    maxlength="100"
                                                                                    placeholder="Room Rent Paid"
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)"
                                                                                    onkeypress="return  blockSpecialChar(event,'numeric')">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-FoodCharge0">
                                                                                <input type="text" id="FoodCharge0"
                                                                                    class="food-charge p-2"
                                                                                    name="TabillHotel[FoodCharge][]"
                                                                                    maxlength="100"
                                                                                    placeholder="Food Charges"
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)"
                                                                                    onkeypress="return  blockSpecialChar(event,'numeric')">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-TotalAmount0">
                                                                                <input type="text" id="TotalAmount0"
                                                                                    class="p-2"
                                                                                    name="TabillHotel[TotalAmount][]"
                                                                                    readonly="" maxlength="100"
                                                                                    placeholder="Total Amount"
                                                                                    onkeypress="return blockSpecialChar(event,'characterNumericAndAllowSomespecials')"
                                                                                    oninput="inputData(this.id,this.value,0);chkValidation(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            <div class="mb-3 field-HotelFile0">
                                                                                <input type="hidden"
                                                                                    name="TabillHotel[HotelFile][]"
                                                                                    value=""><input type="file"
                                                                                    id="HotelFile0"
                                                                                    class="p-2 uploaded_file"
                                                                                    name="TabillHotel[HotelFile][]"
                                                                                    onchange="chkValidation(this.id,this.value,0)">
                                                                                <div class="invalid-feedback"></div>
                                                                            </div>
                                                                            <div class="invalid-feedback d-none"></div>
                                                                        </td>
                                                                        <td>
                                                                            NA
                                                                        </td>
                                                                    </tr>
                                                                </tbody>
                                                            </table>
                                                            <div class="text-center">
                                                                <button type="button" class="btn btn-success me-2"
                                                                    onclick="addMoreHotel()">Add More+</button>
                                                            </div>
                                                            <p>
                                                                *Orignal Bills (verified by yourself) must be enclosed
                                                                with his form. It is certified that the particulars
                                                                filled in above are correct and true.<br>
                                                                All the money paid is the interest of organisation.
                                                            </p>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="text-end">
                                                <button type="button" id="outsideFormPreviewBtn"
                                                    class="btn btn-warning me-2 modalPopupOut">Preview</button>
                                                <!-- <button type="Submit" id="outsideFormPreviewBt111111" class="btn btn-warning me-2 modalPopupOut">Preview</button>                                      -->
                                                <button type="submit"
                                                    class="btn btn-success float-end d-none outsideFormSubmitBtn finalSubmitOnlineBtn"
                                                    name="submit" value="2" style="float:right"><i
                                                        class="ri-save-line float-start me-1"></i> Submit</button>

                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- end outstation -->

                <div id="div_show" class="fs-1 fw-bold text-danger text-center"><br /><b>Please Fill the Remuneration To
                        Continue<b></div>
            </div>
        </div>
        </div>
        <!-- ---- model Local from----- -->
        <div class="modal fade" id="PreviewModal" tabindex="-1" aria-labelledby="PreviewModalLabel"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="PreviewModalLabel">Preview</h5>
                        {{-- <button type="button" class="btn-close EditBill" data-bs-dismiss="modal"
                        aria-label="Close"></button> --}}
                        {{-- <button type="button" class="close EditBill" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                          </button> --}}
                    </div>
                    <div class="modal-body ">
                        <div class="RemunerationModal">
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-success verifyAadhaarBtn" data-id="1"
                            id="verifyAadhaarBtn">Verify Email</button>
                        <button type="button" class="btn btn-primary EditBill clearHtml"
                            data-bs-dismiss="modal">Edit</button>
                    </div>
                </div>
            </div>
        </div>
        </div>
        <div class="modal fade" id="AadharModal" tabindex="-1" aria-labelledby="AadharModalLabel" aria-hidden="true"
            data-bs-backdrop="static">
            <div class="overlay">
                <div id="loader"><img src="{{ asset('assets/images/loader.gif') }}" width="200" alt="Loading...">
                </div>
            </div>
            <div class="modal-dialog" style="max-width: 700px!important">
                <div class="modal-content">
                    <div class="modal-header">
                        <h1 class="modal-title fs-5" id="exampleModalLabel">Email Verification</h1>
                        {{-- <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button> --}}
                        {{-- <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                      </button> --}}
                    </div>
                    <div class="modal-body">
                        <div class="my-4 aadharverify">
                            <p class="text-center fs-4 text-danger">Kindly Generate Email OTP For Verification </p>
                        </div>
                        <div class="row text-center" id="divMessage">
                            <span id="spnResult" class=""
                                style="color: green; font-weight: bold; font-size: 14px;padding-left:20px"></span>
                        </div>
                        <div class="my-4 otpverify d-none">
                            <label class="fs-5 fw-bold">Enter OTP</label>
                            <input type="text" name="Otp" id="Otp" class="form-control form-control-sm"
                                placeholder="Enter OTP" autocomplete="off" maxlength="4"
                                onkeypress="return blockSpecialChar(event,'numeric')">
                            <span class="OTPTxt text-danger d-block overflow-auto visibility-hidden"></span>
                            <span class="control-label" id="OtpLabel"
                                style="text-align:left;margin-left:5px;font-size:12px;font-weight:bold; ">Please validate
                                the OTP within 10 minutes of receiving it</span>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <div class="fw-bold" id="countdown"></div>
                        <button type="button" class="btn btn-info my-3" style="display:none" id="resendOTPBtn"
                            onclick="onGenerateEmailOTP()">Resend OTP</button>
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"
                            onclick="resetAadharVerification()">Cancel</button>
                        <button type="button" class="btn btn-warning my-3" id="generateAadhaarOTPBtn"
                            onclick="onGenerateEmailOTP()">Generate OTP</button>
                        <button id="btnValidateOTP" class="btn btn-warning my-3" style="display:none"
                            onclick="onValidateEmailOtp()">Validate OTP</button>
                        <button type="submit" class="btn btn-success FinalSubmit d-none">Final Submit</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- outstation model -->
        <div class="my-4 d-flex gx-2 justify-content-end">
            <div class="me-3 text-right"></div>
            <div class="modal fade" id="exampleModalOut" tabindex="-1" aria-labelledby="exampleModalOutLabel"
                aria-hidden="true">
                <div class="modal-dialog modal-dialog-scrollable">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalOutLabel">Preview</h5>
                            {{-- <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button> --}}
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body card">
                            <div class="card-header text-center fw-bold fs-4">
                                Outstation TA Claim Form (TO BE FILLED BY OUTSTAION TRAVELERS ONLY)
                            </div>
                            <div class="">
                                <table class="table cco-table table-striped table-bordered">
                                    <tbody>
                                        <tr>
                                            <th>Name of Exam:</th>
                                            <td id="examNameOutTd"></td>
                                            <th>Date of Exam:</th>
                                            <td id="examDateOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>

                                        </tr>
                                        <tr>
                                            <th>Centre Code: </th>
                                            <td id="centNoOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                            <th>Name of Observer/Deputy Observer</th>
                                            <td id="NameOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>Address for Communication</th>
                                            <td id="AddressOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                            <th>Registered Contact No.</th>
                                            <td id="ContactOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>PAN No.</th>
                                            <td id="PANOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                            <th>Name of CC with Contact Number</th>
                                            <td id="CCNameOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>Bank Name and Branch</th>
                                            <td id="BankName_BranchOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                            <th>Bank Account No.</th>
                                            <td id="AccountNoOutTd">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                        </tr>
                                        <tr>
                                            <th>IFSC Code</th>
                                            <td id="IFSCOutTd" colspan="3">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div class="">
                                <div class="card-header text-center fw-bold fs-4 ">
                                    Amount Claimed (Details Overleaf)
                                </div>
                                <table class="table table-striped table-bordered RemunerationTableModalOut">
                                </table>
                                <p>
                                    Certified that the particulars filled in above are correct and true. All the expenditure
                                    incurred/money paid is in the intrest of organisation.
                                </p>
                            </div>

                            <div class="card-header text-center fw-bold fs-4 ">
                                (A) Travelling Details:
                            </div>
                            <div class="">
                                <table class="table cco-table table-striped table-bordered">
                                    <thead class="thead-light">
                                        <tr>
                                            <th colspan="3">Departure</th>
                                            <th colspan="3">Arrival</th>
                                            <th>Mode of</th>
                                            <th>Travel Type</th>
                                            <th>Distance</th>
                                            <th>Air/Rail/Taxi</th>
                                            <th>Amount of</th>
                                            <th>Eligible Taxes</th>
                                            <!-- <th style="min-width: 200px !important;">File</th> -->
                                            <!-- <th>Action</th> -->
                                        </tr>
                                    </thead>
                                    <tbody id="travellPreview">
                                        <tr>
                                            <td>Date</td>
                                            <td>Time</td>
                                            <td>From</td>
                                            <td>Date</td>
                                            <td>Time</td>
                                            <td>To</td>
                                            <td>Journey</td>
                                            <td></td>
                                            <td>in Kms</td>
                                            <td>Receipt No</td>
                                            <td>Fare Paid (Air/Rail/Taxi)</td>
                                            <td></td>
                                        </tr>
                                        <tr class="travel-row">
                                            <td>
                                                <p id="DepartureDate0Td"></p>
                                            </td>
                                            <td>
                                                <p id="DepartureTime0Td"></p>
                                            </td>
                                            <td>
                                                <p id="DepartureFrom0Td"></p>
                                            </td>
                                            <td>
                                                <p id="ArrivalDate0Td"></p>
                                            </td>
                                            <td>
                                                <p id="ArrivalTime0Td"></p>
                                            </td>
                                            <td>
                                                <p id="ArrivalTo0Td"></p>
                                            </td>
                                            <td>
                                                <p id="JourneyMode0Td"></p>
                                                <p id="OtherJourneyMode0Td"></p>
                                            </td>
                                            <td>
                                                <p id="TravelType0Td"></p>
                                            </td>
                                            <td>
                                                <p id="Distance0Td"></p>
                                            </td>
                                            <td>
                                                <p id="ReceiptNo0Td"></p>
                                            </td>
                                            <td>
                                                <p id="FareAmount0Td"></p>
                                            </td>
                                            <td>
                                                <p id="EligibleTax0Td"></p>
                                            </td>
                                        </tr>
                                    <tbody>
                                </table>
                            </div>

                            <div class="card-header text-center fw-bold fs-4 ">
                                (B) Details of Hotel / Food Bill etc. (if applicable):
                            </div>
                            <div class="">
                                <div class="table-responsive">
                                    <table class="table table-striped table-bordered">
                                        <thead class="thead-light">
                                            <tr>
                                                <th>Name & Address of Hotel/Guest House with Phone No</th>
                                                <th>No. of days</th>
                                                <th>Bill No.</th>
                                                <th>Bill Date</th>
                                                <th>Room Rent Paid</th>
                                                <th>Food Charges</th>
                                                <th>Total Amount</th>
                                                <!-- <th style="min-width: 200px !important;">File</th> -->
                                                <!-- <th>Action</th> -->
                                            </tr>
                                        </thead>
                                        <tbody id="HotelDetailPreview">
                                            <tr class="hotel-detail-row">
                                                <td>
                                                    <p id="HotelName0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="DaysNumber0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="BillNoDate0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="BillDate0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="RoomRentPaid0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="FoodCharge0Td"></p>
                                                </td>
                                                <td>
                                                    <p id="TotalAmount0Td"></p>
                                                </td>
                                                <!-- <td><p id="HotelFile0Td"></p></td> -->
                                            </tr>
                                        </tbody>
                                    </table>
                                    <p>
                                        *Orignal Bills (verified by yourself) must be enclosed with his form. It is
                                        certified that the particulars filled in above are correct and true.<br>
                                        All the money paid is the interest of organisation.
                                    </p>
                                </div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-success verifyAadhaarBtn" id="verifyAadhaarBtn"
                                    data-id="2">Verify Email</button>

                                <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Edit</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>


        <!-- Modal -->
        <div class="modal fade" id="detailsModal" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
            aria-labelledby="detailsModalLabel" aria-hidden="true">
            <div class="modal-dialog" style="max-width: 500px!important">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="detailsModalLabel">Remuneration Details</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <table class="table">
                            <thead class="table-dark">
                                <th>Duty Date</th>
                                <th>No. of Shift</th>
                                <th>Remuneration Rate</th>
                            </thead>
                            <tbody id="ShiftWiseAmount">

                            </tbody>
                        </table>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </main>


@endsection
@section('script')
    <!-- Local from script -->
    <script>
        var totalTds = 0;
        $('#preview').click(function() {
            var formIsValid = true;
            $('.valid-field-1').each(function() {
                if ($(this).val().trim() === '') {
                    $(this).next('span.text-danger').remove();
                    $(this).after('<span class="text-danger">*This field is required</span>');

                    if (formIsValid) {
                        $(this).focus();
                        formIsValid = false;
                    }
                } else {
                    $(this).next('span.text-danger').remove();
                }

            });

            if (!formIsValid) {
                return false;
            } else {
                $('#PreviewModal').modal('show');
                var tableHtml = $('.RemunerationMain').clone();
                tableHtml.find('input:not(.common-fields)').addClass('border-0').prop({
                    'readonly': true,
                }).css('pointer-events', 'none');
                tableHtml.find('input.common-fields').prop({
                    'readonly': true,
                }).css('pointer-events', 'none');
                tableHtml.find('#preview').hide();
                tableHtml.find('.file-label').hide();
                $('.RemunerationModal').html(tableHtml);
            }
        });

        $('#AttachDocument').removeClass('valid-field-1');
        $(document).on('input', '.MiscellanousCharge', function() {
            var MiscellanousCharge = $('.MiscellanousCharge').val();
            if (MiscellanousCharge > 0) {
                $('#AttachDocument').addClass('valid-field-1');
            } else {
                $('span.text-danger').remove();
                $('#AttachDocument').removeClass('valid-field-1');
            }
        });


        // email otp

        $(document).on('click', '.verifyAadhaarBtn', function() {
            $('#PreviewModal').modal('hide');
            var FormId = $(this).data('id');
            if (FormId == 1) {
                $('#exampleModal').modal('hide');
            } else {
                $('#exampleModalOnline').modal('hide');
            }
            resetAadharVerification();
            $('#AadharModal').modal('show').attr('data-id', +FormId);
        });

        function resetAadharVerification() {
            $('#Otp').val('');
            $('.otpverify').addClass('d-none');
            $('.aadharverify ').removeClass('d-none');
            $('#aadhaarNumberTxt').val('');
            $('.aadhaarNumberTxt').text('');
            $('.aadhaarNumberTxt').addClass('visibility-hidden');
            $('#btnValidateOTP').hide();
            $('#generateAadhaarOTPBtn').show();
            $('.OTPTxt').text('');
            $('#resendOTPBtn').hide();
            $('#spnResult').text('');
            $('.FinalSubmit').removeClass('d-block');
            $('.FinalSubmit').addClass('d-none');

        }

        function onGenerateEmailOTP() {
            var ExamType = '<?php echo session('examType'); ?>'
            var BillType = $('#AadharModal').data('id');
            var ObsDetails = {
                'Email': '<?php echo session('email'); ?>',
                'Name': '<?php echo session('Name'); ?>',
                'ObserverId': '<?php echo session('ObserverID'); ?>',
                'examType': ExamType
            };
            var testMail = 'pkumar10@expediens.com'
            // console.log(BillType);
            $('#resendOTPBtn').hide();
            $('.OTPTxt').text('');

            $.ajax({
                type: 'POST',
                url: "{{ route('generatemailotp') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    ObsDetails: ObsDetails,
                    BillType: BillType,
                    ExamType: ExamType,
                },
                "beforeSend": function(response) {
                    $('.overlay').show();
                },
                success: function(resp) {
                    $('.overlay').hide();
                    if (!resp) {
                        $('#spnResult').html('Error in sending mail!');
                        $('#spnResult').css("color", "red");
                        $('.overlay').hide();
                        return false;
                    }

                    var message = "OTP sent successfully";
                    message = message + " to " + ObsDetails.Email;
                    var seconds = 60;

                    function updateCountdown() {
                        $('#countdown').show();
                        $('#countdown').text('Resend OTP In: ' + seconds + ' seconds');
                        seconds--;
                        if (seconds < 0) {
                            clearInterval(timer);
                            $('#resendOTPBtn').show();
                            $('#countdown').text('');
                        }
                    }
                    timer = setInterval(updateCountdown, 1000);
                    $('.aadharverify').addClass('d-none');
                    $('.otpverify').removeClass('d-none');
                    $('#spnResult').html(message);
                    $('#btnValidateOTP').show();
                    $('#generateAadhaarOTPBtn').hide();
                    $('#spnResult').css("color", "green");

                },
                error: function(xhr, textStatus, error) {
                    var errorMessage = xhr.status + ': ' + xhr.statusText;
                    // alert(errorMessage)
                    $('#spnResult').html('Error - ' + errorMessage);
                    $('#spnResult').css("color", "red");
                    $('#divMessage').show();
                    //$('#divMessage').delay(3000).fadeOut("slow");
                    $('.overlay').hide();
                    return false;
                }
            });
        }

        function onValidateEmailOtp() {

            var formId = $('#AadharModal').data('id');
            var otpValue = $('#Otp').val();
            var ExamType = '<?php echo session('examType'); ?>';

            if (otpValue == '') {
                $('#Otp').focus();
                $('.OTPTxt').text('OTP cannot be blank');
                $('.overlay').hide();
                return false;
            } else if (otpValue && otpValue.trim().length !== 4) {
                $('#Otp').focus();
                $('.overlay').hide();
                $('.OTPTxt').text('OTP Length Should be 4 Digits');
                return false;
            } else {
                $('.OTPTxt').text('');
            }

            $.ajax({

                type: 'POST',
                url: "{{ route('validatemailotp') }}",
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                data: {
                    OTPVALUE: otpValue,
                    ExamType: ExamType,
                },
                "beforeSend": function(response) {
                    $('.overlay').show();
                },
                success: function(data) {

                    if (data.status == 0) {
                        $('.OTPTxt').text(data.message);
                        $('.OTPTxt').removeClass('visibility-hidden');
                        $('.overlay').hide();
                        return false;
                    }
                    $('.overlay').hide();
                    // alert('Otp Verified Successfully!');
                    clearInterval(timer);
                    $('#spnResult').text(data.message);
                    $('.otpverify').addClass('d-none');
                    $('#spnResult').css('color', 'green');
                    $('#btnValidateOTP').hide();
                    $('#countdown').text('');
                    $('#resendOTPBtn').hide();
                    $('#countdown').hide();
                    $('.FinalSubmit').removeClass('d-none');

                    if (formId == 1) {
                        $('.FinalSubmit').addClass('finalSubmitOffline');
                    } else {
                        $('.FinalSubmit').addClass('finalSubmitOnline');

                    }
                },
                error: function(xhr, textStatus, error) {
                    $('#spnResult').html(error.message);
                    $('#spnResult').css("color", "red");
                    $('#divMessage').show();
                    $('.overlay').hide();
                    return false;
                }
            });
        }

        $(document).on('click', '.finalSubmitOffline', function() {
            var btn = $(".finalSubmitOfflineBtn");
            btn.trigger("click"); // First click
            // Second click after a small delay
            // setTimeout(function() {
            //     btn.trigger("click");
            // }, 300); // You can adjust the delay as needed
        });

        $(document).on('click', '.finalSubmitOnline', function() {

            var btn = $(".finalSubmitOnlineBtn");
            btn.trigger("click"); // First click
            // Second click after a small delay
            // setTimeout(function() {
            //    // btn.trigger("click");
            // }, 300); // You can adjust the delay as needed
        });
        $(document).on('click', '.clearHtml', function() {
            $('.RemunerationModal').html('');
        });
        $('#outstation').hide();

        function openTab(evt, cityName) {
            var i, tabcontent, tablinks;
            tabcontent = document.getElementsByClassName("local");
            for (i = 0; i < tabcontent.length; i++) {
                tabcontent[i].style.display = "none";
            }
            tablinks = document.getElementsByClassName("tablinks");
            for (i = 0; i < tablinks.length; i++) {
                tablinks[i].className = tablinks[i].className.replace(" active", "");
            }
            document.getElementById(cityName).style.display = "block";
            evt.currentTarget.className += " active";
        }


        var fromvalue = $('#fromvalue').val();
        if (fromvalue == '1') {
            $('#outstation_li').hide();
        }
        $('#div_show').hide();
        $('#outstationBtn').click(function() {
            var fromvalue = $('#fromvalue').val();
            if (fromvalue == 0) {
                $('#outstation').show();
                $('#div_show').hide();
            }
            if (fromvalue == '') {
                $('#outstation').hide();
                $('#div_show').show();
            }
        });
        $('#localBtn').click(function() {
            $('#div_show').hide();
        });
    </script>
    <!-- outStation script  -->
    <script>
        function populatePreviewTable() {
            var previewTable = document.getElementById("previewTable");
            previewTable.innerHTML = '';
            $('tr').each(function(index) {
                var trHtml = $(this).html();
                var trClone = document.createElement('tr');
                trClone.innerHTML = trHtml;
                previewTable.appendChild(trClone);
            });
        }
        var localBtn = document.getElementById('localBtn');
        var outstationBtn = document.getElementById('outstationBtn');

        localBtn.addEventListener('click', function() {
            localBtn.classList.remove('btn-secondary');
            localBtn.classList.add('btn-success');
            outstationBtn.classList.remove('btn-success');
            outstationBtn.classList.add('btn-secondary');
        });

        outstationBtn.addEventListener('click', function() {
            // Change color of outstation button to green
            outstationBtn.classList.remove('btn-secondary');
            outstationBtn.classList.add('btn-success');
            // Change color of local button back to its default
            localBtn.classList.remove('btn-success');
            localBtn.classList.add('btn-secondary');
        });

        var loop_count = 1;

        function addMoreTravel() {
            var rowHtmlTravel = `<tr class="travel-row">
        <td>
            <input type="date" name="TabillMst[DepartureDate][]" class="hasDatepicker date-input p-2 valid-field" placeholder="dd-mm-yyyy" id="DepartureDate${loop_count}" onchange = "dateTime(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="time" name="TabillMst[DepartureTime][]" class="p-2 valid-field time-input" id="DepartureTime${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>

            <input type="text" name="TabillMst[DepartureFrom][]" placeholder="From" class="p-2 valid-field" id="DepartureFrom${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})" onkeypress="return lettersOnly(event)">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="date" name="TabillMst[ArrivalDate][]" class="hasDatepicker date-input p-2 valid-field" placeholder="dd-mm-yyyy" autocomplete="off" id="ArrivalDate${loop_count}" onchange = "dateTime(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="time" name="TabillMst[ArrivalTime][]" class="p-2 valid-field time-input" id="ArrivalTime${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="text" name="TabillMst[ArrivalTo][]" placeholder="To" class="p-2 valid-field" id="ArrivalTo${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})" onkeypress="return lettersOnly(event)">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td id="">
            <select name="TabillMst[JourneyMode][]" placeholder="Journey" class="p-2 valid-field" id="JourneyMode${loop_count}" onchange = "dateTime(this.id,this.value,${loop_count});addTextBoxFun(${loop_count},this.value)">
                <option value=' '>--Select--</option><option value='By Air'>By Air</option><option value='By Railways'>By Railways</option><option value='By roadways'>By roadways</option><option value='By own vehicle'>By own vehicle</option><option value='Others'>Others</option>            </select>
            <div class="invalid-feedback d-none"></div>
            <input type="text" name="TabillMst[OtherJourneyMode][]" placeholder="Enter other journey mode" class="p-2 mt-1 d-none" id="OtherJourneyMode${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})">
        </td>
        <td id="">
            <select name="TabillMst[TravelType][]" placeholder="Travel Type" class="p-2 valid-field" id="TravelType${loop_count}" onchange = "dateTime(this.id,this.value,${loop_count});makeReadonlyFun(${loop_count},this.value)">
                <option value=' '>--Select--</option>
                <option value='local'>Local</option>
                <option value='outstation'>Outstation</option>
            </select>
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
        <input type="text" name="TabillMst[Distance][]" placeholder="Distance(km)" class="p-2 valid-field" id="Distance${loop_count}" onkeypress = "return blockSpecialChar(event,'numeric')" oninput = "inputData(this.id,this.value,${loop_count});calculateDistAmt(${loop_count},this.value)">
            <div class="invalid-feedback d-none"></div>
        <td>
            <input type="text" name="TabillMst[ReceiptNo][]" placeholder="Receipt No" class="p-2 valid-field" id="ReceiptNo${loop_count}" oninput = "inputData(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="text" name="TabillMst[FareAmount][]" placeholder="Fare Paid" class="fare-amount p-2 valid-field" id="FareAmount${loop_count}" onkeypress = "return blockSpecialChar(event,'numeric')" oninput = "inputData(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="text" name="TabillMst[EligibleTax][]" placeholder="Eligible Tax" class="fare-amount p-2 valid-field" id="EligibleTax${loop_count}" onkeypress = "return blockSpecialChar(event,'numeric')" oninput = "inputData(this.id,this.value,${loop_count})">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <input type="file" name="TabillMst[TravelFile][]" maxlength="true" id="TravelFile${loop_count}" class="p-2 valid-field uploaded_file">
            <div class="invalid-feedback d-none"></div>
        </td>
        <td>
            <button type="button" class="btn btn-danger btn-sm" onclick="removeTravelRow(this,${loop_count})">Remove</button>
        </td>

        </tr>`;

            $('#faq6 tbody tr:last-child').after(rowHtmlTravel);
            var today = new Date().toISOString().split('T')[0];
            $('.hasDatepicker').attr('max', today);
            var rowHtmlTravelTd = `
        <tr class="travel-row appendedTravelTr${loop_count}">
            <td><p id="DepartureDate${loop_count}Td"></p></td>
            <td><p id="DepartureTime${loop_count}Td"></p></td>
            <td><p id="DepartureFrom${loop_count}Td"></p></td>
            <td><p id="ArrivalDate${loop_count}Td"></p></td>
            <td><p id="ArrivalTime${loop_count}Td"></p></td>
            <td><p id="ArrivalTo${loop_count}Td"></p></td>
            <td><p id="JourneyMode${loop_count}Td"></p><p id="OtherJourneyMode${loop_count}Td"></p></td>
            <td><p id="TravelType${loop_count}Td"></p><p id="OtherTravelType${loop_count}Td"></p></td>
            <td><p id="Distance${loop_count}Td"></p></td>
            <td><p id="ReceiptNo${loop_count}Td"></p></td>
            <td><p id="FareAmount${loop_count}Td"></p></td>
            <td><p id="EligibleTax${loop_count}Td"></p></td>
        </tr>`;

            $('#travellPreview tr:last-child').after(rowHtmlTravelTd);
            loop_count++;
        }

        function dateTime(name, date, id) {
            $('#' + name + 'Td').text(date);
        }

        function dateTimeAddMore(name, date, id) {

            const [year, month, day] = date.split("-");
            const formattedDate = `${day}-${month}-${year}`;
            $('#' + name + 'Td').text(formattedDate);
        }

        function inputData(name, vals, id) {
            $('#' + name + 'Td').text(vals);
        }

        function removeTravelRow(button, id) {
            $(button).closest('tr').remove();
            $('.appendedTravelTr' + id).remove();
        }

        function addTextBoxFun(id, value) {
            if (value == 'Others') {
                $('#OtherJourneyMode' + id).removeClass('d-none');
                $('#OtherJourneyMode' + id).addClass('d-block');
                $('#OtherJourneyMode' + id).addClass('valid-field');

            } else if (value == "By own vehicle") {
                alert("Upload Toll slip with the RC ");

                $('#OtherJourneyMode' + id).removeClass('d-block');
                $('#OtherJourneyMode' + id).addClass('d-none');
                $('#OtherJourneyMode' + id).removeClass('valid-field');
                $('#OtherJourneyMode' + id + 'Td').text('');
            } else {
                $('#OtherJourneyMode' + id).removeClass('d-block');
                $('#OtherJourneyMode' + id).addClass('d-none');
                $('#OtherJourneyMode' + id).removeClass('valid-field');
                $('#OtherJourneyMode' + id + 'Td').text('');
            }
        }

        function makeReadonlyFun(id, value) {
            if (value == 'local') {
                $('#FareAmount' + id).val('');
                $('#Distance' + id).val('');
                $('#FareAmount' + id).prop('readonly', true);
            } else {
                $('#FareAmount' + id).prop('readonly', false);
                $('#FareAmount' + id).val('');
                $('#Distance' + id).val('');
            }
        }

        function calculateDistAmt(id, value) {

            let travelType = $('#TravelType' + id).val();
            if (travelType == 'local') {
                let newAmt = value * 16;
                $('#FareAmount' + id).val(newAmt);
                $('#FareAmount' + id + 'Td').text(newAmt);
                var sum2 = 0;
                $('.fare-amount').each(function(index) {
                    var value = parseFloat($(this).val()) || 0;
                    sum2 += value; // Add the value to the sum
                });
                $('#fare-amount').text(sum2);
            }

        }

        loop_count1 = 1;

        function addMoreHotel() {
            var rowHtmlHotel =
                `<tr class="hotel-detail-row">
            <td>
                <textarea name="TabillHotel[HotelName][]" placeholder="Name/Address" class="" id="HotelName${loop_count1}" oninput="inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100"></textarea>
                <div class="invalid-feedback d-none"></div>
                </td>
            <td>
                <input type="text" name="TabillHotel[DaysNumber][]" placeholder="No. of days" class="p-2" onkeypress = "return blockSpecialChar(event,'numeric')" id="DaysNumber${loop_count1}" oninput = "inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="text" name="TabillHotel[BillNoDate][]" placeholder="Bill No." class="p-2" id="BillNoDate${loop_count1}" oninput = "inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="date" name="TabillHotel[BillDate][]" placeholder="dd-mm-yyyy" class="hasDatepicker p-2" id="BillDate${loop_count1}" onchange = "dateTime(this.id,this.value,0);chkValidation(this.id,this.value,${loop_count1})">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="text" name="TabillHotel[RoomRentPaid][]" placeholder="Room Rent Paid" class="room-rent p-2" onkeypress = "return blockSpecialChar(event,'numeric')" id="RoomRentPaid${loop_count1}" oninput = "inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="text" name="TabillHotel[FoodCharge][]" placeholder="Food Charges" class="food-charge p-2" onkeypress = "return blockSpecialChar(event,'numeric')" id="FoodCharge${loop_count1}" oninput = "inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="text" name="TabillHotel[TotalAmount][]" placeholder="Total Amount" class="p-2" id="TotalAmount${loop_count1}" onkeypress = "return blockSpecialChar(event,'numeric')" oninput = "inputData(this.id,this.value,${loop_count1});chkValidation(this.id,this.value,${loop_count1})" maxlength="100">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td>
                <input type="file" name="TabillHotel[HotelFile][]" maxlength="true" id="HotelFile${loop_count1}" onchange = "chkValidation(this.id,this.value,${loop_count1}) class="p-2 uploaded_file">
                <div class="invalid-feedback d-none"></div>
            </td>
            <td><button type="button" class="btn btn-danger btn-sm" onclick="removeHotelRow(this,${loop_count1})">Remove</button></td>
        </tr>`;
            $('#faq7 tbody tr:last-child').after(rowHtmlHotel);
            var today = new Date().toISOString().split('T')[0];
            $('.hasDatepicker').attr('max', today);

            //To append preview model for hotel details
            var rowHtmlHotelTd =
                `<tr class="hotel-detail-row appendedHotelTr${loop_count1}">
            <td><p id="HotelName${loop_count1}Td"></p>
            <td><p id="DaysNumber${loop_count1}Td"></p>
            <td><p id="BillNoDate${loop_count1}Td"></p>
            <td><p id="BillDate${loop_count1}Td"></p>
            <td><p id="RoomRentPaid${loop_count1}Td"></p>
            <td><p id="FoodCharge${loop_count1}Td"></p>
            <td><p id="TotalAmount${loop_count1}Td"></p>
        </tr>`;
            $('#HotelDetailPreview tr:last-child').after(rowHtmlHotelTd);

            loop_count1++;
        }

        function removeHotelRow(button, id) {
            $(button).closest('tr').remove();
            $('.appendedHotelTr' + id).remove();
        }

        function chkValidation(name, vals, id) {

            var hotelNameField = '#HotelName' + id;
            var daysNumberField = '#DaysNumber' + id;
            var billNoDateField = '#BillNoDate' + id;
            var billDateField = '#BillDate' + id;
            var roomRentPaidField = '#RoomRentPaid' + id;
            var foodChargeField = '#FoodCharge' + id;
            var hotelFileField = '#HotelFile' + id;

            if (vals != '') {
                addRequiredClass(id);
            } else {
                removeRequiredClass(id);
            }
        }

        function addRequiredClass(id) {
            if (!$('#HotelName' + id).hasClass('valid-field')) {
                $('#HotelName' + id).addClass('valid-field')
            }
            if (!$('#DaysNumber' + id).hasClass('valid-field')) {
                $('#DaysNumber' + id).addClass('valid-field')
            }
            if (!$('#BillNoDate' + id).hasClass('valid-field')) {
                $('#BillNoDate' + id).addClass('valid-field')
            }
            if (!$('#BillDate' + id).hasClass('valid-field')) {
                $('#BillDate' + id).addClass('valid-field')
            }
            if (!$('#RoomRentPaid' + id).hasClass('valid-field')) {
                $('#RoomRentPaid' + id).addClass('valid-field')
            }
            if (!$('#FoodCharge' + id).hasClass('valid-field')) {
                $('#FoodCharge' + id).addClass('valid-field')
            }
            if (!$('#HotelFile' + id).hasClass('valid-field')) {
                $('#HotelFile' + id).addClass('valid-field')
            }
        }

        function removeRequiredClass(id) {
            let HotelNameVal = $('#HotelName' + id).val();
            let DaysNumberVal = $('#DaysNumber' + id).val();
            let BillNoDateVal = $('#BillNoDate' + id).val();
            let BillDateVal = $('#BillDate' + id).val();
            let RoomRentPaidVal = $('#RoomRentPaid' + id).val();
            let FoodChargeVal = $('#FoodCharge' + id).val();
            let HotelFileVal = $('#HotelFile' + id).val();

            if (HotelNameVal == '' && DaysNumberVal == '' && BillNoDateVal == '' && BillDateVal == '' && RoomRentPaidVal ==
                '' && FoodChargeVal == '' && HotelFileVal == '') {
                $('#HotelName' + id).removeClass('valid-field');
                $('#DaysNumber' + id).removeClass('valid-field');
                $('#BillNoDate' + id).removeClass('valid-field');
                $('#BillDate' + id).removeClass('valid-field');
                $('#RoomRentPaid' + id).removeClass('valid-field');
                $('#FoodCharge' + id).removeClass('valid-field');
                $('#HotelFile' + id).removeClass('valid-field');

                $('#HotelName' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#DaysNumber' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#BillNoDate' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#BillDate' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#RoomRentPaid' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#FoodCharge' + id).siblings('div').removeClass('d-block').addClass('d-none');
                $('#HotelFile' + id).siblings('div').removeClass('d-block').addClass('d-none');

            }

        }
        $(document).ready(function() {
            $(document).on('input', '.food-charge', function() {
                var sum1 = 0;

                $('.food-charge').each(function(index) {
                    var value = parseFloat($(this).val()) || 0;
                    sum1 += value;
                });

                $('#food-expense').text(sum1);
                updateTotal();
            });

            $(document).on('input', '.fare-amount', function() {
                var sum2 = 0;

                $('.fare-amount').each(function(index) {
                    var value = parseFloat($(this).val()) || 0;
                    sum2 += value;
                });
                $('#fare-amount').text(sum2);
                updateTotal();
            });

            $(document).on('input', '.room-rent', function() {
                var sum3 = 0;
                $('.room-rent').each(function(index) {
                    var value = parseFloat($(this).val()) || 0;
                    sum3 += value;
                });

                $('#room-rent').text(sum3);
                updateTotal();
            });

            function updateTotal() {
                var sum1 = parseFloat($('#food-expense').text()) || 0;
                var sum2 = parseFloat($('#fare-amount').text()) || 0;
                var sum3 = parseFloat($('#room-rent').text()) || 0;

                var totalSum = sum1 + sum2 + sum3;

                $('#expense-total-amount').text(totalSum);
                $('#expense-total-amount-input').val(totalSum);

            }
            $(document).on('input', ".valid-field", function() {
                var next = $(this).siblings('div');
                if ($.trim($(this).val()) == '') {
                    next.addClass('error');
                    next.removeClass('d-none');
                    next.addClass('d-block');
                    next.text(`This is required`)
                } else {
                    next.removeClass('error');
                    next.removeClass('d-block');
                    next.addClass('d-none');
                }
            });

        });
        var rcount = 1;
        $('.addMoreRows').click(function() {
            //if(count <= 5){
            $('.RemunerationTable tr:last').prev().prev().after(`<tr class="RemunerationAppendedRow${rcount}"><td>*</td>
                <td><input type="text" class="form-control form-control-sm" name="TabillMst[ExtraExpenseDataName][]" id="ExtraExpenseDataName${rcount}" oninput = "inputData(this.id,this.value,${rcount})"><div class="invalid-feedback d-none"></div></td>
                <td><input type="date" class="form-control form-control-sm" name="TabillMst[ExtraExpenseDataDate][]" placeholder="dd-mm-yyyy" id="ExtraExpenseDataDate${rcount}" onchange = "dateTimeAddMore(this.id,this.value,${rcount})"><div class="invalid-feedback d-none"></div></td>
                <td>-</td>
                <td class="d-flex">
                    <div><input type="text" class="form-control form-control-sm ExtraExpenseDataAmount" name="TabillMst[ExtraExpenseDataAmount][]" id="ExtraExpenseDataAmount${rcount}" oninput = "inputData(this.id,this.value,${rcount})" onkeypress = "return blockSpecialChar(event,'numeric')">
                        <div class="invalid-feedback d-none"></div>
                    </div>
                    <div class="mt-3">
                        <button type="button" class="btn btn-danger btn-sm ms-3 removeRows" data-id="${rcount}"><i class="fa fa-trash"></i></button>
                    </div>
                </td>
                </tr>`);

            $('.RemunerationTableModal tr:last').prev().prev().after(`<tr class="RemunerationAppendedRow${rcount}"><td>*</td>
                <td><p id="ExtraExpenseDataName${rcount}Td"></p><div class="invalid-feedback d-none"></div></td>
                <td><p id="ExtraExpenseDataDate${rcount}Td"></p><div class="invalid-feedback d-none"></div></td>
                <td><p id="ExtraExpenseDataDays${rcount}Td">-</p><div class="invalid-feedback d-none"></div></td>
                <td><p id="ExtraExpenseDataAmount${rcount}Td"></p><div class="invalid-feedback d-none"></div>
                </tr>`);

            rcount++;
        });

        $(document).on('click', '.removeRows', function() {
            var dataId = $(this).attr('data-id');
            if (dataId) {
                $('.RemunerationAppendedRow' + dataId).remove();
                updateExtraExpenseAmountFun();
            }
        });

        $(document).on('input', '.ExtraExpenseDataAmount', function() {
            updateExtraExpenseAmountFun();
        });
        $(document).on('input', '#advancePayment', function() {
            updateExtraExpenseAmountFun();
            $(document).on('input', '#ManualLocalConvence', function() {});
            $("#ManualLocalConvence").val('');
            if ($.trim($(this).val()) == '') {
                $('.ManualLocalConvenceFix').text(0);
                $("#ManualLocalError").removeClass('d-none');
                $("#ManualLocalError").addClass('d-block');
            } else {
                if ($.trim($(this).val()) > 1000) {
                    $("#ManualLocalError").removeClass('d-none');
                    $("#ManualLocalError").addClass('d-block');
                    $("#ManualLocalConvence").val(0);
                    $("#ManualLocalError").text('Max Amount 1000');
                    $('.ManualLocalConvenceFix').text(0);
                } else {
                    $('#manualLocalConveyanceView').text(value);
                    var value = parseFloat($(this).val());
                }
            }

            updateExtraExpenseAmountFun();
        });

        function updateExtraExpenseAmountFun() {
            var sum = 0;
            let totalAmtClaimedTxt = 8300;

            $('.ExtraExpenseDataAmount').each(function(index) {
                var value = parseFloat($(this).val()) || 0;
                sum += value; // Add the value to the sum
            });

            var ManualLocalConvence = parseFloat($('#ManualLocalConvence').val()) || 0;
            var advancePayment = parseFloat($('#advancePayment').val()) || 0;

            let finalAmtClaimed = (parseFloat(totalAmtClaimedTxt) + sum + ManualLocalConvence) - advancePayment;
            $('.AdvancePayshow').text(advancePayment);
            $('.totalAmtClaimed').text(finalAmtClaimed);
        }

        function updateTotalAmount(rowIndex) {
            var roomRentPaid = parseFloat($('#RoomRentPaid' + rowIndex).val()) ||
                0;
            var foodCharge = parseFloat($('#FoodCharge' + rowIndex).val()) || 0;

            var totalAmount = roomRentPaid + foodCharge;
            $('#TotalAmount' + rowIndex).val(totalAmount);
            $('#TotalAmount' + rowIndex + 'Td').text(totalAmount);
        }

        $(document).on('input', 'input[name^="TabillHotel[RoomRentPaid][]"], input[name^="TabillHotel[FoodCharge][]"]',
            function() {
                var rowIndex = $(this).attr('id').match(/\d+/)[0];
                console.log(rowIndex)
                updateTotalAmount(rowIndex);
            });
    </script>
    </div>
    </main>
    <script>
        jQuery(function($) {
            $(document).ready(function() {
                $('#TravelFile0').removeClass('form-control');
                $('#HotelFile0').removeClass('form-control');
                $('#JourneyMode0').removeClass('form-select');
            });
            $(document).ready(function() {

                $('.verifyAadhaarBtn').on('click', function() {
                    let id = $(this).data('id');
                    $('#AadharEnrolmentNumber' + id).removeClass('d-none');
                    $('#verifyAadhaarBtn' + id).addClass('d-none');
                    $('#generateAadhaarOTPBtn' + id).addClass('d-block');
                });

                $('#outsideFormPreviewBtn').on('click', function() {
                    var isValid = true;
                    var activeForm = $('.tab-pane.active').find('form');
                    activeForm.find(".valid-field").each(function() {
                        if ($(this).is("input[type='file']") && !$(this).prop('files')[0]) {
                            var next = $(this).siblings('div');
                            next.removeClass('d-none');
                            next.addClass('d-block');
                            next.text(`This is required`);
                            isValid = false;
                        } else if ($.trim($(this).val()) == '') {
                            var next = $(this).siblings('div');
                            next.removeClass('d-none');
                            next.addClass('d-block');
                            next.text(`This is required`);
                            isValid = false;
                        } else if ($(this).attr('type') === 'date' && !$(this)
                            .val()) { // Check if date field is blank
                            var next = $(this).siblings('div');
                            next.removeClass('d-none');
                            next.addClass('d-block');
                            next.text(`This is required`);
                            isValid = false;
                        }
                    });

                    if (!isValid) {
                        return false;
                    } else {

                        var examName = $('#Exam\\#\\#Name').val();
                        var examDate = $('#Exam\\#\\#Date').val();
                        var centreCode = $('#Centre\\#\\#No_').val();
                        var CentreNameWithAddress = $('#Address').val();
                        var ObserverName = $('#Observer\\#\\#Name').val();
                        // var ObserverName =$('#Observer\\#\\#\\#\\#Name').val();
                        var ObserverID = $('#Observer\\#\\#ID').val();
                        var AddressOfComm = $('#Address\\#\\#For\\#\\#Communication').val();
                        var MobilePhoneNo_ = $('#Contact\\#\\#No').val();
                        var P_A_N_No_ = $('#PAN_No').val();
                        var ccName = $('#CcName').val();
                        var rcName = $('#RC\\#\\#Name').val();
                        //  var BankName = $('#Bank_Branch_Name').val();
                        var branch = $('#Bank_Branch_Name').val();
                        var VendorAccountNo_ = $('#Bank_Account_No').val();
                        var ifsc = $('#IFSC\\#\\#Code').val();
                        var TableAmountClaimed = $('.TableAmountClaimed').html();

                        $('#examNameOutTd').text(examName);
                        $('#examDateOutTd').text(examDate);
                        $('#centNoOutTd').text(centreCode);
                        $('#NameOutTd').text(ObserverName);
                        $('#AddressOutTd').text(CentreNameWithAddress);
                        $('#ContactOutTd').text(MobilePhoneNo_);
                        $('#contactTd').text(MobilePhoneNo_);
                        $('#PANOutTd').text(P_A_N_No_);
                        $('#CCNameOutTd').text(ccName);
                        $('#FromToDestinationOutTd').text(rcName);
                        // $('#TravellingDateOutTd').text(BankName);
                        $('#BankName_BranchOutTd').text(branch);
                        $('#AccountNoOutTd').text(VendorAccountNo_);
                        $('#IFSCOutTd').text(ifsc);
                        $('#AddressOutTd').text(AddressOfComm);

                        $('.RemunerationTableModalOut').html(TableAmountClaimed);


                        // $('#ExamName_YearOutTd').text($('#ExamName_YearOut').val());
                        // $('#CENTNO_AddressOutTd').text($('#CENTNO_AddressOut').val());
                        // $('#ObserverIDOutTd').text($('#ObserverIDOut').val());
                        // $('#ClaimantNameOutTd').text($('#ClaimantNameOut').val());
                        // $('#DesignationOutTd').text($('#DesignationOut').val());
                        // $('#AddressOut1Td').text($('#AddressOut1').val());
                        // $('#ContactNoOutTd').text($('#ContactNoOut').val());
                        // $('#TotalDutyDayOutTd').text($('#TotalDutyDayOut').val());
                        // $('#HonorariumAmountOutTd').text($('#HonorariumAmountOut').val());
                        // $('#AdmissibleChargeOutTd').text($('#AdmissibleChargeOut').val());
                        // $('#BankName_BranchOut1Td').text($('#BankName_BranchOut1').val());
                        // $('#AccountNoOut1Td').text($('#AccountNoOut1').val());
                        // $('#MICRNoOut1Td').text($('#MICRNoOut1').val());
                        // $('#PANOut1Td').text($('#PANOut1').val());

                        $('#exampleModalOut').modal('show')
                        // console.log('in elseeee')
                        // activeForm .submit();
                    }

                    // $('#FormFinalSubmitBtn2').on('click',function(){
                    //     $('#outstation-form').submit();
                    // });
                });

                $('#localFormPreviewBtn').on('click', function() {

                    var examNameValue = $('#ExamName').val();
                    var examDateValue = $('#ExamDate').val();
                    var centNoValue = $('#CENTNO').val();
                    var centerNameValue = $('#centerName').val();
                    var nameValue = $('#Name').val();
                    var observerIdValue = $('#ObserverID').val();
                    var addressValue = $('#Address').val();
                    var contactValue = $('#Contact').val();
                    var panValue = $('#PAN').val();
                    var ccNameValue = $('#CCNameContact').val();
                    var rsNameValue = $('#RSName').val();
                    var branchValue = $('#Branch').val();
                    var accountNoValue = $('#AccountNo').val();
                    var ifscValue = $('#IFSC').val();
                    var RemunerationTable = $('.RemunerationTable').html();

                    $('#examNameTd').text(examNameValue);
                    $('#examDateTd').text(examDateValue);
                    $('#centNoTd').text(centNoValue);
                    $('#centerNameTd').text(centerNameValue);
                    $('#nameTd').text(nameValue);
                    $('#observerIdTd').text(observerIdValue);
                    $('#addressTd').text(addressValue);
                    $('#contactTd').text(contactValue);
                    $('#panTd').text(panValue);
                    $('#ccNameTd').text(ccNameValue);
                    $('#rsNameTd').text(rsNameValue);
                    $('#branchTd').text(branchValue);
                    $('#accountNoTd').text(accountNoValue);
                    $('#ifscTd').text(ifscValue);
                    // $('.RemunerationTableModal').html(RemunerationTable);

                    var isValid = true;
                    var activeForm = $('.tab-pane.active').find('form');

                    activeForm.find(
                            "input[type='text'], textarea, select[name$='[time]'],input[type='date']"
                        )
                        .each(function() {
                            if ($.trim($(this).val()) == '') {
                                var next = $(this).siblings('div');
                                // var input_name = $(this).prev().text();
                                // var input_name = input_name.slice(0, -1);
                                next.addClass('error');
                                next.removeClass('d-none');
                                next.addClass('d-block');
                                next.text(`This is required`);
                                isValid = false;

                            }
                        });
                    if (!isValid) {
                        return false; // Prevent form submission
                    } else {
                        var examNameValue = $('#ExamName').val();
                        var examDateValue = $('#ExamDate').val();
                        var centNoValue = $('#CENTNO').val();
                        var centerNameValue = $('#centerName').val();
                        var nameValue = $('#Name').val();
                        var observerIdValue = $('#ObserverID').val();
                        var addressValue = $('#Address').val();
                        var contactValue = $('#Contact').val();
                        var panValue = $('#PAN').val();
                        var ccNameValue = $('#CCName').val();
                        var rsNameValue = $('#RSName').val();
                        var branchValue = $('#Branch').val();
                        var accountNoValue = $('#AccountNo').val();
                        var ifscValue = $('#IFSC').val();
                        var RemunerationTable = $('.RemunerationTable').html();

                        $('#examNameTd').text(examNameValue);
                        $('#examDateTd').text(examDateValue);
                        $('#centNoTd').text(centNoValue);
                        $('#centerNameTd').text(centerNameValue);
                        $('#nameTd').text(nameValue);
                        $('#observerIdTd').text(observerIdValue);
                        $('#addressTd').text(addressValue);
                        $('#contactTd').text(contactValue);
                        $('#panTd').text(panValue);
                        $('#ccNameTd').text(ccNameValue);
                        $('#rsNameTd').text(rsNameValue);
                        $('#branchTd').text(branchValue);
                        $('#accountNoTd').text(accountNoValue);
                        $('#ifscTd').text(ifscValue);
                        // $('.RemunerationTableModal').html(RemunerationTable);

                        $('#exampleModal').modal('show')
                        // activeForm .submit();
                    }
                });


                $(document).on('click', '.verifyAadhaarBtn', function() {

                    var FormId = $(this).data('id');

                    if (FormId == 1) {
                        $('#exampleModal').modal('hide');
                    } else {
                        $('#exampleModalOut').modal('hide');
                    }
                    resetAadharVerification();
                    $('#AadharModal').modal('show').attr('data-id', +FormId);

                });
            });

            $(document).on('click', '.finalSubmitLocal', function() {
                var btn = $('.localFormSubmitBtn');
                btn.trigger('click');
                setTimeout(function() {
                    btn.trigger('click');
                }, 300);
            });
            $(document).on('click', '.finalSubmitOutstation', function() {
                var btn = $('.outsideFormSubmitBtn');
                btn.trigger('click');
                setTimeout(function() {
                    btn.trigger('click');
                }, 300);
            });



        });

        function submitForm() {
            document.getElementById("logoutForm").submit();
        }

        function calculation() {
            var totalRemuneration = 0;
            var totalTDS = 0;

            $('.RemunerationOnlineTable tr').each(function() {
                if ($(this).find('.RemunerationAmount').length > 0) {
                    var countCenter = '{{ count($UserData) }}';
                    if(countCenter > 1){
                        var dutydays = '{{$totalDutyDays ?? 0}}';
                    }else{
                        var dutydays = '{{ $BillData->A_Dutydays }}';
                    }
                   
                   
                    var MockVal = '{{ $BillData->mockval }}';
                    var attrName = $(this).find('.RemunerationSection').attr("name");

                    if ($(this).find('.mockdrilldutydays').length > 0) {

                        if (MockVal == 1) {

                            dutydays = '{{ $BillData->A_Dutydays }}';
                        } else {
                            dutydays = 1;
                        }

                    }

                    var RemunerationtdsAmount = 0;

                    $(this).find('.RemunerationAmount').each(function() {
                        RemunerationtdsAmount += parseFloat($(this).val()) || 0;
                    });
                    // console.log('Prasidh = ' + RemunerationtdsAmount)
                    if (attrName == 'Remuneration##Amount') {
                        var rowRemuneration = RemunerationtdsAmount;
                    } else {
                        var rowRemuneration = RemunerationtdsAmount * dutydays;
                    }
                    //totalRemuneration += rowRemuneration;
                    if (rowRemuneration > 0) {
                        $(this).find('.RemunerationSection').val(rowRemuneration);
                    }

                    if ($(this).find('.tds').length > 0) {
                        var tdsPer = parseFloat($(this).find('.tds').val()) || 0;
                        var tds = (rowRemuneration * tdsPer) / 100;
                        totalTDS += tds;
                        $('#tds').val(totalTDS);
                    }
                }
            });

            $('.RemunerationOnlineTable tr').each(function() {
                if ($(this).find('.RemunerationSection').length > 0) {
                    var remuneration = parseInt($(this).find('.RemunerationSection').val()) || 0;
                    if (!isNaN(remuneration)) {
                        totalRemuneration += remuneration;
                    }
                }
            });
            var totalTDS = $('#tds').val();
            var advanceP = parseFloat($('#advancePayment').val()) || 0;
            $('#NetPaybleAmount').val(parseFloat(totalRemuneration - advanceP - totalTDS));
        }

        $(document).ready(function() {
            calculation();
            $('.RemunerationSection  ,#advancePayment').on('input', function() {
                calculation();

            });

        });
        // for upload
        document.querySelectorAll('.file-upload').forEach(uploadContainer => {
            const fileInput = uploadContainer.querySelector('.file-input');
            const fileLabel = uploadContainer.querySelector('.file-label');
            const fileName = uploadContainer.querySelector('.file-name');

            // Create a span element for error messages
            const fileError = document.createElement('span');
            fileError.style.color = 'red';
            uploadContainer.appendChild(fileError); // Append it to the container

            fileLabel.addEventListener('click', function() {
                fileInput.click();
            });

            fileInput.addEventListener('change', function() {
                if (fileInput.files.length > 0) {
                    const file = fileInput.files[0];
                    const allowedExtensions =
                        /(\.pdf|\.xls|\.xlsx|\.jpg|\.jpeg|\.png|\.doc|\.docx)$/i; // Add more extensions as needed 'jpg','jpeg', 'png', 'pdf','doc','docx','xls','xlsx'
                    const maxSize = 2 * 1024 * 1024; // 2MB in bytes
                    const filePath = file.name;
                    const fileSize = file.size;

                    // Reset error message
                    fileError.textContent = '';

                    // Check for allowed file extensions
                    if (!allowedExtensions.exec(filePath)) {
                        fileError.textContent =
                            'Invalid file type. Only jpg, jpeg, png, pdf, doc, docx, xls, xlsx files are allowed.';
                        fileInput.value = ''; // Clear the input
                        fileName.textContent = 'No file chosen';
                        return false;
                    }

                    // Check for file size
                    if (fileSize > maxSize) {
                        fileError.textContent = 'File size must not exceed 2MB.';
                        fileInput.value = ''; // Clear the input
                        fileName.textContent = 'No file chosen';
                        return false;
                    }

                    // If valid, display the file name
                    fileName.textContent = file.name;
                } else {
                    fileName.textContent = 'No file chosen';
                }
            });
        });

        var today = new Date().toISOString().split('T')[0];
        $('.hasDatepicker').attr('max', today);
    </script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>
    <script>
        // // Function to handle date validation
        // function validateDates() {
        //     $('.date-input').each(function() {
        //         // Get the IDs of the current DepartureDate and ArrivalDate
        //         let id = $(this).attr('id');
        //         let index = id.match(/\d+$/)[0];

        //         // Get DepartureDate and ArrivalDate values
        //         let departureDate = $(`#DepartureDate${index}`).val();
        //         let arrivalDate = $(`#ArrivalDate${index}`).val();

        //         // Perform validation
        //         if (departureDate && arrivalDate && departureDate > arrivalDate) {
        //             Swal.fire({
        //                     title: "Warning",
        //                     text: "Departure Date must be earlier than Arrival Date.",
        //                     icon: "error"
        //                 });

        //             // Clear only the invalid date input
        //             $(this).val('');

        //             // Optionally, you can focus on the cleared input
        //             $(this).focus();
        //         }
        //     });
        // }
        // // Bind validation function to the change event of date inputs
        // $(document).on('change','.date-input',function() {
        //     validateDates();validateTimes();
        // });

        // Function to handle date and time validation
        function validateDatesAndTimes() {
            $('.date-input').each(function() {
                // Get the ID of the current input
                let id = $(this).attr('id');
                let index = id.match(/\d+$/)[0];

                // Get DepartureDate, ArrivalDate, DepartureTime, and ArrivalTime values
                let departureDate = $(`#DepartureDate${index}`).val();
                let arrivalDate = $(`#ArrivalDate${index}`).val();
                let departureTime = $(`#DepartureTime${index}`).val();
                let arrivalTime = $(`#ArrivalTime${index}`).val();

                if (departureDate && arrivalDate && departureTime && arrivalTime) {
                    // Combine date and time into Date objects
                    let departureDateTime = new Date(`${departureDate}T${departureTime}`);
                    let arrivalDateTime = new Date(`${arrivalDate}T${arrivalTime}`);

                    // Perform validation
                    if (departureDateTime >= arrivalDateTime) {
                        Swal.fire({
                            title: "Warning",
                            text: "Departure Date and Time must be earlier than Arrival Date and Time.",
                            icon: "error"
                        });

                        // Clear the invalid date and time inputs
                        $(`#DepartureDate${index}`).val('');
                        $(`#DepartureTime${index}`).val('');
                        $(`#ArrivalDate${index}`).val('');
                        $(`#ArrivalTime${index}`).val('');

                        // Optionally, you can focus on the cleared input
                        $(`#DepartureDate${index}`).focus();
                    }
                }
            });
        }

        // Bind validation function to the change event of date and time inputs
        $(document).on('change', '.date-input, .time-input', function() {
            validateDatesAndTimes();
        });


        $(document).on('change', '.uploaded_file', function() {
            const fileInput = this;
            const file = fileInput.files[0];
            const allowedExtensions = /(\.pdf|\.xls|\.xlsx|\.jpg|\.jpeg|\.png|\.doc|\.docx)$/i;
            const maxSize = 2 * 1024 * 1024; // 2MB in bytes

            // Find or create the error message element next to the file input
            let $fileError = $(fileInput).next('.fileError');
            if ($fileError.length === 0) {
                $fileError = $(
                    '<div class="fileError" style="color: red; font-size: 12px; margin-top: 5px;"></div>');
                $(fileInput).after($fileError);
            }

            // Reset error message
            $fileError.text('');

            if (file) {
                const filePath = file.name;
                const fileSize = file.size;

                // Check for allowed file extensions
                if (!allowedExtensions.exec(filePath)) {
                    $fileError.text(
                        'Invalid file type. Only jpg, jpeg, png, pdf, doc, docx, xls, xlsx files are allowed.');
                    fileInput.value = ''; // Clear the input
                    return false;
                }

                // Check for file size
                if (fileSize > maxSize) {
                    $fileError.text('File size must not exceed 2MB.');
                    fileInput.value = ''; // Clear the input
                    return false;
                }

                // If valid, clear the error message
                $fileError.remove();
            } else {
                // If no file is selected, clear the error message
                $fileError.remove();
            }
        });


        $(document).on('click', '.detailsModal', function() {
            // Get data from the clicked element
            var dutyDates = $(this).data('dutydate'); // Array
            var shiftCount = $(this).data('shiftcount'); // Object
            var shiftAmounts = $(this).data('shiftamount'); // Array
            var totalAmount = $(this).data('totalamount'); // Number

            console.log("Duty Dates:", dutyDates);
            console.log("Shift Count:", shiftCount);
            console.log("Shift Amounts:", shiftAmounts);
            console.log("Total Amount:", totalAmount);

            // Ensure data is parsed correctly
            if (typeof dutyDates === "string") {
                dutyDates = JSON.parse(dutyDates.replace(/&quot;/g, '"')); // Convert string to array
            }
            if (typeof shiftCount === "string") {
                shiftCount = JSON.parse(shiftCount.replace(/&quot;/g, '"')); // Convert string to object
            }
            if (typeof shiftAmounts === "string") {
                shiftAmounts = JSON.parse(shiftAmounts.replace(/&quot;/g, '"')); // Convert string to array
            }

            var shiftCountValues = Object.values(shiftCount);

            // Clear previous table data
            $('#ShiftWiseAmount').empty();

            // Loop through dutyDates and display in the table
            $.each(dutyDates, function(index, date) {
                var shiftTotal = shiftCountValues[index] || "N/A";
                var amount = shiftAmounts[index] ? parseFloat(shiftAmounts[index]).toLocaleString('en-US', {
                    minimumFractionDigits: 2,
                    maximumFractionDigits: 2
                }) : "N/A"; // Format amount

                var newRow = `
            <tr>
                <td>${date}</td>
                <td>${shiftTotal}</td>
                <td>${amount}</td>
            </tr>`;
                $('#ShiftWiseAmount').append(newRow);
            });

            // Format total amount and add it as a separate row
            var formattedTotalAmount = totalAmount ? parseFloat(totalAmount).toLocaleString('en-US', {
                minimumFractionDigits: 2,
                maximumFractionDigits: 2
            }) : "N/A";

            var totalRow = `
            <tr class="font-weight-bold text-success">
                <td colspan="2" class="text-right"><strong>Total Amount:</strong></td>
                <td><strong>${formattedTotalAmount}</strong></td>
            </tr>`;

            $('#ShiftWiseAmount').append(totalRow);

            $('#detailsModal').modal('show'); // Open modal
        });
    </script>
@endsection
