<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ 'NTA:: ' . $title ?? 'Default' }}</title>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.bunny.net">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">
    <link rel="shortcut icon" href="{{ asset('assets/images/logo-icon.ico') }}">

    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/bootstrap.min.css') }}">
    <!-- no need to menu only icon show -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/font-awesome.min.css') }}">
    <!--- no need to menu only icon show -->
    <!-- rsmenu CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-main.css') }}">
    <!-- rsmenu transitions CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-transitions.css') }}">
    <!-- style css -->

    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/style.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/responsive.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/outside.css') }}" />
    <link rel="stylesheet" href="{{ asset('assets/css/select2.min.css') }}" />


    <!-- Scripts -->
    {{-- @vite(['resources/sass/app.scss', 'resources/js/app.js']) --}}
    <style>
        .cursor-pointer {
            cursor: pointer;
        }

        .sitemap-widget li a {
            text-decoration: none;
        }

        .nav-menu>li>a:hover {
            color: #fff !important;
        }

        .flexes a {
            text-decoration: none !important;
        }

        .card-header a {
            text-decoration: none !important;
        }

        .nav-link>.menuformR:hover {
            cursor: pointer;
        }

        ul.breadcrumb {
            padding: 10px 16px;
            list-style: none;
            background-color: #eee;
        }

        ul.breadcrumb li {
            display: inline;
            font-size: 14px;
        }

        ul.breadcrumb li+li:before {
            padding: 8px;
            color: black;
            content: "/\00a0";
        }

        ul.breadcrumb li a {
            color: #0275d8;
            text-decoration: none;
        }

        ul.breadcrumb li a:hover {
            color: #01447e;
            text-decoration: underline;
        }
    </style>
</head>
@php
    $ExamsList = getUserExamsList();
    $SelectedExam = Session::get('examType');
    $allowedRoles = [10, 3, 11, 12, 13, 14];

@endphp

<body>
    <div id="app">
        <div class="rs-header-top py-3">
            <div class="container custom-container">
                <div class="row">
                    <div class="col-lg-12 col-md-12">
                        <div class="row">
                            <div class="col-sm-6 col-6">
                                <div class="header-contact mt-3">
                                    <a href="{{ route('home') }}">
                                        <img class="img-fluid cursor-pointer"
                                            src="{{ asset('assets/images/nta-logo.png') }}" alt="nta-logo.png">
                                    </a>
                                </div>
                            </div>
                            <?php
                            $userProfileDetails = getUserInformation();
                            ?>
                            <div class="col-sm-6 col-12 custom-logo-3">
                                <div class="header-contact text-end">
                                    <div class="dropdown mt-15 user-profile-outer">
                                        <button type="button"
                                            class="btn btn-outline-secondary dropdown-toggle user-profile-btn bg-gray"
                                            data-bs-toggle="dropdown" aria-expanded="false">
                                            <img class="img-responsive"
                                                src="{{ isset($userProfileDetails->{'Profile Image'}) && $userProfileDetails->{'Profile Image'} != 'NULL' && !empty($userProfileDetails->{'Profile Image'}) ? $userProfileDetails->{'Profile Image'} : 'assets/images/default-user.jpg' }}"
                                                alt="default-user.jpg"> {{ Auth::user()->UserName }}
                                        </button>
                                        <ul class="dropdown-menu dropdown-menu-end">
                                            <li>
                                                <h5 class="dropdown-header">User Access Activity</h5>
                                            </li>
                                            <li><a class="dropdown-item" href="{{ route('view-profile') }}">Update
                                                    Profile</a></li>
                                            <li><a class="dropdown-item" href="{{ route('change-password') }}">Change
                                                    Password</a></li>
                                            <li>
                                                <form id="logout-form" action="{{ route('logout') }}" method="POST">
                                                    {{ csrf_field() }}
                                                    <button type="submit" class="dropdown-item"
                                                        value="submit">Logout</button>
                                                </form>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <nav class="menu-area nav-main-custom menu-sticky">
            <div class="container custom-container">
                <div class="main-menu">
                    <div class="row">
                        <div class="col-sm-10">
                            <a class="rs-menu-toggle"><i class="fa fa-bars"></i>Menu</a>
                            <nav class="rs-menu rs-menu-close">
                                @if (Session::has('examType'))
                                    <ul class="nav-menu">
                                        <li class="nav-item"> <a class="nav-link" href="{{ url('/home') }}">Home</a>
                                        </li>

                                        <li class="nav-item"><a class="nav-link">
                                                <form action="{{ route('exam-subdashboard') }}" method="POST"
                                                    class="menuformR">
                                                    @csrf
                                                    <input type="hidden" name="type" value='1'>
                                                    {{ config('constants.RoleName.' . session('role')) }}
                                                </form>
                                            </a>
                                        </li>
                                        @if (session('role') == 1)
                                            <li class="nav-item">
                                                <a class="nav-link">
                                                    <form action="{{ route('exam-subdashboard') }}" method="POST"
                                                        class="menuformR">
                                                        @csrf
                                                        <input type="hidden" name="type" value='2'>
                                                        Observer/Deputy Observer
                                                    </form>
                                                </a>
                                            </li>
                                        @elseif (!in_array(session('role'), $allowedRoles))
                                            <li class="nav-item">
                                                <a class="nav-link">
                                                    <form action="{{ route('exam-subdashboard') }}" method="POST"
                                                        class="menuformR">
                                                        @csrf
                                                        <input type="hidden" name="type" value='2'>
                                                        City Coordinator
                                                    </form>
                                                </a>
                                            </li>
                                        @endif
                                        <li class="nav-item">
                                            <a class="nav-link">
                                                <form action="{{ route('exam-subdashboard') }}" method="POST"
                                                    class="menuformR">
                                                    @csrf
                                                    <input type="hidden" name="type" value='3'>
                                                    Reports
                                                </form>
                                            </a>
                                        </li>
                                        <li class="nav-item">
                                            <a class="nav-link">
                                                <form action="{{ route('exam-detail') }}" method="POST"
                                                    class="menuformR">
                                                    @csrf
                                                    Exam Details
                                                </form>
                                            </a>
                                        </li>
                                        <li class="nav-item">
                                            <a class="nav-link">
                                                <form action="{{ route('my-profile') }}" method="POST"
                                                    class="menuformR">
                                                    @csrf
                                                    My Profile
                                                </form>
                                            </a>
                                        </li>
                                        <li class="nav-item"> <a class="nav-link"
                                                href="{{ url('contact') }}">Contact NTA</a></li>
                                        <li class="nav-item pull-right"> <a class="nav-link"
                                                href="javascript:history.back()"><i class="fa fa-arrow-left"
                                                    aria-hidden="true"></i>Back</a></li>
                                    </ul>
                                @else
                                    <ul class="nav-menu">
                                        <li class="nav-item"> <a class="nav-link"
                                                href="{{ url('/home') }}">Home</a></li>
                                        <li class="nav-item"> <a class="nav-link" href="#">Instruction</a></li>
                                        <li class="nav-item"> <a class="nav-link" href="#">Important</a></li>
                                        <li class="nav-item"> <a class="nav-link" href="#">Help</a></li>
                                        <li class="nav-item"> <a class="nav-link"
                                                href="{{ url('contact') }}">Contact NTA</a></li>
                                    </ul>
                                @endif
                            </nav>

                        </div>







                    </div>

                </div>
            </div>
        </nav>
        <div class="container custom-container">
            <div class="main-menu">
                <div class="row">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <?php
                            
                            function removeAfterString($fullString, $substring)
                            {
                                $position = strpos($fullString, $substring);
                                if ($position !== false) {
                                    return substr($fullString, 0, $position + strlen($substring));
                                }
                                return $fullString;
                            }
                            
                            // Initialize or update session link based on current URI segment
                            if (Request::segment(1) == 'dashboard') {
                                $link = Request::segment(1);
                                session(['link' => $link]);
                            } else {
                                $linkArray = explode('/', session('link'));
                                $linkArray[] = Request::segment(1);
                                $newLink = join('/', array_unique($linkArray));
                                $newLink = removeAfterString($newLink, Request::segment(1));
                                session(['link' => $newLink]);
                            }
                            // Split session link into segments
                            $linkSegments = explode('/', session('link'));
                            // Build breadcrumb HTML
                            $breadcrumb = '';
                            $url = '';
                            foreach ($linkSegments as $index => $segment) {
                                $url .= $segment . '/';
                                if ($index == count($linkSegments) - 1) {
                                    $breadcrumb .= '<li>' . ucwords($segment, '-') . '</li>'; // Last segment without link
                                } else {
                                    $breadcrumb .= "<li><a href='$segment'>" . ucwords($segment, '-') . '</a></li>';
                                }
                            }
                            echo $breadcrumb;
                            ?>
                        </ul>
                    </div>
                </div>
            </div>
        </div>


        <main class="">
            <!--  Loader -->
            <div class="overlay">
                <div id="loader"><img src="{{ asset('assets/images/loader.gif') }}" width="200"
                        alt="Loading..."></div>
            </div>
            <!--  Loader -->


            @if (session('success'))
                <div class="container custom-container">
                    <div class="d-flex justify-content-between alert alert-success alert-dismissible fade show mt-3"
                        role="alert">
                        {{ session('success') }}
                        <button type="button" class="btn-close" data-bs-dismiss="alert"
                            aria-label="Close"></button>
                    </div>
                </div>
            @endif


            @yield('content')
        </main>

        <footer class="bg3 rs-footer custm-footer" id="rs-footer">
            <!-- Footer Top -->
            <div class="footer-top">
                <div class="container custom-container">
                    <div class="row">
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Helpdesk</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a href="{{ route('contact') }}"><i class="fa fa-angle-right"
                                            aria-hidden="true"></i>Contact Us</a></li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Additional Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a target="_blank" href="https://www.education.gov.in/"><i
                                            class="fa fa-angle-right" aria-hidden="true"></i>Ministry Of Education</a>
                                </li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Important Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a target="_blank" href="https://www.nta.ac.in/Home"><i
                                            class="fa fa-angle-right" aria-hidden="true"></i>National Testing
                                        Agency</a></li>
                                <li><a target="_blank" href="https://www.nta.ac.in/abhyas"><i
                                            class="fa fa-angle-right" aria-hidden="true"></i>National Testing
                                        Abhyas</a></li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Other Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                {{-- <li class="active"><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Copyright Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Privacy Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Hyperlink Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Terms and Conditions</a></li> --}}
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Help</a>
                                </li>

                            </ul>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Footer Bottom -->
            <div class="footer-bottom custm-footer">
                <div class="container custom-container-fluid">
                    <div class="copyright">
                        <p>Last Updated: <?= date('F, d Y') ?></p>
                    </div>
                </div>
            </div>
        </footer>

    </div>
    <!-- jquery latest version -->
    <script src="{{ asset('assets/js/jquery.min.js') }}"></script>
    <script src="{{ asset('assets/js/rsmenu-main.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.min.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.bundle.min.js') }}"></script>
    <script src="{{ asset('assets/js/select2.min.js') }}"></script>
    <script>
    $(document).ready(function() {

        jQuery('.selectBox').select2({
            placeholder: '--Select--',
            dropdownAutoWidth: true,
            allowClear: true
        });
        jQuery('.selectBoxMultiple').select2({
            placeholder: '--Select--',
            multiple: true,
            dropdownAutoWidth: true,
            allowClear: true
        });
    });
    </script>
    @yield('script')
</body>

</html>
