<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">
    <title>{{ 'NTA:: ' . $title ?? 'Default' }}</title>
    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.bunny.net">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">
    <link rel="shortcut icon" href="{{ asset('assets/images/logo-icon.ico') }}">

    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/bootstrap.min.css') }}">
    <!-- no need to menu only icon show -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/font-awesome.min.css') }}">
    <!--- no need to menu only icon show -->
    <!-- rsmenu CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-main.css') }}">
    <!-- rsmenu transitions CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-transitions.css') }}">
    <!-- style css -->

    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/style.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/responsive.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/outside.css') }}" />
    <link rel="stylesheet" href="{{ asset('assets/css/select2.min.css') }}" />
    <link rel="stylesheet" type="text/css" href="{{ asset('admin/assets/css/style.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/sweetalert2.min.css') }}" />
    <link rel="stylesheet" href="https://cdn.datatables.net/2.2.2/css/dataTables.dataTables.css" />
  


    @yield('styles')
    <!-- Scripts -->
    {{-- @vite(['resources/sass/app.scss', 'resources/js/app.js']) --}}
    <style>
        .cursor-pointer {
            cursor: pointer;
        }

        .sitemap-widget li a {
            text-decoration: none;
        }

        .nav-menu>li>a:hover {
            color: #fff !important;
        }

        .flexes a {
            text-decoration: none !important;
        }

        .card-header a {
            text-decoration: none !important;
        }

        .nav-link>.menuformR:hover {
            cursor: pointer;
        }

        ul.breadcrumb {
            padding: 10px 16px;
            list-style: none;
            background-color: #eee;
        }

        ul.breadcrumb li {
            display: inline;
            font-size: 14px;
        }

        ul.breadcrumb li+li:before {
            padding: 8px;
            color: black;
            content: "/\00a0";
        }

        ul.breadcrumb li a {
            color: #0275d8;
            text-decoration: none;
        }

        ul.breadcrumb li a:hover {
            color: #01447e;
            text-decoration: underline;
        }

        .user-circle {
            width: 40px;
            height: 40px;
            border-radius: 50%;
            overflow: hidden;
            display: flex;
            background-color: #004b64;
            /* Adjust for desired color */
            color: #fff;
            font-size: 18px;
            font-weight: bold;
            display: flex;
            align-items: center;
            justify-content: center;
            text-transform: uppercase;
        }

        .user-circle img {
            width: 100%;
            height: 100%;
            object-fit: cover;
            /* Ensures the image covers the circle */
        }


        .dropdown-menu {
            padding: 0;
            margin: 0;
        }

        .dropdown-menu li {
            border-bottom: 1px solid #e0e0e0;
            margin: 0;
        }

        .dropdown-menu li:last-child {
            border-bottom: none;
        }

        .dropdown-menu .dropdown-item {
            padding: 8px 15px;
        }

        .nav-menu2>li>a:hover {
            background-color: #035671;
            color: #fff;
            transition: background-color 0.3s ease;
        }
        a.btn:hover {
            color: #fff !important;
        }
        .astric-sign{
            color: red;
            font-size: 16px;
        }
    </style>
</head>
@php
    $ExamsList = getUserExamsList();
    $SelectedExam = Session::get('examType');
    $allowedRoles = [10, 3, 11, 12, 13, 14];

@endphp

<body>
    <div id="app">
        <nav class="menu-area nav-main-custom-admin menu-sticky">
            <div class="container custom-container">
                <div class="main-menu">
                    <div class="row align-items-center">
                        <div class="col-sm-10">
                            {{-- <a class="rs-menu-toggle"><i class="fa fa-bars"></i>Menu</a> --}}
                            <nav class="rs-menu rs-menu-close">
                                <ul class="nav-menu2" style="padding: 10px">
                                    <li class="nav-item">
                                        @if (Auth::user()->Role_ID == 27)
                                            <a href="{{ route('admin.superdashboard') }}">
                                                <img class="img-fluid"
                                                    src="{{ asset('admin/assets/images/inside--logo.png') }}"
                                                    alt="nta-logo.png">
                                                <span style="font-size:16px;color:#fff" class="mx-3">National Testing
                                                    Agency</span>
                                            </a>
                                        @elseif(Auth::user()->Role_ID == 24)
                                            <a href="{{ route('admin.dashboard') }}">
                                                <img class="img-fluid"
                                                    src="{{ asset('admin/assets/images/inside--logo.png') }}"
                                                    alt="nta-logo.png">
                                                <span style="font-size:16px;color:#fff" class="mx-3">National Testing
                                                    Agency</span>
                                            </a>
                                        @endif
                                    </li>
                                </ul>
                            </nav>
                        </div>
                        <!-- User Dropdown Menu with Circular Design -->
                        <div class="col-sm-2 text-end">
                            <div class="dropdown pull-right">
                                <button class="btn dropdown-toggle d-flex align-items-center" type="button"
                                    id="userMenu" data-bs-toggle="dropdown" aria-expanded="false"
                                    style="background-color: #035671;border-color: #035671;color:#fff;transition: background-color 0.3s;">
                                    <div class="user-circle">
                                        @if (Auth::user()->ProfileImage && file_exists(public_path('admin/' . Auth::user()->ProfileImage)))
                                            <img src="{{ asset('admin/' . Auth::user()->ProfileImage) }}"
                                                alt="Profile Image">
                                        @else
                                            <!-- Display the first letter of the username -->
                                            {{ substr(Auth::user()->FullName, 0, 2) }}
                                        @endif
                                    </div>
                                    <span class="ms-2">{{ Auth::user()->FullName }}</span>
                                </button>
                                <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="userMenu">

                                    <li><a class="dropdown-item" href="{{ route('change-password.form') }}"><i
                                                class="fa fa-key me-2"></i> Change
                                            Password</a></li>
                                    <li><a class="dropdown-item" href="{{ route('profile.view') }}"><i
                                                class="fa fa-user me-2"></i> Update
                                            Profile</a></li>
                                    <li>
                                        <form id="logout-form" action="{{ route('adminlogout') }}" method="POST">
                                            {{ csrf_field() }}
                                            <button type="submit" class="dropdown-item" value="submit"><i
                                                    class="fa fa-sign-out me-2"></i> Logout</button>
                                        </form>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </nav>

        <main class="">
            <!--  Loader -->
            <div class="overlay">
                <div id="loader"><img src="{{ asset('assets/images/loader.gif') }}" width="200" alt="Loading...">
                </div>
            </div>
            <!--  Loader -->

            {{-- <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    @foreach (Breadcrumbs::current() as $breadcrumb)
                        @if ($breadcrumb->url && !$loop->last)
                            <li class="breadcrumb-item">
                                <a href="{{ $breadcrumb->url }}">{{ $breadcrumb->title }}</a>
                            </li>
                        @else
                            <li class="breadcrumb-item active" aria-current="page">{{ $breadcrumb->title }}</li>
                        @endif
                    @endforeach
                </ol>
            </nav> --}}

            @yield('content')
        </main>

        <footer class="bg3 rs-footer-admin " id="rs-footer" style="margin-top:430px;">
            <!-- Footer Bottom -->
            <div class="footer-bottom ">
                <div class="container custom-container-fluid">
                    <div class="copyright">
                        <p>&copy; {{ date('Y') }} National Testing Agency. All rights reserved.
                            {{-- Last Updated: </?= date('F, d Y') ?></p> --}}
                    </div>
                </div>
            </div>
        </footer>
    </div>
    <!-- jquery latest version -->

    <script src="{{ asset('assets/js/jquery.min.js') }}"></script>
    <script src="{{ asset('assets/js/rsmenu-main.js') }}"></script>
    {{-- <script src="{{ asset('assets/js/bootstrap.bundle.min.js') }}"></script> --}}
    <script src="{{ asset('assets/js/popper.min.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.min.js') }}"></script>
    <script src="{{ asset('assets/js/select2.min.js') }}"></script>
    <script src="{{ asset('assets/js/sweetalert2.min.js') }}"></script>
    <script src="{{ asset('assets/js/jquery.validate.min.js') }}"></script>

    <script src="https://cdn.datatables.net/2.2.2/js/dataTables.js"></script>
    @if (session('success'))
        <script>
            Swal.fire({
                title: 'Success!',
                text: '{{ session('success') }}',
                icon: 'success',
                confirmButtonText: 'Ok'
            });
        </script>
    @endif

    @if (session('error'))
        <script>
            Swal.fire({
                title: 'Error!',
                text: '{{ session('error') }}',
                icon: 'error',
                confirmButtonText: 'Ok'
            });
        </script>
    @endif

    @if (session('warning'))
        <script>
            Swal.fire({
                title: 'Warning!',
                text: '{{ session('warning') }}',
                icon: 'warning',
                confirmButtonText: 'Ok'
            });
        </script>
    @endif

    <!-- Load jQuery Validation Plugin -->
    <script>
        $(document).ready(function() {
            jQuery('.selectBox').select2({
                placeholder: '--Select--',
                dropdownAutoWidth: true,
                allowClear: true
            });
            jQuery('.selectBoxMultiple').select2({
                placeholder: '--Select--',
                multiple: true,
                dropdownAutoWidth: true,
                allowClear: true
            });
        });
    </script>
    @yield('script')
</body>

</html>
