<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{  $title ?? 'NTA' }}</title>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.bunny.net">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">
    <link rel="shortcut icon" href="{{ asset('assets/images/logo-icon.ico') }}">
    <!-- no need to menu only icon show -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/bootstrap.min.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/font-awesome.min.css') }}">
    <!--- no need to menu only icon show -->
    <!-- rsmenu CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-main.css') }}">
    <!-- rsmenu transitions CSS -->
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/rsmenu-transitions.css') }}">
    <!-- style css -->

    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/style.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('assets/css/responsive.css') }}">
    <link rel="stylesheet" href="{{ asset('assets/css/outside.css') }}" />
    <!-- Scripts -->
    <!-- rsmenu js -->
    <style>
    .cursor-pointer {
        cursor: pointer;
    }

    .sitemap-widget li a {
        text-decoration: none;
    }

    .nav-menu>li>a:hover {
        color: #fff !important;
    }

    .flexes a {
        text-decoration: none !important;
    }

    .card-header a {
        text-decoration: none !important;
    }
    </style>

</head>

<body>
    <div id="app">
        <div class="rs-header-top py-3">
            <div class="container custom-container">
                <div class="row">
                    <div class="col-lg-12 col-md-12">
                        <div class="row">
                            <div class="col-sm-6 col-6">
                                <div class="header-contact mt-3">
                                    <img class="img-fluid" src="{{ asset('assets/images/edu-logo.png') }}"
                                        alt="edu-logo.png">
                                </div>
                            </div>
                            <div class="col-sm-6 col-12 custom-logo-3 d-flex justify-content-end">
                                <div class="header-contact mt-3">
                                    <img class="img-fluid" src="{{ asset('assets/images/nta-logo.png') }}"
                                        alt="nta-logo.png">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <nav class="menu-area nav-main-custom menu-sticky">
            <div class="container custom-container">
                <div class="main-menu">
                    <div class="row">
                        <div class="col-sm-12">
                            <!-- <div id="logo-sticky" class="text-center">
                            <a href="index.html"><img src="images/logo.png" alt="logo"></a>
                        </div> -->
                            <a class="rs-menu-toggle"><i class="fa fa-bars"></i>Menu</a>
                            <nav class="rs-menu rs-menu-close">
                                <ul class="nav-menu">
                                    <li class="nav-item"> <a class="nav-link" href="{{ url('/dashboard') }}">Home</a>
                                    </li>
                                    <li class="nav-item"> <a class="nav-link" href="#">Instruction</a></li>
                                    <li class="nav-item"> <a class="nav-link" href="#">Important</a></li>
                                    <li class="nav-item"> <a class="nav-link" href="#">Help</a></li>
                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </nav>
        <main class="">
        
            @if($errors->any())
            <div class="container custom-container">
                <div class="d-flex justify-content-between alert alert-danger mt-3">
                    @foreach ($errors->all() as $error)
                    {{ $error }}
                    @endforeach
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>
            </div>
            @endif

            @yield('content')
        </main>

        <footer class="bg3 rs-footer custm-footer" id="rs-footer">
            <!-- jquery latest version -->

            <!-- Footer Top -->
            <div class="footer-top">
                <div class="container custom-container">
                    <div class="row">
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Helpdesk</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a href="{{route('contact')}}"><i class="fa fa-angle-right"
                                            aria-hidden="true"></i>Contact Us</a></li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Additional Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a target="_blank" href="https://www.education.gov.in/"><i
                                            class="fa fa-angle-right" aria-hidden="true"></i>Ministry Of Education</a>
                                </li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Important Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                <li class="active"><a target="_blank" href="https://www.nta.ac.in/Home"><i
                                            class="fa fa-angle-right" aria-hidden="true"></i>National Testing Agency</a>
                                </li>
                                <li><a target="_blank" href="https://www.nta.ac.in/abhyas"><i class="fa fa-angle-right"
                                            aria-hidden="true"></i>National Testing Abhyas</a></li>
                            </ul>
                        </div>
                        <div class="col-lg-3 col-md-12">
                            <h5 class="footer-title">Other Links</h5>
                            <ul class="list-unstyled sitemap-widget">
                                {{-- <li class="active"><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Copyright Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Privacy Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Hyperlink Policy</a></li>
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Terms and Conditions</a></li> --}}
                                <li><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i>Help</a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Footer Bottom -->
            <div class="footer-bottom custm-footer">
                <div class="container custom-container-fluid">
                    <div class="copyright">
                        <p>Last Updated: June 11, 2024</p>
                    </div>
                </div>
            </div>
        </footer>

    </div>


    <script src="{{ asset('assets/js/jquery.min.js') }}"></script>
    <script src="{{ asset('assets/js/rsmenu-main.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.min.js') }}"></script>
    <script src="{{ asset('assets/js/bootstrap.bundle.min.js') }}"></script>

    @yield('script')
    <script>
    $(document).ready(function() {
        $('[data-toggle="tooltip"]').tooltip();
    });
    </script>
</body>

</html>