<style>
    @keyframes blink {
        0% {
            opacity: 1;
        }

        50% {
            opacity: 0;
        }

        100% {
            opacity: 1;
        }
    }

    .blinking-text {
        animation: blink 1s infinite;
        color: red;
        /* Adjust the color as needed */
    }
</style>

<div class="col-sm-4 mb-30">
    <div class="card card-white">
        <div class="custom-card overflw">
            <div class="form-inner">
                <div class="row">
                    <div class="col-md-12">
                        @php
                            $userProfileDetails = getUserInformation();
                        @endphp
                        <h4>Welcome - {{ isset(Auth::user()->UserName) ? Auth::user()->UserName : null }}</h4>
                    </div>
                    <div class="col-md-3 col-4">
                        <img class="img-thumbnail img-responsive cut-image"
                            src="{{ isset($userProfileDetails->{'Profile Image'}) && $userProfileDetails->{'Profile Image'} != 'NULL' && !empty($userProfileDetails->{'Profile Image'}) ? $userProfileDetails->{'Profile Image'} : asset('assets/images/default-user.jpg') }}"
                            alt="default-user.jpg">
                    </div>
                    <div class="col-md-9 col-8">
                        <div class="custom-head-text">
                            <p>Username:
                                <strong>{{ isset($userProfileDetails->vendorDetails->{'Name'}) ? $userProfileDetails->vendorDetails->{'Name'} : null }}</strong>
                            </p>
                            <p>Mobile:
                                <strong>{{ isset($userProfileDetails->vendorDetails->{'Mobile Phone No_'}) ? $userProfileDetails->vendorDetails->{'Mobile Phone No_'} : null }}</strong>
                            </p>
                            <p>Email:
                                <strong>{{ isset($userProfileDetails->vendorDetails->{'E-Mail'}) ? $userProfileDetails->vendorDetails->{'E-Mail'} : null }}</strong>
                            </p>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="form-group mt-30">
                        <div class="row">
                            <div class="col-md-6">
                                <p class="flexes">Contact Details</p>
                            </div>
                            <div class="col-md-6">
                                <p class="flexes custom-flexes"><a href="{{ route('view-profile') }}"
                                        class="">Update Profile</a></p>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>

    @php 

    if (Request::segment(1) == 'dashboard') {
        $getCommonSettingsData = _getCommonSettingsDataLastNotBlank();
    } else {
        $role = session('role') ?? '';
        $examType = session('examType') ?? '';
        $getCommonSettingsData = _getCommonSettingsData($examType,$role);
    }
    @endphp
    @if(isset($getCommonSettingsData->instructions_texts) && !empty($getCommonSettingsData->instructions_texts))
    <div class="card card-white mt-15">
        <div class="custom-card overflw">
            <div class="form-inner">
                <div>
                    <h6 class="blinking-text"><i class="fa fa-clock-o" aria-hidden="true"></i> Important Instructions:
                    </h6>
                    <div class="cust-h6"></div>
                    <div class="form-group mt-30">
                        <div class="row">
                            <div class="col-md-12 p-0">
                                <!-- <ol class="numbered-list">
                                    <li>User must update their profile details before submitting the bill.</li>
                                    <li>Single bill will need to be submitted for a particular exam conducted on
                                        multiple days.</li>
                                    <li>Bill can’t be edited once it is submitted successfully. You can only resubmit
                                        when NTA rejects the bill (Status: Sent for Clarification).</li>
                                    <li>You may check the current bill status from Reports/ Submitted Bill status
                                        section.</li>
                                    <li>In CC Bill, please fill the details of your Observers/ Dy. Observers along
                                        with the Bank details, PAN no., Advance payments, Duty days, etc. and upload the excel file.</li>
                                    <li>No need to enter the number of duty days wherever it is not required in the
                                        bill.</li>
                                    <li>For more information, go to the Help section for the entire bill submission
                                        process.</li>
                                </ol> -->
                                {!! $getCommonSettingsData->instructions_texts ?? '' !!}
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
    @endif
    <div class="card card-white mt-15">
        <div class="custom-card overflw">
            <div class="form-inner">
                <div>
                    <h6><i class="fa fa-clock-o" aria-hidden="true"></i> Activity Logs</h6>
                    <div class="cust-h6"></div>
                    <div class="form-group mt-30">
                        <?php 
                        $user = Auth::user();
                        $userName = $user ? str_replace(' ', '_', $user->UserName) : 'guest';
                        $path = 'customlog/' . $userName . '.json';
                        $limitTwoLog=[];
                        if (Storage::disk('local')->exists($path)) {
                            $logData = Storage::disk('local')->get($path);
                            $logEntries = explode(PHP_EOL, trim($logData));

                            $logs = array_map(function ($entry) {
                                return json_decode($entry, true);
                            }, $logEntries);
                            $logs=array_values(array_filter($logs));
                            krsort($logs);
                            $limitTwoLog=array_slice($logs,0,3);
                        }
                        // prd($logs);
                        foreach($limitTwoLog as $val)
                            {?>
                        <div class="row">
                            <div class="col-md-5">
                                <p class="flexes"><?= ucwords($val['Description']) ?></p>
                            </div>
                            <div class="col-md-7">
                                <p class="flexes custom-flexes"><?= date('d-m-Y h:i A', strtotime($val['date'])) ?> </p>
                            </div>
                        </div>
                        <?php }?>

                    </div>
                    <div class="form-group">
                        <div class="row">
                            <div class="col-md-6">
                                <p class="flexes"></p>
                            </div>
                            <div class="col-md-6">
                                @if (count($limitTwoLog) > 0)
                                    <p class="flexes custom-flexes"><a href="{{ route('activity-log') }}"
                                            class="">View</a></p>
                                @endif
                            </div>
                        </div>
                    </div>
                </div>
                <div class="clearfix"></div>
            </div>
        </div>
    </div>
</div>
