@extends('layouts.admin')
@section('content')
    <style>
        .table tr td,
        tr th {
            text-align: center !important;

        }

        .card-header .btn-header-link {
            padding: 5px !important;
            margin: 1px solid;
        }

        .rmargin {
            margin-bottom: 2px !important;
        }

        .linehiteR {
            line-height: 16px;
            text-align: center !important;
        }

        input[type=checkbox][disabled] {
            background: gray !important;
            border: 1px solid #d4d4d5 !important;
        }

        input.largerCheckbox {
            width: 22px;
            height: 22px;
            margin: 3px;
        }

        label {
            margin-bottom: 0px !important;
        }

        .messageR {
            font-size: 14px;
            text-align: center;
            margin: 6px 25%;
            /* display: block; */
            /* margin-top: 2px; */
            width: 50%;
        }

        table {
            border-color: #ccc;
        }
    </style>

    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="login-5">
                <div class="container-fluid">
                    <div class="row no-gutters">
                        <div class="content-body mt-50 mb-50">
                            <div class="">
                                <div class="row no-gutters">
                                    <div class="col-sm-12">
                                        <div id="main">
                                            <div class="">
                                                <div class="card">
                                                    <h3 class="p-3 m-1">Mark Attendance -
                                                        <?= $data[0]->{'Exam Name'} ?? '' ?>
                                                        (Observer / Deputy Observer Lists)</h3>

                                                    <br />
                                                    <div class="ms-3">
                                                        <form method="GET" action="{{ route('mark-attendance') }}"
                                                            id="attendanceForm">
                                                            <div class="d-flex align-items-center">
                                                                <div class="me-3">
                                                                    <select class="form-select fs-5" name="showData"
                                                                        onchange="filterCheck()">
                                                                        <option value='All'
                                                                            @if (request('showData') == 'All') selected @endif>
                                                                            All</option>
                                                                        <option value='10'
                                                                            @if (request('showData') == 10) selected @endif>
                                                                            10
                                                                        </option>
                                                                        <option value='20'
                                                                            @if (request('showData') == 20) selected @endif>
                                                                            20
                                                                        </option>
                                                                        <option value='50'
                                                                            @if (request('showData') == 50) selected @endif>
                                                                            50
                                                                        </option>
                                                                        <option value='100'
                                                                            @if (request('showData') == 100) selected @endif>
                                                                            100</option>
                                                                    </select>
                                                                </div>
                                                                <div class="me-5">
                                                                    <label for="showData" class="fw-bold fs-5">Show
                                                                        Records</label>
                                                                </div>
                                                                <div class="form-check mx-3 ms-5">
                                                                    <input type="radio" class="form-check-input fs-4"
                                                                        name="attendance" value="yes" id="attendanceYes"
                                                                        @if (request('attendance') == 'yes') checked @endif
                                                                        onchange="filterCheck()">
                                                                    <label for="attendanceYes" class="form-check-label"
                                                                        style="font-size:15px">Filter with Marked
                                                                        Attendance</label>
                                                                </div>
                                                                <div class="form-check mx-3">
                                                                    <input type="radio" class="form-check-input fs-4"
                                                                        name="attendance" value="no" id="attendanceNo"
                                                                        @if (request('attendance') == 'no') checked @endif
                                                                        onchange="filterCheck()">
                                                                    <label for="attendanceNo" class="form-check-label"
                                                                        style="font-size:15px">Filter without Marked
                                                                        Attendance</label>
                                                                </div>

                                                                <div class="form-check">
                                                                    <nav class="navbar navbar-light bg-light">
                                                                        <div class="container-fluid">
                                                                            <div class="input-group">
                                                                                <input type="text" class="form-control"
                                                                                    placeholder="Filter Name"
                                                                                    aria-label="Search"
                                                                                    value="{{ request('filter') }}"
                                                                                    name="filter">
                                                                                <button class="btn btn-success"
                                                                                    type="submit"
                                                                                    onclick="filterCheck()">Search</button>
                                                                            </div>
                                                                        </div>
                                                                    </nav>
                                                                </div>
                                                                <div>
                                                                    <a href="{{ route('mark-attendance') }}"
                                                                        class="btn btn-warning p-3"
                                                                        onclick="filterCheck()">Reset</a>
                                                                </div>
                                                            </div>
                                                        </form>
                                                    </div>
                                                    <hr style="opacity: 0.7; border: 1px solid #000;" />
                                                    <div class="accordion accordion-flush mx-3" id="accordionFlushExample">
                                                        <?php $arrayIDs=array();
                                                    if(count($data)>0)
                                                    { $i=0;
                                                        $sNO=$page;
                                                        foreach($data as $row)
                                                        {++$i;
                                                            /************************************************** Shift wise******************************************************************/
                                                            if(session('ShiftWiseExam')=='yes')
                                                            {
                                                            $arrayIDs[]=$row->ObserverID;
                                                            if($row->Submitted==1 or $row->IsBlocked==1)
                                                            {
                                                                $disabled='disabled';
                                                            }else{
                                                                $disabled='';
                                                            }?>
                                                        <div class="accordion-item">
                                                            <h2 class="accordion-header" id="flush-heading<?= $i ?>">
                                                                <button class="accordion-button collapsed" type="button"
                                                                    data-bs-toggle="collapse"
                                                                    data-bs-target="#flush-collapse<?= $i ?>"
                                                                    aria-expanded="false"
                                                                    aria-controls="flush-collapse<?= $i ?>">
                                                                    <?= ++$sNO ?>. <?= $row->ObserverID ?> -
                                                                    <?= $row->Name ?>&nbsp;&nbsp;(Center
                                                                    No.-<?= $row->CENTNO ?>) &nbsp;&nbsp;
                                                                    <?= $row->{'Observer Type'} == 2 ? "<span class='text-info'>Deputy Observer</span>" : "<span class='text-info'>Observer</span>" ?>
                                                                    &nbsp;&nbsp;
                                                                    <?= $row->Submitted == 1 ? "( <span class='text-success'>Bill Submitted</span> )" : '' ?>
                                                                    &nbsp;&nbsp;
                                                                    <?php
                                                                    if ($row->IsBlocked == 1) {
                                                                        echo '(&nbsp;';
                                                                        if ($row->{'Observer Type'} == 2) {
                                                                            echo "<span class='text-danger'>Deputy Observer blocked </span>";
                                                                        } else {
                                                                            echo "<span class='text-danger'>Observer  blocked</span>";
                                                                        }
                                                                        echo '&nbsp;)';
                                                                    }
                                                                    ?>
                                                                </button>
                                                            </h2>
                                                            <div id="flush-collapse<?= $i ?>"
                                                                class="accordion-collapse collapse"
                                                                aria-labelledby="flush-heading<?= $i ?>"
                                                                data-bs-parent="#accordionFlushExample">
                                                                <div class="accordion-body">
                                                                    <?php
                                                                if($row->Submitted==0 || $row->Submitted==''){?>
                                                                    <span class="pull-right">
                                                                        <label
                                                                            style="font-weight:bold;margin-top:5px;margin-right: 20px;"><input
                                                                                type="checkbox" class="largerCheckbox"
                                                                                name="blockuser"
                                                                                onclick="blockUnblock('<?= $row->ObserverID ?>')"
                                                                                id="block_<?= $row->ObserverID ?>"
                                                                                <?= $row->IsBlocked == 1 ? 'checked' : '' ?> />
                                                                            Block</label>
                                                                        <label style="font-weight:bold;margin-top:5px">
                                                                            <input type="checkbox" class="largerCheckbox"
                                                                                id="all<?= $row->ObserverID ?>"
                                                                                onclick="allChecked('<?= $row->ObserverID ?>')">All
                                                                        </label>
                                                                    </span>
                                                                    <?php }?>
                                                                    <table class="table-bordered" width="100%">
                                                                        <tr>
                                                                            <?= $mockDrillShow == 'yes' ? '<th>Mock Drill</th>' : '' ?>
                                                                            <th style="min-width:90px">Exam Date</th>
                                                                            <?php for($k=1;$k<=12;$k++){?>

                                                                            <?php
                                                                            $shift=0;
                                                                            if($row->{'D'.$k}==1){
                                                                            for($j=1;$j<=4;$j++)
                                                                            {
                                                                            if (null !== $row->{'D'.$k.'S'.$j} && ($row->{'D'.$k.'S'.$j} == 1))
                                                                                {
                                                                                    $shift=1;
                                                                                }
                                                                            }
                                                                            if($shift==1)
                                                                            {
                                                                            echo " <th style='min-width:90px' scope='col' class='linehiteR'>";
                                                                                echo date('d-m-Y',strtotime($examDates['Date_'.$k]));
                                                                            echo "</th>";
                                                                            }?>
                                                                            <?php }}?>
                                                                        </tr>
                                                                        <input type="hidden" class=""
                                                                            id="CENTNO_<?= $row->ObserverID ?>"
                                                                            value="<?= $row->CENTNO ?>">
                                                                        <?php if($mockDrillShow=='yes'){?>
                                                                        <tr>
                                                                            <td rowspan="2" class="text-center">
                                                                                <input type="checkbox"
                                                                                    class="largerCheckbox"
                                                                                    id="drill_<?= $row->ObserverID ?>"
                                                                                    <?= $row->A_MT == 1 ? 'checked' : '' ?>
                                                                                    <?= ($row->IsBlocked == 1 or $row->Submitted == 1) ? 'disabled' : '' ?>>
                                                                            </td>
                                                                        </tr>
                                                                        <?php }?>
                                                                        <tr>
                                                                            <th style="min-width:90px">Mark Attendance</th>
                                                                            <?php for($k=1;$k<=12;$k++){
                                                                            $shift=0;
                                                                            if($row->{'D'.$k}==1){
                                                                                    for($j=1;$j<=4;$j++)
                                                                                    {

                                                                                    if (null !== $row->{'D'.$k.'S'.$j} && ($row->{'D'.$k.'S'.$j} == 1))
                                                                                        {
                                                                                            $shift=1;
                                                                                        }
                                                                                    }
                                                                                    if($shift==1)
                                                                                    { echo '<td  style="min-width:90px" scope="col" class="linehiteR" style="margin:0px;padding:0px">';
                                                                                        for($j=1;$j<=4;$j++)
                                                                                        {
                                                                                            if(null !==($row->{'att_D'.$k.'S'.$j}) && ($row->{'att_D'.$k.'S'.$j}==1))
                                                                                            {
                                                                                                $checked='checked';
                                                                                            }else{
                                                                                                $checked='';
                                                                                            }
                                                                                            $shiftInner=0;
                                                                                        if (null !== $row->{'D'.$k.'S'.$j} && ($row->{'D'.$k.'S'.$j} == 1))
                                                                                            {
                                                                                                $shiftInner=1;
                                                                                            }
                                                                                            if($shiftInner==1){
                                                                                            ?>
                                                                            <label style="padding:10px 5px">
                                                                                <div
                                                                                    style="float:left;margin:3px;padding:4px">
                                                                                    <input type="checkbox"
                                                                                        class="largerCheckbox"
                                                                                        name="Atten<?= $k ?>"
                                                                                        id="checkB_<?= $row->ObserverID . '_s' . $j . '_' . $k ?>"
                                                                                        <?= $checked ?> <?= $disabled ?>>
                                                                                    <br />
                                                                                    S<?= $j ?>
                                                                                </div>
                                                                            </label>
                                                                            <?php
                                                                                        }}
                                                                                        echo '</td>';
                                                                                    }
                                                                                }}
                                                                            ?>
                                                                        </tr>
                                                                    </table>
                                                                </div>
                                                            </div>
                                                        </div>

                                                        <?php }else{
                                                    /************************************************** without shift wise******************************************************************/
                                                        $arrayIDs[]=$row->ObserverID;
                                                        if($row->Submitted==1 or $row->IsBlocked==1)
                                                        {
                                                            $disabled='disabled';
                                                        }else{
                                                            $disabled='';
                                                        }
                                                    ?>
                                                        <div class="accordion-item">
                                                            <h2 class="accordion-header" id="flush-heading<?= $i ?>">
                                                                <button class="accordion-button collapsed" type="button"
                                                                    data-bs-toggle="collapse"
                                                                    data-bs-target="#flush-collapse<?= $i ?>"
                                                                    aria-expanded="false"
                                                                    aria-controls="flush-collapse<?= $i ?>">
                                                                    <?php /*  <?=++$sNO?> ?> ?> ?> ?> ?> ?>.
                                                                    <?= $row->ObserverID ?> -
                                                                    <?= $row->Name ?>&nbsp;&nbsp;(Center
                                                                    No.-<?= $row->CENTNO ?>)
                                                                    &nbsp;&nbsp;<?= $row->{'Observer Type'} == 2 ? " <span class='text-info'>Deputy Observer</span> " : " <span class='text-info'>Observer</span> " ?>&nbsp;&nbsp;
                                                                    <?= $row->Submitted == 1 ? "( <span class='text-success'>Bill Submitted</span> )" : '' ?>
                                                                    &nbsp;&nbsp;<?= $row->IsBlocked == 1 ? "(&nbsp; <span class='text-danger'> Blocked </span> &nbsp;)" : '' ?>
                                                                    */?>
                                                                    <?= ++$sNO ?>. <?= $row->ObserverID ?> -
                                                                    <?= $row->Name ?>&nbsp;&nbsp;(Center
                                                                    No.-<?= $row->CENTNO ?>) &nbsp;&nbsp;
                                                                    <?= $row->{'Observer Type'} == 2 ? "<span class='text-info'>Deputy Observer</span>" : "<span class='text-info'>Observer</span>" ?>
                                                                    &nbsp;&nbsp;
                                                                    <?= $row->Submitted == 1 ? "( <span class='text-success'>Bill Submitted</span> )" : '' ?>
                                                                    &nbsp;&nbsp;
                                                                    <?php
                                                                    if ($row->IsBlocked == 1) {
                                                                        echo '(&nbsp;';
                                                                        if ($row->{'Observer Type'} == 2) {
                                                                            echo "<span class='text-danger'>Deputy Observer blocked </span>";
                                                                        } else {
                                                                            echo "<span class='text-danger'>Observer  blocked</span>";
                                                                        }
                                                                        echo '&nbsp;)';
                                                                    }
                                                                    ?>
                                                                </button>
                                                            </h2>
                                                            <div id="flush-collapse<?= $i ?>"
                                                                class="accordion-collapse collapse"
                                                                aria-labelledby="flush-heading<?= $i ?>"
                                                                data-bs-parent="#accordionFlushExample">
                                                                <div class="accordion-body">
                                                                    <?php
                                                                if($row->Submitted==0 || $row->Submitted==''){?>
                                                                    <span class="pull-right">
                                                                        <label
                                                                            style="font-weight:bold;margin-top:5px;margin-right: 20px;"><input
                                                                                type="checkbox" class="largerCheckbox"
                                                                                name="blockuser"
                                                                                onclick="blockUnblock('<?= $row->ObserverID ?>')"
                                                                                id="block_<?= $row->ObserverID ?>"
                                                                                <?= $row->IsBlocked == 1 ? 'checked' : '' ?> />
                                                                            Block</label>
                                                                        <label style="font-weight:bold;margin-top:5px">
                                                                            <input type="checkbox" class="largerCheckbox"
                                                                                id="all<?= $row->ObserverID ?>"
                                                                                onclick="allChecked('<?= $row->ObserverID ?>')">All
                                                                        </label>
                                                                    </span>
                                                                    <?php }?>
                                                                    <table class="table-bordered" width="100%">
                                                                        <tr>
                                                                            <?= $mockDrillShow == 'yes' ? '<th>Mock Drill</th>' : '' ?>
                                                                            <th>Exam Date</th>
                                                                            <?php for($k=1;$k<=12;$k++){?>
                                                                            <?php if ($row->{'D' . $k} == 1) {
                                                                                echo '<th scope="col" class="linehiteR">';
                                                                                echo date('d-m-Y', strtotime($examDates['Date_' . $k]));
                                                                                echo '</th>';
                                                                            } ?>
                                                                            <?php }?>
                                                                        </tr>
                                                                        <input type="hidden" class=""
                                                                            id="CENTNO_<?= $row->ObserverID ?>"
                                                                            value="<?= $row->CENTNO ?>">
                                                                        <?php if($mockDrillShow=='yes'){?>
                                                                        <tr>
                                                                            <td rowspan="2" class="text-center">
                                                                                <input type="checkbox"
                                                                                    class="largerCheckbox"
                                                                                    id="drill_<?= $row->ObserverID ?>"
                                                                                    <?= $row->A_MT == 1 ? 'checked' : '' ?>
                                                                                    <?= ($row->IsBlocked == 1 or $row->Submitted == 1) ? 'disabled' : '' ?>>
                                                                            </td>
                                                                        </tr>
                                                                        <?php }?>
                                                                        <tr>
                                                                            <th>Mark Attendance</th>
                                                                            <?php for($k=1;$k<=12;$k++){
                                                                            if(null !==($row->{'A_D'.$k}) && ($row->{'A_D'.$k}==1))
                                                                            {
                                                                            $checked='checked';
                                                                            }else{
                                                                                $checked='';
                                                                            }
                                                                            if($row->{'D'.$k}==1)
                                                                            {
                                                                            ?>
                                                                            <td scope="col" class="linehiteR"
                                                                                style="margin:0px;padding:0px">
                                                                                <label style="padding:10px 26px">
                                                                                    <input type="checkbox"
                                                                                        class="largerCheckbox"
                                                                                        name="Atten<?= $k ?>"
                                                                                        id="checkB_<?= $row->ObserverID . '_' . $k ?>"
                                                                                        <?= $checked ?> <?= $disabled ?>>
                                                                                </label>
                                                                            </td>

                                                                            <?php }}?>
                                                                        </tr>
                                                                    </table>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <?php
                                                }

                                                 }}else{?>
                                                        <table class="table-bordered" width="100%">
                                                            <tr class="text-danger">
                                                                <th>No Records Founds.</th>
                                                            </tr>
                                                        </table>
                                                        <?php }?>
                                                        <p id="message"></p>
                                                        <br />
                                                        <div class="pull-right">
                                                            <?php
                                                        $ids="'".implode("','",$arrayIDs)."'";
                                                        if(count($data)>0)
                                                        {
                                                        ?>
                                                            <button class="btn btn-success"
                                                                onclick="attendance(<?= $ids ?>)">Update</button>
                                                            <button class="ms-3 btn btn-dark"
                                                                onclick="filterCheck(),refreshPage()">Refresh</button>
                                                            <?php } ?>
                                                        </div>
                                                        <div class="clearfix"></div>
                                                        <br />
                                                        <div class="">
                                                            {!! $data->withQueryString()->links('pagination::bootstrap-5') !!}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
    <script>
        function filterCheck() {
            $(".overlay").show();
            $('#attendanceForm').submit();
        }
    </script>
    <!--************************************************** Shift wise******************************************************************/ -->
    <?php if(session('ShiftWiseExam')=='yes'){?>
    <script>
        function refreshPage() {
            window.location.reload();
        }
        //block
        function blockUnblock(ID) {
            if ($("#block_" + ID).is(':checked')) {
                for (i = 1; i <= 12; i++) {
                    for (u = 1; u <= 4; u++) {
                        if ($("#checkB_" + ID + "_s" + u + '_' + i).length > 0) {
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('disabled', true);
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('checked', false);
                        }
                    }
                }
                $("#all" + ID).prop('disabled', true);
                $("#drill_" + ID).prop('disabled', true);
                $("#all" + ID).prop('checked', false);
                $("#drill_" + ID).prop('checked', false);
            } else {
                for (i = 1; i <= 12; i++) {
                    for (u = 1; u <= 4; u++) {
                        if ($("#checkB_" + ID + "_s" + u + '_' + i).length > 0) {
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('disabled', false);
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('checked', false);
                        }
                    }
                }
                $("#all" + ID).prop('disabled', false);
                $("#drill_" + ID).prop('disabled', false);
            }
        }

        //checked all
        function allChecked(ID) {
            if ($("#all" + ID).is(':checked')) {
                for (i = 1; i <= 12; i++) {
                    for (u = 1; u <= 4; u++) {
                        if ($("#checkB_" + ID + "_s" + u + '_' + i).length > 0) {
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('checked', true);
                        }
                    }
                }
            } else {
                for (i = 1; i <= 12; i++) {
                    for (u = 1; u <= 4; u++) {
                        if ($("#checkB_" + ID + "_s" + u + '_' + i).length > 0) {
                            $("#checkB_" + ID + "_s" + u + '_' + i).prop('checked', false);
                        }
                    }
                }
            }
        }

        //attendance
        function attendance(...ID) {
            var myObject = {};
            for (var j = 0; j < ID.length; j++) {
                var oneID = {};
                var mokedrill = $("#drill_" + ID[j]).is(':checked') ? 1 : 0;
                var CENTNO = $("#CENTNO_" + ID[j]).val();
                var isblock = ($("#block_" + ID[j]).length > 0 && $("#block_" + ID[j]).is(':checked')) ? 1 : 0;
                oneID['isblock'] = isblock;
                oneID['mokedrill'] = mokedrill;
                oneID['ID'] = ID[j];
                oneID['CENTNO'] = CENTNO;
                var totalAttendance = 0;

                for (var i = 0; i < 12; i++) {
                    for (var u = 1; u <= 4; u++) {
                        if ($("#checkB_" + ID[j] + "_s" + u + '_' + i).length > 0 && $("#checkB_" + ID[j] + "_s" + u + '_' +
                                i).is(':checked')) {
                            totalAttendance += 1;
                            oneID['D' + i + 'S' + u] = 1;
                        } else if ($("#checkB_" + ID[j] + "_s" + u + '_' + i).length > 0 && $("#checkB_" + ID[j] + "_s" +
                                u + '_' + i).is(':not(:checked)')) {
                            oneID['D' + i + 'S' + u] = 0;
                        }
                    }
                }
                oneID['totalAttendance'] = totalAttendance;
                myObject[ID[j]] = oneID;
            }

            // var jsonData = JSON.stringify(myObject);

            //console.log(myObject);
            $.ajax({
                url: "marked",
                type: 'POST',
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                dataType: "json",
                contentType: 'application/json',
                data: JSON.stringify({
                    jsonData: myObject,
                    "_token": "{{ csrf_token() }}"
                }),
                beforeSend: function() {
                    $('.overlay').show();
                },
                success: function(data) {
                    $('.overlay').hide();
                    //console.log(data);
                    if (data.status == 'true') {
                        $('#message').html(data.message);
                        setInterval(() => {
                            $('#message').html('');
                        }, 5000);
                    } else {
                        $('#message').html(
                            "<span class='badge bg-danger messageR'> Attendance Mark Fail.</span>");
                        setInterval(() => {
                            $('#message').html('');
                        }, 5000);
                    }
                }
            });
        }
    </script>
    <?php }else{?>
    <!--************************************************** without Shift wise******************************************************************/ -->
    <script>
        function refreshPage() {
            window.location.reload();
        }
        //block
        function blockUnblock(ID) {
            if ($("#block_" + ID).is(':checked')) {
                for (i = 1; i <= 12; i++) {
                    if ($("#checkB_" + ID + "_" + i).length > 0) {
                        $("#checkB_" + ID + "_" + i).prop('disabled', true);
                        $("#checkB_" + ID + "_" + i).prop('checked', false);
                    }
                }
                $("#all" + ID).prop('disabled', true);
                $("#drill_" + ID).prop('disabled', true);
                $("#all" + ID).prop('checked', false);
                $("#drill_" + ID).prop('checked', false);
            } else {
                for (i = 1; i <= 12; i++) {
                    if ($("#checkB_" + ID + "_" + i).length > 0) {
                        $("#checkB_" + ID + "_" + i).prop('disabled', false);
                        $("#checkB_" + ID + "_" + i).prop('checked', false);
                    }
                }
                $("#all" + ID).prop('disabled', false);
                $("#drill_" + ID).prop('disabled', false);
            }
        }

        //checked all
        function allChecked(ID) {
            if ($("#all" + ID).is(':checked')) {
                for (i = 1; i <= 12; i++) {
                    if ($("#checkB_" + ID + "_" + i).length > 0) {
                        $("#checkB_" + ID + "_" + i).prop('checked', true);
                    }
                }
            } else {
                for (i = 1; i <= 12; i++) {
                    if ($("#checkB_" + ID + "_" + i).length > 0) {
                        $("#checkB_" + ID + "_" + i).prop('checked', false);
                    }
                }
            }
        }

        //attendance
        function attendance(...ID) {

            var myObject = {};
            for (var j = 0; j < ID.length; j++) {
                var oneID = {};
                var mokedrill = $("#drill_" + ID[j]).is(':checked') ? 1 : 0;
                var CENTNO = $("#CENTNO_" + ID[j]).val();
                var isblock = ($("#block_" + ID[j]).length > 0 && $("#block_" + ID[j]).is(':checked')) ? 1 : 0;
                oneID['isblock'] = isblock;
                oneID['mokedrill'] = mokedrill;
                oneID['ID'] = ID[j];
                oneID['CENTNO'] = CENTNO;
                var totalAttendance = 0;
                for (i = 0; i < 12; i++) {
                    if ($("#checkB_" + ID[j] + "_" + i).length > 0 && $("#checkB_" + ID[j] + "_" + i).is(':checked')) {
                        totalAttendance += 1;
                        oneID['A_D' + i] = 1;
                    } else if ($("#checkB_" + ID[j] + "_" + i).length > 0 && $("#checkB_" + ID[j] + "_" + i).is(
                            ':not(:checked)')) {
                        oneID['A_D' + i] = 0;
                    }
                }
                oneID['totalAttendance'] = totalAttendance;
                myObject[ID[j]] = oneID;
            }

            //var jsonData = JSON.stringify(myObject);


            //console.log(jsonData);
            $.ajax({
                url: "marked",
                type: 'POST',
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                dataType: "json",
                contentType: 'application/json',
                data: JSON.stringify({
                    jsonData: myObject,
                    "_token": "{{ csrf_token() }}"
                }),
                beforeSend: function() {
                    $('.overlay').show();
                },
                success: function(data) {
                    $('.overlay').hide();
                    //console.log(data);
                    if (data.status == 'true') {
                        $('#message').html(data.message);
                        setInterval(() => {
                            $('#message').html('');
                        }, 5000);
                    } else {
                        $('#message').html(
                            "<span class='badge bg-danger messageR'> Attendance Mark Fail.</span>");
                        setInterval(() => {
                            $('#message').html('');
                        }, 5000);
                    }
                },
                error: function(xhr, status, error) {
                    // Handle error
                    console.log(xhr.responseText);
                }
            });
        }
    </script>
    <?php }?>
@endsection
