@extends('layouts.admin')
@section('content')
<main role="main" class="flex-shrink-0">
   <div class="container custom-container">
      <style>
         .modal-dialog {
         max-width: 90%;
         }
      </style>
      <div class="content-body mt-50 mb-50">
         <div class="">
            <div class="row no-gutters">
               <div class="col-sm-12">
                  <div id="main">
                     <div class="accordion mt-4" id="faq">
                        <div class="card">
                           <div class="card-header position-relative" id="faqhead2">
                              <h3 class="p-1 m-1">Manage Bills - (Observers Lists)</h3>
                           </div>
                           <div id="faq3" class="collapse show" aria-labelledby="faqhead2" data-parent="#faq1">
                              <div class="card-body">
                                 <div>
                                    <form id="filter-form" action="#" method="get" disabled="disabled" autocomplete="off">
                                       <input type="hidden" name="examType" value="CUETUG2024">                                        
                                       <div class="row">
                                          <div class="col-md-4 px-1">
                                             <div class="form-group">
                                                <label class="text-nowrap col-md-4" for="startDate">Bill Status:</label>
                                                <div class=" col-md-12">
                                                   <select class="form-select form-control p-1" name="ta_bill_status" id="ta_bill_status">
                                                      <option value="">Select Bill Status</option>
                                                      <option value="0">Submitted</option>
                                                      <option value="1">Processed</option>
                                                      <option value="3">Sent for Clarification</option>
                                                      <option value="5">Settled</option>
                                                   </select>
                                                </div>
                                             </div>
                                          </div>
                                          <div class="col-md-4 px-1">
                                             <div class="form-group">
                                                <label class="text-nowrap col-md-4" for="startDate">Exam Type:</label>
                                                <div class="col-md-12">
                                                   <select class="form-select form-control p-1" name="ta_exam_type" id="ta_exam_type">
                                                      <option value="">Select Exam Type</option>
                                                      <option value="206">CUO24</option>
                                                      <option value="207">ORIENTATION</option>
                                                      <option value="255">NEETEXAM2024</option>
                                                      <option value="209">CUETUG2024</option>
                                                      <option value="210">SHRESHTA2024</option>
                                                      <option value="211">CUETUG2024ONLINE</option>
                                                      <option value="212">CUETUG2024-29MAY</option>
                                                   </select>
                                                </div>
                                             </div>
                                          </div>
                                          <div class="col-md-4">
                                             <button class="btn btn-block btn-success" style="width:100%">Search </button>
                                             <a href="#" class="btn btn-block btn-secondary" style="color:#fff;width:100%">Reset</a>
                                          </div>
                                       </div>
                                    </form>
                                 </div>
                                 <div class="table-responsive">
                                    <table class="table table-striped table-bordered">
                                       <thead class="thead-light">
                                          <tr>
                                             <th>S.No</th>
                                             <th>Reference No.</th>
                                             <th>Centre Number</th>
                                             <th>City</th>
                                             <th>Exam Details</th>
                                             <th>Total Amount</th>
                                             <th>Bill Date</th>
                                             <th>Status</th>
                                             <th class="action-column">Actions</th>
                                          </tr>
                                       </thead>
                                       <tbody>
                                       @if (count($ObserverDetail) > 0)
                                       @foreach($ObserverDetail as $key => $Observer)
                                       <td>{{ $key+1 }}</td>
                                                <td>{{ isset($Observer->{'Reference No_'} ) ? $Observer->{'Reference No_'} :null }}</td>
                                                <td>{{ isset($Observer->{'CenterNo'} ) ? $Observer->{'CenterNo'} :null }}</td>
                                                <td>{{ isset($Observer->{'Center City'} ) ? $Observer->{'Center City'} :null }}</td>
                                                <td>{{ isset($Observer->{'Exam Name'} ) ? $Observer->{'Exam Name'} :null }}</td>
                                                <td>{{ isset($Observer->{'Net Amount Payable'} ) ? round($Observer->{'Net Amount Payable'},2) :null }}</td>
                                                <td>{{ isset($Observer->{'$systemCreatedAt'} ) ? $Observer->{'$systemCreatedAt'} :null }}</td>
                                                <td>Submitted </td>
                                                <td><b>-</b></td>
                                          <tr>
                                          @endforeach
                                          @else
                                             <td colspan="11" class="text-center">No records found</td>
                                          </tr>
                                          @endif
                                       </tbody>
                                    </table>
                                 </div>
                              </div>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
         </div>
      </div>
      <div class="modal fade" id="exampleModalOnline" tabindex="-1" aria-labelledby="exampleModalOnlineLabel" aria-hidden="true">
         <div class="modal-dialog modal-dialog-scrollable">
            <div class="modal-content">
               <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalOnlineLabel">Bill Details</h5>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
               </div>
               <div class="modal-body position-relative">
                  <div class="loaderbox position-absolute row justify-content-center align-items-center" style="left: 0; right:0; top: 0;
                     bottom: 0; background-color: #ddda">
                     <div class="loader"></div>
                  </div>
                  <div class="appendHtml"></div>
               </div>
               <div class="modal-footer">
                  <!-- <button type="button" class="btn btn-primary">Download</button> -->
               </div>
            </div>
         </div>
      </div>
      <script src="https://examsaudit.ntaonline.in/NTA_ERP_Billing/backend/web/js/new/jquery.min.js"></script>
      <script>
         function ViewDetailsCCBill(ObserverID, ExamType, ReferenceNo, Emode, CENTNO, BillType, CITY_CD, TC_CODE, City_code) {
         
             $.ajax({
                 url: baseurl + '/event/centrebill/get-online-centre-bill-data',
                 type: 'POST',
                 data: {
                     ObserverID: ObserverID,
                     ExamType: ExamType,
                     ReferenceNo: ReferenceNo,
                     ExamMode: Emode,
                     CENTNO: CENTNO,
                     BillType: BillType,
                     CITY_CD: CITY_CD,
                     TC_CODE: TC_CODE,
                     City_code: City_code,
                 },
                 beforeSend: function() {
                     $('.loaderbox').show();
                     $('.loader').show();
                 },
                 success: function(response) {
                     $('.appendHtml').html(response);
                     $('.loaderbox').hide();
                     $('.loader').hide();
                 },
             });
         }
         
         function ViewDetails(ObserverID, ExamType, ReferenceNo, CENTNO, CITY_CD, TC_CODE) {
             $.ajax({
                 url: baseurl + '/event/centrebill/get-centre-bill-data',
                 type: 'POST',
                 data: {
                     ObserverID: ObserverID,
                     ExamType: ExamType,
                     ReferenceNo: ReferenceNo,
                     // ExamMode: Emode,
                     CENTNO: CENTNO,
                     // BillType: BillType,
                     CITY_CD: CITY_CD,
                     TC_CODE: TC_CODE,
                     // City_code: City_code,
                 },
                 beforeSend: function() {
                     $('.loaderbox').show();
                     $('.loader').show();
                 },
                 success: function(response) {
                     $('.appendHtml').html(response);
                     $('.loaderbox').hide();
                     $('.loader').hide();
                 },
             });
         
         }
      </script>        
   </div>
</main>
@endsection
<style>
   .row {
   padding-bottom: 5px;
   }
</style>
<script type="text/javascript">
   function display_data() {
       //$("#maintable").hide();
       //$("#loadmessage").html("Warning !! Do Not Close this Window.");
     //  $(".loader-div").show(); // show loader
       var examDate = $('.examDate').val();
       var examID = $('.examID').val();
       $.ajax({
            url:"{{ url('city-coordinator-report') }}",
            type:"GET",
            cache: false,
            xhrFields:{
              responseType: 'blob'
            },
            data:{
               examDate: examDate,
               examID:examID,
               type:'downloadexcel'
            },
            success: function(result, status, xhr) {
               $("#maintable").show();
               $('#loadmessage').html(result).css("display", "block");
           var disposition = xhr.getResponseHeader('content-disposition');
           var filename = 'ExcelDownload.xlsx';
           // The actual download
           var blob = new Blob([result], {
               type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
           });
           var link = document.createElement('a');
           link.href = window.URL.createObjectURL(blob);
           link.download = filename;
           document.body.appendChild(link);
           link.click();
           document.body.removeChild(link);
          // $(".loader-div").hide();
           },
             error: function (xhr, status) {
               $(".loader-div").hide(); // hide loader	
               console.log('ajax error = ' + xhr.statusText);
             }
        });
   }
</script>