@extends('layouts.admin')
<style>
    table td:nth-child(3) {
        word-wrap: break-word;
        word-break: break-all;
        white-space: normal;
    }

    .col-md-4 {
        width: 20% !important;
    }
</style>
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="content-body">
                <div class="card mt-50 mb-50">
                    <div class="card-header">
                        <h4 class="mb-2">Report</h4>
                    </div>
                    <div class="card-body">
                        <form action="{{ route('city-coordinator-report') }}" method="POST" id="ccReportform">
                            @csrf
                            <div class="custom-form">
                                <div class="row">
                                    <div class="form-group col-md-4">
                                        <label>Bill Date:</label>
                                        <input type="date" class="form-control form-control-sm examDate" name="billDate"
                                            id="billDate"
                                            value="{{ isset($_POST['billDate']) ? $_POST['billDate'] : old('billDate') }}">
                                    </div>

                                    <div class="col-md-4">
                                        <label>&nbsp;</label>
                                        <button type="submit" onclick="getloader()"
                                            class="btn btn-block btn-success form-control-btn border-0">Search</button>
                                    </div>
                                    <div class="col-md-4">
                                        <label>&nbsp;</label>
                                        <a href="{{ route('city-coordinator-report') }}"
                                            class="form-control-btn btn btn-block btn-secondary border-0">
                                            Reset
                                        </a>
                                    </div>
                                    <div class="col-md-4">
                                        <label>&nbsp;</label>
                                        <button id="downloadR" type="button"
                                            class="form-control-btn btn btn-block custom-orange">Download</button>
                                    </div>
                                </div>
                        </form>
                        <iframe id="downloadFrame" style="display:none;"></iframe>
                        <div class="form-group col-md-2">
                            <label for="per_page">Items per page:</label>
                            <select name="per_page" id="per_page" onchange="getloader()">
                                <option value="10"{{ request('per_page') == 10 ? ' selected' : '' }}>10</option>
                                <option value="20"{{ request('per_page') == 20 ? ' selected' : '' }}>20</option>
                                <option value="50"{{ request('per_page') == 50 ? ' selected' : '' }}>50</option>
                                <option value="all"{{ request('per_page') == 'all' ? ' selected' : '' }}>All</option>
                            </select>
                        </div>
                        <div class="table-responsive">
                            <table id="exportR" class="table table-striped table-bordered">
                                <thead class="thead-light">
                                    <tr>
                                        <th>S.No</th>
                                        <th>Reference No.</th>
                                        <th>Centre Number</th>
                                        <th>City</th>
                                        <th>Exam Details</th>
                                        <th>Total Amount</th>
                                        <th>Bill Date</th>
                                        <th>Status</th>
                                        <th>Remark</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @if (count($CityCoordinators) > 0)
                                        @foreach ($CityCoordinators as $key => $CityCoordinator)
                                            @php
                                                if ($CityCoordinator->{'Bill Status'} == 0) {
                                                    $Billstatus = 'Submitted';
                                                } elseif ($CityCoordinator->{'Bill Status'} == 1 || $CityCoordinator->{'Bill Status'} == 2 || $CityCoordinator->{'Bill Status'} == 4) {
                                                    $Billstatus = 'In Process';
                                                } elseif ($CityCoordinator->{'Bill Status'} == 3) {
                                                    $Billstatus = 'Sent for clarification';
                                                } elseif ($CityCoordinator->{'Bill Status'} == 5) {
                                                    $Billstatus = 'Settled';
                                                } else {
                                                    $Billstatus = '';
                                                }

                                                $remark = '-';
                                                if (
                                                    $CityCoordinator->{'Bill Status'} == 3 &&
                                                    isset($CityCoordinator->{'Rejection Remark'}) &&
                                                    !empty($CityCoordinator->{'Rejection Remark'})
                                                ) {
                                                    $remark = $CityCoordinator->{'Rejection Remark'};
                                                } elseif (
                                                    $CityCoordinator->{'Bill Status'} == 5 &&
                                                    isset($CityCoordinator->{'Remark'}) &&
                                                    !empty($CityCoordinator->{'Remark'})
                                                ) {
                                                    $remark = $CityCoordinator->{'Remark'};
                                                }

                                            @endphp
                                            <tr>
                                                <td>{{ $key + 1 }}</td>
                                                <td style="width:10%;">
                                                    {{ isset($CityCoordinator->{'Reference No_'}) ? $CityCoordinator->{'Reference No_'} : null }}
                                                </td>
                                                <td style="width:30%;">
                                                    {{ isset($CityCoordinator->{'CenterNo'}) ? $CityCoordinator->{'CenterNo'} : null }}
                                                </td>
                                                <td style="width:10%;">
                                                    {{ isset($CityCoordinator->{'Center City'}) ? $CityCoordinator->{'Center City'} : null }}
                                                </td>
                                                <td style="width:10%;">
                                                    {{ isset($CityCoordinator->{'Exam Name'}) ? $CityCoordinator->{'Exam Name'} : null }}
                                                </td>
                                                <td style="width:10%;">
                                                    {{ isset($CityCoordinator->{'Net Amount Payable'}) ? number_format($CityCoordinator->{'Net Amount Payable'}, 2) : null }}
                                                </td>
                                                <td style="width:10%;">
                                                    {{ isset($CityCoordinator->{'Created On'}) ? date('d-m-Y', strtotime($CityCoordinator->{'Created On'})) : null }}
                                                </td>
                                                <td style="width:10%;">{{ $Billstatus }}</td>
                                                <td>{{ $remark }}</td>
                                            </tr>
                                        @endforeach
                                    @else
                                        <tr>
                                            <td colspan="9" id="noData">
                                                <center>No Data Found !!</center>
                                            </td>
                                        </tr>
                                    @endif

                                </tbody>
                            </table>

                            {!! $CityCoordinators->withQueryString()->links('pagination::bootstrap-5') !!}

                        </div>
                    </div>
                </div>
            </div>

        </div>
        </div>
    </main>
@endsection

@section('script')
    <script>
        $(document).ready(function() {
            $('#downloadR').click(function(e) {
                e.preventDefault();
                if ($('#noData').text()) {
                    alert($('#noData').text());
                    return false;
                }
                $('.overlay').show();

                var billDate = $('#billDate').val();
                var url =
                    '{{ route('city-coordinator-excel', ['excel', 'billDate' => 'CreatedDate']) }}'; // Dummy placeholder
                url = url.replace('CreatedDate', billDate); // Replace the placeholder with actual value
                $('#downloadFrame').attr('src', url);
                //window.location.href = url;
                setTimeout(function() {
                    $('.overlay').hide();
                }, 500); // Adjust the timeout if needed

            });
        });

        function getloader() {
            $('.overlay').show();
            $('#ccReportform').submit();
        }
    </script>
@endsection
