@extends('layouts.admin')
<style>
    table td:nth-child(3) {
        word-wrap: break-word;
        word-break: break-all;
        white-space: normal;
    }

    .col-md-3 {
        width: 20% !important;
    }
</style>
@section('content')
    <main role="main" class="flex-shrink-0">
        <div class="container custom-container">
            <div class="content-body">
                <div class="card mt-50 mb-50">
                    <div class="card-header">
                        <h4 class="mb-2">Report</h4>
                    </div>
                    <div class="card-body">
                        <form id="observerReportform" action="{{ route('observer-report') }}" method="post"
                            autocomplete="off">
                            @csrf
                            <div class="custom-form">
                                <div class="row">
                                    <div class="form-group col-md-2">
                                        <label>Bill Date:</label>
                                        <input type="date" class="form-control form-control-sm examDate" name="billDate"
                                            id="billDate"
                                            value="{{ request('billDate') ? request('billDate') : old('billDate') }}">
                                    </div>
                                    @if (Session::get('role') == 1)
                                        <div class="form-group col-md-2">
                                            <label class="text-nowrap">Observer / Deputy Observer List:</label>
                                            <select class="form-control form-control-sm" name="obName" id="obName">
                                                <option value="">---Select---</option>
                                                @foreach ($obsFilter as $key => $val)
                                                    <option value="{{ $key }}"
                                                        {{ request('obName') == $key ? 'selected' : '' }}>
                                                        {{ $val }}</option>
                                                @endforeach
                                            </select>
                                        </div>
                                    @endif

                                    <div class="form-group col-md-3">
                                        <label>&nbsp;</label>
                                        <button type="submit" onclick="getloader()"
                                            class="btn btn-block btn-success form-control-btn border-0">Search</button>
                                    </div>
                                    <div class="form-group col-md-3">
                                        <label>&nbsp;</label>
                                        <a href="{{ route('observer-report') }}"
                                            class="form-control-btn btn btn-block btn-secondary border-0">
                                            Reset
                                        </a>
                                    </div>
                                    <div class="form-group col-md-3">
                                        <label>&nbsp;</label>
                                        <button id="downloadR" type="button"
                                            class="btn btn-block form-control-btn custom-orange border-0">Download</button>
                                    </div>


                                </div>
                                <iframe id="downloadFrame" style="display:none;"></iframe>
                                <div class="form-group col-md-2">
                                    <label for="per_page">Items per page:</label>
                                    <select name="per_page" id="per_page" onchange="getloader()">
                                        <option value="10"{{ request('per_page') == 10 ? ' selected' : '' }}>10</option>
                                        <option value="20"{{ request('per_page') == 20 ? ' selected' : '' }}>20</option>
                                        <option value="50"{{ request('per_page') == 50 ? ' selected' : '' }}>50</option>
                                        <option value="all"{{ request('per_page') == 'all' ? ' selected' : '' }}>All
                                        </option>
                                    </select>
                                </div>
                                <div class="table-responsive">
                                    <table id="exportR" class="table table-striped table-bordered">
                                        <thead class="thead-light">
                                            <tr>
                                                <th>S.No</th>
                                                <th>Reference No.</th>
                                                <th>Exam Name</th>
                                                <th>Observer Name</th>
                                                <th>Centre Number</th>
                                                <th>Total Amount</th>
                                                <th>Bill Date</th>
                                                <th>Status</th>
                                                <th>Remark</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @if (count($Observers) > 0)

                                                @foreach ($Observers as $key => $Observer)
                                                    @php
                                                        $observerName = getUserProfileDataByNTAID(
                                                            $Observer->{'Observer ID'},
                                                        );

                                                        if ($Observer->{'Bill Status'} == 0) {
                                                            $Billstatus = 'Submitted';
                                                        } elseif ($Observer->{'Bill Status'} == 1 || $Observer->{'Bill Status'} == 2 || $Observer->{'Bill Status'} == 4) {
                                                            $Billstatus = 'In Process';
                                                        } elseif ($Observer->{'Bill Status'} == 3) {
                                                            $Billstatus = 'Sent for clarification';
                                                        }elseif ($Observer->{'Bill Status'} == 5) {
                                                            $Billstatus = 'Settled';
                                                        } else {
                                                            $Billstatus = '-';
                                                        }

                                                        $remark = '-';
                                                        if (
                                                            $Observer->{'Bill Status'} == 3 &&
                                                            isset($Observer->{'Rejection Remark'}) &&
                                                            !empty($Observer->{'Rejection Remark'})
                                                        ) {
                                                            $remark = $Observer->{'Rejection Remark'};
                                                        } elseif (
                                                            $Observer->{'Bill Status'} == 5 &&
                                                            isset($Observer->{'Remark'}) &&
                                                            !empty($Observer->{'Remark'})
                                                        ) {
                                                            $remark = $Observer->{'Remark'};
                                                        }

                                                        $netAmount =  number_format($Observer->{'Net Payable Amount'} + $Observer->{'Net Payable After Deduction'}, 2);

                                                    @endphp
                                                    <tr>
                                                        <td>
                                                            {{ $key + 1 }}
                                                        </td>
                                                        <td>
                                                            {{ isset($Observer->{'Reference No_'}) ? $Observer->{'Reference No_'} : null }}
                                                        </td>
                                                        <td>
                                                            {{ isset($Observer->{'Exam Name'}) ? $Observer->{'Exam Name'} : null }}
                                                        </td>
                                                        <td>
                                                            {{ isset($observerName->Name) ? $observerName->Name : null }}
                                                        </td>
                                                        <td>
                                                            {{ isset($Observer->{'Centre No_'}) ? $Observer->{'Centre No_'} : null }}
                                                        </td>
                                                        <td>
                                                            {{-- {{ isset($Observer->{'Net Payable Amount'}) ? number_format($Observer->{'Net Payable Amount'}, 2) : null }} --}}
                                                            {{ $netAmount }}
                                                        </td>
                                                        <td>
                                                            {{ isset($Observer->{'CreatedDate'}) ? date('d-m-Y', strtotime($Observer->{'CreatedDate'})) : null }}
                                                        </td>
                                                        <td>
                                                            {{ $Billstatus }}
                                                        </td>
                                                        <td>
                                                            {{ $remark }}
                                                        </td>

                                                    </tr>
                                                @endforeach
                                            @else
                                                <tr>
                                                    <td colspan="9" id="noData">
                                                        <center>No Data Found !!</center>
                                                    </td>
                                                </tr>
                                            @endif

                                        </tbody>
                                    </table>
                                    {!! $Observers->withQueryString()->links('pagination::bootstrap-5') !!}
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </main>
@endsection
@section('script')
    <script>
        $(document).ready(function() {
            $('#downloadR').click(function(e) {
                e.preventDefault();
                if ($('#noData').text()) {
                    alert($('#noData').text());
                    return false;
                }
                $('.overlay').show();

                var billDate = $('#billDate').val() ?? '';
                var observerName = $('#obName').val() ?? '';
                var url =
                    '{{ route('observer-report-excel', ['excel', 'billDate' => 'CreatedDate', 'obName' => 'observerName']) }}'; // Dummy
                url = url.replace('CreatedDate', encodeURIComponent(billDate));
                url = url.replace('observerName', encodeURIComponent(
                    observerName)); // Use the correct placeholder
                url = url.replace("&amp;", "&");
                $('#downloadFrame').attr('src', url);
                // window.location.href = url;
                setTimeout(function() {
                    $('.overlay').hide();
                }, 500); // Adjust the timeout if needed

            });
        });

        function getloader() {
            $('.overlay').show();
            $('#observerReportform').submit();
        }
    </script>
@endsection
