<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>PDF Report</title>
    <style>
        /*this css work on print page default date time and page title print on page */
        @page {
            size: auto;
            margin: 5mm 5mm;
        }

        /*End of this css work on print page default date time and page title print on page */
        body {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 12px;
            line-height: 14px;
            color: #000;
        }

        .logo {
            float: left;
            margin-right: 10px;
        }

        .logo_name {
            float: left;
            margin-top: 13px;
            font-size: 14px;
            font-weight: bold;
        }

        table tr td {
            padding: 2px;
        }

        .centered {
            text-align: center;
        }

        /* this css work on page break to nest page */
        @media print {
            table {
                page-break-inside: auto
            }

            tr {
                page-break-inside: avoid;
                page-break-after: auto
            }
        }

        /* End of this css work on page break to nest page */
        p,
        td {
            font-family: freeserif;
        }

        .img-fluid {
            max-width: 100%;
            /* height: auto; */
            height: 100px !important;
        }
    </style>
</head>

<body>
    <div class="appendHtml">
        <div id="positionR">
            @if (isset($pdf) && $pdf == 'pdf')
                <table width="100%" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tr>
                        <th style="width: 20%; text-align: left;"><img
                                src="{{ asset('assets/images/Emblem-of-India.jpg') }}" alt="Emblem of India"
                                class="img-fluid" height="100px"></th>
                        <th style="width: 60%;"><img src="{{ asset('assets/images/logo-outside.jpg') }}"
                                alt="Logo Outside" class="img-fluid" height="100px"></th>
                        <th style="width: 20%;"><img src="{{ asset('assets/images/Azadi-Ka-Amrit-Mahotsav.jpg') }}"
                                alt="Azadi Ka Amrit Mahotsav" class="img-fluid" height="100px"></th>
                    </tr>
                </table>
            @endif

            <div class="table-responsive">
                <table class="table cco-table table-bordered" border="1" width="100%" cellspacing="0"
                    cellpadding="5" style="border-collapse: collapse; border-color: #000;">
                    <tbody>
                        @php
                            $counter = 0;
                        @endphp
                        <tr>
                            <th colspan="4" class="text-center">Annexure A-4 (TO BE FILLED BY
                                {{ strtoupper($ObserverType) }} )</th>
                        </tr>
                        @foreach ($FieldsArray as $key => $Fields)
                            {{-- Start a new row for the first column or after every second column --}}
                            @if ($counter % 2 == 0)
                                <tr>
                            @endif
                            {{-- Add the data in two columns --}}
                            <th>{{ htmlspecialchars($Fields['fieldLabel']) }}</th>
                            <td id="examinationValueTd" width="25%">{{ $Fields['fieldValue'] }}</td>
                            {{-- Close the row after the second column --}}
                            @if ($counter % 2 == 1)
                                </tr>
                            @endif

                            {{-- Increment the counter --}}
                            @php $counter++@endphp
                        @endforeach

                        {{-- Close the last row if it is not closed --}}
                        @if ($counter % 2 != 0)
                            </tr>
                        @endif
                        @if (isset($UserDataToArray) && !empty($UserDataToArray) && $UserDataToArray['IsNewBill'] == 0)
                            <tr>
                                <td><strong>Name of Exam</strong></td>
                                <td>{{ $UserDataToArray['Exam Name'] ?? '-' }}</td>
                                <td><strong>Date of Exam</strong></td>
                                <td>{{ $UserDataToArray['Exam Date'] ?? '-' }}</td>
                            </tr>
                            <tr>
                                <td><strong>Centre Code</strong></td>
                                <td>{{ $UserDataToArray['Centre No_'] ?? '-' }}</td>
                                <td><strong>Name of Centre(s)</strong></td>
                                <td>{{ $UserDataToArray['Centre Address'] ?? '-' }}</td>
                            </tr>
                            <tr>
                                <td><strong>Name of Observer</strong></td>
                                <td>{{ $UserDataToArray['Observer Name'] ?? '-' }}</td>
                                <td><strong>Observer ID</strong></td>
                                <td>{{ $UserDataToArray['Observer ID'] ?? '-' }}</td>
                            </tr>
                            <tr>
                                <td><strong>Address for Communication</strong></td>
                                <td>{{ $UserDataToArray['Address For Communication'] ?? '-' }}</td>
                                <td><strong>Registred Contact Number</strong></td>
                                <td>{{ $UserDataToArray['Contact No'] ?? '-' }}</td>
                            </tr>
                            <tr>
                                <td><strong>PAN No.</strong></td>
                                <td>{{ $UserDataToArray['PAN_No'] ?? '-' }}</td>
                                <td><strong>Name of CC with Contact Number</strong></td>
                                <td>N KAREEM KHAN, 9494751548</td>
                            </tr>
                            <tr>
                                <td><strong>Name of RC</strong></td>
                                <td>NA</td>
                                <td><strong>Bank Name and Branch</strong></td>
                                <td>{{ $UserDataToArray['Bank_Branch_Name'] ?? '-' }}</td>
                            </tr>
                            <tr>
                                <td><strong>Bank Account No.</strong></td>
                                <td>{{ $UserDataToArray['Bank_Account_No'] ?? '-' }}</td>
                                <td><strong>IFSC Code</strong></td>
                                <td>{{ $UserDataToArray['IFSC Code'] ?? '-' }}</td>
                            </tr>
                            <tr></tr>
                        @endif
                    </tbody>
                </table>
            </div>

            @if (isset($travel) && !empty($travel))
                <br>
                <table class="table table-bordered" border="1" width="100%" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tr>
                        <th colspan="13" class="text-center"><strong>(A) Travelling Details</strong></th>
                    </tr>
                    <tr>
                        <th colspan="3" class="centered">Departure</th>
                        <th colspan="3" class="centered">Arrival</th>
                        <th class="centered">Mode of </th>
                        <th class="centered">Distance</th>
                        <th class="centered">Travel Type</th>
                        <th class="centered">Air/Rail/Taxi</th>
                        <th class="centered">Amount of</th>
                        <th class="centered">Eligible Taxes</th>
                        <th class="centered">File</th>
                    </tr>
                    <tr>
                        <td class="centered">Date</td>
                        <td class="centered">Time</td>
                        <td class="centered">From</td>
                        <td class="centered">Date</td>
                        <td class="centered">Time</td>
                        <td class="centered">To</td>
                        <td class="centered">Journey</td>
                        <td class="centered">in Kms</td>
                        <td class="centered"></td>
                        <td class="centered">Receipt No</td>
                        <td class="centered">Fare Paid (Air/Rail/Taxi)</td>
                        <td class="centered"></td>
                        <td class="centered">File</td>
                    </tr>

                    @foreach ($travel as $row)
                        <tr>
                            <td class="centered">
                                {{ isset($row['Departure Date']) ? date('d-m-Y', strtotime($row['Departure Date'])) : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($row['Departure Time']) ? date('H:i:s', strtotime($row['Departure Time'])) : '' }}
                            </td>
                            <td class="centered">{{ isset($row['Departure From']) ? $row['Departure From'] : '' }}</td>
                            <td class="centered">
                                {{ isset($row['Arrival Date']) ? date('d-m-Y', strtotime($row['Arrival Date'])) : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($row['Arrival Time']) ? date('H:i:s', strtotime($row['Arrival Time'])) : '' }}
                            </td>
                            <td class="centered">{{ isset($row['Arrival To']) ? $row['Arrival To'] : '' }}</td>
                            <td class="centered">{{ isset($row['Mode Of Journey']) ? $row['Mode Of Journey'] : 'NA' }}
                            </td>
                            <td class="centered">
                                {{ isset($row['Distance Of Journey']) ? $row['Distance Of Journey'] : 'NA' }}</td>
                            <td class="centered">{{ isset($row['Travel Type']) ? ucfirst($row['Travel Type']) : 'NA' }}
                            </td>
                            <td class="centered">{{ isset($row['Receipt No']) ? $row['Receipt No'] : '' }}</td>
                            <td class="centered">{{ isset($row['Amount']) ? number_format($row['Amount'], 2) : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($row['Approved Amount']) ? number_format($row['Approved Amount'], 2) : '' }}
                            </td>
                            <td>


                                <a href="{{ $row['File Path'] }}" target="_blank">View</a>

                            </td>

                        </tr>
                    @endforeach
                </table><br>
            @endif


            @if (isset($hotel) && !empty($hotel))
                <table class="table table-bordered" border="1" width="100%" cellspacing="0" cellpadding="5"
                    style="border-collapse: collapse; border-color: #000;">
                    <tr>
                        <th colspan="8" class="text-center"><strong>(B) Details of Hotel / Food Bill etc.</strong>
                        </th>
                    </tr>
                    <tr>
                        <th>Name & Address of Hotel/Guest House with Phone No</th>
                        <th class="centered">Nos. of days</th>
                        <th class="centered">Bill No.</th>
                        <th class="centered">Bill Date</th>
                        <th class="centered">Room Rent Paid</th>
                        <th class="centered">Food Charges</th>
                        <th class="centered">Total Amount</th>
                        <th class="centered">File</th>
                    </tr>
                    @foreach ($hotel as $val)
                        <tr>
                            <td>{{ $val['Hotel Name & Address'] ?? '' }}</td>
                            <td class="centered">
                                {{ isset($val['No of Days']) && is_numeric($val['No of Days']) ? number_format($val['No of Days'], 2, '.', '') : '' }}
                            </td>
                            <td class="centered">{{ $val['Hotel Bill No'] ?? '' }}</td>
                            <td class="centered">
                                {{ isset($val['Hotel Bill Date']) && !empty($val['Hotel Bill Date']) ? date('d-m-Y', strtotime($val['Hotel Bill Date'])) : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($val['Room Rent']) && is_numeric($val['Room Rent']) ? number_format($val['Room Rent'], 2, '.', '') : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($val['Food Charges']) && is_numeric($val['Food Charges']) ? number_format($val['Food Charges'], 2, '.', '') : '' }}
                            </td>
                            <td class="centered">
                                {{ isset($val['Total Amount']) && is_numeric($val['Total Amount']) ? number_format($val['Total Amount'], 2, '.', '') : '' }}
                            </td>
                            <td class="centered">
                                @if (isset($val['File Path']) && !empty($val['File Path']))
                                    <a href="{{ $val['File Path'] }}" target="_blank">View</a>
                                @else
                                    <!-- Optionally handle the case where there's no file path -->
                                @endif
                            </td>
                        </tr>
                    @endforeach
                </table><br>
            @endif
            <br>
            <table class="table cco-table table-bordered RemunerationOnlineTable" border="1" width="100%"
                cellspacing="0" cellpadding="5" style="border-collapse: collapse; border-color: #000;">
                <thead>
                    <tr>
                        <th colspan="6" class="text-center fs-5">Details of Remuneration and Other Expenses</th>
                    </tr>
                    <tr>
                        <th>S.No</th>
                        <th width="40%">Details</th>
                        <th class="centered">Dates</th>
                        <th class="centered">Duty Days</th>
                        <th class="centered">Amount</th>
                        <th class="centered">Deduction Amount</th>
                    </tr>
                </thead>
                <tbody>

                    @if (isset($RemunerationFieldsArray) && !empty($RemunerationFieldsArray))

                        @php $i = 0 ;@endphp
                        @foreach ($RemunerationFieldsArray as $k => $Remuneration)
                            @php
                                $Remuneration = (array) $Remuneration;
                                $totalRemuneratinAmt = 0;
                                $shiftAmount_Separate = [];

                            @endphp
                            @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL')
                                @foreach ($ShiftCountArr as $shiftVal)
                                    @php
                                        $shiftAmount_Separate[] = $Remuneration['Remuneration Amount_S' . $shiftVal];
                                        $shiftAmount = $Remuneration['Remuneration Amount_S' . $shiftVal];
                                        $totalRemuneratinAmt += $shiftAmount;
                                    @endphp
                                @endforeach
                            @else
                                @php
                                    $totalRemuneratinAmt = $Remuneration['Remuneration Amount_S1'];
                                @endphp
                            @endif
                            @if ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] != '')
                                <tr>
                                    <td>{{ ++$i }}</td>
                                    <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                    <td class="centered">
                                        @if ($Remuneration['Source Code'] == 'MISCELLANEOUS CHARGE' && $Remuneration['FieldValue'] > 0)
                                            {

                                            }
                                        @else
                                            @if (
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 0)
                                                {{ isset($BillData->Mock_Date) && !empty($BillData->Mock_Date) ? date('d-m-Y', strtotime($BillData->Mock_Date)) : '' }}
                                            @elseif (
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 1)
                                                {!! !empty($MockDutyDays) && is_array($MockDutyDays)
                                                    ? str_replace(',', '<br>', implode(',', $MockDutyDays))
                                                    : '' !!}
                                            @else
                                                {!! !empty($dutydays) && is_array($dutydays) ? str_replace(',', '<br>', implode(',', $dutydays)) : '' !!}
                                            @endif
                                        @endif

                                    </td>

                                    <td class="centered">

                                        @if (
                                            ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                $BillData->mockval == 0)
                                            {{ 1 }}
                                        @elseif(
                                            ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                $BillData->mockval == 1)
                                            {{ $BillData->A_Dutydays ?? '' }}
                                        @else
                                            {{ $BillData->A_Dutydays ?? '' }}
                                        @endif
                                    </td>

                                    <td class="centered">
                                        {{ isset($Remuneration['FieldValue']) && is_numeric($Remuneration['FieldValue']) ? number_format($Remuneration['FieldValue'], 2) : '' }}
                                        @if ($Remuneration['Source Code'] == 'MISCELLANEOUS CHARGE' && $Remuneration['FieldValue'] > 0)
                                            @if (isset($UserDataToArray['File Path']) && !empty($UserDataToArray['File Path']))
                                                <a href="{{ $UserDataToArray['File Path'] }}" target="_blank"
                                                    class="ml-5">View</a>
                                            @endif
                                        @endif
                                    </td>
                                    <td class="centered">
                                        {{ number_format((float) $Remuneration['Field_Name_Deduction_Value'], 0) }}
                                    </td>
                                </tr>
                            @elseif ($Remuneration['Remuneration Text'] != '' && $Remuneration['Mock Drill Text'] == '')
                                <tr>
                                    <td>{{ ++$i }}</td>
                                    <td>{{ $Remuneration['Remuneration Text'] }}</td>
                                    @if (
                                        $Remuneration['Source Code'] != 'ADVANCE PAYMENT' &&
                                            $Remuneration['Source Code'] != 'TDS WITH LABEL' &&
                                            $Remuneration['Source Code'] != 'MISCELLANEOUS CHARGE')
                                        <td class="centered">
                                            @if ($Remuneration['No_ of Days'] <= 0)
                                                {{ ' ' }}
                                            @elseif(
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 0)
                                                {{ isset($BillData->Mock_Date) && !empty($BillData->Mock_Date) ? date('d-m-Y', strtotime($BillData->Mock_Date)) : '' }}
                                            @elseif (
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 1)
                                                {!! !empty($MockDutyDays) && is_array($MockDutyDays)
                                                    ? str_replace(',', '<br>', implode(',', $MockDutyDays))
                                                    : '' !!}
                                            @else
                                                {!! !empty($dutydays) && is_array($dutydays) ? str_replace(',', '<br>', implode(',', $dutydays)) : '' !!}
                                            @endif
                                        </td>

                                        <td class="centered">
                                            @if ($Remuneration['No_ of Days'] <= 0)
                                                {{ ' ' }}
                                            @elseif(
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 0)
                                                {{ 1 }}
                                            @elseif(
                                                ($Remuneration['Source Code'] == 'MOCKDRILL' || $Remuneration['Source Code'] == 'MOCKDRILL CONVEYANCE') &&
                                                    $BillData->mockval == 1)
                                                {{ $BillData->A_Dutydays ?? '' }}
                                            @else
                                                {{ $BillData->A_Dutydays ?? '' }}
                                            @endif
                                        </td>
                                    @else
                                        <td class="centered"></td>
                                        <td class="centered"></td>
                                    @endif
                                    <td class="centered">
                                        {{ isset($Remuneration['FieldValue']) && is_numeric($Remuneration['FieldValue']) ? number_format($Remuneration['FieldValue'], 2) : '0.00' }}
                                        @if ($Remuneration['Source Code'] == 'MISCELLANEOUS CHARGE' && $Remuneration['FieldValue'] > 0)
                                            @if (isset($UserDataToArray['File Path']) && !empty($UserDataToArray['File Path']))
                                                <a href="{{ $UserDataToArray['File Path'] }}" target="_blank"
                                                    class="ml-5">View</a>
                                            @endif
                                        @endif
                                        {{-- @if ($Remuneration['Source Code'] == 'OBSERVER LOCAL')
                                                <a href="javascript:void(0);"
                                                    data-dutyDate="{{ json_encode($dutydays) ?? '' }}"
                                                    data-shiftcount="{{ json_encode($ShiftCountArr) ?? 0 }}"
                                                    data-shiftamount="{{ json_encode($shiftAmount_Separate) ?? 0 }}"
                                                    data-totalamount="{{ $totalRemuneratinAmt ?? 0 }}"
                                                    class="float-right text-success text-bold detailsModal"><b>View
                                                        Details</b></a>
                                            @endif --}}

                                    </td>
                                    <td class="centered">
                                        {{ number_format((float) $Remuneration['Field_Name_Deduction_Value'], 0) }}
                                    </td>
                                </tr>
                            @elseif ($Remuneration['Remuneration Text'] == '' && $Remuneration['Mock Drill Text'] != '')
                                <tr>
                                    <td>{{ ++$i }}</td>
                                    <td>{{ $Remuneration['Mock Drill Text'] }}</td>
                                    @if (
                                        $Remuneration['Source Code'] != 'ADVANCE PAYMENT' &&
                                            $Remuneration['Source Code'] != 'TDS WITH LABEL' &&
                                            $Remuneration['Source Code'] != 'MISCELLANEOUS CHARGE')
                                        <td class="centered"> {!! !empty($dutydays) && is_array($dutydays) ? str_replace(',', '<br>', implode(',', $dutydays)) : '' !!} </td>
                                        <td class="centered">{{ $BillData->A_Dutydays }}</td>
                                    @else
                                        <td class="centered"></td>
                                        <td class="centered"></td>
                                    @endif
                                    <td class="centered">
                                        {{ isset($Remuneration['MockDrillFieldValue']) && is_numeric($Remuneration['MockDrillFieldValue']) ? number_format($Remuneration['MockDrillFieldValue'], 2) : '' }}

                                        @if ($Remuneration['Source Code'] == 'MISCELLANEOUS CHARGE' && $Remuneration['FieldValue'] > 0)
                                            @if (isset($UserDataToArray['File Path']) && !empty($UserDataToArray['File Path']))
                                                <a href="{{ $UserDataToArray['File Path'] }}" target="_blank"
                                                    class="ml-5">View</a>
                                            @endif
                                        @endif
                                    </td>
                                    <td class="centered">
                                        {{ number_format((float) $Remuneration['Field_Name_Deduction_Value'], 0) }}
                                    </td>
                                </tr>
                            @else
                                <tr>
                                    <td>{{ ++$i }}</td>
                                    <td>&nbsp;</td>
                                    @if (
                                        $Remuneration['Source Code'] != 'ADVANCE PAYMENT' &&
                                            $Remuneration['Source Code'] != 'TDS WITH LABEL' &&
                                            $Remuneration['Source Code'] != 'MISCELLANEOUS CHARGE')
                                        <td class="centered">
                                            {{ str_replace(',', '<br>', implode(',', $dutydays)) ?? '' }}</td>
                                        <td class="centered">{{ $BillData->A_Dutydays }}</td>
                                    @else
                                        <td class="centered"></td>
                                        <td class="centered"></td>
                                    @endif

                                    <td class="centered">
                                        {{ isset($Remuneration['FieldValue']) && is_numeric($Remuneration['FieldValue']) ? number_format($Remuneration['FieldValue'], 2) : 0 }}
                                    </td>
                                    <td class="centered">
                                        {{ (float) $Remuneration['Field_Name_Deduction_Value'] == 0 ? '0' : number_format((float) $Remuneration['Field_Name_Deduction_Value'], 2) }}
                                    </td>
                                </tr>
                            @endif
                        @endforeach

                        @if (isset($travel) && !empty($travel))
                            <tr>
                                <td>{{ ++$i }}</td>
                                <td>Travelling Expenses</td>
                                <td class="centered"></td>
                                <td class="centered">-</td>
                                <td class="centered">
                                    {{ isset($travelExpenseTotal) && is_numeric($travelExpenseTotal) ? number_format($travelExpenseTotal, 2) : 0 }}
                                </td>
                                <td class="centered">
                                    {{ isset($UserDataToArray['Outstation_Travelling_Expenses_Deduction']) && $UserDataToArray['Outstation_Travelling_Expenses_Deduction'] !== null
                                        ? ($UserDataToArray['Outstation_Travelling_Expenses_Deduction'] == 0
                                            ? '0'
                                            : number_format((float) $UserDataToArray['Outstation_Travelling_Expenses_Deduction'], 2))
                                        : ''
                                    }}

                                </td>
                            </tr>
                        @endif
                        @if (isset($hotel) && !empty($hotel))
                            <tr>
                                <td>{{ ++$i }}</td>
                                <td>Hotel / Food Bill etc Expenses</td>
                                <td class="centered"></td>
                                <td class="centered">-</td>
                                <td class="centered">
                                    {{ isset($hotelExpenseTotal) && is_numeric($hotelExpenseTotal) ? number_format($hotelExpenseTotal, 2) : 0 }}
                                </td>
                                <td class="centered">
                                    {{ (float) $UserDataToArray['Outstation Hotal_Food Deduction'] == 0 ? '0' : number_format((float) $UserDataToArray['Outstation Hotal_Food Deduction'], 2) }}
                                </td>

                            </tr>
                        @endif

                        <tr>
                            <td>{{ ++$i }}</td>
                            <td class="fw-bold" colspan="3">Total Amount Claimed</td>
                            <td class="centered fw-bold">
                                {{ isset($totalPayableAmt) && is_numeric($totalPayableAmt) ? number_format($totalPayableAmt, 2) : '' }}
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>{{ ++$i }}</td>
                            <td class="fw-bold" colspan="3">Total Deduction Amount </td>
                            <td class="centered fw-bold">
                                {{ isset($UserDataToArray['Total Deduction Amount']) && is_numeric($UserDataToArray['Total Deduction Amount']) ? number_format($UserDataToArray['Total Deduction Amount'], 2) : '' }}
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td>{{ ++$i }}</td>
                            <td class="fw-bold" colspan="3">Total Amount After Deduction </td>
                            <td class="centered fw-bold">
                                {{ isset($totalAmountAfterDeduction) && is_numeric($totalAmountAfterDeduction) ? number_format($totalAmountAfterDeduction, 2) : '' }}
                            </td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="6">
                                <span>*No receipt to be attached for Food expense. Please mention if you are special
                                    observer.</span><br>
                                <span>*Payment shall be released by NTA post verification of the submitted bill.</span>
                            </td>
                        </tr>

                    @endif
                    @if (isset($UserDataToArray) && !empty($UserDataToArray) && $UserDataToArray['IsNewBill'] == 0)
                        <tr>
                            <td>*</td>
                            <td>Remuneration @ {{ number_format($UserDataToArray['Remuneration Rate']) }}/- per exam as per duty days.</td>
                            <td></td>
                            <td>{{ $UserDataToArray['Remuneration Days'] }}</td>
                            <td>{{ number_format($UserDataToArray['Remuneration Amount']) }}</td>
                            <td>{{ number_format($UserDataToArray['Remuneration Deduction Amount']) }}</td>
                        </tr>
                        <tr>
                            <td>*</td>
                            <td>Fixed local Conveyance @1,000/- day</td>
                            <td></td>
                            <td>{{ $UserDataToArray['Remuneration Days'] }}</td>
                            <td>{{ number_format($UserDataToArray['Conveyance Amount Local']) }}</td>
                            <td>{{ number_format($UserDataToArray['Conveyance Deduction Amount']) }}</td>
                        </tr>
                        <tr>
                            <td>*</td>
                            <td>Fixed Food Expense @300/- day</td>
                            <td></td>
                            <td>{{ $UserDataToArray['Remuneration Days'] }}</td>
                            <td>{{ number_format($UserDataToArray['Food Amount']) }}</td>
                            <td>{{ number_format($UserDataToArray['Food Deduction Amount']) }}</td>
                        </tr>
                        <tr>
                            <td>*</td>
                            <td>Remuneration for Mock Drill @ {{ number_format($UserDataToArray['Mock Drill Charges']) }}/-</td>
                            <td></td>
                            <td>1</td>
                            <td>{{ number_format($UserDataToArray['Mock Drill Charges']) }}</td>
                            <td>{{ number_format($UserDataToArray['Mock Drill Remuneration Deduction']) }}</td>
                        </tr>
                        <tr>
                            <td>*</td>
                            <td>Fixed Conveyance for Mock Drill @1,000/-</td>
                            <td></td>
                            <td>1</td>
                            <td>{{ number_format($UserDataToArray['Mock Drill Conveyance']) }}</td>
                            <td>{{ number_format($UserDataToArray['Mock Drill Conveyance Deduction']) }}</td>
                        </tr>
                        <tr>
                            <td>*</td>
                            <td>TDS @10% on Remuneration</td>
                            <td>-</td>
                            <td>-</td>
                            <td>{{ number_format($UserDataToArray['TDS Amount']) }}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Advance Amount Received From CC/NTA</td>
                            <td>{{ number_format($UserDataToArray['Advance Payment']) }}</td>
                            <td>-</td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Miscellaneous Charge</td>
                            <td>{{ number_format($UserDataToArray['Miscellaneous Charge']) }}</td>
                            <td>{{ number_format($UserDataToArray['Miscellaneous Deduction Amount']) }}</td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Total Amount Claimed</td>
                            <td>{{ number_format($UserDataToArray['Claimed Amount']) }}</td>
                            <td>-</td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Total Deduction Amount</td>
                            <td>{{ number_format($UserDataToArray['Total Deduction Amount']) }}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Net Payable After Deduction</td>
                            <td>{{ number_format($UserDataToArray['Net Payable After Deduction']) }}</td>
                            <td></td>
                        </tr>
                        <tr>
                            <td colspan="4" class="fw-bold">Uploaded File</td>
                            <td colspan="2"><a target="_blank" href="{{ $UserDataToArray['File Path'] ?? '#' }}">View</a></td>
                        </tr>
                    @endif
                </tbody>

            </table>
            <b>Bill Submitted Date:</b>
            {{ isset($UserDataToArray['CreatedDate']) && !empty($UserDataToArray['CreatedDate']) ? date('d-m-Y', strtotime($UserDataToArray['CreatedDate'])) : '' }}
        </div>
    </div>

    <!-- Modal -->
    {{-- <div class="modal fade" id="detailsModal" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
     aria-labelledby="detailsModalLabel" aria-hidden="true">
     <div class="modal-dialog" style="max-width: 500px!important">
         <div class="modal-content">
             <div class="modal-header">
                 <h5 class="modal-title" id="detailsModalLabel">Remuneration Details</h5>
                 <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
             </div>
             <div class="modal-body">
                 <table class="table">
                     <thead class="table-dark">
                         <th>Duty Date</th>
                         <th>No. of Shift</th>
                         <th>Remuneration Rate</th>
                     </thead>
                     <tbody id="ShiftWiseAmount">

                     </tbody>
                 </table>
             </div>
             <div class="modal-footer">
                 <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
             </div>
         </div>
     </div>
 </div> --}}
</body>

</html>
{{-- <script>
        $(document).on('click', '.detailsModal', function() {
            // Get data from the clicked element
            var dutyDates = $(this).data('dutydate'); // Array
            var shiftCount = $(this).data('shiftcount'); // Object
            var shiftAmounts = $(this).data('shiftamount'); // Array
            var totalAmount = $(this).data('totalamount'); // Number

            console.log("Duty Dates:", dutyDates);
            console.log("Shift Count:", shiftCount);
            console.log("Shift Amounts:", shiftAmounts);
            console.log("Total Amount:", totalAmount);

            // Ensure data is parsed correctly
            if (typeof dutyDates === "string") {
                dutyDates = JSON.parse(dutyDates.replace(/&quot;/g, '"')); // Convert string to array
            }
            if (typeof shiftCount === "string") {
                shiftCount = JSON.parse(shiftCount.replace(/&quot;/g, '"')); // Convert string to object
            }
            if (typeof shiftAmounts === "string") {
                shiftAmounts = JSON.parse(shiftAmounts.replace(/&quot;/g, '"')); // Convert string to array
            }

            var shiftCountValues = Object.values(shiftCount);

            // Clear previous table data
            $('#ShiftWiseAmount').empty();

            // Loop through dutyDates and display in the table
            $.each(dutyDates, function(index, date) {
                var shiftTotal = shiftCountValues[index] || "N/A";
                var amount = shiftAmounts[index] ? parseFloat(shiftAmounts[index]).toLocaleString('en-US', {
                    minimumFractionDigits: 2,
                    maximumFractionDigits: 2
                }) : "N/A"; // Format amount

                var newRow = `
            <tr>
                <td>${date}</td>
                <td>${shiftTotal}</td>
                <td>${amount}</td>
            </tr>`;
                $('#ShiftWiseAmount').append(newRow);
            });

            // Format total amount and add it as a separate row
            var formattedTotalAmount = totalAmount ? parseFloat(totalAmount).toLocaleString('en-US', {
                minimumFractionDigits: 2,
                maximumFractionDigits: 2
            }) : "N/A";

            var totalRow = `
            <tr class="font-weight-bold text-success">
                <td colspan="2" class="text-right"><strong>Total Amount:</strong></td>
                <td><strong>${formattedTotalAmount}</strong></td>
            </tr>`;
            $('#ShiftWiseAmount').append(totalRow);

            $('#detailsModal').modal('show'); // Open modal
        });
</script> --}}
