<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQAd2DtR6p6O/xLEcYf3/b2xv7Wa2l6ICsw7Gh0b8YJp8cNKKuNlF0xIm" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-kQtW33rZJAHjge9c0Rj1Tvbvo/6FVdE5gI1Q1ik6jcKIRYgvFNmLghU9vXk1WjH5" crossorigin="anonymous"></script>

<div class="content-body">
    <div class="card card-white mb-4">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h5 class="m-0 font-weight-normal text-head-color">Review Observer/Deputy Observer Details:</h5>
        </div>
        <div class="card-body">

            <!-- Observers Section -->
            @if (isset($observers) && !empty($observers))
                <div class="text-center">
                    <h4>Observers</h4>
                </div>
                <hr />
                @foreach ($observers as $observer)
                    <div class="row mb-4">
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Observer ID</strong> :</div>
                            <div>{{ $observer->Observer_ID ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Observer Name</strong> :</div>
                            <div>{{ $observer->Observer_Name ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Observer Phone</strong> :</div>
                            <div>{{ $observer->Observer_Phone ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Observer Email</strong> :</div>
                            <div>{{ $observer->Observer_Email ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Account Holder Name</strong> :</div>
                            <div>{{ $observer->Account_Holder_Name ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Account Number</strong> :</div>
                            <div>{{ $observer->Account_Number ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>IFSC</strong> :</div>
                            <div>{{ $observer->IFSC_CODE ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Branch Name</strong> :</div>
                            <div>{{ $observer->Branch_Name ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>PAN Number</strong> :</div>
                            <div>{{ $observer->PAN ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Duty Days</strong> :</div>
                            <div>{{ $observer->Duty_Days ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Mock Duty Days</strong> :</div>
                            <div>{{ $observer->{'Mock Duty Days'} ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Advance Payment</strong> :</div>
                            <div>{{ number_format($observer->Advance_Payment, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>TDS Amount</strong> :</div>
                            <div>{{ number_format($observer->TDS, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Amount To Be Paid</strong> :</div>
                            <div>{{ number_format($observer->{'Amount To Paid'}, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                    </div>
                    <hr />
                @endforeach
            @endif

            <!-- Deputy Observers Section -->
            @if (isset($deputyObservers) && !empty($deputyObservers))
                <div class="text-center">
                    <h4>Deputy Observers</h4>
                </div>
                <hr />
                @foreach ($deputyObservers as $dobserver)
                    <div class="row mb-4">
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Deputy Observer ID</strong> :</div>
                            <div>{{ $dobserver->Observer_ID ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Deputy Observer Name</strong> :</div>
                            <div>{{ $dobserver->Observer_Name ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Deputy Observer Phone</strong> :</div>
                            <div>{{ $dobserver->Observer_Phone ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Deputy Observer Email</strong> :</div>
                            <div>{{ $dobserver->Observer_Email ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Account Holder Name</strong> :</div>
                            <div>{{ $dobserver->Account_Holder_Name ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Account Number</strong> :</div>
                            <div>{{ $dobserver->Account_Number ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>IFSC</strong> :</div>
                            <div>{{ $dobserver->IFSC_CODE ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Branch Name</strong> :</div>
                            <div>{{ $dobserver->Branch_Name ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>PAN Number</strong> :</div>
                            <div>{{ $dobserver->PAN ?? 'NA' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Duty Days</strong> :</div>
                            <div>{{ $dobserver->Duty_Days ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Mock Duty Days</strong> :</div>
                            <div>{{ $dobserver->{'Mock Duty Days'} ?? 'NA' }}</div>
                        </div>

                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Advance Payment</strong> :</div>
                            <div>{{ number_format($dobserver->Advance_Payment, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>TDS Amount</strong> :</div>
                            <div>{{ number_format($dobserver->TDS, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                        <div class="col-6 d-flex justify-content-between">
                            <div><strong>Amount To Be Paid</strong> :</div>
                            <div>{{ number_format($dobserver->{'Amount To Paid'}, 2, '.', ',') ?? '0.00' }}</div>
                        </div>
                    </div>
                    <hr />
                @endforeach
            @endif

        </div>
    </div>
</div>
