<?php
//=====================================Super Admin Routing=======================================================//
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\admin\ExamMasterController;
use App\Http\Controllers\admin\FormfieldsController;
use App\Http\Controllers\admin\ImportremMasterController;
use App\Http\Controllers\admin\ImportremVendorMasterController;
use App\Http\Controllers\admin\ImportAdvanceDataController;
use App\Http\Controllers\admin\ImportCandidateWiseCountDataController;
use App\Http\Controllers\admin\CommonSettingMasterDataController;
use App\Http\Controllers\admin\ImportFinancialNormsController;
use App\Http\Controllers\admin\ProfileController;
use App\Http\Controllers\admin\AdminDashboardController;
use App\Http\Controllers\admin\AdminLoginController;
use App\Http\Controllers\admin\ChangesLogController;
use App\Http\Controllers\admin\BillReportController;

Route::middleware(['guestadmin'])->group(function () {
    Route::get('/admin/login', [AdminLoginController::class, 'index'])->name('admin.loginpage');
    Route::get('/admin', [AdminLoginController::class, 'index'])->name('admin.index');
    Route::post('/admin/login', [AdminLoginController::class, 'adminlogin'])->name('admin.login');

    Route::get('/admin/forgot-password', [AdminLoginController::class, 'forgotPassword'])->name('admin.forgot-password');
    Route::post('/admin/forgot-password', [AdminLoginController::class, 'forgotPasswordPost'])->name('admin.admin-forgot-password-link');
    Route::get('/admin/reset-passwords/{token}', [AdminLoginController::class, 'showResetForm'])->name('admin.reset-passwords');
    Route::post('/admin/admin-forgot-passwords', [AdminLoginController::class, 'setForgotPassword'])->name('admin.admin-forgot-passwords');

});

// Common logout route for both roles
Route::middleware(['admin'])->prefix('admin')->group(function () {
    Route::controller(ProfileController::class)->prefix('profile')->group(function () {
        Route::any('logout', 'AdminLogout')->name('adminlogout');
        Route::get('change-password', 'showChangePasswordForm')->name('change-password.form');
        Route::post('change-password', 'changePassword')->name('change-password.update');
        Route::get('view-profile', 'viewProfile')->name('profile.view');
        Route::patch('update-profile', 'updateProfile')->name('profile.update');
    });
});

Route::middleware(['admin', 'role:24,25,26'])->prefix('admin')->group(function () {
    Route::controller(AdminDashboardController::class)->group(function () {
        Route::get('dashboard', 'index')->name("admin.dashboard");
        Route::post('searchExam', 'serachExamByExamMode')->name("searchExam");
        Route::post('countTotalBill', 'getTotalCountBill')->name("countTotalBill");
        Route::get('allBill', 'getAllBilldata')->name("allBill");
        Route::get('billDetails', 'billDetails')->name("billDetails");
        Route::get('billList', 'getListingByLabel')->name("billList");
        Route::get('updateBillDeatils', 'updateBillDeatils')->name("updateBillDeatils");
        Route::get('generatePdf/{referenceNo}/{examType}/{observerID}/{isNew}/{Role}', 'generatePdf')->name("generatePdf");
        Route::post('generate-bulk-pdf', 'generateBulkPdf')->name("generate-bulk-pdf");
        Route::post('detailReport', 'detailReport')->name("detailReport");
        Route::post('expotReportDownload', 'expotReportDownload')->name("expotReportDownload");

        
    });
});

Route::middleware(['admin', 'role:27'])->prefix('superadmin')->group(function () {

    Route::controller(AdminDashboardController::class)->group(function () {
        Route::get('/superdashboard', 'superIndex')->name("admin.superdashboard");
    });
    Route::controller(ExamMasterController::class)->prefix('exam')->group(function () {
        Route::get('index', 'index')->name("exam.index");
        Route::get('view', 'view')->name("exam.view");
        Route::get('add', 'add')->name("exam.add");
        Route::post('saveExamDetails', 'saveExamDetails')->name('exam.savedetail');
        Route::get('edit', 'edit')->name("exam.edit");
        Route::post('import', 'import')->name('exam.import');
        Route::post('check-exam-type-exist', 'checkExamTypeExist')->name('check.exam.type.exist');
        Route::post('exam-status', 'updateExamStatus')->name('exam.status');

    });

    Route::controller(ImportremMasterController::class)->prefix('importrem')->group(function () {
        Route::get('index', 'index')->name("importrem.index");
        Route::get('view', 'view')->name("importrem.view");
        Route::get('add', 'add')->name("importrem.add");
        Route::get('edit', 'editShiftwiseDutyDays')->name("importrem.edit");
        Route::post('savedetail', 'savedetail')->name('importrem.savedetail');
        Route::get('indexshift', 'indexshift')->name("importrem.indexshift");
        Route::get('addshift', 'addshift')->name("importrem.addshift");
        Route::post('savedetailshift', 'savedetailshift')->name('importrem.savedetailshift');
        Route::post('update', 'updateShiftwiseDutyDays')->name("shiftwise.dutyDays.update");
        Route::get('edit-duty-days', 'editDutyDays')->name("edit.dutydays");
        Route::post('update-duty-days', 'updateDutyDays')->name("dutyDays.update");
        Route::post('updatedutydays', 'updateDutyDay')->name("dutyDays.updates");
        Route::get('ntausers-id-search', 'ntausersIdSearch')->name("ntausers-id-search");
        Route::get('ntausers-id-search-shift-wise-duty', 'ntausersIdSearchSiftWise')->name("ntausers-id-search-shift-wise-duty");


    });

    Route::controller(ImportremVendorMasterController::class)->prefix('vendor')->group(function () {
        Route::get('import-vendor-details', 'index')->name("import-vendor-details");
        Route::get('import-vendor-details/add', 'add')->name("import-vendor-details.add");
        Route::get('vendor-details-edit/{edit}', 'edit')->name('admin.vendor-details-edit');
        Route::post('vendor-save-detail', 'savedetail')->name('vendor-save-detail');
        Route::post('vendor-save-detail-Single', 'saveSingleDetail')->name('vendor-save-detail-Single');
    });

    Route::controller(ImportAdvanceDataController::class)->prefix('advancedata')->group(function () {
        Route::get('list-advance', 'index')->name("list-advance");
        Route::get('edit-advance/{ID}', 'edit')->name('edit-advance');
        Route::get('add-advance', 'add')->name('add-advance');
        Route::post('update-advance', 'store')->name('update-advance');
        Route::get('import-advance', 'import')->name("import-advance");
        Route::post('save-import-advance', 'saveimport')->name("save-import-advance");
        Route::get('ntausers-search', 'ntausersSearch')->name("ntausers-search");
    });

    Route::controller(ImportCandidateWiseCountDataController::class)->prefix('countdata')->group(function () {
        Route::get('list-count', 'index')->name("list-count");
        Route::get('edit-count/{ID}', 'edit')->name('edit-count');
        Route::get('add-count', 'add')->name('add-count');
        Route::post('update-count', 'store')->name('update-count');
        Route::get('import-count', 'import')->name("import-count");
        Route::post('save-import-count', 'saveimport')->name("save-import-count");
        Route::post('/delete-count/{id}', 'deleteCandidateCount')->name('delete-count');
    });

    Route::controller(ImportFinancialNormsController::class)->prefix('financialnorms')->group(function () {

        Route::get('import-financial-norms', 'index')->name("import-financial-norms");
        Route::get('import-financial-norms/add', 'add')->name("importfinancial.add");
        Route::get('import-financial-norms-bulk/add', 'addBulk')->name("importfinancial_bulk.add");
        Route::post('financial-norms-save-detail', 'savedetail')->name('financial-norms-save-detail');
        Route::post('financial-norms-save-bulk-detail', 'savebulkdetail')->name('financial-norms-save-bulk-detail');
        Route::get('financial-norms-edit', 'edit')->name('importfinance.edit');
        Route::post('financial-norms-update-detail', 'updateFinanceDetail')->name('financial-norms-update-detail');
        Route::get('get_exam_name', 'getExamDetails')->name('get_exam_name');
        Route::get('get_gategory_list', 'getGategoryList')->name('get_gategory_list');
    });

    Route::controller(FormfieldsController::class)->prefix('formfield')->group(function () {
        Route::get('form-fields', 'index')->name("form-fields");
        Route::get('form-fields-edit/{edit}', 'edit')->name('admin.form-fields-edit');
        Route::get('form-fields/add', 'add')->name("form-fields.add");
        Route::post('form-fields-submit', 'saveUpdate')->name("form-fields-submit");
        Route::post('fields-copy', 'fieldsCopy')->name("fields-copy");
        Route::post('updateFieldStatus', 'updateFieldStatus')->name("updateFieldStatus");
    });
    Route::controller(ChangesLogController::class)->prefix('logs')->group(function(){
        Route::get('index', 'index')->name("changesLog");
    });
    Route::controller(BillReportController::class)->prefix('bill-report')->group(function(){
        Route::get('index', 'index')->name("billReports");
    });

    Route::controller(CommonSettingMasterDataController::class)->prefix('setting')->group(function () {
        Route::get('list', 'index')->name("setting-list");
        Route::match(['get', 'post'], 'edit/{ID}', 'edit')->name('setting-edit');
        Route::match(['get', 'post'], 'add', 'add')->name('setting-add');

    });
});



